SystemOrganization addCategory: #'Sight-Dynamic'!
SystemOrganization addCategory: #'Sight-Dynamic-UI-Designs'!
SystemOrganization addCategory: #'Sight-Dynamic-UI-Layouts'!
SystemOrganization addCategory: #'Sight-Dynamic-UI-Support'!
SystemOrganization addCategory: #'Sight-Dynamic-UI-Columns'!
SystemOrganization addCategory: #'Sight-Dynamic-Models'!
SystemOrganization addCategory: #'Sight-Dynamic-Models-Code'!
SystemOrganization addCategory: #'Sight-Dynamic-Tests'!
SystemOrganization addCategory: #'Sight-Dynamic-Tests-Support'!
SystemOrganization addCategory: #'Sight-Dynamic-Events'!
SystemOrganization addCategory: #'Sight-Dynamic-Support'!
SystemOrganization addCategory: #'Sight-Dynamic-Traits'!
SystemOrganization addCategory: #'Sight-Dynamic-Help'!
SystemOrganization addCategory: #'Sight-Dynamic-Benchmarks'!
SystemOrganization addCategory: #'Sight-Dynamic-Models-System'!

Trait named: #TSdDynamicActivation
	uses: {}
	category: 'Sight-Dynamic-Traits'!

Trait named: #TSdDynamicAccessor
	uses: TSdDynamicActivation
	category: 'Sight-Dynamic-Traits'!

TSdDynamicAccessor classTrait
	uses: TSdDynamicActivation classTrait!

!TSdDynamicAccessor methodsFor: 'dynamic - actions' stamp: 'mt 7/21/2011 11:16:04.92'!
browseArgumentClass: aNode index: anInteger

	aNode argumentClasses ifNil: [
		self collectProperties: #(argumentClasses) inNodeGroups: {{aNode}}].
	
	self classActivated: (aNode argumentClasses at: anInteger).! !

!TSdDynamicAccessor methodsFor: 'dynamic - actions' stamp: 'mt 7/21/2011 10:31:23.185'!
browseMethod: aNode

	self methodActivated: aNode clientReference.! !

!TSdDynamicAccessor methodsFor: 'dynamic - actions' stamp: 'mt 7/21/2011 10:31:27.61'!
browseReceiverClass: aNode

	self classActivated: aNode receiverClass.! !

!TSdDynamicAccessor methodsFor: 'dynamic - actions' stamp: 'mt 7/21/2011 11:16:25.054'!
browseReturnClass: aNode

	aNode returnClass ifNil: [
		self collectProperties: #(returnClass) inNodeGroups: {{aNode}}].
	
	self classActivated: aNode returnClass.! !

!TSdDynamicAccessor methodsFor: 'dynamic - aggregation' stamp: 'mt 7/23/2011 10:44:31.012'!
collectArgumentClasses: nodeGroups
	"All nodes are for one method call. Different to #collectArgumentClassesByCallgraph: this method joins all found classes and returns each class only once."
	
	| args |
	self
		collectProperties: #(argumentClasses)
		inNodeGroups: (nodeGroups collect: [:nodes |
			nodes select: [:node | node argumentClasses isNil]]).
	
	args := nodeGroups first first argumentClasses collect: [:cls | Set new].
	
	"Collect all classes from all traces into sets."
	nodeGroups do: [:nodes | nodes do: [:node |
		node argumentClasses withIndexDo: [:cls :idx |
			(args at: idx) add: cls]]].

	args := args collect: [:arg | arg asOrderedCollection].

	^ args! !

!TSdDynamicAccessor methodsFor: 'dynamic - aggregation' stamp: 'mt 7/23/2011 11:27:22.76'!
collectArgumentClassesByCallgraph: nodeGroups
	"All nodes are for one method call."
	
	self
		collectProperties: #(argumentClasses)
		inNodeGroups: (nodeGroups collect: [:nodes |
			nodes select: [:node | node argumentClasses isNil]]).
	
	^ nodeGroups collect: [:nodes | nodes collect: [:node |
		node argumentClasses]]! !

!TSdDynamicAccessor methodsFor: 'dynamic - tracing' stamp: 'mt 6/21/2012 14:27:41.857'!
collectCoveringNodes: aCompiledMethod
	"Update callgraphs for tests covering the given method."
	
	aCompiledMethod isTestMethod
		ifTrue: [Error signal: 'Test methods do not cover each other!!'].
		
	aCompiledMethod hasMethodExtension
		ifFalse: [Error signal: 'No coverage information available!!'].
	
	Cursor wait showWhile: [
		| nodeGroups |
		nodeGroups := (aCompiledMethod methodExtension tests collect: [:testReference |
			| callgraph |
			callgraph := SdCallgraphEditor callgraphAtTest: testReference.
			
			"Fill callgraph if empty."
			callgraph ifEmpty: [
				callgraph selectedCategories: 
					(PackageOrganizer default packageOfMethod: aCompiledMethod methodReference) systemCategories,
					(PackageOrganizer default packageOfMethod: testReference methodReference) systemCategories.
				
				SdCallgraphTracer new callgraph: callgraph; trace].
			
			"Collect covering call nodes."
			callgraph selectMethodCalls: aCompiledMethod methodReference]).

		^ self sortCoveringNodes: nodeGroups asOrderedCollection]! !

!TSdDynamicAccessor methodsFor: 'dynamic - tracing' stamp: 'mt 7/21/2011 11:11:10.374'!
collectGlobalProperties: someSymbols inCallgraphs: someCallgraphs

	Cursor wait showWhile: [
		someCallgraphs do: [:cg |
			SdCallgraphTracer new
				callgraph: cg;
				collectGlobalProperties: someSymbols]].! !

!TSdDynamicAccessor methodsFor: 'dynamic - tracing' stamp: 'mt 7/23/2011 11:37:28.783'!
collectProperties: someSymbols inNodeGroups: someNodeGroups
	"Every group of nodes should belong to the same callgraph."
	
	Cursor wait showWhile: [
		someNodeGroups
			select: [:nodes | nodes notEmpty]
			thenDo: [:nodes |
				SdCallgraphTracer new
					callgraph: nodes first callgraph;
					collectProperties: someSymbols
					inNodes: nodes]].! !

!TSdDynamicAccessor methodsFor: 'dynamic - tracing' stamp: 'mt 7/23/2011 11:37:22.649'!
collectPropertiesInNodeGroups: someNodeGroups
	"Every group of nodes should belong to the same callgraph."
	
	Cursor wait showWhile: [
		someNodeGroups
			select: [:nodes | nodes notEmpty]
			thenDo: [:nodes |
				SdCallgraphTracer new
					callgraph: nodes first callgraph;
					collectPropertiesInNodes: nodes]].! !

!TSdDynamicAccessor methodsFor: 'dynamic - aggregation' stamp: 'mt 7/21/2011 20:49:55.077'!
collectReturnClasses: nodeGroups
	"All nodes are for one method call."
	
	| returnClasses |
	self
		collectProperties: #(returnClass)
		inNodeGroups: (nodeGroups collect: [:nodes |
			nodes select: [:node | node returnClass isNil]]).
	
	returnClasses := Set new.
	
	"Collect all classes from all traces into sets."
	nodeGroups do: [:nodes | nodes do: [:node |
		returnClasses add: node returnClass]].

	returnClasses := returnClasses asOrderedCollection.

	^ returnClasses! !

!TSdDynamicAccessor methodsFor: 'dynamic - aggregation' stamp: 'mt 7/23/2011 11:27:14.169'!
collectReturnClassesByCallgraph: nodeGroups
	"All nodes are for one method call."
	
	self
		collectProperties: #(returnClass)
		inNodeGroups: (nodeGroups collect: [:nodes |
			nodes select: [:node | node returnClass isNil]]).
	
	^ nodeGroups collect: [:nodes | nodes collect: [:node |
		node returnClass]]! !

!TSdDynamicAccessor methodsFor: 'dynamic - actions' stamp: 'mt 7/21/2011 11:17:25.134'!
exploreArgumentObject: aNode index: anInteger
	
	aNode argumentObjectsBefore ifNil: [
		aNode requestProperty: #argumentObjectsBefore].
	
	aNode argumentObjectsAfter ifNil: [
		aNode requestProperty: #argumentObjectsAfter].
	
	self collectPropertiesInNodeGroups: {{aNode}}.
	
	self objectActivated: (SdObjectStateChange new
		before: (aNode argumentObjectsBefore at: anInteger);
		after: (aNode argumentObjectsAfter at: anInteger);
		node: aNode).! !

!TSdDynamicAccessor methodsFor: 'dynamic - actions' stamp: 'mt 4/6/2012 16:11:05.959'!
exploreReceiverObject: aNode

	aNode receiverObjectBefore ifNil: [
		aNode requestProperty: #receiverObjectBefore].
	
	aNode receiverObjectAfter ifNil: [
		aNode requestProperty: #receiverObjectAfter].
	
	self collectPropertiesInNodeGroups: {{aNode}}.
	
	self objectActivated: (SdObjectStateChange new
		before: aNode receiverObjectBefore;
		after: aNode receiverObjectAfter;
		node: aNode).! !

!TSdDynamicAccessor methodsFor: 'dynamic - actions' stamp: 'mt 7/21/2011 11:17:51.91'!
exploreReturnObject: aNode

	aNode returnObject ifNil: [
		self collectProperties: #(returnObject) inNodeGroups: {{aNode}}].
	
	self objectActivated: (SdObjectStateChange new
		before: aNode returnObject;
		after: nil;
		node: aNode).! !

!TSdDynamicAccessor methodsFor: 'dynamic - tracing' stamp: 'mt 2/16/2012 11:23:48.83'!
sortCoveringNodes: someNodeGroups
	"Sort groups by test name."

	^ someNodeGroups sortBy: [:nodes1 :nodes2 |
			| t1 t2 |
			t1 := nodes1 first callgraph traceEvent.
			t2 := nodes2 first callgraph traceEvent.
			 t1 testClass name < t2 testClass name
				or: [t1 testClass name = t2 testClass name
					and: [t1 testSelector <= t2 testSelector]]]! !

!TSdDynamicActivation methodsFor: 'dynamic - signals - activation' stamp: 'mt 7/21/2011 10:38:53.118'!
classActivated: aClass

	self emitInOwnerChain.! !

!TSdDynamicActivation methodsFor: 'dynamic - signals - activation' stamp: 'mt 7/21/2011 10:38:48.73'!
methodActivated: aMethodReference

	self emitInOwnerChain.! !

!TSdDynamicActivation methodsFor: 'dynamic - signals - activation' stamp: 'mt 7/21/2011 10:38:44.341'!
objectActivated: anObject

	self emitInOwnerChain.! !

!TSdDynamicActivation methodsFor: 'dynamic - signals - activation' stamp: 'mt 7/23/2011 11:39:26.205'!
traceActivated: aNode

	self emitInOwnerChain.! !

Trait named: #TSdDynamicMenusForMethod
	uses: {}
	category: 'Sight-Dynamic-Traits'!

!TSdDynamicMenusForMethod methodsFor: 'dynamic - menus - support' stamp: 'mt 7/31/2011 17:32:42.187'!
browseMenuForArgument: argIndex nodes: nodeGroups
	
	| menu |
	menu := MenuMorph new defaultTarget: self.
	
	((self collectArgumentClasses: nodeGroups) at: argIndex) do: [:cls |		
		menu
			add: cls name
			selector: #classActivated:
			argument: cls].

	^ menu! !

!TSdDynamicMenusForMethod methodsFor: 'dynamic - menus - support' stamp: 'mt 7/31/2011 17:37:53.495'!
browseMenuForMethodNodes: nodeGroups
	
	| menu argNames |
	menu := MenuMorph new defaultTarget: self.
	argNames := nodeGroups first first argumentNames.
		
	menu
		add: 'Result Classes'
		icon: nil
		subMenu: (self browseMenuForReturnNodes: nodeGroups);
		addLine.

	argNames withIndexDo: [:argName :idx |
		menu
			add: argName
			icon: nil
			subMenu: (self browseMenuForArgument: idx nodes: nodeGroups)].

	^ menu! !

!TSdDynamicMenusForMethod methodsFor: 'dynamic - menus - support' stamp: 'mt 7/31/2011 17:38:04.122'!
browseMenuForReturnNodes: nodeGroups
	
	| menu |
	menu := MenuMorph new defaultTarget: self.
	
	(self collectReturnClasses: nodeGroups) do: [:cls |		
		menu
			add: cls name
			selector: #classActivated:
			argument: cls].

	^ menu! !

!TSdDynamicMenusForMethod methodsFor: 'dynamic - menus - support' stamp: 'mt 7/31/2011 17:32:52.586'!
exploreMenuForArgument: argIndex nodes: nodeGroups
	
	| menu |
	menu := MenuMorph new defaultTarget: self.
	
	self collectArgumentClassesByCallgraph: nodeGroups.
	nodeGroups do: [:nodes | 	
		menu
			add: ('{1} {2} [{3}>>{4}]' format: {
				nodes first argumentClasses at: argIndex.
				nodes first argumentIds ifNotNil: [:ids | ids at: argIndex].
				nodes first callgraph traceEvent testClass.
				nodes first callgraph traceEvent testSelector})
			target: self
			selector: #exploreArgumentObject:index:
			argumentList: {nodes first.argIndex}].

	^ menu! !

!TSdDynamicMenusForMethod methodsFor: 'dynamic - menus - support' stamp: 'mt 7/31/2011 17:38:18.309'!
exploreMenuForMethodNodes: nodeGroups
	
	| menu argNames|
	menu := MenuMorph new defaultTarget: self.
	argNames := nodeGroups first first argumentNames.
		
	menu
		add: 'Receivers'
		icon: nil
		subMenu: (self exploreMenuForReceiverNodes: nodeGroups);
		add: 'Results'
		icon: nil
		subMenu: (self exploreMenuForReturnNodes: nodeGroups);
		addLine.

	argNames withIndexDo: [:argName :idx |
		menu
			add: argName
			icon: nil
			subMenu: (self exploreMenuForArgument: idx nodes: nodeGroups)].

	^ menu! !

!TSdDynamicMenusForMethod methodsFor: 'dynamic - menus - support' stamp: 'mt 7/31/2011 17:38:28.304'!
exploreMenuForReceiverNodes: nodeGroups
	
	| menu |
	menu := MenuMorph new defaultTarget: self.
	
	nodeGroups do: [:nodes |
		menu
			add: ('{1} {2} [{3}>>{4}]' format: {
				nodes first receiverClass.
				nodes first receiverId.
				nodes first callgraph traceEvent testClass.
				nodes first callgraph traceEvent testSelector})
			target: self
			selector: #exploreReceiverObject:
			argument: nodes first].

	^ menu! !

!TSdDynamicMenusForMethod methodsFor: 'dynamic - menus - support' stamp: 'mt 7/31/2011 17:38:35.275'!
exploreMenuForReturnNodes: nodeGroups
	
	| menu |
	menu := MenuMorph new defaultTarget: self.
	
	self collectReturnClassesByCallgraph: nodeGroups.
	nodeGroups do: [:nodes |
		menu
			add: ('{1} {2} [{3}>>{4}]' format: {
				nodes first returnClass.
				nodes first returnId.
				nodes first callgraph traceEvent testClass.
				nodes first callgraph traceEvent testSelector})
			target: self
			selector: #exploreReturnObject:
			argument: nodes first].

	^ menu! !

!TSdDynamicMenusForMethod methodsFor: 'dynamic - menus - support' stamp: 'mt 2/16/2012 11:41:52.812'!
implementorsMenuForMethodNodes: nodeGroups
	
	| menu implementors |
	Error signal: 'Implementation broken.'.
	
	menu := MenuMorph new defaultTarget: self.
	implementors := (nodeGroups gather: [:nodes | nodes gather: [:node |
		node children collect: [:childNode | childNode clientReference]]]) asSet asOrderedCollection sortBy: [:ref1 :ref2 |
			ref1 classSymbol < ref2 classSymbol or: [
				ref1 classSymbol = ref2 classSymbol and: [ref1 selector <= ref2 selector]]].
	
	implementors ifEmpty: [^ nil].
	
	implementors do: [:reference |
		menu
			add: ('{1}>>{2}' format: {reference classSymbol. reference selector})
			selector: #methodActivated:
			argument: reference].
		
	^ menu! !

!TSdDynamicMenusForMethod methodsFor: 'dynamic - menus' stamp: 'mt 7/31/2011 17:31:44.03'!
menuForArgument: argIndex method: aCompiledMethod
	
	| nodeGroups menu |
	menu := MenuMorph new.
	nodeGroups := self collectCoveringNodes: aCompiledMethod.

	menu
		add: 'Browse Class'
		icon: UiSilkIcons scriptCodeIcon
		subMenu: (self browseMenuForArgument: argIndex nodes: nodeGroups).

	menu
		add: 'Explore Object'
		icon: UiFugueIcons propertyIcon
		subMenu: (self exploreMenuForArgument: argIndex nodes: nodeGroups).		
			
	^ menu! !

!TSdDynamicMenusForMethod methodsFor: 'dynamic - menus' stamp: 'mt 7/31/2011 17:32:19.49'!
menuForMessage: aSymbol method: aCompiledMethod
	
	| nodeGroups menu implementors |
	menu := MenuMorph new defaultTarget: self.
	nodeGroups := self collectCoveringNodes: aCompiledMethod.

	implementors := (nodeGroups gather: [:nodes | nodes gather: [:node |
		node children
			select: [:childNode | childNode clientSelector = aSymbol]
			thenCollect: [:childNode | childNode clientReference]]]) asSet asOrderedCollection
			sortBy: [:ref1 :ref2 |
				ref1 classSymbol < ref2 classSymbol
					or: [ref1 classSymbol = ref2 classSymbol and: [ref1 selector <= ref2 selector]]].

	implementors do: [:reference |
		menu
			add: ('{1}>>{2}' format: {reference classSymbol. reference selector})
			selector: #methodActivated:
			argument: reference].

	^ menu! !

!TSdDynamicMenusForMethod methodsFor: 'dynamic - menus' stamp: 'mt 2/16/2012 11:42:01.32'!
menuForMethod: aCompiledMethod
	
	| nodeGroups menu |
	menu := MenuMorph new.
	nodeGroups := self collectCoveringNodes: aCompiledMethod.

	nodeGroups ifEmpty: [^ nil].

	menu
		add: 'Browse Class'
		icon: UiSilkIcons scriptCodeIcon
		subMenu: (self browseMenuForMethodNodes: nodeGroups).

	menu
		add: 'Explore Object'
		icon: UiFugueIcons propertyIcon
		subMenu: (self exploreMenuForMethodNodes: nodeGroups).		
		
	menu
		add: 'View Trace'
		icon: UiFugueIcons nodeSelectIcon
		subMenu: (self traceMenuForMethodNodes: nodeGroups).
	
	(self sendersMenuForMethodNodes: nodeGroups) ifNotNil: [:m |
		menu
			addLine;
			add: 'Senders'
			icon: UiFugueIcons arrowStepIcon
			subMenu: m].
		
	"(self implementorsMenuForMethodNodes: nodeGroups) ifNotNil: [:m |
		menu
			add: 'Implementors'
			icon: UiFugueIcons arrowStepOverIcon
			subMenu: m]."
		
	^ menu! !

!TSdDynamicMenusForMethod methodsFor: 'dynamic - menus - support' stamp: 'mt 2/16/2012 11:34:14.03'!
sendersMenuForMethodNodes: nodeGroups
	
	| menu senders |
	menu := MenuMorph new defaultTarget: self.
	senders := (nodeGroups gather: [:nodes | nodes
		select: [:node | node parent clientMethod isTestMethod not]
		thenCollect: [:node | node parent clientReference]]) asSet asOrderedCollection sortBy: [:ref1 :ref2 |
			ref1 classSymbol < ref2 classSymbol or: [
				ref1 classSymbol = ref2 classSymbol and: [ref1 selector <= ref2 selector]]].
	
	senders ifEmpty: [^ nil].
	
	senders do: [:reference |
		menu
			add: ('{1}>>{2}' format: {reference classSymbol. reference selector})
			selector: #methodActivated:
			argument: reference].
		
	^ menu! !

!TSdDynamicMenusForMethod methodsFor: 'dynamic - menus - support' stamp: 'mt 7/31/2011 17:39:25.439'!
traceMenuForMethodNodes: nodeGroups
	
	| menu |
	menu := MenuMorph new defaultTarget: self.
	
	"Choose only the first call node in a callgraph for each trace/test."
	nodeGroups do: [:nodes |
		menu
			add: ('{1}>>{2}' format: {
				nodes first callgraph traceEvent testClass.
				nodes first callgraph traceEvent testSelector})
			target: self
			selector: #traceActivated:
			argument: nodes first].	

	^ menu! !

Trait named: #TSdMemento
	uses: {}
	category: 'Sight-Dynamic-Traits'!

!TSdMemento methodsFor: 'memento - cleanup' stamp: 'mt 6/20/2012 10:53:56.52'!
aboutToClose

	self emit.! !

!TSdMemento methodsFor: 'memento - data' stamp: 'mt 6/20/2012 10:42:33.189'!
acceptChanges
	"After calling this method, #hasUnacceptedChanges should return false."! !

!TSdMemento methodsFor: 'memento - cleanup' stamp: 'mt 6/20/2012 11:02:13.39'!
clear
	"Reset the internal state."! !

!TSdMemento methodsFor: 'memento - cleanup' stamp: 'mt 6/20/2012 11:01:15.609'!
close

	self
		clear; "Own cleanup"
		aboutToClose; "Chance for dependent cleanup"
		delete; "Morphic - remove from world"
		closed. "Chance for dependent post-mortem cleanup"! !

!TSdMemento methodsFor: 'memento - cleanup' stamp: 'mt 6/20/2012 10:53:51.853'!
closed

	self emit.! !

!TSdMemento methodsFor: 'memento - data' stamp: 'mt 6/20/2012 10:43:22.118'!
hasUnacceptedChanges
	"Answer if myself or any direct dependents have any unaccepted changes."

	^ false! !

!TSdMemento methodsFor: 'memento - ui' stamp: 'mt 6/20/2012 11:21:17.985'!
loadState: anEditorState

! !

!TSdMemento methodsFor: 'memento - ui' stamp: 'mt 6/20/2012 11:21:20.885'!
saveState: anEditorState

	! !

!TSdMemento methodsFor: 'memento - cleanup' stamp: 'mt 6/21/2012 14:56:43.467'!
tryClear
	"Private. Use #tryClose instead."

	| msg |
	self hasUnacceptedChanges
		ifFalse: [self clear. ^ true].
		
	msg := SdOverlayMessageBox new
		title: 'Close editor';
		message: 'There are unaccepted changes.' icon: UiSilkIcons informationIcon.
	msg addAction: 'Accept all changes.' icon: UiSilkIcons diskMultipleIcon receiver: self selectors: #(acceptChanges tryClose).
	msg addAction: 'Ignore all changes.' icon: UiSilkIcons binIcon receiver: self selectors: #(clear tryClose).
	msg addAction: 'Abort this action.' icon: UiSilkIcons cancelIcon.
	
	msg showAbove: self.
	
	^ false! !

!TSdMemento methodsFor: 'memento - cleanup' stamp: 'mt 6/20/2012 11:01:47.437'!
tryClose
	"Weakened form of #close that considers unaccepted changes."
	
	self tryClear ifTrue: [
		self
			aboutToClose;
			delete;
			closed].! !

UiItemViewColumnSpec subclass: #SdItemViewButtonColumnSpec
	instanceVariableNames: 'root'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sight-Dynamic-UI-Support'!

!SdItemViewButtonColumnSpec methodsFor: 'building' stamp: 'mt 7/8/2012 19:49:43.59'!
itemFor: aNode

	| button |
	"container := Morph new color: Color transparent."
	button := (UiToolButton new
		buttonStyle: #iconOnly;
		icon: (aNode checkable
			ifTrue: [UiFugueIcons minusSmallIcon]
			ifFalse: [UiFugueIcons plusSmallIcon]);
		layoutInset: (0 @ -2 corner: 0 @ -1);
		fullBounds;
		yourself).
"	container addMorph: button.
	container submorphs first topLeft: container topLeft + (1@1).
	container bounds: (container topLeft corner: container submorphs first bottomRight).
"	

	aNode checkable
		ifTrue: [
			button setProperty: #selectable toValue: true.
			self connect: button signal: #clicked: to: self root selector: #removeStatement: pattern: {#=. aNode}]
		ifFalse: [
			button setProperty: #selectable toValue: false.
			self connect: button signal: #clicked: to: self root selector: #addStatement].

	^ button! !

!SdItemViewButtonColumnSpec methodsFor: 'accessing' stamp: 'mt 7/8/2012 19:32:57.456'!
root

	^ root! !

!SdItemViewButtonColumnSpec methodsFor: 'accessing' stamp: 'mt 7/8/2012 19:33:07.902'!
root: anObject

	root := anObject.! !

SystemWindow subclass: #SdSystemWindow
	instanceVariableNames: 'applicationBox'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sight-Dynamic'!

!SdSystemWindow commentStamp: 'mt 5/1/2011 11:13:55.168' prior: 0!
A system window with a different appearance.!

!SdSystemWindow class methodsFor: 'initializing' stamp: 'mt 5/9/2012 11:54:21.701'!
borderWidth

	^ 1! !

!SdSystemWindow class methodsFor: 'initializing' stamp: 'mt 5/1/2011 12:17:25.923'!
closeBoxImage

	^ UiFugueIcons crossButtonIcon! !

!SdSystemWindow class methodsFor: 'initializing' stamp: 'mt 5/1/2011 12:19:52.703'!
collapseBoxImage

	^ UiFugueIcons minusButtonIcon asGrayScale2! !

!SdSystemWindow class methodsFor: 'initializing' stamp: 'mt 5/1/2011 12:18:13.498'!
expandBoxImage

	^ UiFugueIcons plusButtonIcon asGrayScale2! !

!SdSystemWindow class methodsFor: 'instance creation' stamp: 'mt 5/1/2011 11:22:23.26'!
morph: aMorph label: aString
	"Like Morph>>#openInWindowLabeled:inWorld:."
	
	| window extent |

	window := (self labelled: aString) model: nil.
	window 
		" guess at initial extent"
		bounds: (RealEstateAgent
			initialFrameFor: window
			initialExtent: aMorph fullBounds extent
			world: ActiveWorld);
		addMorph: aMorph frame: (0@0 extent: 1@1);
		updatePaneColors.
	" calculate extent after adding in case any size related attributes were changed.  Use
	fullBounds in order to trigger re-layout of layout morphs"
	extent := aMorph fullBounds extent + 
			(window borderWidth@window labelHeight) + window borderWidth.
	window extent: extent.
	ActiveWorld addMorph: window.
	window activate.
	ActiveWorld startSteppingSubmorphsOf: window.
	
	^window
! !

!SdSystemWindow methodsFor: 'signals' stamp: 'mt 5/2/2011 16:12:35.236'!
aboutRequested

	self emitAlways.! !

!SdSystemWindow methodsFor: 'as yet unclassified' stamp: 'mt 5/1/2011 12:26:05.802'!
activateWindow

	super activateWindow.
	label color: Color white.
	self setStripeColorsFrom: self paneColorToUse.! !

!SdSystemWindow methodsFor: 'initialization' stamp: 'mt 5/1/2011 12:11:32.293'!
addApplicationBox
	
	labelArea ifNil: [^ self].

	applicationBox ifNotNil: [applicationBox delete].
	applicationBox := self createApplicationBox.
	labelArea addMorphBack: applicationBox! !

!SdSystemWindow methodsFor: 'initialization' stamp: 'mt 5/1/2011 12:14:15.052'!
addCloseBox
	"If I have a labelArea, add a close box to it"

	labelArea
		ifNil: [^ self].
	closeBox ifNotNil: [closeBox delete].
	closeBox := self createCloseBox.
	closeBox layoutFrame: self class closeBoxFrame.
	labelArea addMorphBack: closeBox! !

!SdSystemWindow methodsFor: 'label' stamp: 'mt 5/1/2011 11:42:59.639'!
addLabel

	(labelArea isNil or: [label isNil]) ifTrue: [^ self].

	labelArea addMorphBack: label.

	label on: #startDrag send: #startDragFromLabel: to: self.
	self class clickOnLabelToEdit
		ifTrue: [label on: #mouseUp send: #relabel to: self].
	self class doubleClickOnLabelToExpand
		ifTrue: [label on: #doubleClick send: #expandBoxHit to: self].! !

!SdSystemWindow methodsFor: 'initialization' stamp: 'mt 5/1/2011 11:38:13.541'!
addLabelArea

	labelArea ifNotNil: [labelArea abandon].
	
	labelArea := Morph new
		color: Color transparent;
		changeTableLayout;
		listDirection: #leftToRight;
		vResizing: #shrinkWrap;
		hResizing: #spaceFill.
		
	self addMorph: labelArea.    ! !

!SdSystemWindow methodsFor: 'initialization' stamp: 'mt 5/1/2011 11:43:36.498'!
addSpacer

	labelArea ifNil: [^ self].

	labelArea addMorphBack: (UiSpacer new height: 5).! !

!SdSystemWindow methodsFor: 'menu' stamp: 'mt 5/2/2011 16:14:12.012'!
buildWindowMenu
	| aMenu |
	aMenu := MenuMorph new defaultTarget: self.

	aMenu add: 'About...' action: #aboutRequested.
	aMenu addLine.

	self unexpandedFrame 
		ifNil: [aMenu add: 'Show full screen' translated action: #expandBoxHit]
		ifNotNil: [aMenu add: 'Show original size' translated action: #expandBoxHit].

	aMenu addLine.
	aMenu add: 'Close' action: #delete.

	^aMenu! !

!SdSystemWindow methodsFor: 'initialization' stamp: 'mt 5/2/2011 16:10:39.773'!
createAboutBox
	^ (self createBox: UiFugueIcons informationButtonIcon)
		actionSelector: #aboutRequested;
		setBalloonText: 'About' translated! !

!SdSystemWindow methodsFor: 'initialization' stamp: 'mt 5/1/2011 12:12:39.39'!
createApplicationBox
	^ (self createBox: UiFugueIcons lightningIcon)
		actionSelector: #offerApplicationMenu;
		setBalloonText: 'Application Menu' translated! !

!SdSystemWindow methodsFor: 'as yet unclassified' stamp: 'mt 5/1/2011 12:46:14.678'!
getRawLabel

	^ label! !

!SdSystemWindow methodsFor: 'initialization' stamp: 'mt 5/2/2011 16:11:30.637'!
initializeLabelArea

	"Initialize the label area (titlebar) for the window."
	label := UiLabel new text: ('<font color="#DDDDDD"><b>', labelString, '</b></font>') asHtmlText.
	label fullBounds.
	
	"Add collapse box so #labelHeight will work"
	collapseBox := self createCollapseBox.
	stripes := Array
				with: (RectangleMorph newBounds: bounds)
				with: (RectangleMorph newBounds: bounds).
	
	"see extent:"
	self addLabelArea.
	self setLabelWidgetAllowance.
	self addApplicationBox.
	self addLabel; addSpacer.
	
	labelArea addMorphBack: self createAboutBox.
	labelArea addMorphBack: collapseBox.
	self addExpandBox.
	self addCloseBox.
			
	self setFramesForLabelArea.! !

!SdSystemWindow methodsFor: 'label' stamp: 'mt 5/1/2011 12:05:24.445'!
labelHeight

	^ label height! !

!SdSystemWindow methodsFor: 'menu' stamp: 'mt 5/1/2011 12:12:31.329'!
offerApplicationMenu

	| aMenu |
	aMenu := self buildWindowMenu.
	model ifNotNil:
		[model addModelItemsToWindowMenu: aMenu].
	aMenu popUpEvent: self currentEvent in: self world! !

!SdSystemWindow methodsFor: 'panes' stamp: 'mt 7/1/2011 17:57:36.847'!
paneColorToUse

	^ Display depth <= 2
		ifTrue: [Color white]
		ifFalse:[self isActive
			ifTrue: [(Color gray: 0.3) alpha: 0.8]
			ifFalse: [(Color gray: 0.5) alpha: 0.5]]! !

!SdSystemWindow methodsFor: 'as yet unclassified' stamp: 'mt 5/1/2011 12:28:10.415'!
passivate

	super passivate.
	label color: (Color gray: 0.2).! !

SdSystemWindow subclass: #SdToolWindow
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sight-Dynamic'!

!SdToolWindow methodsFor: 'as yet unclassified' stamp: 'mt 5/3/2011 14:42:46.822'!
initializeLabelArea

	"Initialize the label area (titlebar) for the window."
	label := UiLabel new text: ('<font color="#DDDDDD"><b>', labelString, '</b></font>') asHtmlText.
	label fullBounds.
	
	"Add collapse box so #labelHeight will work"
	collapseBox := self createCollapseBox.
	stripes := Array
				with: (RectangleMorph newBounds: bounds)
				with: (RectangleMorph newBounds: bounds).
	
	"see extent:"
	self addLabelArea.
	self setLabelWidgetAllowance.
	self addLabel; addSpacer.
	
"	labelArea addMorphBack: self createAboutBox.
	labelArea addMorphBack: collapseBox.
	self addExpandBox.
"	self addCloseBox.
			
	self setFramesForLabelArea.! !

HelpTopic subclass: #SdHelpTopic
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sight-Dynamic-Help'!

!SdHelpTopic class methodsFor: 'instance creation' stamp: 'mt 7/31/2011 20:23:58.098'!
title: stringOrText icon: aForm contents: string

	^ super
		title: stringOrText
		icon: aForm
		contents: (string copyReplaceAll: '<tab>' with: String tab) asHtmlText
		! !

Object subclass: #SdBenchmark
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sight-Dynamic-Benchmarks'!

!SdBenchmark class methodsFor: 'as yet unclassified' stamp: 'abc 8/18/2011 19:41:38.481'!
all

	| results |
	results := OrderedCollection new.
	#(Monticello Seaside Magritte Pier) do: [:packageName |
		#(#coverageFor: #overheadForCoverage: #allTracesFor: #coveredTracesFor:) do: [:action |
			results add: (SdBenchmark perform: action with: packageName)]].
	
	^ results! !

!SdBenchmark class methodsFor: 'as yet unclassified' stamp: 'mt 1/31/2012 13:57:14.527'!
allTracesFor: packageName

	| nums |
	nums := OrderedCollection new.
	
	SCoverageCollector updateCoverageForPackage: packageName.
	
	(PackageInfo named: packageName) classes
		select: [:c | (c inheritsFrom: TestCase) and: [c isAbstract not]]
		thenDo: [:c |
			(c shouldInheritSelectors
				ifTrue: [c allTestSelectors]
				ifFalse: [c testSelectors]) do: [:s |
				nums add: [SdCallgraphTracer new traceTest: c method: s] timeToRunWithoutGC]].
		
	^ {
	nums size.
	nums min.
	nums max.
	nums average asFloat.
	nums sum.
	nums median}! !

!SdBenchmark class methodsFor: 'as yet unclassified' stamp: 'abc 8/20/2011 06:13:33.921'!
coverageFor: packageName

	| package nums methods nonTestMethods |
	package := PackageInfo named: packageName.
	
	"SdCoverageInstrumentor updateCoverageForPackage: packageName."
	
	nums := OrderedCollection new.

	package actualMethodsDo: [:method |
		nums add: method coveringTestMethods size].

	methods := package methods collect: [:m | m compiledMethod].
	nonTestMethods := (methods reject: [:m | m isTestMethod]).

	^ {
	nonTestMethods size.
	self numberOfTestsFor: packageName.
	nums average asFloat.
	(nums reject: [:i | i = 0]) size.
	(nums reject: [:i | i = 0]) average asFloat.
	(nums reject: [:i | i = 0]) median.
	(nums reject: [:i | i = 0]) size / nonTestMethods size asFloat.
	nums max}! !

!SdBenchmark class methodsFor: 'as yet unclassified' stamp: 'mt 1/31/2012 13:57:20.376'!
coveredTracesFor: packageName

	| package nums |
	package := PackageInfo named: packageName.
	nums := OrderedCollection new.
	
	SCoverageCollector updateCoverageForPackage: packageName.

	package actualMethodsDo: [:method |
		| runs |
		runs := OrderedCollection new.

		method coveringTestMethods do: [:testMethod |
			runs add: [SdCallgraphTracer new
				traceTest: testMethod methodClass
				method: testMethod selector] timeToRunWithoutGC].
		runs ifNotEmpty: [nums add: runs sum]].

	^ {
	nums max.
	nums average asFloat.
	nums median}! !

!SdBenchmark class methodsFor: 'as yet unclassified' stamp: 'abc 8/19/2011 09:20:56.622'!
methodsToTestsFor: packageName

	| packageInfo result cm |
	packageInfo := PackageInfo named: packageName.
	result := OrderedCollection new.
	cm := (packageInfo methods
		select: [:m | m compiledMethod coveringTestMethods size > 20]
		thenCollect: [:m | m compiledMethod]).

	Transcript cr; show: cm size.
	
	cm do: [:method1 | cm do: [:method2 |
		method1 ~~ method2 ifTrue: [
		result add: (method1 coveringTestMethods, method2 coveringTestMethods) size
			]]].
	
	^ {
	result size.
	result average asFloat.
	result max.
	result min.
	result median}! !

!SdBenchmark class methodsFor: 'as yet unclassified' stamp: 'abc 8/18/2011 18:32:02.839'!
numberOfTestsFor: packageName

	| selectors |
	selectors := OrderedCollection new.

	(PackageInfo named: packageName) classes
		select:[:c | (c inheritsFrom: TestCase) and: [c isAbstract not]]
		thenDo: [:c | c shouldInheritSelectors
			ifTrue: [selectors addAll: c allTestSelectors]
			ifFalse: [selectors addAll: c testSelectors]].
		
	^ selectors size! !

!SdBenchmark class methodsFor: 'as yet unclassified' stamp: 'mt 1/31/2012 13:57:08.605'!
overheadForCoverage: packageName

	| suite testCases r1 r2 |
	testCases := (PackageInfo named: packageName) classes select: [:c |
		(c inheritsFrom: TestCase) and: [c isAbstract not]].
		
	r1 := [suite := TestSuite new.		
		testCases do: [:c | c addToSuiteFromSelectors: suite].
		suite run] timeToRunWithoutGC.
	
	r2 := [SCoverageCollector updateCoverageForPackage: packageName] timeToRunWithoutGC.
	
	^ {r1. r2}! !

Object subclass: #SdCallgraphModel
	uses: TUiItemModel + TSdDynamicAccessor
	instanceVariableNames: 'node checked'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sight-Dynamic-Models'!

!SdCallgraphModel commentStamp: 'mt 3/23/2011 14:44:06.545' prior: 0!
| cgt tree |
cgt := SdCallgraphTracer new.
cgt profilingMode: #ms.
cgt selectedCategories: (PackageInfo named: #Widgets) systemCategories.
cgt callgraphModel: SdCallgraph new.
cgt traceSourceCode: 'UiTextEdit new'.
tree := UiTreeView new model: (SdCallgraphModel new root: cgt callgraphModel).
tree openInWorld.!

SdCallgraphModel class
	uses: TUiItemModel classTrait + TSdDynamicAccessor classTrait
	instanceVariableNames: ''!

!SdCallgraphModel methodsFor: 'comparing' stamp: 'mt 2/16/2012 15:34:59.999'!
= anObject

	^ self species = anObject species
		and: [self node == anObject node]! !

!SdCallgraphModel methodsFor: 'menus' stamp: 'mt 7/23/2011 10:48:23.245'!
browseMenuFor: node
	
	| menu |
	menu := MenuMorph new defaultTarget: self.

	menu
		add: 'Method Source'
		selector: #browseMethod:
		argument: node;
		addLine;
		add: ('Receiver Class [{1}]' format: {node receiverClass})
		selector: #browseReceiverClass:
		argument: node;
		add: ('Result Class [{1}]' format: {node returnClass})
		selector: #browseReturnClass:
		argument: node;
		addLine.
		
	node argumentNames withIndexDo: [:argName :idx |
		menu
		add: ('Class of ''{1}'' [{2}]' format: {
			argName.
			node argumentClasses ifNotNil: [:classes | classes at: idx]})
		target: self
		selector: #browseArgumentClass:index:
		argumentList: {node.idx}].


	^ menu! !

!SdCallgraphModel methodsFor: 'accessing' stamp: 'mt 5/2/2012 10:48:41.732'!
calls

	^ self node
		ifNil: [#()]
		ifNotNil: [:n | n children]! !

!SdCallgraphModel methodsFor: 'accessing' stamp: 'mt 2/16/2012 15:48:57.445'!
checked

	^ checked ifNil: [false]! !

!SdCallgraphModel methodsFor: 'accessing' stamp: 'mt 2/16/2012 16:52:07.34'!
checked: aBoolean

	aBoolean = checked ifTrue: [^ self].
	checked := aBoolean.
	
	self propertyChanged: #status.! !

!SdCallgraphModel methodsFor: 'item model - hierarchy' stamp: 'mt 5/2/2012 10:49:02.65'!
childAt: index inGroup: groupName
	"groupName == #calls"
	
	^ SdCallgraphModel new
		node: ((self perform: groupName) at: index)! !

!SdCallgraphModel methodsFor: 'dynamic - signals - activation' stamp: 'mt 2/16/2012 15:20:24.59'!
classActivated: aClass

	self emit.! !

!SdCallgraphModel methodsFor: 'properties' stamp: 'mt 5/16/2012 09:10:10.317'!
duration

	^ self node valueOfProperty: #duration! !

!SdCallgraphModel methodsFor: 'menus' stamp: 'mt 7/23/2011 10:48:19.357'!
exploreMenuFor: node
	
	| menu |
	menu := MenuMorph new defaultTarget: self.

	menu
		add: ('Receiver [{1} {2}]' format: {node receiverClass. node receiverId})
		selector: #exploreReceiverObject:
		argument: node;
		add: ('Result [{1} {2}]' format: {node returnClass. node returnId})
		selector: #exploreReturnObject:
		argument: node;
		addLine.
		
	node argumentNames withIndexDo: [:argName :idx |
		menu
		add: ('{1} [{2} {3}]' format: {
			argName.
			node argumentClasses ifNotNil: [:classes | classes at: idx].
			node argumentIds ifNotNil: [:ids | ids at: idx]})
		target: self
		selector: #exploreArgumentObject:index:
		argumentList: {node.idx}].


	^ menu! !

!SdCallgraphModel methodsFor: 'item model - hierarchy' stamp: 'mt 5/2/2012 10:39:34.189'!
groups
	
	^ #(calls)! !

!SdCallgraphModel methodsFor: 'comparing' stamp: 'mt 2/16/2012 15:36:49.772'!
hash

	^ self species hash bitXor: [self node scaledIdentityHash]! !

!SdCallgraphModel methodsFor: 'properties' stamp: 'mt 3/29/2012 16:25:33.089'!
label

	self node isInstantiation ifTrue: [
		^ ('<font color="#{2}">Instantiate <b>{1}</b></font>' format: {
			self node clientClass theNonMetaClass.
			(self node clientClass theNonMetaClass inheritsFrom: TestCase)
				ifTrue: ['AAAAAA']
				ifFalse: ['008000']}) asHtmlText].
			
	self node clientMethod isTestMethod ifTrue: [
		^ ('<font color="#AAAAAA">Run <b>{1}</b></font>' format: {
			self node clientSelector}) asHtmlText].
			
	^ self node receiverClass = self node clientClass
		ifTrue: [('{1} \\>\\> <b>{2}</b>' format: {
			self node receiverClass.
			self node clientSelector}) asHtmlText]
		ifFalse: [	('{1} <i>({2})</i> \\>\\> <b>{3}</b>' format: {
			self node receiverClass.
			self node clientClass.
			self node clientSelector}) asHtmlText].! !

!SdCallgraphModel methodsFor: 'menus' stamp: 'mt 2/16/2012 15:10:43.245'!
menu
	
	| menu |
	menu := MenuMorph new.

	menu
		add: 'Browse Code'
		icon: UiSilkIcons scriptCodeIcon
		"help: 'May require additional tracing which may cause a small delay. Be patient.'"
		subMenu: (self browseMenuFor: self node).

	menu
		add: 'Explore Object'
		icon: UiFugueIcons propertyIcon
		"help: 'May require additional tracing which may cause a small delay. Be patient.'"
		subMenu: (self exploreMenuFor: self node).

	self node clientMethod isTestMethod ifFalse: [
		menu
			add: 'View Trace'
			icon: UiFugueIcons nodeSelectIcon
			help: 'Open another trace that passes this method.'
			subMenu: (self traceMenuFor: self node)].
				
	^ menu! !

!SdCallgraphModel methodsFor: 'dynamic - signals - activation' stamp: 'mt 2/16/2012 15:20:20.984'!
methodActivated: aMethodReference

	self emit.! !

!SdCallgraphModel methodsFor: 'accessing' stamp: 'mt 2/15/2012 21:09:02.383'!
node

	^ node! !

!SdCallgraphModel methodsFor: 'accessing' stamp: 'mt 2/15/2012 21:08:55.344'!
node: aCallgraphNode

	node := aCallgraphNode.! !

!SdCallgraphModel methodsFor: 'dynamic - signals - activation' stamp: 'mt 2/16/2012 15:20:17.057'!
objectActivated: anObject

	self emit.! !

!SdCallgraphModel methodsFor: 'properties' stamp: 'mt 2/16/2012 15:18:00.776'!
receiverIcon
	"Return an iconc representation of the receiver."
	
	^ (self node clientClass inheritsFrom: Morph)
		ifTrue: [self node clientClass widgetClassIcon]
		ifFalse: []

	! !

!SdCallgraphModel methodsFor: 'properties' stamp: 'mt 2/16/2012 15:51:58.737'!
status
	"Used to compute status icons. See SdCallGraphEditor>>initializeTree for more information."

	self flag: #weird.
	^ self node! !

!SdCallgraphModel methodsFor: 'dynamic - signals - activation' stamp: 'mt 7/26/2011 16:48:01.291'!
traceActivated: aNode

	self emitAlways.! !

!SdCallgraphModel methodsFor: 'menus' stamp: 'mt 2/16/2012 15:12:15.849'!
traceMenuFor: node
	
	| menu |
	menu := MenuMorph new defaultTarget: self.

	(self collectCoveringNodes: node clientMethod)
		"Only choose callgraphs that are different to me."
		reject: [:nodes | nodes first callgraph traceEvent = self node callgraph traceEvent]
		thenDo: [:nodes | menu
			add: ('{1}>>{2}' format: {
				nodes first callgraph traceEvent testClass.
				nodes first callgraph traceEvent testSelector})
			selector: #traceActivated:
			argument: nodes first].
		
	MenuMorph new hasItems ifFalse: [
		^ nil].

	^ menu! !

Object subclass: #SdCallgraphNodeWrapper
	instanceVariableNames: 'node'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sight-Dynamic-Models'!

!SdCallgraphNodeWrapper class methodsFor: 'instance creation' stamp: 'mt 3/29/2012 16:05:07.228'!
node: aNode

	^ self new node: aNode! !

!SdCallgraphNodeWrapper methodsFor: 'exploring' stamp: 'mt 3/29/2012 16:46:30.507'!
asExplorerString

	^ '<font color="#AAAAAA">a ', self node class name, '</font>'! !

!SdCallgraphNodeWrapper methodsFor: 'exploring' stamp: 'mt 3/29/2012 16:04:50.62'!
explorerContents

	^ (self node class allInstVarNames asOrderedCollection withIndexCollect: [:each :index |
		ObjectExplorerWrapper
			with: (self node instVarAt: index)
			name: each
			model: self node]) ,
	((1 to: self node basicSize) collect: [:index |
		ObjectExplorerWrapper
			with: (self node basicAt: index)
			name: index printString
			model: self node])! !

!SdCallgraphNodeWrapper methodsFor: 'exploring' stamp: 'mt 3/29/2012 16:14:15.969'!
hasContentsInExplorer

	^ true! !

!SdCallgraphNodeWrapper methodsFor: 'accessing' stamp: 'mt 3/29/2012 15:58:00.091'!
node

	^ node! !

!SdCallgraphNodeWrapper methodsFor: 'accessing' stamp: 'mt 3/29/2012 15:58:07.238'!
node: aNode

	node := aNode.! !

Object subclass: #SdCodeNode
	uses: TUiItemModel
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sight-Dynamic-Models-Code'!

SdCodeNode class
	uses: TUiItemModel classTrait
	instanceVariableNames: ''!

SdCodeNode subclass: #SdClassNode
	instanceVariableNames: 'theClass namespace'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sight-Dynamic-Models-Code'!

!SdClassNode class methodsFor: 'custom protocols' stamp: 'mt 2/12/2012 17:38:14.738'!
customProtocolChildAt: index for: aProtocolNode
	
	"--- all ---"
	^ SdMethodNode new
		method: (aProtocolNode theClass methodDict values,
			aProtocolNode theClass theMetaClass methodDict values
			at: index).! !

!SdClassNode methodsFor: 'comparing' stamp: 'mt 2/14/2012 17:35:24.743'!
= anObject

	^ super = anObject
		and: [self theClass == anObject theClass]! !

!SdClassNode methodsFor: 'item model - hierarchy' stamp: 'mt 5/2/2012 11:10:33.731'!
childAt: index inGroup: groupName

	^ (groupName == #customProtocols
		ifTrue: [SdCustomProtocolNode]
		ifFalse: [SdProtocolNode]) new
			theClass: self theClass;
			protocol: ((self perform: groupName) at: index)! !

!SdClassNode methodsFor: 'properties' stamp: 'mt 5/2/2012 11:09:45.117'!
customProtocols

	^ SdCustomProtocolNode knownProtocols! !

!SdClassNode methodsFor: 'properties' stamp: 'mt 2/12/2012 17:03:03.067'!
groupedClassLabel
	"E.g., 'Sd Class Node' plus formatting."
	
	| label cname |
	label := ''.
	(self theClass name startsWith: self namespace)
		ifTrue: [
			label := '<font color="#AAAAAA">', self namespace, '</color>'.
			cname := self theClass name allButFirst: self namespace size]
		ifFalse: [cname := self theClass name].
		
	'[[:upper:]][[:lower:]]*[[:digit:]]*' asRegex matchesIn: cname do: [:token |
		token = self namespace
			ifTrue: [label := label, '<font color="#AAAAAA">', self namespace, '</color>']
			ifFalse: [label := label, String space, token]].
		
	^ label withBlanksTrimmed asHtmlText! !

!SdClassNode methodsFor: 'item model - hierarchy' stamp: 'mt 5/2/2012 10:52:08.582'!
groups

	^ #(customProtocols protocols)! !

!SdClassNode methodsFor: 'comparing' stamp: 'mt 2/14/2012 17:35:36.154'!
hash

	^ super hash bitXor: [self theClass hash]! !

!SdClassNode methodsFor: 'properties' stamp: 'mt 2/12/2012 17:03:53.866'!
icon

	^ SdMethodFinder iconForClass: self theClass! !

!SdClassNode methodsFor: 'testing' stamp: 'mt 2/14/2012 17:08:41.886'!
isClassNode

	^ true! !

!SdClassNode methodsFor: 'accessing' stamp: 'mt 2/12/2012 17:01:23.457'!
namespace
	^ namespace! !

!SdClassNode methodsFor: 'accessing' stamp: 'mt 2/12/2012 17:01:23.49'!
namespace: anObject
	namespace := anObject! !

!SdClassNode methodsFor: 'item model - properties' stamp: 'mt 2/12/2012 16:43:54.498'!
properties
	
	^ #(groupedClassLabel)! !

!SdClassNode methodsFor: 'properties' stamp: 'mt 5/2/2012 10:52:43.439'!
protocols

	^ (self theClass organization categories,
		self theClass theMetaClass organization categories
			reject: [:label | label = 'no messages']) asSet asArray! !

!SdClassNode methodsFor: 'accessing' stamp: 'mt 2/12/2012 16:37:35.01'!
theClass
	^ theClass! !

!SdClassNode methodsFor: 'accessing' stamp: 'mt 2/12/2012 16:37:35.043'!
theClass: anObject
	theClass := anObject! !

!SdCodeNode methodsFor: 'comparing' stamp: 'mt 2/14/2012 17:34:26.319'!
= anObject

	^ self species == anObject species! !

!SdCodeNode methodsFor: 'comparing' stamp: 'mt 2/14/2012 17:34:39.123'!
hash

	^ self species hash! !

!SdCodeNode methodsFor: 'testing' stamp: 'mt 2/14/2012 17:08:16.083'!
isClassNode

	^ false! !

!SdCodeNode methodsFor: 'testing' stamp: 'mt 2/14/2012 17:08:19.878'!
isMethodNode

	^ false! !

!SdCodeNode methodsFor: 'testing' stamp: 'mt 2/14/2012 17:08:23.065'!
isProtocolNode

	^ false! !

!SdCodeNode methodsFor: 'testing' stamp: 'mt 2/14/2012 17:08:30.145'!
isSystemCategoryNode

	^ false! !

SdCodeNode subclass: #SdMethodNode
	uses: TSdDynamicAccessor + TSdDynamicMenusForMethod
	instanceVariableNames: 'method'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sight-Dynamic-Models-Code'!

SdMethodNode class
	uses: TSdDynamicAccessor classTrait + TSdDynamicMenusForMethod classTrait
	instanceVariableNames: ''!

!SdMethodNode methodsFor: 'comparing' stamp: 'mt 2/14/2012 17:38:45.48'!
= anObject

	^ super = anObject
		and: [self method == anObject method]! !

!SdMethodNode methodsFor: 'properties' stamp: 'mt 2/14/2012 16:26:49.056'!
author

	| tokens |
	tokens := self timeStamp findTokens: ' '.
	^ tokens
		ifEmpty: [' ']
		ifNotEmpty: [tokens first]! !

!SdMethodNode methodsFor: 'properties' stamp: 'mt 2/12/2012 17:54:22.325'!
formattedAuthor

	^ ('<font color="#AAAAAA">', self author, '</font>') asHtmlText! !

!SdMethodNode methodsFor: 'properties' stamp: 'mt 2/12/2012 18:01:04.905'!
formattedCoverage
	
	| numberOfTests |
	self method isTestMethod
		ifTrue: [^ nil].
		
	numberOfTests := self tests size.
	
	^ numberOfTests > 0
		ifTrue: [('<font color="#AAAAAA">', numberOfTests, '</font>') asHtmlText]
		ifFalse: [('<font color="#FF0000">0</font>') asHtmlText]! !

!SdMethodNode methodsFor: 'properties' stamp: 'mt 2/12/2012 17:50:16.214'!
formattedSelector

	^ self isMeta
		ifTrue: [^ ('<u>', self selector, '</u>') asHtmlText]
		ifFalse: [^ self selector]! !

!SdMethodNode methodsFor: 'properties' stamp: 'mt 2/14/2012 16:49:34.129'!
formattedTimeStamp

	^ ('<font color="#AAAAAA">', (
		[self relativeTimeStampFor: (TimeStamp fromMethodTimeStamp: self timeStamp)]
			on: Error
			do: [' ']), '</font>') asHtmlText! !

!SdMethodNode methodsFor: 'comparing' stamp: 'mt 2/14/2012 17:37:03.671'!
hash

	^ super hash bitXor: [self method hash]! !

!SdMethodNode methodsFor: 'properties' stamp: 'mt 2/12/2012 18:07:36.974'!
icon

	^ SdMethodFinder
		iconForClass: self theClass
		selector: self selector! !

!SdMethodNode methodsFor: 'properties' stamp: 'mt 2/12/2012 17:20:32.274'!
isMeta

	^ self method methodClass isMeta! !

!SdMethodNode methodsFor: 'testing' stamp: 'mt 2/14/2012 17:08:52.355'!
isMethodNode

	^ true! !

!SdMethodNode methodsFor: 'properties' stamp: 'mt 3/22/2012 11:18:47.932'!
menu

	| menu |
	self method isTestMethod ifTrue: [^ nil].
	
	menu := (self menuForMethod: self method)
		ifNotNil: [:m | m addMorphFront: MenuLineMorph new; yourself]
		ifNil: [MenuMorph new].
	
	(self method methodClass isMeta and:[self method numArgs == 0]) ifTrue: [
		
		menu 
		addMorphFront: (MenuItemMorph new
			contents: ('Do It: "{1} {2}"' format: {self theClass theNonMetaClass name. self selector});
			target: self;
			selector: #doIt:;
			arguments: {self method})].
	
	menu 
		addMorphFront: (MenuItemMorph new
			contents: 'Open Method Source';
			target: self;
			selector: #methodActivated:;
			arguments: {self method methodReference}).

	^ menu! !

!SdMethodNode methodsFor: 'dynamic - menus' stamp: 'mt 3/22/2012 11:03:37.907'!
menuForMethod: aCompiledMethod
	
	| nodeGroups menu |
	menu := MenuMorph new.
	[nodeGroups := self collectCoveringNodes: aCompiledMethod]
		on: Error
		do: [^ nil].

	nodeGroups ifEmpty: [^ nil].

	menu
		add: 'Browse Class'
		icon: UiSilkIcons scriptCodeIcon
		subMenu: (self browseMenuForMethodNodes: nodeGroups).

	menu
		add: 'Explore Object'
		icon: UiFugueIcons propertyIcon
		subMenu: (self exploreMenuForMethodNodes: nodeGroups).		
		
	menu
		add: 'View Trace'
		icon: UiFugueIcons nodeSelectIcon
		subMenu: (self traceMenuForMethodNodes: nodeGroups).
	
	(self sendersMenuForMethodNodes: nodeGroups) ifNotNil: [:m |
		menu
			addLine;
			add: 'Senders'
			icon: UiFugueIcons arrowStepIcon
			subMenu: m].
		
	"(self implementorsMenuForMethodNodes: nodeGroups) ifNotNil: [:m |
		menu
			add: 'Implementors'
			icon: UiFugueIcons arrowStepOverIcon
			subMenu: m]."
		
	^ menu! !

!SdMethodNode methodsFor: 'accessing' stamp: 'mt 2/12/2012 17:16:46.5'!
method
	^ method! !

!SdMethodNode methodsFor: 'accessing' stamp: 'mt 2/12/2012 17:16:46.532'!
method: anObject
	method := anObject! !

!SdMethodNode methodsFor: 'item model - properties' stamp: 'mt 2/12/2012 18:01:59.946'!
properties
	
	^#(formattedSelector formattedCoverage formattedAuthor formattedTimeStamp)! !

!SdMethodNode methodsFor: 'support' stamp: 'mt 2/12/2012 17:53:29.315'!
relativeTimeStampFor: aTimeStamp
	"Convert the given time stamp into a formatted string."

	| dateString timeString |
	aTimeStamp date = Date today ifTrue: [dateString := 'Today'].
	aTimeStamp date = Date yesterday ifTrue: [dateString := 'Yesterday'].
	dateString ifNil: [dateString := aTimeStamp date printFormat: #(1 2 3 $- 1 1 2)].
	
	timeString := String streamContents:
		[ :aStream | aTimeStamp time print24: true showSeconds: false on: aStream ].
	
	^ dateString, ' ', timeString! !

!SdMethodNode methodsFor: 'properties' stamp: 'mt 2/12/2012 17:50:22.845'!
selector

	^ self method selector! !

!SdMethodNode methodsFor: 'properties' stamp: 'mt 2/12/2012 18:26:55.107'!
tests
	"Coverage information. See Sight-Coverage package."
	
	^ self method isTestMethod
		ifTrue: [#()]
		ifFalse: [self method hasMethodExtension
			ifTrue: [self method methodExtension tests]
			ifFalse: [#()]]! !

!SdMethodNode methodsFor: 'properties' stamp: 'mt 2/12/2012 17:50:31.587'!
theClass

	^ self method methodClass! !

!SdMethodNode methodsFor: 'properties' stamp: 'mt 2/12/2012 17:51:37.701'!
timeStamp

	^ self method timeStamp! !

SdCodeNode subclass: #SdProtocolNode
	instanceVariableNames: 'theClass protocol'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sight-Dynamic-Models-Code'!

SdProtocolNode subclass: #SdCustomProtocolNode
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sight-Dynamic-Models-Code'!

!SdCustomProtocolNode class methodsFor: 'protocols' stamp: 'mt 5/2/2012 11:08:57.129'!
knownProtocols

	^ #('--- all ---')! !

!SdCustomProtocolNode methodsFor: 'item model - hierarchy' stamp: 'mt 5/2/2012 11:12:13.31'!
childAt: index inGroup: groupName
	
	"--- all ---"
	^ SdMethodNode new
		method: (self theClass methodDict values,
			self theClass theMetaClass methodDict values
			at: index).! !

!SdCustomProtocolNode methodsFor: 'properties' stamp: 'mt 5/2/2012 11:14:25.905'!
formattedLabel

	^ ('<i>', self protocol, '</i>') asHtmlText! !

!SdCustomProtocolNode methodsFor: 'properties' stamp: 'mt 5/2/2012 11:14:03.012'!
icon

	^ UiSilkIcons tagBlueIcon! !

!SdCustomProtocolNode methodsFor: 'item model - properties' stamp: 'mt 5/2/2012 11:15:06.953'!
properties

	^ #(formattedLabel)! !

!SdCustomProtocolNode methodsFor: 'accessing' stamp: 'mt 5/2/2012 11:07:50.283'!
selectors

	self protocol = '--- all ---'
		ifTrue: [^ self theClass selectors, self theClass theMetaClass selectors].
		
	^ #()! !

!SdProtocolNode methodsFor: 'comparing' stamp: 'mt 2/14/2012 17:37:55.592'!
= anObject

	^ super = anObject
		and: [self theClass = anObject theClass]
		and: [self protocol = anObject protocol]! !

!SdProtocolNode methodsFor: 'item model - hierarchy' stamp: 'mt 5/2/2012 11:13:18.368'!
childAt: index inGroup: groupName

	| instanceSideSelectors |		
	instanceSideSelectors := self organization listAtCategoryNamed: protocol.

	^ SdMethodNode new method: 
		(index > instanceSideSelectors size
			ifFalse: [self theClass >> (instanceSideSelectors at: index)]
			ifTrue: [
				| classSideSelectors |
				classSideSelectors := self metaOrganization listAtCategoryNamed: protocol.
				self theClass theMetaClass >> (classSideSelectors at: index - instanceSideSelectors size)]).
! !

!SdProtocolNode methodsFor: 'item model - hierarchy' stamp: 'mt 5/2/2012 11:07:09.178'!
groups

	^ #(selectors)! !

!SdProtocolNode methodsFor: 'comparing' stamp: 'mt 2/14/2012 17:38:22.804'!
hash

	^ [super hash
		bitXor: [self theClass hash]]
		bitXor: [self protocol hash]! !

!SdProtocolNode methodsFor: 'properties' stamp: 'mt 5/2/2012 11:14:14.601'!
icon

	^ UiSilkIcons tagOrangeIcon! !

!SdProtocolNode methodsFor: 'testing' stamp: 'mt 2/14/2012 17:09:07.423'!
isProtocolNode

	^ true! !

!SdProtocolNode methodsFor: 'accessing' stamp: 'mt 2/12/2012 17:28:13.384'!
metaOrganization

	^ self theClass theMetaClass organization! !

!SdProtocolNode methodsFor: 'accessing' stamp: 'mt 2/12/2012 17:28:23.188'!
organization

	^ self theClass organization! !

!SdProtocolNode methodsFor: 'item model - properties' stamp: 'mt 5/2/2012 11:14:53.126'!
properties
	
	^ #(protocol)! !

!SdProtocolNode methodsFor: 'accessing' stamp: 'mt 2/12/2012 17:11:45.029'!
protocol
	^ protocol! !

!SdProtocolNode methodsFor: 'accessing' stamp: 'mt 2/12/2012 17:11:45.047'!
protocol: anObject
	protocol := anObject! !

!SdProtocolNode methodsFor: 'accessing' stamp: 'mt 5/2/2012 11:06:56.899'!
selectors

	^ (self organization listAtCategoryNamed: self protocol),
		(self metaOrganization listAtCategoryNamed: self protocol)! !

!SdProtocolNode methodsFor: 'accessing' stamp: 'mt 2/12/2012 17:28:38.857'!
theClass
	^ theClass! !

!SdProtocolNode methodsFor: 'accessing' stamp: 'mt 2/12/2012 17:28:38.888'!
theClass: anObject
	theClass := anObject! !

SdCodeNode subclass: #SdSystemCategoryNode
	instanceVariableNames: 'category prefix'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sight-Dynamic-Models-Code'!

!SdSystemCategoryNode methodsFor: 'comparing' stamp: 'mt 2/14/2012 17:49:36.705'!
= anObject

	^ super = anObject
		and: [self category = anObject category]! !

!SdSystemCategoryNode methodsFor: 'accessing' stamp: 'mt 2/12/2012 16:01:33.354'!
category
	^ category! !

!SdSystemCategoryNode methodsFor: 'accessing' stamp: 'mt 2/12/2012 16:01:33.387'!
category: anObject
	category := anObject! !

!SdSystemCategoryNode methodsFor: 'properties' stamp: 'mt 2/12/2012 16:17:23.623'!
categoryShortened

	^ self category = self prefix
		ifTrue: [self category]
		ifFalse: [self category allButFirst: self prefix size + 1]! !

!SdSystemCategoryNode methodsFor: 'item model - hierarchy' stamp: 'mt 5/2/2012 10:56:42.166'!
childAt: index inGroup: groupName
	"groupName == #classes"

	^ SdClassNode new
		theClass: (Smalltalk at: (self classes at: index));
		namespace: (SdPackageModel namespaceForCategory: self category)! !

!SdSystemCategoryNode methodsFor: 'properties' stamp: 'mt 2/12/2012 16:39:40.692'!
classes

	^ SystemOrganization listAtCategoryNamed: self category! !

!SdSystemCategoryNode methodsFor: 'item model - hierarchy' stamp: 'mt 5/2/2012 10:56:16.895'!
groups

	^ #(classes)! !

!SdSystemCategoryNode methodsFor: 'comparing' stamp: 'mt 2/14/2012 17:52:08.89'!
hash

	^ super hash bitXor: [self category hash]! !

!SdSystemCategoryNode methodsFor: 'properties' stamp: 'mt 2/12/2012 16:19:08.971'!
icon

	(self category matchesRegexIgnoringCase: '.*(test).*')
		ifTrue: [^ UiSilkIcons folderLightbulbIcon].
		
	(self category matchesRegexIgnoringCase: '.*(core|kernel).*')
		ifTrue: [^ UiSilkIcons folderWrenchIcon].
		
	(self category matchesRegexIgnoringCase: '.*(model).*')
		ifTrue: [^ UiSilkIcons folderLinkIcon].
		
	^ UiSilkIcons folderIcon! !

!SdSystemCategoryNode methodsFor: 'testing' stamp: 'mt 2/14/2012 17:09:16.21'!
isSystemCategoryNode

	^ true! !

!SdSystemCategoryNode methodsFor: 'accessing' stamp: 'mt 2/12/2012 16:01:33.409'!
prefix
	^ prefix! !

!SdSystemCategoryNode methodsFor: 'accessing' stamp: 'mt 2/12/2012 16:01:33.426'!
prefix: anObject
	prefix := anObject! !

!SdSystemCategoryNode methodsFor: 'item model - properties' stamp: 'mt 2/12/2012 16:19:45.613'!
properties
	
	^ #(categoryShortened)! !

Object subclass: #SdEditorState
	instanceVariableNames: 'properties'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sight-Dynamic'!

!SdEditorState methodsFor: 'accessing' stamp: 'mt 7/4/2011 15:45:36.932'!
addState: anEditorState

	^ (self properties at: #children ifAbsentPut: [OrderedCollection new])
		add: anEditorState! !

!SdEditorState methodsFor: 'loading - editors' stamp: 'mt 6/20/2012 11:48:39.142'!
loadCallgraphEditor: anEditor

	anEditor lastTraceItEvent: (self properties at: #lastTraceItEvent).! !

!SdEditorState methodsFor: 'loading - editors' stamp: 'mt 6/15/2012 14:18:11.104'!
loadClassEditor: anEditor

	anEditor theClass: (self properties at: #theClass).
	
	anEditor closeAll.

	anEditor ui findBtn checked: (self properties at: #isFinderActive).
	anEditor ui commentBtn checked: (self properties at: #isCommentVisible).
	anEditor ui definitionBtn checked: (self properties at: #isDefinitionVisible).

	anEditor openMethods: (self properties at: #openMethods).
	anEditor methodEditors withIndexDo: [:me :index |
		((self properties at: #methodEditorsExpanded) at: index)
			ifTrue: [me expand]
			ifFalse: [me collapse]].! !

!SdEditorState methodsFor: 'loading - general' stamp: 'mt 7/4/2011 18:29:52.6'!
loadColumn: aColumn

	aColumn width: (self properties at: #width).
	(self properties at: #editorClasses) withIndexDo: [:editorClass :index |
		| editor |
		editor := editorClass new vResizing: #spaceFill.
		aColumn addMorphBack: editor.
		editor loadState: (self states at: index)].! !

!SdEditorState methodsFor: 'loading - general' stamp: 'mt 7/4/2011 18:28:14.683'!
loadEditor: anEditor

	(self properties at: #isExpanded)
		ifTrue: [anEditor expand]
		ifFalse: [anEditor collapse].! !

!SdEditorState methodsFor: 'loading - general' stamp: 'mt 7/4/2011 18:15:42.415'!
loadIDE: anIDE

	(self properties at: #fixedColumns) do: [:state |
		(anIDE addColumnIn: anIDE inFrontOf: anIDE scrollArea)
			loadState: state].
		
	(self properties at: #scrollableClumns) do: [:state |
		(anIDE addColumnIn: anIDE scrollArea widget inFrontOf: anIDE border)
			loadState: state].
		
	anIDE scrollArea horizontalScrollBar currentValue:
		(self properties at: #scrollOffset).! !

!SdEditorState methodsFor: 'loading - editors' stamp: 'mt 7/4/2011 18:07:09.435'!
loadObjectExplorer: anEditor

	anEditor object: (self properties at: #object).! !

!SdEditorState methodsFor: 'loading - editors' stamp: 'mt 7/4/2011 18:07:41.582'!
loadObjectInspector: anEditor! !

!SdEditorState methodsFor: 'loading - editors' stamp: 'mt 7/4/2011 18:09:13.704'!
loadPackageViewer: anEditor

	anEditor packageName: (self properties at: #packageName).
	anEditor ui treeView currentIndex: (self properties at: #index).! !

!SdEditorState methodsFor: 'loading - editors' stamp: 'mt 7/4/2011 18:10:25.814'!
loadTranscriptEditor: anEditor

	anEditor ui transcriptEdit theText: (self properties at: #text).! !

!SdEditorState methodsFor: 'loading - editors' stamp: 'mt 7/4/2011 18:11:56.884'!
loadWorkspaceEditor: anEditor

	anEditor ui workspaceEdit theText: (self properties at: #text).! !

!SdEditorState methodsFor: 'accessing' stamp: 'mt 7/4/2011 15:46:11.714'!
newState

	^ self addState: SdEditorState new! !

!SdEditorState methodsFor: 'accessing' stamp: 'mt 7/4/2011 15:07:18.576'!
properties

	^ properties ifNil: [properties := Dictionary new]! !

!SdEditorState methodsFor: 'saving - editors' stamp: 'mt 6/20/2012 11:48:51.393'!
saveCallgraphEditor: anEditor

	self properties at: #lastTraceItEvent put: anEditor lastTraceItEvent copy.! !

!SdEditorState methodsFor: 'saving - editors' stamp: 'mt 6/15/2012 14:18:22.646'!
saveClassEditor: anEditor

	self properties
		at: #theClass put: anEditor theClass;
		at: #isFinderActive put: anEditor ui findBtn checked;
		at: #isCommentVisible put: anEditor ui commentBtn checked;
		at: #isDefinitionVisible put: anEditor ui definitionBtn checked;
		at: #openMethods put: anEditor openMethods;
		at: #methodEditorsExpanded put: (anEditor methodEditors collect: [:me | me isExpanded]).! !

!SdEditorState methodsFor: 'saving - general' stamp: 'mt 7/4/2011 17:52:24.393'!
saveColumn: aColumn

	self properties
		at: #editorClasses put: (aColumn submorphs collect: [:morph |
			morph saveState: self newState.
			morph class]);
		at: #width put: aColumn width.! !

!SdEditorState methodsFor: 'saving - general' stamp: 'mt 7/4/2011 17:23:58.324'!
saveEditor: anEditor

	self properties
		at: #timestamp put: TimeStamp now;
		at: #isExpanded put: anEditor isExpanded.! !

!SdEditorState methodsFor: 'saving - general' stamp: 'mt 7/4/2011 17:29:55.361'!
saveIDE: anIDE

	self properties at: #fixedColumns put: (
		anIDE columnsFixed collect: [:column | | newState |
			newState := self newState.
			column saveState: newState.
			newState]).
		
	self properties at: #scrollableClumns put: (
		anIDE columnsScrollable collect: [:column | | newState |
			newState := self newState.
			column saveState: newState.
			newState]).
		
	self properties at: #scrollOffset put: anIDE scrollArea horizontalScrollBar currentValue.! !

!SdEditorState methodsFor: 'saving - editors' stamp: 'mt 7/4/2011 17:16:08.309'!
saveObjectExplorer: anEditor

	self properties at: #object put: anEditor object. "copy?"! !

!SdEditorState methodsFor: 'saving - editors' stamp: 'mt 7/4/2011 15:17:59.163'!
saveObjectInspector: anEditor! !

!SdEditorState methodsFor: 'saving - editors' stamp: 'mt 7/4/2011 17:15:50.283'!
savePackageViewer: anEditor

	self properties
		at: #packageName put: anEditor packageName;
		at: #index put: anEditor ui treeView currentIndex copy. "may break"! !

!SdEditorState methodsFor: 'saving - editors' stamp: 'mt 7/4/2011 17:15:41.839'!
saveTranscriptEditor: anEditor

	self properties at: #text put: anEditor ui transcriptEdit theText copy.! !

!SdEditorState methodsFor: 'saving - editors' stamp: 'mt 7/4/2011 17:16:38.306'!
saveWorkspaceEditor: anEditor

	self properties at: #text put: anEditor ui workspaceEdit theText copy.! !

!SdEditorState methodsFor: 'accessing' stamp: 'mt 7/4/2011 15:28:40.934'!
states
	
	^ self properties at: #children ifAbsent: [OrderedCollection new]! !

Object subclass: #SdObjectExplorerModel
	uses: TUiItemModel + TSdDynamicAccessor
	instanceVariableNames: 'before after node'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sight-Dynamic-Models'!

!SdObjectExplorerModel commentStamp: '<historical>' prior: 0!
This is a tree model that uses object explorer wrappers to simluate the object explorer in an item view (tree, table, list).!

SdObjectExplorerModel class
	uses: TUiItemModel classTrait + TSdDynamicAccessor classTrait
	instanceVariableNames: ''!

!SdObjectExplorerModel methodsFor: 'accessing' stamp: 'mt 3/22/2012 16:12:01.372'!
after

	^ after! !

!SdObjectExplorerModel methodsFor: 'accessing' stamp: 'mt 3/22/2012 16:11:57.011'!
after: aWrapper

	after := aWrapper.! !

!SdObjectExplorerModel methodsFor: 'properties' stamp: 'mt 4/17/2012 10:13:01.293'!
afterClass

	^ self after ifNotNil: [self afterObject class]! !

!SdObjectExplorerModel methodsFor: 'properties' stamp: 'mt 4/17/2012 10:04:01.364'!
afterIcon

	^ (([self after icon] on: Error do: [])
		ifNil: [SdMethodFinder iconForClass: self afterObject class])
		ifNil: [SdMethodFinder blankIcon]! !

!SdObjectExplorerModel methodsFor: 'properties' stamp: 'mt 3/22/2012 16:45:53.864'!
afterMenu
	
	^ self menuFor: self afterObject! !

!SdObjectExplorerModel methodsFor: 'accessing' stamp: 'mt 3/22/2012 16:40:57.42'!
afterObject

	^ self after ifNotNil: [:wrapper |
		wrapper withoutListWrapper]! !

!SdObjectExplorerModel methodsFor: 'properties' stamp: 'mt 4/17/2012 10:10:28.591'!
afterText

	| afterString beforeString |
	self after ifNil: [
		^ '<font color="#AAAAAA">\<out of scope\></font>' asHtmlText].

	afterString := [self afterObject asExplorerString]
		on: Error
		do: [nil].
	
	afterString ifNil: [^ '<font color="#FF0000">???</font>' asHtmlText].

"	beforeString := [self beforeObject asExplorerString]
		on: Error
		do: [nil]."
		
	self afterObject = self beforeObject "afterString = beforeString"
		ifTrue: [^ '<font color="#AAAAAA">\<apparently unchanged\></font>' asHtmlText]
		ifFalse: [^ afterString]
	! !

!SdObjectExplorerModel methodsFor: 'accessing' stamp: 'mt 3/29/2012 15:27:10.726'!
base
	"This object will be used to determine the instance variables."

	^ self beforeObject
		ifNil: [self after "use initialized type" ifNil: [self before]]
		ifNotNil: [(self beforeObject isCollection
			and: [self afterObject isCollection]
			and: [self beforeObject size < self afterObject size])
				ifTrue: [self after]
				ifFalse: [self before]]! !

!SdObjectExplorerModel methodsFor: 'accessing' stamp: 'mt 3/22/2012 16:41:04.431'!
baseObject
	"This object will be used to determine the instance variables."

	^ self base ifNotNil: [:wrapper |
		wrapper withoutListWrapper]! !

!SdObjectExplorerModel methodsFor: 'accessing' stamp: 'mt 3/22/2012 16:11:44.073'!
before

	^ before ! !

!SdObjectExplorerModel methodsFor: 'accessing' stamp: 'mt 3/22/2012 16:11:52.077'!
before: aWrapper

	before := aWrapper.! !

!SdObjectExplorerModel methodsFor: 'properties' stamp: 'mt 4/17/2012 10:13:13.283'!
beforeClass

	^ self before ifNotNil: [self beforeObject class]! !

!SdObjectExplorerModel methodsFor: 'properties' stamp: 'mt 4/17/2012 10:02:20.579'!
beforeIcon

	^ (([self before icon] on: Error do: [])
		ifNil: [SdMethodFinder iconForClass: self beforeObject class])
		ifNil: [SdMethodFinder blankIcon]! !

!SdObjectExplorerModel methodsFor: 'properties' stamp: 'mt 3/22/2012 16:45:44.437'!
beforeMenu
	
	^ self menuFor: self beforeObject! !

!SdObjectExplorerModel methodsFor: 'accessing' stamp: 'mt 3/22/2012 16:41:10.214'!
beforeObject

	^ self before ifNotNil: [:wrapper |
		wrapper withoutListWrapper]! !

!SdObjectExplorerModel methodsFor: 'properties' stamp: 'mt 3/29/2012 16:45:10.045'!
beforeText

	self before ifNil: [
		^ '<font color="#AAAAAA">\<out of scope\></font>' asHtmlText].

	^ [self beforeObject asExplorerString asHtmlText]
		on: Error
		do: [:err | err explore. '<font color="#FF0000">???</font>' asHtmlText]! !

!SdObjectExplorerModel methodsFor: 'accessing - callgraph' stamp: 'mt 3/22/2012 16:43:50.415'!
callgraph

	^ self node
		ifNotNil: [:n | n callgraph]! !

!SdObjectExplorerModel methodsFor: 'item model - hierarchy' stamp: 'mt 5/2/2012 10:45:21.254'!
childAt: index inGroup: groupName

	| baseWrapper |
	baseWrapper := self base contents at: index.
	
	^ SdObjectExplorerModel new
		node: self node;
		before: (self base == self before
			ifTrue: [baseWrapper]
			ifFalse: [self baseObject class ~~ self beforeObject class
				ifTrue: [nil "Type mismatch!!"]
				ifFalse: [self before contents at: index ifAbsent: []]]);
		after: (self base == self after
			ifTrue: [baseWrapper]
			ifFalse: [self baseObject class ~~ self afterObject class
				ifTrue: [nil "Type mismatch!!"]
				ifFalse: [self after contents at: index ifAbsent: []]])! !

!SdObjectExplorerModel methodsFor: 'item model - hierarchy' stamp: 'mt 3/22/2012 17:22:40.992'!
childCount

	^ self base
		ifNil: [0]
		ifNotNil: [:wrapper |
			wrapper withoutListWrapper isString
				ifTrue: [0]
				ifFalse: [wrapper contents size]]! !

!SdObjectExplorerModel methodsFor: 'item model - hierarchy' stamp: 'mt 5/2/2012 10:44:57.237'!
childCountInGroup: groupName

	^ self childCount! !

!SdObjectExplorerModel methodsFor: 'dynamic - signals - activation' stamp: 'mt 7/26/2011 16:48:57.204'!
classActivated: aClass

	self emitAlways.! !

!SdObjectExplorerModel methodsFor: 'item model - hierarchy' stamp: 'mt 5/2/2012 10:44:48.456'!
groups
	
	^ #(instVars)! !

!SdObjectExplorerModel methodsFor: 'properties' stamp: 'mt 3/22/2012 16:45:36.153'!
menuFor: anObject
	
	| menu |	

	menu := MenuMorph new
		defaultTarget: self.

	menu
		add: ('Browse Class [{1}]' format: {anObject class})
		selector: #classActivated:
		argument: anObject class.
		
	menu
		add: 'Explore'
		selector: #objectActivated:
		argument: anObject.
	
	menu
		addLine;
		add: ('Back to Trace [{1}>>{2}]' format: {
			self callgraph traceEvent testClass.
			self callgraph traceEvent testSelector})
		target: self
		selector: #traceActivated:
		argument: self node.
				
	^ menu! !

!SdObjectExplorerModel methodsFor: 'dynamic - signals - activation' stamp: 'mt 7/26/2011 16:48:51.427'!
methodActivated: aMethodReference

	self emitAlways.! !

!SdObjectExplorerModel methodsFor: 'accessing - callgraph' stamp: 'mt 3/22/2012 16:43:06.177'!
node

	^ node! !

!SdObjectExplorerModel methodsFor: 'accessing - callgraph' stamp: 'mt 3/22/2012 16:43:14.268'!
node: aCallgraphNode

	node := aCallgraphNode.! !

!SdObjectExplorerModel methodsFor: 'dynamic - signals - activation' stamp: 'mt 7/26/2011 16:48:46.93'!
objectActivated: anObject

	self emitAlways.! !

!SdObjectExplorerModel methodsFor: 'accessing' stamp: 'mt 3/22/2012 17:02:33.78'!
setStateChange: anObjectStateChange

	self before: (ObjectExplorerWrapper
		with: anObjectStateChange before
		name: 'root before'
		model: self).
		
	self after: (ObjectExplorerWrapper
		with: anObjectStateChange after
		name: 'root after'
		model: self).
		
	self node: anObjectStateChange node.
	
	self modelReset.! !

!SdObjectExplorerModel methodsFor: 'properties' stamp: 'mt 3/22/2012 17:40:41.173'!
tag

	^ ('<font color="#777777">', self base itemName,'</font>') asHtmlText! !

!SdObjectExplorerModel methodsFor: 'dynamic - signals - activation' stamp: 'mt 7/26/2011 16:48:24.514'!
traceActivated: aNode

	self emitAlways.! !

Object subclass: #SdObjectStateChange
	instanceVariableNames: 'before after node'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sight-Dynamic-Support'!

!SdObjectStateChange methodsFor: 'accessing' stamp: 'mt 7/18/2011 14:45:08.471'!
after

	^ after! !

!SdObjectStateChange methodsFor: 'accessing' stamp: 'mt 7/18/2011 14:45:03.354'!
after: anObject

	after := anObject.! !

!SdObjectStateChange methodsFor: 'accessing' stamp: 'mt 7/18/2011 14:44:49.012'!
before

	^ before! !

!SdObjectStateChange methodsFor: 'accessing' stamp: 'mt 7/18/2011 14:44:56.439'!
before: anObject

	before := anObject.! !

!SdObjectStateChange methodsFor: 'accessing' stamp: 'mt 7/18/2011 15:08:02.314'!
callgraph

	^ self node ifNotNil: [:node | node callgraph]! !

!SdObjectStateChange methodsFor: 'accessing' stamp: 'mt 7/18/2011 15:07:34.134'!
node

	^ node! !

!SdObjectStateChange methodsFor: 'accessing' stamp: 'mt 7/18/2011 15:07:42.106'!
node: aNode

	node := aNode.! !

Object subclass: #SdPackageModel
	uses: TUiItemModel + TSdDynamicAccessor
	instanceVariableNames: 'packageInfo'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sight-Dynamic-Models-Code'!

SdPackageModel class
	uses: TUiItemModel classTrait + TSdDynamicAccessor classTrait
	instanceVariableNames: 'namespaces'!

!SdPackageModel commentStamp: '<historical>' prior: 0!
This item model can be used to show detailed information about one package.!

SdPackageModel class
	uses: TUiItemModel classTrait + TSdDynamicAccessor classTrait
	instanceVariableNames: 'namespaces'!

!SdPackageModel class methodsFor: 'instance creation' stamp: 'mt 5/17/2011 10:31:42.441'!
forPackageNamed: aString

	^ self new
		packageInfo: (PackageInfo named: aString)! !

!SdPackageModel class methodsFor: 'namespaces' stamp: 'mt 2/12/2012 17:00:34.842'!
guessNamespaceForCategory: aSystemCategory

	| frequency max |
	frequency := Dictionary new.
	
	(SystemOrganization listAtCategoryNamed: aSystemCategory)
		collect: [:className | Smalltalk at: className]
		thenDo: [:class | | combinedTokens |
			"Prefix is uppercase."
			(class name first isUppercase and: [class name second isUppercase])
				ifTrue: [ | p |
					p := ''.
					class name detect: [:char | char isUppercase
						ifTrue: [p := p, char. false]
						ifFalse: [
							p := p allButLast.
							frequency
								at: p
								put: (frequency at: p ifAbsentPut: [0]) + 1. true]]].	

			"Prefix is not uppercase."
			combinedTokens := ''.
			'[[:upper:]][[:lower:]]+' asRegex
				matchesIn: class name
				do: [:token | combinedTokens := combinedTokens, token.
					frequency
						at: combinedTokens
						put: (frequency at: combinedTokens ifAbsentPut: [0]) + 1]].
	
		max := '' -> 0.
		frequency associationsDo: [:assoc |
			assoc value > max value
				ifTrue: [max := assoc]].

	^ max key! !

!SdPackageModel class methodsFor: 'namespaces' stamp: 'mt 3/23/2012 09:35:28.153'!
namespaceForCategory: aSystemCategory

	namespaces ifNil: [namespaces := Dictionary new].
	
	(#(Morphic Kernel Collections Exceptions Files Balloon Graphics Network Compiler System)
		anySatisfy: [:prefix | aSystemCategory startsWith: prefix])
		ifTrue: [^ ''].
		
	^ namespaces
		at: aSystemCategory
		ifAbsentPut: [self guessNamespaceForCategory: aSystemCategory]! !

!SdPackageModel methodsFor: 'item model - hierarchy' stamp: 'mt 5/2/2012 11:46:37.503'!
childAt: index inGroup: groupName
	"groupName == #systemCategories"
	
	^ SdSystemCategoryNode new
		category: ((self perform: groupName) at: index);
		prefix: self packageInfo systemCategoryPrefix! !

!SdPackageModel methodsFor: 'dynamic - signals - activation' stamp: 'mt 2/16/2012 10:52:43.743'!
classActivated: aClass

	self emitAlways.! !

!SdPackageModel methodsFor: 'actions' stamp: 'mt 3/22/2012 11:21:13.141'!
doIt: aCompiledMethod
	"Exectue the given method. The method needs to expect 0 arguments."
	
	Transcript
		cr;
		show: (aCompiledMethod methodClass theNonMetaClass perform: aCompiledMethod selector).! !

!SdPackageModel methodsFor: 'item model - hierarchy' stamp: 'mt 5/2/2012 11:45:54.83'!
groups
	
	^ #(systemCategories)! !

!SdPackageModel methodsFor: 'dynamic - signals - activation' stamp: 'mt 2/16/2012 10:52:39.206'!
methodActivated: aMethodReference

	self emitAlways.! !

!SdPackageModel methodsFor: 'dynamic - signals - activation' stamp: 'mt 2/16/2012 10:52:35.092'!
objectActivated: anObject

	self emitAlways.! !

!SdPackageModel methodsFor: 'accessing' stamp: 'mt 2/14/2012 16:06:35.832'!
packageInfo

	^ packageInfo! !

!SdPackageModel methodsFor: 'accessing' stamp: 'mt 2/14/2012 16:20:10.554'!
packageInfo: aPackageInfo

	aPackageInfo = packageInfo ifTrue: [^ self].

	packageInfo := aPackageInfo.
	
	self modelReset.! !

!SdPackageModel methodsFor: 'accessing' stamp: 'mt 5/2/2012 11:45:44.694'!
systemCategories

	^ self packageInfo
		ifNil: [#()]
		ifNotNil: [:pkg | pkg systemCategories]! !

!SdPackageModel methodsFor: 'dynamic - signals - activation' stamp: 'mt 2/16/2012 10:52:29.093'!
traceActivated: aNode

	self emitAlways.! !

Object subclass: #SdParserHelper
	instanceVariableNames: 'text view selection'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sight-Dynamic-Support'!

!SdParserHelper commentStamp: 'mt 4/11/2011 09:38:06.258' prior: 0!
Used for notification of default parser.!

!SdParserHelper methodsFor: 'interactive error handling' stamp: 'mt 5/1/2011 14:28:00.192'!
correctFrom: start to: end with: string

	"Ignore."! !

!SdParserHelper methodsFor: 'interactive error handling' stamp: 'mt 5/1/2011 14:20:07.806'!
deselect! !

!SdParserHelper methodsFor: 'interactive error handling' stamp: 'mt 4/13/2011 11:15:37.231'!
notify: aMessage at: aLocation in: aSource

	self view
		notify: (aMessage allButLast: 3) "remove trailing ' ->' "
		at: aLocation
		in: aSource.! !

!SdParserHelper methodsFor: 'interactive error handling' stamp: 'mt 4/11/2011 09:56:44.834'!
select
! !

!SdParserHelper methodsFor: 'interactive error handling' stamp: 'mt 4/11/2011 10:13:37.356'!
selectFrom: startIndex to: endIndex

	self selection: (startIndex to: endIndex).! !

!SdParserHelper methodsFor: 'interactive error handling' stamp: 'mt 5/1/2011 14:20:53.512'!
selectInvisiblyFrom: startIndex to: endIndex

	self selection: (startIndex to: endIndex).! !

!SdParserHelper methodsFor: 'accessing' stamp: 'mt 5/1/2011 14:24:34.748'!
selectedText

	self selection ifNil: [^ nil].

	^ self text
		copyFrom: self selection first
		to: self selection last! !

!SdParserHelper methodsFor: 'accessing' stamp: 'mt 4/11/2011 10:13:18.346'!
selection

	^ selection! !

!SdParserHelper methodsFor: 'accessing' stamp: 'mt 4/11/2011 10:13:26.415'!
selection: anInterval

	selection := anInterval.! !

!SdParserHelper methodsFor: 'interactive error handling' stamp: 'mt 4/11/2011 09:40:44.679'!
selectionInterval

	^ 1 to: 0! !

!SdParserHelper methodsFor: 'accessing' stamp: 'mt 4/11/2011 09:41:19.665'!
text

	^ text! !

!SdParserHelper methodsFor: 'accessing' stamp: 'mt 4/11/2011 09:41:26.804'!
text: stringOrText

	text := stringOrText.! !

!SdParserHelper methodsFor: 'accessing' stamp: 'mt 4/11/2011 09:46:17.653'!
view

	^ view! !

!SdParserHelper methodsFor: 'accessing' stamp: 'mt 4/11/2011 09:46:25.661'!
view: aMorph

	view := aMorph.! !

Object subclass: #SdPreviewBuilder
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sight-Dynamic-UI-Support'!

!SdPreviewBuilder class methodsFor: 'building' stamp: 'mt 7/17/2011 22:21:28.318'!
createClassPreviewFor: aClass

	| classComment preview |
	classComment := aClass theNonMetaClass organization classComment.
	classComment ifEmpty: [^ nil].
	
	preview := UiTextEdit new
		extent: 300@150;
		colorBackground: Color yellow muchLighter paler;
		updateFocusColor: false;  
		scrollingMode: #limit;
		scrollingLimit: 10;
		scrollBarThickness: 9;
		readOnly: true;  
		theText: classComment.
		
	^ preview! !

!SdPreviewBuilder class methodsFor: 'building' stamp: 'mt 6/22/2012 16:17:37.712'!
createMethodPreviewFor: aMethodReference
	
	| preview |	
	preview := SdSourceCodeEdit new
		readOnly: true;
		theClass: aMethodReference actualClass;

		sourceCode: aMethodReference compiledMethod getSource;
		scrollingMode: #limit;
		scrollingLimit: 10;
		displayMode: #highlight;
		colorHighlightedBackground: Color yellow muchLighter paler;
		colorHighlightedBorder: (Color gray: 0.6);
		updateFocusColor: false.
	
	preview verticalScrollBar buttonMode: #none.
	
	preview width: preview optimalWidth.
		
	^ preview! !

Object subclass: #SdQueryModel
	uses: TUiItemModel
	instanceVariableNames: 'fromBlocks selectBlocks groupByBlocks collectBlocks groups'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sight-Dynamic-Models'!

!SdQueryModel commentStamp: 'mt 6/24/2012 07:44:44.499' prior: 0!
self objects: Morph allInstances
self modelReset.
self selectBlock: [:obj | true].
self collectBlock: [:object | {#submorphs -> object submorphs size. #owner -> object owner class asString}].
self groupBlock: [:object | object owner class].
self modelReset.
self sortBlockForGroups: [:g1 :g2 | g1 asString < g2 asString].
self sortBlockForObjects: [:o1 :o2 | true].!

SdQueryModel class
	uses: TUiItemModel classTrait
	instanceVariableNames: ''!

!SdQueryModel methodsFor: 'item model - hierarchy' stamp: 'mt 7/10/2012 14:50:14.708'!
childAt: index inGroup: groupName
	
	| obj node |
	obj := (groups at: groupName) at: index.
	node := UiPropertyItemNode new
		at: #object put: obj;
		yourself.
	
	^ node! !

!SdQueryModel methodsFor: 'item model - hierarchy' stamp: 'mt 6/22/2012 17:49:57.715'!
childCountInGroup: groupName
	"Override this if you can return the group size in a faster way ;-)"

	^ (groups at: groupName) size! !

!SdQueryModel methodsFor: 'accessing' stamp: 'mt 7/10/2012 14:27:41.99'!
collectBlocks

	^ collectBlocks ifNil: [collectBlocks := OrderedCollection new]! !

!SdQueryModel methodsFor: 'accessing' stamp: 'mt 7/10/2012 14:28:14.023'!
collectBlocks: someCollectBlocks

	collectBlocks := someCollectBlocks.
	self collectChanged.! !

!SdQueryModel methodsFor: 'signals' stamp: 'mt 7/10/2012 14:24:06.204'!
collectChanged

	self emit.! !

!SdQueryModel methodsFor: 'accessing' stamp: 'mt 7/9/2012 16:55:58.299'!
fromBlocks

	^ fromBlocks ifNil: [fromBlocks := OrderedCollection new]! !

!SdQueryModel methodsFor: 'accessing' stamp: 'mt 7/10/2012 14:24:38.101'!
fromBlocks: someFromBlocks
	
	fromBlocks := someFromBlocks.
	self fromChanged.! !

!SdQueryModel methodsFor: 'signals' stamp: 'mt 7/10/2012 14:23:39.998'!
fromChanged

	self emit.! !

!SdQueryModel methodsFor: 'accessing' stamp: 'mt 7/10/2012 14:26:15.115'!
groupByBlocks

	^ groupByBlocks ifNil: [groupByBlocks := OrderedCollection new]! !

!SdQueryModel methodsFor: 'accessing' stamp: 'mt 7/10/2012 14:27:16.034'!
groupByBlocks: someGroupByBlocks

	groupByBlocks := someGroupByBlocks.
	self groupByChanged.! !

!SdQueryModel methodsFor: 'signals' stamp: 'mt 7/10/2012 14:23:59.162'!
groupByChanged

	self emit.! !

!SdQueryModel methodsFor: 'item model - hierarchy' stamp: 'mt 7/10/2012 14:47:44.475'!
groups

	^ groups
		ifNil: [#()]
		ifNotNil: [:g | g keys]! !

!SdQueryModel methodsFor: 'initialization' stamp: 'mt 7/10/2012 14:46:15.749'!
initialize

	super initialize.
	self connect: self signal: #fromChanged toSelector: #updateGroups.
	self connect: self signal: #selectChanged toSelector: #updateGroups.
	self connect: self signal: #groupByChanged toSelector: #updateGroups.
	self connect: self signal: #collectChanged toSelector: #updateGroups.! !

!SdQueryModel methodsFor: 'item model - properties' stamp: 'mt 7/10/2012 14:49:49.301'!
properties
	
	^ #()! !

!SdQueryModel methodsFor: 'signals' stamp: 'mt 6/22/2012 18:03:51.753'!
propertiesChanged

	self emit! !

!SdQueryModel methodsFor: 'accessing' stamp: 'mt 7/10/2012 14:24:59.139'!
selectBlocks

	^ selectBlocks ifNil: [selectBlocks := OrderedCollection new]! !

!SdQueryModel methodsFor: 'accessing' stamp: 'mt 7/10/2012 14:25:31.078'!
selectBlocks: someSelectBlocks

	selectBlocks := someSelectBlocks.
	self selectChanged.! !

!SdQueryModel methodsFor: 'signals' stamp: 'mt 7/10/2012 14:23:43.651'!
selectChanged

	self emit.! !

!SdQueryModel methodsFor: 'initialization' stamp: 'mt 7/10/2012 14:46:22.651'!
updateGroups

	| groupByBlock collectBlock |
	groups := Dictionary new.
	groupByBlock := self groupByBlocks at: 1 ifAbsent: [[:obj | #all]].
	collectBlock := self collectBlocks at: 1 ifAbsent: [[:obj | obj]].
	
	self fromBlocks do: [:fromBlock | fromBlock value do: [:object |
		(self selectBlocks allSatisfy: [:selectBlock | selectBlock value: object]) ifTrue: [
			(groups at: (groupByBlock value: object) ifAbsentPut: [OrderedCollection new])
				add: (collectBlock value: object)]]].

	self modelReset.! !

Object subclass: #SdStatementListModel
	uses: TUiItemModel
	instanceVariableNames: 'statements defaultStatement autoExclusive lastStatements'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sight-Dynamic-Models'!

SdStatementListModel class
	uses: TUiItemModel classTrait
	instanceVariableNames: ''!

!SdStatementListModel methodsFor: 'actions' stamp: 'mt 7/10/2012 13:56:57.934'!
addStatement

	self addStatement: self defaultStatement.! !

!SdStatementListModel methodsFor: 'actions' stamp: 'mt 7/11/2012 10:34:09.301'!
addStatement: code

	| node |
	node := (UiPropertyItemNode new
		at: #code put: code;
		at: #checkable put: true;
		at: #checked put: false; "not active by default"
		at: #editable put: true;
		yourself).
	
	self connect: node signal: #propertiesChanged: toSelector: #onStatementChanged:properties: pattern: #(0 1).
	
	self statements add: node beforeIndex: self statements size.
	self childInserted: self statements size - 1.
	
	self onStatementChanged: node properties: node properties.! !

!SdStatementListModel methodsFor: 'accessing' stamp: 'mt 7/11/2012 10:29:13.681'!
autoExclusive
	"Onlye one statement can be chosen?"

	^ autoExclusive ifNil: [autoExclusive := false]! !

!SdStatementListModel methodsFor: 'accessing' stamp: 'mt 7/11/2012 10:28:49.202'!
autoExclusive: aBoolean

	autoExclusive := aBoolean.! !

!SdStatementListModel methodsFor: 'accessing' stamp: 'mt 7/10/2012 13:56:41.753'!
defaultStatement

	^ defaultStatement! !

!SdStatementListModel methodsFor: 'accessing' stamp: 'mt 7/10/2012 13:56:49.813'!
defaultStatement: aCodeString

	defaultStatement := aCodeString.! !

!SdStatementListModel methodsFor: 'item model - hierarchy' stamp: 'mt 7/5/2012 15:22:01.019'!
groups
	
	^ #(statements)! !

!SdStatementListModel methodsFor: 'testing' stamp: 'mt 7/11/2012 13:31:21.197'!
hasErrors

	^ self statements anySatisfy: [:stmt | (stmt at: #status ifAbsent: []) == #error]! !

!SdStatementListModel methodsFor: 'testing' stamp: 'mt 7/11/2012 13:31:25.332'!
hasWarnings

	^ self statements anySatisfy: [:stmt | (stmt at: #status ifAbsent: []) == #warning]! !

!SdStatementListModel methodsFor: 'accessing' stamp: 'mt 7/11/2012 10:09:07.722'!
helpText

	^ (self statements last at: #code) asString! !

!SdStatementListModel methodsFor: 'accessing' stamp: 'mt 7/11/2012 10:09:40.557'!
helpText: aString

	self statements last
		at: #code put: ('<font color="#aaaaaa">', aString, '</font>' )asHtmlText.! !

!SdStatementListModel methodsFor: 'initialization' stamp: 'mt 7/8/2012 19:44:43.286'!
initialize

	super initialize.
	
	self statements add: (UiPropertyItemNode new
		at: #code put: '<font color="#aaaaaa">New Statement</font>' asHtmlText;
		at: #checked put: false;
		at: #checkable put: false;
		at: #editable put: false;
		at: #selectable put: false;
		yourself).! !

!SdStatementListModel methodsFor: 'signals - callbacks' stamp: 'mt 7/11/2012 13:51:17.736'!
onStatementChanged: aStatement properties: changedProperties

	| currentStatements |
	(self statements includes: aStatement) ifTrue: [
		(changedProperties includes: #checked) ifTrue: [
			(aStatement at: #checked) ifTrue: [
				self updateAutoExclusiveFor: aStatement]].
	
		(self updateStatusFor: aStatement)
			ifFalse: [^ self]].
	
	"Check for changed statements. Only the selected ones matter."
	currentStatements := self selectedStatements.
	currentStatements ~= lastStatements ifTrue: [
		lastStatements := currentStatements.
		self resultsChanged].
	
	self statementsChanged.! !

!SdStatementListModel methodsFor: 'actions' stamp: 'mt 7/11/2012 11:36:19.106'!
removeStatement: aPropertyNode

	| i |
	i := self statements indexOf: aPropertyNode.
	self statements remove: aPropertyNode.
		
	self childRemoved: i.
	self onStatementChanged: aPropertyNode properties: aPropertyNode properties.! !

!SdStatementListModel methodsFor: 'accessing' stamp: 'mt 7/11/2012 10:39:42.043'!
results

	^ self selectedStatements collect: [:node | Compiler evaluate: (node at: #code)]! !

!SdStatementListModel methodsFor: 'signals' stamp: 'mt 7/11/2012 10:53:10.722'!
resultsChanged
	"Triggered, whenever the return value of #results changes."

	self emit.! !

!SdStatementListModel methodsFor: 'accessing' stamp: 'mt 7/11/2012 10:39:32.435'!
selectedStatements

	^ self statements allButLast select: [:node | node at: #checked]! !

!SdStatementListModel methodsFor: 'accessing' stamp: 'mt 7/5/2012 15:08:54.032'!
statements

	^ statements ifNil: [statements := OrderedCollection new]! !

!SdStatementListModel methodsFor: 'signals' stamp: 'mt 7/11/2012 10:52:49.219'!
statementsChanged
	"Triggered whenever the data of code statements changes, i.e., the code or the checked state."

	self emit.! !

!SdStatementListModel methodsFor: 'signals' stamp: 'mt 7/11/2012 12:04:14.421'!
statementsError
	"Emitted whenever at least one statement produced a compiler error."

	self emit.! !

!SdStatementListModel methodsFor: 'signals' stamp: 'mt 7/11/2012 12:03:36.221'!
statementsWarning
	"Emitted if at least one statement does not return the value it is supposed to."

	self emit.! !

!SdStatementListModel methodsFor: 'updating' stamp: 'mt 7/11/2012 13:50:54.307'!
updateAutoExclusiveFor: checkedStatement

	self autoExclusive ifFalse: [^ self].
	
	self statements
		select: [:node | node ~~ checkedStatement]
		thenDo: [:node | node at: #checked put: false].! !

!SdStatementListModel methodsFor: 'updating' stamp: 'mt 7/11/2012 13:38:21.777'!
updateStatusFor: aStatement

	[((Compiler evaluate: (aStatement at: #code)) class == (Compiler evaluate: self defaultStatement) class)
		ifTrue: [aStatement at: #status put: #good]
		ifFalse: [aStatement at: #status put: #warning]]
		on: Error do: [aStatement at: #status put: #error].
	
	(aStatement at: #status) == #good ifTrue: [
		aStatement at: #icon put: nil.
		^ true].

	(aStatement at: #status) == #warning ifTrue: [
		aStatement at: #icon put: UiFugueIcons exclamationSmallIcon.
		self statementsWarning].
	(aStatement at: #status) == #error ifTrue: [
		aStatement at: #icon put: UiFugueIcons exclamationSmallRedIcon.
		self statementsError].
	^ false! !

Object subclass: #SdSystemCategoriesModel
	uses: TUiItemModel
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sight-Dynamic-Models-System'!

SdSystemCategoriesModel class
	uses: TUiItemModel classTrait
	instanceVariableNames: ''!

!SdSystemCategoriesModel methodsFor: 'item model - hierarchy' stamp: 'mt 5/18/2012 11:57:23.103'!
childAt: index inGroup: groupName

	| node |
	node := UiPropertyItemNode new.
	node
		at: #package put: (PackageInfo named: groupName);
		at: #category put: ((PackageInfo named: groupName) systemCategories
			at: index
			ifAbsent: [node at: #dummy put: true. groupName]).
	
	^ node! !

!SdSystemCategoriesModel methodsFor: 'item model - hierarchy' stamp: 'mt 5/22/2012 08:47:23.544'!
childCountInGroup: groupName
	"Do not allow empty groups."

	| numberOfCategories |
	numberOfCategories := (PackageInfo named: groupName) systemCategories size.
	numberOfCategories == 0 ifTrue: [^ 1].
	^ numberOfCategories! !

!SdSystemCategoriesModel methodsFor: 'item model - hierarchy' stamp: 'mt 5/18/2012 11:09:00.924'!
groups
	
	^ self packageNames! !

!SdSystemCategoriesModel methodsFor: 'accessing' stamp: 'mt 5/18/2012 11:55:21.298'!
packageNames

	^ PackageOrganizer default packageNames sorted! !

Object subclass: #SdSystemClassesModel
	uses: TUiItemModel
	instanceVariableNames: 'systemCategories classIcons classNames'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sight-Dynamic-Models-System'!

SdSystemClassesModel class
	uses: TUiItemModel classTrait
	instanceVariableNames: ''!

!SdSystemClassesModel methodsFor: 'item model - hierarchy' stamp: 'mt 5/22/2012 09:10:39.541'!
childAt: index inGroup: groupName

	| node |
	node := UiPropertyItemNode new.
	node
		at: #className put: ((classNames at: groupName) at: index);
		at: #classIcon put: ((classIcons at: groupName) at: index).
	^ node! !

!SdSystemClassesModel methodsFor: 'item model - hierarchy' stamp: 'mt 5/22/2012 09:06:08.458'!
childCountInGroup: groupName
	
	| numberOfClasses |
	numberOfClasses := (classNames at: groupName) size.
	numberOfClasses == 0 ifTrue: [^ 1].
	^ numberOfClasses! !

!SdSystemClassesModel methodsFor: 'item model - hierarchy' stamp: 'mt 5/22/2012 09:02:26.737'!
groups
	
	^ self systemCategories! !

!SdSystemClassesModel methodsFor: 'initialization' stamp: 'mt 5/22/2012 09:08:14.074'!
initialize

	super initialize.
	self updateHierarchy.! !

!SdSystemClassesModel methodsFor: 'accessing' stamp: 'mt 5/22/2012 08:56:10.294'!
systemCategories

	^ systemCategories ifNil: [#()]! !

!SdSystemClassesModel methodsFor: 'accessing' stamp: 'mt 5/22/2012 08:56:42.245'!
systemCategories: someCategories

	systemCategories := someCategories.
	self updateHierarchy.! !

!SdSystemClassesModel methodsFor: 'updating' stamp: 'mt 5/22/2012 09:02:09.306'!
updateHierarchy
	"Sorting ported from OmniBrowser code."
	
	classIcons := Dictionary new.
	classNames := Dictionary new.

	self systemCategories do: [:cat |
		| classes order superChain |
		classes := (Smalltalk organization listAtCategoryNamed: cat) collect: [:e | Smalltalk at: e].
		order := SortedCollection sortBlock: 
			[:assoc1 :assoc2 | | i chain2 chain1 result max |
			result := nil.
			chain1 := assoc1 key.
			chain2 := assoc2 key.
			max := chain1 size min: chain2 size.
			i := 1.
			[result isNil and: [i <= max]] whileTrue: 
				[(chain1 at: i) = (chain2 at: i) 
					ifTrue: [i := i + 1]
					ifFalse: [result := (chain1 at: i) name < (chain2 at: i) name]].
			result isNil ifTrue: [chain1 size < chain2 size] ifFalse: [result]].

		"Fill sorted collection."
		classes do: [:class |
			superChain := class withAllSuperclasses reversed.
			superChain removeAllSuchThat: [:cl | (classes includes: cl) not].
			order add: superChain contents -> class].

		"Fill model cache."
		classIcons at: cat put: OrderedCollection new.
		classNames at: cat put: OrderedCollection new.
		order do: [:assoc |
			(classNames at: cat) add: assoc value name.
			(classIcons at: cat) add: (assoc key size > 1
					ifTrue: [Form extent: (10 * (assoc key size - 1)) @1 depth: 32]
					ifFalse: [])]].

	self modelReset.! !

Object subclass: #SdSystemMessagesModel
	uses: TUiItemModel
	instanceVariableNames: 'theClass protocols methodReferences'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sight-Dynamic-Models-System'!

SdSystemMessagesModel class
	uses: TUiItemModel classTrait
	instanceVariableNames: ''!

!SdSystemMessagesModel methodsFor: 'item model - hierarchy' stamp: 'mt 5/23/2012 09:18:19.573'!
childAt: index inGroup: groupName

	| node |
	node := UiPropertyItemNode new.
	node
		at: #reference put: (methodReferences at: index) first;
		at: #protocol put: (methodReferences at: index) second.
	^ node! !

!SdSystemMessagesModel methodsFor: 'item model - hierarchy' stamp: 'mt 5/23/2012 09:41:52.155'!
childCountInGroup: groupName
	
	^ methodReferences size! !

!SdSystemMessagesModel methodsFor: 'item model - hierarchy' stamp: 'mt 5/23/2012 09:11:52.108'!
groups
	
	^ #(messages)! !

!SdSystemMessagesModel methodsFor: 'initialization' stamp: 'mt 5/22/2012 15:37:16.694'!
initialize

	super initialize.
	self updateReferences.! !

!SdSystemMessagesModel methodsFor: 'accessing' stamp: 'mt 5/22/2012 14:52:11.435'!
protocols

	^ protocols ifNil: [#()].! !

!SdSystemMessagesModel methodsFor: 'accessing' stamp: 'mt 5/22/2012 14:51:41.23'!
theClass

	^ theClass! !

!SdSystemMessagesModel methodsFor: 'accessing' stamp: 'mt 5/22/2012 15:58:59.37'!
theClass: aClass protocols: someProtocols

	theClass := aClass theNonMetaClass.
	protocols := someProtocols.
	self updateReferences.! !

!SdSystemMessagesModel methodsFor: 'updating' stamp: 'mt 5/23/2012 09:30:42.749'!
updateReferences

	methodReferences := OrderedCollection new.
	self protocols do: [:protocol |
		methodReferences addAll: ((self theClass organization listAtCategoryNamed: protocol)
			collect: [:selector | {MethodReference class: self theClass selector: selector. protocol}]).
		methodReferences addAll: ((self theClass class organization listAtCategoryNamed: protocol)
			collect: [:selector | {MethodReference class: self theClass class selector: selector. protocol}])].
			
	self modelReset.! !

Object subclass: #SdSystemProtocolsModel
	uses: TUiItemModel
	instanceVariableNames: 'theClass protocols'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sight-Dynamic-Models-System'!

SdSystemProtocolsModel class
	uses: TUiItemModel classTrait
	instanceVariableNames: ''!

!SdSystemProtocolsModel methodsFor: 'item model - hierarchy' stamp: 'mt 5/22/2012 14:44:45.814'!
childAt: index inGroup: groupName
	
	| node |
	node := UiPropertyItemNode new.
	node
		at: #class put: self theClass;
		at: #protocol put: (self protocols at: index) key;
		at: #size put: (self protocols at: index) value.
	^ node! !

!SdSystemProtocolsModel methodsFor: 'item model - hierarchy' stamp: 'mt 5/22/2012 14:37:55.042'!
groups
	
	^ #(protocols)! !

!SdSystemProtocolsModel methodsFor: 'accessing' stamp: 'mt 5/22/2012 14:47:03.215'!
protocols

	^ protocols ifNil: [#()]! !

!SdSystemProtocolsModel methodsFor: 'accessing' stamp: 'mt 5/22/2012 13:34:15.906'!
theClass

	^ theClass! !

!SdSystemProtocolsModel methodsFor: 'accessing' stamp: 'mt 5/22/2012 14:40:36.386'!
theClass: aClass

	theClass := aClass theNonMetaClass.
	self updateProtocols.! !

!SdSystemProtocolsModel methodsFor: 'updating' stamp: 'mt 5/22/2012 14:48:19.113'!
updateProtocols

	protocols := OrderedCollection new.
	(self theClass class organization categories, self theClass organization categories)
		asSet do: [:protocol | protocols add: protocol -> ((self theClass organization listAtCategoryNamed: protocol) size + (self theClass class organization listAtCategoryNamed: protocol) size)].
		
	self modelReset.! !

CustomHelp subclass: #SdHelp
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sight-Dynamic-Help'!

!SdHelp class methodsFor: 'construction' stamp: 'mt 7/31/2011 19:50:12.523'!
appendCode: aString toText: aText

	| snippet styler |
	snippet := aString asText.
	snippet addAttribute: (TextFontReference toFont: Preferences standardCodeFont).

	styler := SdTextStyler new.
	styler font: Preferences standardCodeFont.

	snippet := styler format: snippet.
	snippet := (styler styledTextFor: snippet).
	snippet addAttribute: (TextFontReference toFont: Preferences standardCodeFont).
		
	aText append: snippet.! !

!SdHelp class methodsFor: 'accessing' stamp: 'mt 7/31/2011 19:22:17.077'!
bookName

	^ 'Sight Dynamic IDE'! !

!SdHelp class methodsFor: 'pages' stamp: 'mt 9/1/2011 15:06:34.132'!
keyboardShortcuts

	^ SdHelpTopic
		title: 'Keyboard Shortcuts'
		icon: UiFugueIcons keyboardIcon
		contents: '<b>Keyboard Shortcuts</b><br>
1. General<br>
<i>These shortcuts need an element having keyboard focus within the IDE.</i><br>
ctrl + shift + f<tab>open finder (packages, classes, methods)<br>
2. Finder<br>
arrow up/down<tab>navigate in search results
escape<tab><tab><tab>exit current search scope
return<tab><tab><tab>choose current item or enter scope (i.e., package filter)<br>
2.1. Class Finder<br>
return<tab><tab><tab>open/create class or enter category scope
shift + return<tab><tab>create class category<br>
2.2. Method Finder<br>
return<tab><tab><tab>open/create class or enter protocol scope
shift + return<tab><tab>create method protocol
cmd + q<tab><tab><tab>toggle class/instance side<br>
3. Class Editor<br>
cmd + f<tab><tab>activate method finder
cmd + w<tab><tab>close comment editor, class definition editor, method editor<br>
4. Method Editor<br>
cmd + w<tab><tab><tab><tab><tab>close editor
cmd + arrow up/down<tab>focus previous/next method
cmd + o<tab><tab><tab><tab><tab>open selected symbol (i.e., selector, class, global variable)
ctrl<tab><tab><tab><tab><tab><tab>show/hide text links for dynamic information
cmd + s<tab><tab><tab><tab><tab>save changes<br>
5. Workspace<br>
cmd + d<tab><tab>evaluate current selection
cmd + o<tab><tab>evaluate current selection and open result (i.e., browse class or explore object)
cmd + t<tab><tab>trace current selection and open call tree<br>
6. Transcript<br>
<i>No keyboard shortcuts.</i><br>
7. Package Viewer<br>
return<tab>browse class/method source<br>
8. Callgraph Editor<br>
return<tab>browse method source'.! !

!SdHelp class methodsFor: 'accessing' stamp: 'mt 7/31/2011 19:23:08.21'!
pages

	^ #(keyboardShortcuts)! !

UiToolButton subclass: #SdDraggableButton
	instanceVariableNames: 'target passenger'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sight-Dynamic-UI-Support'!

!SdDraggableButton class methodsFor: 'accessing' stamp: 'mt 4/25/2011 10:42:50.921'!
widgetCategory

	^ 'Sight-Dynamic'! !

!SdDraggableButton class methodsFor: 'accessing' stamp: 'mt 4/25/2011 10:42:38.703'!
widgetClassName

	^ 'Draggable Button'! !

!SdDraggableButton methodsFor: 'initialization' stamp: 'mt 4/25/2011 10:53:32.387'!
initialize

	super initialize.
	
	self
		dragEnabled: true;
		autoRaise: true.! !

!SdDraggableButton methodsFor: 'initialization' stamp: 'mt 4/25/2011 10:45:51.888'!
initializeEventHandler

	super initializeEventHandler.
	
	self connect: self eventHandler signal: #mouseDragStarted: toSelector: #mouseStartDrag:.  ! !

!SdDraggableButton methodsFor: 'dragging' stamp: 'mt 6/18/2012 10:50:48.757'!
mouseStartDrag: evt 
	
	evt hand hasSubmorphs ifTrue: [^ self].
	self dragEnabled ifFalse: [^ self].
	
	self down: false; flatten.
	
	[evt hand grabMorph: (TransferMorph
		withPassenger: self passenger
		from: self target)]
		ensure: [Cursor normal show. evt hand releaseMouseFocus: self].! !

!SdDraggableButton methodsFor: 'accessing' stamp: 'mt 6/18/2012 10:50:25.041'!
passenger

	^ passenger ifNil:[ ('<font color="#FFFFFF">', self target asString escapeHtmlText, '</font>') asHtmlText asMorph]! !

!SdDraggableButton methodsFor: 'accessing' stamp: 'mt 6/18/2012 10:49:38.336'!
passenger: aMorph

	passenger := aMorph.! !

!SdDraggableButton methodsFor: 'accessing' stamp: 'mt 4/25/2011 10:47:23.444'!
target
	"The class element editor that is attached to the transfer morph."
	
	^ target! !

!SdDraggableButton methodsFor: 'accessing' stamp: 'mt 6/18/2012 10:49:56.38'!
target: anObject
	
	target := anObject.! !

UiToolButton subclass: #SdFadingButton
	instanceVariableNames: 'fadeAnimation fadeEnabled'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sight-Dynamic-UI-Support'!

!SdFadingButton class methodsFor: 'testing' stamp: 'mt 4/19/2011 10:15:31.048'!
isWidgetClass

	^ false! !

!SdFadingButton methodsFor: 'accessing' stamp: 'mt 5/12/2011 13:07:44.85'!
fadeEnabled

	^ fadeEnabled ifNil: [fadeEnabled := true]! !

!SdFadingButton methodsFor: 'accessing' stamp: 'mt 5/12/2011 13:15:18.664'!
fadeEnabled: aBoolean

	aBoolean = fadeEnabled ifTrue: [^ self].

	fadeEnabled := aBoolean.
	
	fadeEnabled
		ifFalse: [self fadeIn]
		ifTrue: [self fadeOutInstantly].
	! !

!SdFadingButton methodsFor: 'animations' stamp: 'mt 5/12/2011 13:14:48.722'!
fadeIn

	self visible ifFalse: [^ self].

	fadeAnimation
		ifNil: [^ self]
		ifNotNil: [:anim |
			anim unregister.
			fadeAnimation := nil].
	
	self fadeEnabled
		ifFalse: [^ self].
	
	(AnimAlphaBlendAnimation new
		morph: self;
		duration: 200;
		startValue: 0.3;
		endValue: 1.0;
		register;
		start: #deleteWhenFinished).! !

!SdFadingButton methodsFor: 'animations' stamp: 'mt 5/12/2011 13:11:59.723'!
fadeOut

	(self visible not or: [self fadeEnabled not])
		ifTrue: [^ self].
	
	fadeAnimation ifNil: [fadeAnimation := (AnimAlphaBlendAnimation
		fadeOutOn: self
		to: 0.3
		duration: 200)
		register;
		start: #keepWhenFinished].! !

!SdFadingButton methodsFor: 'animations' stamp: 'mt 5/12/2011 13:12:54.534'!
fadeOutInstantly

	self fadeOut.
	
	fadeAnimation ifNotNil: [fadeAnimation
		stop;
		toEnd].! !

!SdFadingButton methodsFor: 'initialization' stamp: 'mt 5/12/2011 13:11:08.276'!
initialize

	super initialize.
	
	self
		fadeOutInstantly;
		layoutInset: (0@ -5 corner: 0@ -3).! !

!SdFadingButton methodsFor: 'initialization' stamp: 'mt 4/18/2011 15:56:09.335'!
initializeEventHandler

	super initializeEventHandler.
	
	self connect: self eventHandler signal: #mouseEntered: toSelector: #fadeIn.
	self connect: self eventHandler signal: #mouseLeft: toSelector: #fadeOut.! !

SdFadingButton subclass: #SdProtocolButton
	instanceVariableNames: 'organization'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sight-Dynamic-UI-Support'!

!SdProtocolButton methodsFor: 'initialization' stamp: 'mt 4/18/2011 16:03:39.71'!
initialize

	super initialize.
	
	self
		color: Color yellow paler;
		text: 'protocol';
		balloonText: 'method protocol'.! !

!SdProtocolButton methodsFor: 'initialization' stamp: 'mt 4/18/2011 15:56:15.093'!
initializeEventHandler

	super initializeEventHandler.
	
	self connect: self eventHandler signal: #mouseClicked: toSelector: #openProtocolList:.! !

!SdProtocolButton methodsFor: 'actions' stamp: 'mt 5/12/2011 14:13:26.672'!
openProtocolList: aMouseEvent

	| menu |
	menu := MenuMorph new
		defaultTarget: self.
		
	self organization categories
		select: [:category | category ~= self text asString asSymbol]
		thenDo: [:category | 
			menu
				add: category
				selector: #protocolChanged:
				argument: (category = #'as yet unclassified'
					ifTrue: []
					ifFalse: [category])].
	
	menu
		popUpAt: aMouseEvent hand position truncated
		forHand: aMouseEvent hand
		in: ActiveWorld
		allowKeyboard: false.! !

!SdProtocolButton methodsFor: 'accessing' stamp: 'mt 4/14/2011 15:33:52.892'!
organization

	^ organization! !

!SdProtocolButton methodsFor: 'accessing' stamp: 'mt 4/14/2011 15:34:18.601'!
organization: anOrganizer

	organization := anOrganizer.! !

!SdProtocolButton methodsFor: 'signals' stamp: 'mt 4/14/2011 15:52:23.076'!
protocolChanged: newProtocolName

	self emitAlways.! !

UiToolButton subclass: #SdNotificationToolButton
	instanceVariableNames: 'notificationIcon'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sight-Dynamic-UI-Support'!

!SdNotificationToolButton methodsFor: 'notifications' stamp: 'mt 7/11/2012 11:25:56.517'!
clear

	notificationIcon := nil.
	self redrawLater.! !

!SdNotificationToolButton methodsFor: 'drawing' stamp: 'mt 7/11/2012 11:00:44.665'!
drawOverlayOn: aCanvas

	self notificationIcon ifNil: [^ self].

	aCanvas
		translucentImage: self notificationIcon
		at: self bottomRight - self notificationIcon extent.! !

!SdNotificationToolButton methodsFor: 'accessing' stamp: 'mt 7/11/2012 10:56:07.535'!
notificationIcon
	^ notificationIcon! !

!SdNotificationToolButton methodsFor: 'accessing' stamp: 'mt 7/11/2012 11:14:30.927'!
setIcon: aForm

	notificationIcon := aForm clippedTo: 8@8.
	self redrawLater.! !

!SdNotificationToolButton methodsFor: 'accessing' stamp: 'mt 7/11/2012 11:13:16.248'!
setIconByNumber: anInteger color: aColor

	| canvas font labelExtent |
	font := StrikeFont familyName: 'Bitmap Envy Code R' pointSize: 8 emphasized: 1.
	labelExtent := (font widthOfString: anInteger asString) @ font height.
	
	notificationIcon := Form extent: labelExtent - (0@4) depth: 32.
	canvas := notificationIcon getCanvas.
	
	canvas
		fillRoundRect: (0@0 corner: notificationIcon extent)
		radius: 3
		fillStyle: (SolidFillStyle color: aColor).
	
	
		
	canvas
		drawString: anInteger asString
		at: (notificationIcon extent - labelExtent // 2) + (1@1)
		font: font
		color: Color white.
		
	self redrawLater.! !

!SdNotificationToolButton methodsFor: 'notifications' stamp: 'mt 7/11/2012 11:46:35.57'!
showError

	self setIcon: UiFugueIcons exclamationSmallRedIcon.! !

!SdNotificationToolButton methodsFor: 'notifications' stamp: 'mt 7/11/2012 11:18:02.669'!
showNumber: anInteger

	self setIconByNumber: anInteger color: Color red darker! !

!SdNotificationToolButton methodsFor: 'notifications' stamp: 'mt 7/11/2012 11:17:15.958'!
showWarning

	self setIcon: UiFugueIcons exclamationSmallIcon.! !

UserInterface subclass: #SdCallgraphEditorUi
	instanceVariableNames: 'hideBtn headerBtn closeBtn infoLbl moreBtn treeView findBtn findEdit findPrevBtn findNextBtn'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sight-Dynamic-UI-Designs'!

!SdCallgraphEditorUi methodsFor: 'accessing' stamp: 'mt 6/20/2012 14:03:41.846'!
closeBtn
	"No description given."
	
	^ closeBtn! !

!SdCallgraphEditorUi methodsFor: 'accessing' stamp: 'mt 6/20/2012 14:03:41.914'!
findBtn
	"No description given."
	
	^ findBtn! !

!SdCallgraphEditorUi methodsFor: 'accessing' stamp: 'mt 6/20/2012 14:03:41.932'!
findEdit
	"No description given."
	
	^ findEdit! !

!SdCallgraphEditorUi methodsFor: 'accessing' stamp: 'mt 6/20/2012 14:03:41.967'!
findNextBtn
	"No description given."
	
	^ findNextBtn! !

!SdCallgraphEditorUi methodsFor: 'accessing' stamp: 'mt 6/20/2012 14:03:41.949'!
findPrevBtn
	"No description given."
	
	^ findPrevBtn! !

!SdCallgraphEditorUi methodsFor: 'accessing' stamp: 'mt 6/20/2012 14:03:41.829'!
headerBtn
	"No description given."
	
	^ headerBtn! !

!SdCallgraphEditorUi methodsFor: 'accessing' stamp: 'mt 6/20/2012 14:03:41.811'!
hideBtn
	"No description given."
	
	^ hideBtn! !

!SdCallgraphEditorUi methodsFor: 'accessing' stamp: 'mt 6/20/2012 14:03:41.864'!
infoLbl
	"No description given."
	
	^ infoLbl! !

!SdCallgraphEditorUi methodsFor: 'ui - private' stamp: 'mt 6/20/2012 14:03:42.015'!
initializePanel
	"This code is auto-generated. DO NOT modify it because another generation step will overwrite all changes."
	
	| unnamedMorph1 unnamedMorph2 unnamedMorph3 unnamedMorph4 unnamedMorph5 |
	
	panel := UiContainer new.
	panel changeTableLayout.
	panel extent: (296@528).
	panel position: (0@0).
	panel hResizing: (#rigid).
	panel vResizing: (#rigid).
	panel minWidth: (2).
	panel minHeight: (2).
	panel cellInset: (1).
	panel cellPositioning: (#center).
	panel cellSpacing: (#none).
	panel layoutInset: (2).
	panel listCentering: (#topLeft).
	panel listDirection: (#topToBottom).
	panel listSpacing: (#none).
	panel maxCellSize: (1073741823).
	panel minCellSize: (0).
	panel wrapCentering: (#topLeft).
	panel wrapDirection: (#none).
	panel frameFractions: (0@0 corner: 1@1).
	panel frameOffsets: (0@0 corner: 0@0).
	panel balloonText: (nil).
	panel balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1.0 alpha: 0.922)).
	panel color: (Color transparent).
	panel borderWidth: (0).
	panel borderStyle2: (#simple).
	panel borderColor: (Color black).
	panel setProperty: #objectName toValue: 'panel'.
	unnamedMorph1 := UiContainer new.
	unnamedMorph1 changeTableLayout.
	unnamedMorph1 extent: (292@22).
	unnamedMorph1 position: (2@2).
	unnamedMorph1 hResizing: (#spaceFill).
	unnamedMorph1 vResizing: (#shrinkWrap).
	unnamedMorph1 minWidth: (2).
	unnamedMorph1 minHeight: (2).
	unnamedMorph1 cellInset: (0).
	unnamedMorph1 cellPositioning: (#center).
	unnamedMorph1 cellSpacing: (#none).
	unnamedMorph1 layoutInset: (0).
	unnamedMorph1 listCentering: (#topLeft).
	unnamedMorph1 listDirection: (#leftToRight).
	unnamedMorph1 listSpacing: (#none).
	unnamedMorph1 maxCellSize: (1073741823).
	unnamedMorph1 minCellSize: (0).
	unnamedMorph1 wrapCentering: (#topLeft).
	unnamedMorph1 wrapDirection: (#none).
	unnamedMorph1 frameFractions: (0@0 corner: 1@1).
	unnamedMorph1 frameOffsets: (0@0 corner: 0@0).
	unnamedMorph1 balloonText: (nil).
	unnamedMorph1 balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1.0 alpha: 0.922)).
	unnamedMorph1 color: (Color transparent).
	unnamedMorph1 borderWidth: (0).
	unnamedMorph1 borderStyle2: (#simple).
	unnamedMorph1 borderColor: (Color black).
	hideBtn := UiToolButton new.
	hideBtn changeTableLayout.
	hideBtn extent: (18@18).
	hideBtn position: (3@4).
	hideBtn hResizing: (#shrinkWrap).
	hideBtn vResizing: (#shrinkWrap).
	hideBtn minWidth: (2).
	hideBtn minHeight: (2).
	hideBtn cellInset: (4).
	hideBtn cellPositioning: (#center).
	hideBtn cellSpacing: (#none).
	hideBtn layoutInset: (0).
	hideBtn listCentering: (#topLeft).
	hideBtn listDirection: (#leftToRight).
	hideBtn listSpacing: (#none).
	hideBtn maxCellSize: (1073741823).
	hideBtn minCellSize: (0).
	hideBtn wrapCentering: (#topLeft).
	hideBtn wrapDirection: (#none).
	hideBtn frameFractions: (0@0 corner: 1@1).
	hideBtn frameOffsets: (0@0 corner: 0@0).
	hideBtn balloonText: (nil).
	hideBtn balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1.0 alpha: 0.922)).
	hideBtn enabled: (true).
	hideBtn setProperty: #iconByDesigner toValue: 'UiSilkIcons eyeIcon'.
	hideBtn icon: (UiSilkIcons eyeIcon).
	hideBtn text: ('ToolButton').
	hideBtn color: ((Color r: 0.85 g: 0.85 b: 0.85)).
	hideBtn checkable: (true).
	hideBtn checked: (true).
	hideBtn autoExclusive: (false).
	hideBtn autoRaise: (true).
	hideBtn buttonStyle: (#iconOnly).
	hideBtn setProperty: #objectName toValue: 'hideBtn'.
	unnamedMorph1 addMorphBack: hideBtn.
	unnamedMorph2 := UiSpacer new.
	unnamedMorph2 extent: (99@10).
	unnamedMorph2 position: (22@8).
	unnamedMorph2 hResizing: (#spaceFill).
	unnamedMorph2 vResizing: (#rigid).
	unnamedMorph2 minWidth: (2).
	unnamedMorph2 minHeight: (2).
	unnamedMorph2 cellInset: (0).
	unnamedMorph2 cellPositioning: (#center).
	unnamedMorph2 cellSpacing: (#none).
	unnamedMorph2 layoutInset: (0).
	unnamedMorph2 listCentering: (#topLeft).
	unnamedMorph2 listDirection: (#topToBottom).
	unnamedMorph2 listSpacing: (#none).
	unnamedMorph2 maxCellSize: (1073741823).
	unnamedMorph2 minCellSize: (0).
	unnamedMorph2 wrapCentering: (#topLeft).
	unnamedMorph2 wrapDirection: (#none).
	unnamedMorph2 frameFractions: (0@0 corner: 1@1).
	unnamedMorph2 frameOffsets: (0@0 corner: 0@0).
	unnamedMorph2 balloonText: (nil).
	unnamedMorph2 balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1.0 alpha: 0.922)).
	unnamedMorph2 color: (Color blue).
	unnamedMorph2 borderWidth: (0).
	unnamedMorph2 borderStyle2: (#simple).
	unnamedMorph2 borderColor: (Color black).
	unnamedMorph2 orientation: (#horizontal).
	unnamedMorph1 addMorphBack: unnamedMorph2.
	headerBtn := SdDraggableButton new.
	headerBtn changeTableLayout.
	headerBtn extent: (52@21).
	headerBtn position: (121@2).
	headerBtn hResizing: (#shrinkWrap).
	headerBtn vResizing: (#shrinkWrap).
	headerBtn minWidth: (2).
	headerBtn minHeight: (2).
	headerBtn cellInset: (4).
	headerBtn cellPositioning: (#center).
	headerBtn cellSpacing: (#none).
	headerBtn layoutInset: (2@0 corner: 2@0).
	headerBtn listCentering: (#topLeft).
	headerBtn listDirection: (#leftToRight).
	headerBtn listSpacing: (#none).
	headerBtn maxCellSize: (1073741823).
	headerBtn minCellSize: (0).
	headerBtn wrapCentering: (#topLeft).
	headerBtn wrapDirection: (#none).
	headerBtn frameFractions: (0@0 corner: 1@1).
	headerBtn frameOffsets: (0@0 corner: 0@0).
	headerBtn balloonText: (nil).
	headerBtn balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1.0 alpha: 0.922)).
	headerBtn enabled: (true).
	headerBtn setProperty: #iconByDesigner toValue: 'nil'.
	headerBtn icon: (nil).
	headerBtn text: ('Call Tree').
	headerBtn color: ((Color r: 0.85 g: 0.85 b: 0.85)).
	headerBtn checkable: (false).
	headerBtn checked: (false).
	headerBtn autoExclusive: (false).
	headerBtn autoRaise: (true).
	headerBtn buttonStyle: (#textBesideIcon).
	headerBtn setProperty: #objectName toValue: 'headerBtn'.
	unnamedMorph1 addMorphBack: headerBtn.
	unnamedMorph3 := UiSpacer new.
	unnamedMorph3 extent: (99@10).
	unnamedMorph3 position: (175@8).
	unnamedMorph3 hResizing: (#spaceFill).
	unnamedMorph3 vResizing: (#rigid).
	unnamedMorph3 minWidth: (2).
	unnamedMorph3 minHeight: (2).
	unnamedMorph3 cellInset: (0).
	unnamedMorph3 cellPositioning: (#center).
	unnamedMorph3 cellSpacing: (#none).
	unnamedMorph3 layoutInset: (0).
	unnamedMorph3 listCentering: (#topLeft).
	unnamedMorph3 listDirection: (#topToBottom).
	unnamedMorph3 listSpacing: (#none).
	unnamedMorph3 maxCellSize: (1073741823).
	unnamedMorph3 minCellSize: (0).
	unnamedMorph3 wrapCentering: (#topLeft).
	unnamedMorph3 wrapDirection: (#none).
	unnamedMorph3 frameFractions: (0@0 corner: 1@1).
	unnamedMorph3 frameOffsets: (0@0 corner: 0@0).
	unnamedMorph3 balloonText: (nil).
	unnamedMorph3 balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1.0 alpha: 0.922)).
	unnamedMorph3 color: (Color blue).
	unnamedMorph3 borderWidth: (0).
	unnamedMorph3 borderStyle2: (#simple).
	unnamedMorph3 borderColor: (Color black).
	unnamedMorph3 orientation: (#horizontal).
	unnamedMorph1 addMorphBack: unnamedMorph3.
	closeBtn := UiToolButton new.
	closeBtn changeTableLayout.
	closeBtn extent: (18@18).
	closeBtn position: (275@4).
	closeBtn hResizing: (#shrinkWrap).
	closeBtn vResizing: (#shrinkWrap).
	closeBtn minWidth: (2).
	closeBtn minHeight: (2).
	closeBtn cellInset: (4).
	closeBtn cellPositioning: (#center).
	closeBtn cellSpacing: (#none).
	closeBtn layoutInset: (0).
	closeBtn listCentering: (#topLeft).
	closeBtn listDirection: (#leftToRight).
	closeBtn listSpacing: (#none).
	closeBtn maxCellSize: (1073741823).
	closeBtn minCellSize: (0).
	closeBtn wrapCentering: (#topLeft).
	closeBtn wrapDirection: (#none).
	closeBtn frameFractions: (0@0 corner: 1@1).
	closeBtn frameOffsets: (0@0 corner: 0@0).
	closeBtn balloonText: (nil).
	closeBtn balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1.0 alpha: 0.922)).
	closeBtn enabled: (true).
	closeBtn setProperty: #iconByDesigner toValue: 'UiFugueIcons minusWhiteIcon'.
	closeBtn icon: (UiFugueIcons minusWhiteIcon).
	closeBtn text: ('Call Graph').
	closeBtn color: ((Color r: 0.85 g: 0.85 b: 0.85)).
	closeBtn checkable: (false).
	closeBtn checked: (false).
	closeBtn autoExclusive: (false).
	closeBtn autoRaise: (true).
	closeBtn buttonStyle: (#iconOnly).
	closeBtn setProperty: #objectName toValue: 'closeBtn'.
	unnamedMorph1 addMorphBack: closeBtn.
	panel addMorphBack: unnamedMorph1.
	unnamedMorph4 := UiContainer new.
	unnamedMorph4 changeTableLayout.
	unnamedMorph4 extent: (292@19).
	unnamedMorph4 position: (2@26).
	unnamedMorph4 hResizing: (#spaceFill).
	unnamedMorph4 vResizing: (#shrinkWrap).
	unnamedMorph4 minWidth: (2).
	unnamedMorph4 minHeight: (2).
	unnamedMorph4 cellInset: (4).
	unnamedMorph4 cellPositioning: (#topCenter).
	unnamedMorph4 cellSpacing: (#none).
	unnamedMorph4 layoutInset: (0).
	unnamedMorph4 listCentering: (#topLeft).
	unnamedMorph4 listDirection: (#leftToRight).
	unnamedMorph4 listSpacing: (#none).
	unnamedMorph4 maxCellSize: (1073741823).
	unnamedMorph4 minCellSize: (0).
	unnamedMorph4 wrapCentering: (#topLeft).
	unnamedMorph4 wrapDirection: (#none).
	unnamedMorph4 frameFractions: (0@0 corner: 1@1).
	unnamedMorph4 frameOffsets: (0@0 corner: 0@0).
	unnamedMorph4 balloonText: (nil).
	unnamedMorph4 balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1.0 alpha: 0.922)).
	unnamedMorph4 color: (Color transparent).
	unnamedMorph4 borderWidth: (0).
	unnamedMorph4 borderStyle2: (#simple).
	unnamedMorph4 borderColor: (Color black).
	infoLbl := UiLabel new.
	infoLbl changeTableLayout.
	infoLbl extent: (268@19).
	infoLbl position: (2@26).
	infoLbl hResizing: (#spaceFill).
	infoLbl vResizing: (#shrinkWrap).
	infoLbl minWidth: (2).
	infoLbl minHeight: (2).
	infoLbl cellInset: (0).
	infoLbl cellPositioning: (#center).
	infoLbl cellSpacing: (#none).
	infoLbl layoutInset: (0).
	infoLbl listCentering: (#topLeft).
	infoLbl listDirection: (#leftToRight).
	infoLbl listSpacing: (#none).
	infoLbl maxCellSize: (1073741823).
	infoLbl minCellSize: (0).
	infoLbl wrapCentering: (#topLeft).
	infoLbl wrapDirection: (#none).
	infoLbl frameFractions: (0@0 corner: 1@1).
	infoLbl frameOffsets: (0@0 corner: 0@0).
	infoLbl balloonText: (nil).
	infoLbl balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1.0 alpha: 0.922)).
	infoLbl text: ('Tracing...').
	infoLbl setProperty: #formByDesigner toValue: 'nil'.
	infoLbl form: (nil).
	infoLbl setProperty: #objectName toValue: 'infoLbl'.
	unnamedMorph4 addMorphBack: infoLbl.
	moreBtn := UiToolButton new.
	moreBtn changeTableLayout.
	moreBtn extent: (18@18).
	moreBtn position: (274@26).
	moreBtn hResizing: (#shrinkWrap).
	moreBtn vResizing: (#shrinkWrap).
	moreBtn minWidth: (2).
	moreBtn minHeight: (2).
	moreBtn cellInset: (4).
	moreBtn cellPositioning: (#center).
	moreBtn cellSpacing: (#none).
	moreBtn layoutInset: (0).
	moreBtn listCentering: (#topLeft).
	moreBtn listDirection: (#leftToRight).
	moreBtn listSpacing: (#none).
	moreBtn maxCellSize: (1073741823).
	moreBtn minCellSize: (0).
	moreBtn wrapCentering: (#topLeft).
	moreBtn wrapDirection: (#none).
	moreBtn frameFractions: (0@0 corner: 1@1).
	moreBtn frameOffsets: (0@0 corner: 0@0).
	moreBtn balloonText: ('More...').
	moreBtn balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1.0 alpha: 0.922)).
	moreBtn enabled: (true).
	moreBtn setProperty: #iconByDesigner toValue: 'UiSilkIcons bulletArrowDownIcon'.
	moreBtn icon: (UiSilkIcons bulletArrowDownIcon).
	moreBtn text: ('ToolButton').
	moreBtn color: ((Color r: 0.85 g: 0.85 b: 0.85)).
	moreBtn checkable: (true).
	moreBtn checked: (false).
	moreBtn autoExclusive: (false).
	moreBtn autoRaise: (true).
	moreBtn buttonStyle: (#iconOnly).
	moreBtn setProperty: #objectName toValue: 'moreBtn'.
	unnamedMorph4 addMorphBack: moreBtn.
	panel addMorphBack: unnamedMorph4.
	treeView := UiTreeView new.
	treeView extent: (292@455).
	treeView position: (2@47).
	treeView hResizing: (#spaceFill).
	treeView vResizing: (#spaceFill).
	treeView minWidth: (2).
	treeView minHeight: (2).
	treeView cellInset: (0).
	treeView cellPositioning: (#center).
	treeView cellSpacing: (#none).
	treeView layoutInset: (0).
	treeView listCentering: (#topLeft).
	treeView listDirection: (#topToBottom).
	treeView listSpacing: (#none).
	treeView maxCellSize: (1073741823).
	treeView minCellSize: (0).
	treeView wrapCentering: (#topLeft).
	treeView wrapDirection: (#none).
	treeView frameFractions: (0@0 corner: 1@1).
	treeView frameOffsets: (0@0 corner: 0@0).
	treeView balloonText: (nil).
	treeView balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1.0 alpha: 0.922)).
	treeView widgetResizable: (false).
	treeView horizontalScrollBarPolicy: (#asNeeded).
	treeView verticalScrollBarPolicy: (#asNeeded).
	treeView outerBorderWidth: (1).
	treeView scrollBarThickness: (9).
	treeView modelClass: (nil).
	treeView horizontalHeaderVisible: (false).
	treeView verticalHeaderVisible: (false).
	treeView selectionBehavior: (#selectRows).
	treeView selectionColor: ((Color r: 0.772 g: 0.858 b: 1.0)).
	treeView selectionMode: (UiViewSingleSelection).
	treeView setProperty: #objectName toValue: 'treeView'.
	panel addMorphBack: treeView.
	unnamedMorph5 := UiContainer new.
	unnamedMorph5 changeTableLayout.
	unnamedMorph5 extent: (292@23).
	unnamedMorph5 position: (2@503).
	unnamedMorph5 hResizing: (#spaceFill).
	unnamedMorph5 vResizing: (#rigid).
	unnamedMorph5 minWidth: (2).
	unnamedMorph5 minHeight: (2).
	unnamedMorph5 cellInset: (2).
	unnamedMorph5 cellPositioning: (#center).
	unnamedMorph5 cellSpacing: (#none).
	unnamedMorph5 layoutInset: (0@0 corner: 0@0).
	unnamedMorph5 listCentering: (#topLeft).
	unnamedMorph5 listDirection: (#leftToRight).
	unnamedMorph5 listSpacing: (#none).
	unnamedMorph5 maxCellSize: (1073741823).
	unnamedMorph5 minCellSize: (0).
	unnamedMorph5 wrapCentering: (#topLeft).
	unnamedMorph5 wrapDirection: (#none).
	unnamedMorph5 frameFractions: (0@0 corner: 1@1).
	unnamedMorph5 frameOffsets: (0@0 corner: 0@0).
	unnamedMorph5 balloonText: (nil).
	unnamedMorph5 balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1.0 alpha: 0.922)).
	unnamedMorph5 color: (Color white).
	unnamedMorph5 borderWidth: (1).
	unnamedMorph5 borderStyle2: (#inset).
	unnamedMorph5 borderColor: (#inset).
	findBtn := UiToolButton new.
	findBtn changeTableLayout.
	findBtn extent: (22@21).
	findBtn position: (3@504).
	findBtn hResizing: (#shrinkWrap).
	findBtn vResizing: (#spaceFill).
	findBtn minWidth: (2).
	findBtn minHeight: (2).
	findBtn cellInset: (4).
	findBtn cellPositioning: (#center).
	findBtn cellSpacing: (#none).
	findBtn layoutInset: (2@1 corner: 2@0).
	findBtn listCentering: (#topLeft).
	findBtn listDirection: (#leftToRight).
	findBtn listSpacing: (#none).
	findBtn maxCellSize: (1073741823).
	findBtn minCellSize: (0).
	findBtn wrapCentering: (#topLeft).
	findBtn wrapDirection: (#none).
	findBtn frameFractions: (0@0 corner: 1@1).
	findBtn frameOffsets: (0@0 corner: 0@0).
	findBtn balloonText: (nil).
	findBtn balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1.0 alpha: 0.922)).
	findBtn enabled: (true).
	findBtn setProperty: #iconByDesigner toValue: 'UiFugueIcons magnifierIcon'.
	findBtn icon: (UiFugueIcons magnifierIcon).
	findBtn text: ('ToolButton').
	findBtn color: (Color white).
	findBtn checkable: (false).
	findBtn checked: (false).
	findBtn autoExclusive: (false).
	findBtn autoRaise: (true).
	findBtn buttonStyle: (#iconOnly).
	findBtn setProperty: #objectName toValue: 'findBtn'.
	unnamedMorph5 addMorphBack: findBtn.
	findEdit := UiLineEdit new.
	findEdit extent: (218@20).
	findEdit position: (27@504).
	findEdit hResizing: (#spaceFill).
	findEdit vResizing: (#rigid).
	findEdit minWidth: (2).
	findEdit minHeight: (2).
	findEdit cellInset: (0).
	findEdit cellPositioning: (#center).
	findEdit cellSpacing: (#none).
	findEdit layoutInset: (0).
	findEdit listCentering: (#topLeft).
	findEdit listDirection: (#topToBottom).
	findEdit listSpacing: (#none).
	findEdit maxCellSize: (1073741823).
	findEdit minCellSize: (0).
	findEdit wrapCentering: (#topLeft).
	findEdit wrapDirection: (#none).
	findEdit frameFractions: (0@0 corner: 1@1).
	findEdit frameOffsets: (0@0 corner: 0@0).
	findEdit balloonText: (nil).
	findEdit balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1.0 alpha: 0.922)).
	findEdit widgetResizable: (false).
	findEdit horizontalScrollBarPolicy: (#alwaysOff).
	findEdit verticalScrollBarPolicy: (#alwaysOff).
	findEdit outerBorderWidth: (0).
	findEdit scrollBarThickness: (9).
	findEdit theText: ('').
	findEdit readOnly: (false).
	findEdit autoConvert: (false).
	findEdit autoAccept: (false).
	findEdit acceptOnFocusLost: (true).
	findEdit scrollingMode: (#none).
	findEdit scrollingLimit: (10).
	findEdit helpText: ('Search by regular expression...').
	findEdit hideCursor: (true).
	findEdit setProperty: #objectName toValue: 'findEdit'.
	unnamedMorph5 addMorphBack: findEdit.
	findPrevBtn := UiToolButton new.
	findPrevBtn changeTableLayout.
	findPrevBtn extent: (22@21).
	findPrevBtn position: (247@504).
	findPrevBtn hResizing: (#shrinkWrap).
	findPrevBtn vResizing: (#spaceFill).
	findPrevBtn minWidth: (2).
	findPrevBtn minHeight: (2).
	findPrevBtn cellInset: (4).
	findPrevBtn cellPositioning: (#center).
	findPrevBtn cellSpacing: (#none).
	findPrevBtn layoutInset: (2@1 corner: 2@0).
	findPrevBtn listCentering: (#topLeft).
	findPrevBtn listDirection: (#leftToRight).
	findPrevBtn listSpacing: (#none).
	findPrevBtn maxCellSize: (1073741823).
	findPrevBtn minCellSize: (0).
	findPrevBtn wrapCentering: (#topLeft).
	findPrevBtn wrapDirection: (#none).
	findPrevBtn frameFractions: (0@0 corner: 1@1).
	findPrevBtn frameOffsets: (0@0 corner: 0@0).
	findPrevBtn balloonText: (nil).
	findPrevBtn balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1.0 alpha: 0.922)).
	findPrevBtn enabled: (true).
	findPrevBtn setProperty: #iconByDesigner toValue: 'UiFugueIcons control180Icon'.
	findPrevBtn icon: (UiFugueIcons control180Icon).
	findPrevBtn text: ('ToolButton').
	findPrevBtn color: (Color white).
	findPrevBtn checkable: (false).
	findPrevBtn checked: (false).
	findPrevBtn autoExclusive: (false).
	findPrevBtn autoRaise: (true).
	findPrevBtn buttonStyle: (#iconOnly).
	findPrevBtn setProperty: #objectName toValue: 'findPrevBtn'.
	unnamedMorph5 addMorphBack: findPrevBtn.
	findNextBtn := UiToolButton new.
	findNextBtn changeTableLayout.
	findNextBtn extent: (22@21).
	findNextBtn position: (271@504).
	findNextBtn hResizing: (#shrinkWrap).
	findNextBtn vResizing: (#spaceFill).
	findNextBtn minWidth: (2).
	findNextBtn minHeight: (2).
	findNextBtn cellInset: (4).
	findNextBtn cellPositioning: (#center).
	findNextBtn cellSpacing: (#none).
	findNextBtn layoutInset: (2@1 corner: 2@0).
	findNextBtn listCentering: (#topLeft).
	findNextBtn listDirection: (#leftToRight).
	findNextBtn listSpacing: (#none).
	findNextBtn maxCellSize: (1073741823).
	findNextBtn minCellSize: (0).
	findNextBtn wrapCentering: (#topLeft).
	findNextBtn wrapDirection: (#none).
	findNextBtn frameFractions: (0@0 corner: 1@1).
	findNextBtn frameOffsets: (0@0 corner: 0@0).
	findNextBtn balloonText: (nil).
	findNextBtn balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1.0 alpha: 0.922)).
	findNextBtn enabled: (true).
	findNextBtn setProperty: #iconByDesigner toValue: 'UiFugueIcons controlIcon'.
	findNextBtn icon: (UiFugueIcons controlIcon).
	findNextBtn text: ('ToolButton').
	findNextBtn color: (Color white).
	findNextBtn checkable: (false).
	findNextBtn checked: (false).
	findNextBtn autoExclusive: (false).
	findNextBtn autoRaise: (true).
	findNextBtn buttonStyle: (#iconOnly).
	findNextBtn setProperty: #objectName toValue: 'findNextBtn'.
	unnamedMorph5 addMorphBack: findNextBtn.
	panel addMorphBack: unnamedMorph5.
	panel setProperty: #uiClassName toValue: 'SdCallgraphEditor'.! !

!SdCallgraphEditorUi methodsFor: 'accessing' stamp: 'mt 6/20/2012 14:03:41.88'!
moreBtn
	"No description given."
	
	^ moreBtn! !

!SdCallgraphEditorUi methodsFor: 'accessing' stamp: 'mt 6/20/2012 14:03:41.897'!
treeView
	"No description given."
	
	^ treeView! !

UserInterface subclass: #SdClassEditorUi
	instanceVariableNames: 'headerContainer pinBtn hideBtn superClassBtn headerBtn subClassBtn closeBtn topContainer findBtn commentBtn definitionBtn testBtn saveAllBtn closeAllBtn codeArea'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sight-Dynamic-UI-Designs'!

!SdClassEditorUi methodsFor: 'accessing' stamp: 'mt 6/15/2012 14:58:05.124'!
closeAllBtn
	"No description given."
	
	^ closeAllBtn! !

!SdClassEditorUi methodsFor: 'accessing' stamp: 'mt 6/15/2012 14:58:05.002'!
closeBtn
	"No description given."
	
	^ closeBtn! !

!SdClassEditorUi methodsFor: 'accessing' stamp: 'mt 6/15/2012 14:58:05.141'!
codeArea
	"No description given."
	
	^ codeArea! !

!SdClassEditorUi methodsFor: 'accessing' stamp: 'mt 6/15/2012 14:58:05.053'!
commentBtn
	"No description given."
	
	^ commentBtn! !

!SdClassEditorUi methodsFor: 'accessing' stamp: 'mt 6/15/2012 14:58:05.071'!
definitionBtn
	"No description given."
	
	^ definitionBtn! !

!SdClassEditorUi methodsFor: 'accessing' stamp: 'mt 6/15/2012 14:58:05.037'!
findBtn
	"No description given."
	
	^ findBtn! !

!SdClassEditorUi methodsFor: 'accessing' stamp: 'mt 6/15/2012 14:58:04.967'!
headerBtn
	"No description given."
	
	^ headerBtn! !

!SdClassEditorUi methodsFor: 'accessing' stamp: 'mt 6/15/2012 14:58:04.896'!
headerContainer
	"No description given."
	
	^ headerContainer! !

!SdClassEditorUi methodsFor: 'accessing' stamp: 'mt 6/15/2012 14:58:04.933'!
hideBtn
	"No description given."
	
	^ hideBtn! !

!SdClassEditorUi methodsFor: 'ui - private' stamp: 'mt 6/19/2012 16:01:22.675'!
initializePanel
	"This code is auto-generated. DO NOT modify it because another generation step will overwrite all changes."
	
	| unnamedMorph1 unnamedMorph2 unnamedMorph3 unnamedMorph4 unnamedMorph5 |
	
	panel := UiContainer new.
	panel changeTableLayout.
	panel extent: (244@569).
	panel position: (0@0).
	panel hResizing: (#rigid).
	panel vResizing: (#rigid).
	panel minWidth: (2).
	panel minHeight: (2).
	panel cellInset: (2).
	panel cellPositioning: (#center).
	panel cellSpacing: (#none).
	panel layoutInset: (2).
	panel listCentering: (#topLeft).
	panel listDirection: (#topToBottom).
	panel listSpacing: (#none).
	panel maxCellSize: (1073741823).
	panel minCellSize: (0).
	panel wrapCentering: (#topLeft).
	panel wrapDirection: (#none).
	panel frameFractions: (0@0 corner: 1@1).
	panel frameOffsets: (0@0 corner: 0@0).
	panel balloonText: (nil).
	panel balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1.0 alpha: 0.922)).
	panel color: (Color transparent).
	panel borderWidth: (0).
	panel borderStyle2: (#simple).
	panel borderColor: (Color black).
	panel setProperty: #objectName toValue: 'panel'.
	headerContainer := UiContainer new.
	headerContainer changeTableLayout.
	headerContainer extent: (240@22).
	headerContainer position: (2@2).
	headerContainer hResizing: (#spaceFill).
	headerContainer vResizing: (#shrinkWrap).
	headerContainer minWidth: (2).
	headerContainer minHeight: (2).
	headerContainer cellInset: (0).
	headerContainer cellPositioning: (#center).
	headerContainer cellSpacing: (#none).
	headerContainer layoutInset: (0).
	headerContainer listCentering: (#center).
	headerContainer listDirection: (#leftToRight).
	headerContainer listSpacing: (#none).
	headerContainer maxCellSize: (1073741823).
	headerContainer minCellSize: (0).
	headerContainer wrapCentering: (#topLeft).
	headerContainer wrapDirection: (#none).
	headerContainer frameFractions: (0@0 corner: 1@1).
	headerContainer frameOffsets: (0@0 corner: 0@0).
	headerContainer balloonText: (nil).
	headerContainer balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1.0 alpha: 0.922)).
	headerContainer color: (Color transparent).
	headerContainer borderWidth: (0).
	headerContainer borderStyle2: (#simple).
	headerContainer borderColor: (Color black).
	headerContainer setProperty: #objectName toValue: 'headerContainer'.
	pinBtn := UiToolButton new.
	pinBtn changeTableLayout.
	pinBtn extent: (18@18).
	pinBtn position: (3@4).
	pinBtn hResizing: (#shrinkWrap).
	pinBtn vResizing: (#shrinkWrap).
	pinBtn minWidth: (2).
	pinBtn minHeight: (2).
	pinBtn cellInset: (4).
	pinBtn cellPositioning: (#center).
	pinBtn cellSpacing: (#none).
	pinBtn layoutInset: (0).
	pinBtn listCentering: (#topLeft).
	pinBtn listDirection: (#leftToRight).
	pinBtn listSpacing: (#none).
	pinBtn maxCellSize: (1073741823).
	pinBtn minCellSize: (0).
	pinBtn wrapCentering: (#topLeft).
	pinBtn wrapDirection: (#none).
	pinBtn frameFractions: (0@0 corner: 1@1).
	pinBtn frameOffsets: (0@0 corner: 0@0).
	pinBtn balloonText: ('Pin this class').
	pinBtn balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1.0 alpha: 0.922)).
	pinBtn enabled: (true).
	pinBtn setProperty: #iconByDesigner toValue: 'UiFugueIcons pinSmallIcon'.
	pinBtn icon: (UiFugueIcons pinSmallIcon).
	pinBtn text: ('ToolButton').
	pinBtn color: ((Color r: 0.85 g: 0.85 b: 0.85)).
	pinBtn checkable: (true).
	pinBtn checked: (false).
	pinBtn autoExclusive: (false).
	pinBtn autoRaise: (true).
	pinBtn buttonStyle: (#iconOnly).
	pinBtn setProperty: #objectName toValue: 'pinBtn'.
	headerContainer addMorphBack: pinBtn.
	hideBtn := UiToolButton new.
	hideBtn changeTableLayout.
	hideBtn extent: (18@18).
	hideBtn position: (23@4).
	hideBtn hResizing: (#shrinkWrap).
	hideBtn vResizing: (#shrinkWrap).
	hideBtn minWidth: (2).
	hideBtn minHeight: (2).
	hideBtn cellInset: (4).
	hideBtn cellPositioning: (#center).
	hideBtn cellSpacing: (#none).
	hideBtn layoutInset: (0).
	hideBtn listCentering: (#topLeft).
	hideBtn listDirection: (#leftToRight).
	hideBtn listSpacing: (#none).
	hideBtn maxCellSize: (1073741823).
	hideBtn minCellSize: (0).
	hideBtn wrapCentering: (#topLeft).
	hideBtn wrapDirection: (#none).
	hideBtn frameFractions: (0@0 corner: 1@1).
	hideBtn frameOffsets: (0@0 corner: 0@0).
	hideBtn balloonText: ('Hide editor').
	hideBtn balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1.0 alpha: 0.933)).
	hideBtn enabled: (true).
	hideBtn setProperty: #iconByDesigner toValue: 'UiSilkIcons eyeIcon'.
	hideBtn icon: (UiSilkIcons eyeIcon).
	hideBtn text: ('ToolButton').
	hideBtn color: ((Color r: 0.85 g: 0.85 b: 0.85)).
	hideBtn checkable: (true).
	hideBtn checked: (true).
	hideBtn autoExclusive: (false).
	hideBtn autoRaise: (true).
	hideBtn buttonStyle: (#iconOnly).
	hideBtn setProperty: #objectName toValue: 'hideBtn'.
	headerContainer addMorphBack: hideBtn.
	unnamedMorph1 := UiSpacer new.
	unnamedMorph1 extent: (28@10).
	unnamedMorph1 position: (42@8).
	unnamedMorph1 hResizing: (#spaceFill).
	unnamedMorph1 vResizing: (#rigid).
	unnamedMorph1 minWidth: (2).
	unnamedMorph1 minHeight: (2).
	unnamedMorph1 cellInset: (4).
	unnamedMorph1 cellPositioning: (#center).
	unnamedMorph1 cellSpacing: (#none).
	unnamedMorph1 layoutInset: (4).
	unnamedMorph1 listCentering: (#topLeft).
	unnamedMorph1 listDirection: (#topToBottom).
	unnamedMorph1 listSpacing: (#none).
	unnamedMorph1 maxCellSize: (1073741823).
	unnamedMorph1 minCellSize: (0).
	unnamedMorph1 wrapCentering: (#topLeft).
	unnamedMorph1 wrapDirection: (#none).
	unnamedMorph1 frameFractions: (0@0 corner: 1@1).
	unnamedMorph1 frameOffsets: (0@0 corner: 0@0).
	unnamedMorph1 balloonText: (nil).
	unnamedMorph1 balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1.0 alpha: 0.922)).
	unnamedMorph1 color: (Color blue).
	unnamedMorph1 borderWidth: (0).
	unnamedMorph1 borderStyle2: (#simple).
	unnamedMorph1 borderColor: (Color black).
	unnamedMorph1 orientation: (#horizontal).
	headerContainer addMorphBack: unnamedMorph1.
	superClassBtn := UiToolButton new.
	superClassBtn changeTableLayout.
	superClassBtn extent: (18@18).
	superClassBtn position: (71@4).
	superClassBtn hResizing: (#shrinkWrap).
	superClassBtn vResizing: (#shrinkWrap).
	superClassBtn minWidth: (2).
	superClassBtn minHeight: (2).
	superClassBtn cellInset: (4).
	superClassBtn cellPositioning: (#center).
	superClassBtn cellSpacing: (#none).
	superClassBtn layoutInset: (0).
	superClassBtn listCentering: (#topLeft).
	superClassBtn listDirection: (#leftToRight).
	superClassBtn listSpacing: (#none).
	superClassBtn maxCellSize: (1073741823).
	superClassBtn minCellSize: (0).
	superClassBtn wrapCentering: (#topLeft).
	superClassBtn wrapDirection: (#none).
	superClassBtn frameFractions: (0@0 corner: 1@1).
	superClassBtn frameOffsets: (0@0 corner: 0@0).
	superClassBtn balloonText: ('Super class chain').
	superClassBtn balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1.0 alpha: 0.922)).
	superClassBtn enabled: (true).
	superClassBtn setProperty: #iconByDesigner toValue: 'UiFugueIcons control090SmallIcon'.
	superClassBtn icon: (UiFugueIcons control090SmallIcon).
	superClassBtn text: ('ToolButton').
	superClassBtn color: ((Color r: 0.85 g: 0.85 b: 0.85)).
	superClassBtn checkable: (false).
	superClassBtn checked: (false).
	superClassBtn autoExclusive: (false).
	superClassBtn autoRaise: (true).
	superClassBtn buttonStyle: (#iconOnly).
	superClassBtn setProperty: #objectName toValue: 'superClassBtn'.
	headerContainer addMorphBack: superClassBtn.
	headerBtn := SdDraggableButton new.
	headerBtn changeTableLayout.
	headerBtn extent: (66@21).
	headerBtn position: (90@2).
	headerBtn hResizing: (#shrinkWrap).
	headerBtn vResizing: (#shrinkWrap).
	headerBtn minWidth: (2).
	headerBtn minHeight: (2).
	headerBtn cellInset: (4).
	headerBtn cellPositioning: (#center).
	headerBtn cellSpacing: (#none).
	headerBtn layoutInset: (2@0 corner: 2@0).
	headerBtn listCentering: (#topLeft).
	headerBtn listDirection: (#leftToRight).
	headerBtn listSpacing: (#none).
	headerBtn maxCellSize: (1073741823).
	headerBtn minCellSize: (0).
	headerBtn wrapCentering: (#topLeft).
	headerBtn wrapDirection: (#none).
	headerBtn frameFractions: (0@0 corner: 1@1).
	headerBtn frameOffsets: (0@0 corner: 0@0).
	headerBtn balloonText: (nil).
	headerBtn balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1.0 alpha: 0.922)).
	headerBtn enabled: (true).
	headerBtn setProperty: #iconByDesigner toValue: 'nil'.
	headerBtn icon: (nil).
	headerBtn text: ('ToolButton').
	headerBtn color: ((Color r: 0.85 g: 0.85 b: 0.85)).
	headerBtn checkable: (false).
	headerBtn checked: (false).
	headerBtn autoExclusive: (false).
	headerBtn autoRaise: (true).
	headerBtn buttonStyle: (#textBesideIcon).
	headerBtn setProperty: #objectName toValue: 'headerBtn'.
	headerContainer addMorphBack: headerBtn.
	subClassBtn := UiToolButton new.
	subClassBtn changeTableLayout.
	subClassBtn extent: (18@18).
	subClassBtn position: (159@4).
	subClassBtn hResizing: (#shrinkWrap).
	subClassBtn vResizing: (#shrinkWrap).
	subClassBtn minWidth: (2).
	subClassBtn minHeight: (2).
	subClassBtn cellInset: (4).
	subClassBtn cellPositioning: (#center).
	subClassBtn cellSpacing: (#none).
	subClassBtn layoutInset: (0).
	subClassBtn listCentering: (#topLeft).
	subClassBtn listDirection: (#leftToRight).
	subClassBtn listSpacing: (#none).
	subClassBtn maxCellSize: (1073741823).
	subClassBtn minCellSize: (0).
	subClassBtn wrapCentering: (#topLeft).
	subClassBtn wrapDirection: (#none).
	subClassBtn frameFractions: (0@0 corner: 1@1).
	subClassBtn frameOffsets: (0@0 corner: 0@0).
	subClassBtn balloonText: ('Direct subclasses').
	subClassBtn balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1.0 alpha: 0.922)).
	subClassBtn enabled: (true).
	subClassBtn setProperty: #iconByDesigner toValue: 'UiFugueIcons control270SmallIcon'.
	subClassBtn icon: (UiFugueIcons control270SmallIcon).
	subClassBtn text: ('ToolButton').
	subClassBtn color: ((Color r: 0.85 g: 0.85 b: 0.85)).
	subClassBtn checkable: (false).
	subClassBtn checked: (false).
	subClassBtn autoExclusive: (false).
	subClassBtn autoRaise: (true).
	subClassBtn buttonStyle: (#iconOnly).
	subClassBtn setProperty: #objectName toValue: 'subClassBtn'.
	headerContainer addMorphBack: subClassBtn.
	unnamedMorph2 := UiSpacer new.
	unnamedMorph2 extent: (28@12).
	unnamedMorph2 position: (178@7).
	unnamedMorph2 hResizing: (#spaceFill).
	unnamedMorph2 vResizing: (#rigid).
	unnamedMorph2 minWidth: (2).
	unnamedMorph2 minHeight: (2).
	unnamedMorph2 cellInset: (4).
	unnamedMorph2 cellPositioning: (#center).
	unnamedMorph2 cellSpacing: (#none).
	unnamedMorph2 layoutInset: (4).
	unnamedMorph2 listCentering: (#topLeft).
	unnamedMorph2 listDirection: (#topToBottom).
	unnamedMorph2 listSpacing: (#none).
	unnamedMorph2 maxCellSize: (1073741823).
	unnamedMorph2 minCellSize: (0).
	unnamedMorph2 wrapCentering: (#topLeft).
	unnamedMorph2 wrapDirection: (#none).
	unnamedMorph2 frameFractions: (0@0 corner: 1@1).
	unnamedMorph2 frameOffsets: (0@0 corner: 0@0).
	unnamedMorph2 balloonText: (nil).
	unnamedMorph2 balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1.0 alpha: 0.922)).
	unnamedMorph2 color: (Color blue).
	unnamedMorph2 borderWidth: (0).
	unnamedMorph2 borderStyle2: (#simple).
	unnamedMorph2 borderColor: (Color black).
	unnamedMorph2 orientation: (#horizontal).
	headerContainer addMorphBack: unnamedMorph2.
	unnamedMorph3 := UiContainer new.
	unnamedMorph3 extent: (16@10).
	unnamedMorph3 position: (206@8).
	unnamedMorph3 hResizing: (#rigid).
	unnamedMorph3 vResizing: (#rigid).
	unnamedMorph3 minWidth: (2).
	unnamedMorph3 minHeight: (2).
	unnamedMorph3 cellInset: (4).
	unnamedMorph3 cellPositioning: (#center).
	unnamedMorph3 cellSpacing: (#none).
	unnamedMorph3 layoutInset: (4).
	unnamedMorph3 listCentering: (#topLeft).
	unnamedMorph3 listDirection: (#topToBottom).
	unnamedMorph3 listSpacing: (#none).
	unnamedMorph3 maxCellSize: (1073741823).
	unnamedMorph3 minCellSize: (0).
	unnamedMorph3 wrapCentering: (#topLeft).
	unnamedMorph3 wrapDirection: (#none).
	unnamedMorph3 frameFractions: (0@0 corner: 1@1).
	unnamedMorph3 frameOffsets: (0@0 corner: 0@0).
	unnamedMorph3 balloonText: (nil).
	unnamedMorph3 balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1.0 alpha: 0.945)).
	unnamedMorph3 color: (Color transparent).
	unnamedMorph3 borderWidth: (0).
	unnamedMorph3 borderStyle2: (#simple).
	unnamedMorph3 borderColor: (Color black).
	headerContainer addMorphBack: unnamedMorph3.
	closeBtn := UiToolButton new.
	closeBtn changeTableLayout.
	closeBtn extent: (18@18).
	closeBtn position: (223@4).
	closeBtn hResizing: (#shrinkWrap).
	closeBtn vResizing: (#shrinkWrap).
	closeBtn minWidth: (2).
	closeBtn minHeight: (2).
	closeBtn cellInset: (4).
	closeBtn cellPositioning: (#center).
	closeBtn cellSpacing: (#none).
	closeBtn layoutInset: (0).
	closeBtn listCentering: (#topLeft).
	closeBtn listDirection: (#leftToRight).
	closeBtn listSpacing: (#none).
	closeBtn maxCellSize: (1073741823).
	closeBtn minCellSize: (0).
	closeBtn wrapCentering: (#topLeft).
	closeBtn wrapDirection: (#none).
	closeBtn frameFractions: (0@0 corner: 1@1).
	closeBtn frameOffsets: (0@0 corner: 0@0).
	closeBtn balloonText: (nil).
	closeBtn balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1.0 alpha: 0.922)).
	closeBtn enabled: (true).
	closeBtn setProperty: #iconByDesigner toValue: 'UiFugueIcons minusWhiteIcon'.
	closeBtn icon: (UiFugueIcons minusWhiteIcon).
	closeBtn text: ('ToolButton').
	closeBtn color: ((Color r: 0.85 g: 0.85 b: 0.85)).
	closeBtn checkable: (false).
	closeBtn checked: (false).
	closeBtn autoExclusive: (false).
	closeBtn autoRaise: (true).
	closeBtn buttonStyle: (#iconOnly).
	closeBtn setProperty: #objectName toValue: 'closeBtn'.
	headerContainer addMorphBack: closeBtn.
	panel addMorphBack: headerContainer.
	topContainer := UiContainer new.
	topContainer changeTableLayout.
	topContainer extent: (240@20).
	topContainer position: (2@27).
	topContainer hResizing: (#spaceFill).
	topContainer vResizing: (#shrinkWrap).
	topContainer minWidth: (2).
	topContainer minHeight: (2).
	topContainer cellInset: (4).
	topContainer cellPositioning: (#center).
	topContainer cellSpacing: (#none).
	topContainer layoutInset: (0).
	topContainer listCentering: (#topLeft).
	topContainer listDirection: (#topToBottom).
	topContainer listSpacing: (#none).
	topContainer maxCellSize: (1073741823).
	topContainer minCellSize: (0).
	topContainer wrapCentering: (#topLeft).
	topContainer wrapDirection: (#none).
	topContainer frameFractions: (0@0 corner: 1@1).
	topContainer frameOffsets: (0@0 corner: 0@0).
	topContainer balloonText: (nil).
	topContainer balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1.0 alpha: 0.922)).
	topContainer color: (Color transparent).
	topContainer borderWidth: (0).
	topContainer borderStyle2: (#simple).
	topContainer borderColor: (Color black).
	topContainer setProperty: #objectName toValue: 'topContainer'.
	unnamedMorph4 := UiContainer new.
	unnamedMorph4 changeTableLayout.
	unnamedMorph4 extent: (240@19).
	unnamedMorph4 position: (2@28).
	unnamedMorph4 hResizing: (#spaceFill).
	unnamedMorph4 vResizing: (#shrinkWrap).
	unnamedMorph4 minWidth: (2).
	unnamedMorph4 minHeight: (2).
	unnamedMorph4 cellInset: (0).
	unnamedMorph4 cellPositioning: (#center).
	unnamedMorph4 cellSpacing: (#none).
	unnamedMorph4 layoutInset: (0).
	unnamedMorph4 listCentering: (#topLeft).
	unnamedMorph4 listDirection: (#leftToRight).
	unnamedMorph4 listSpacing: (#none).
	unnamedMorph4 maxCellSize: (1073741823).
	unnamedMorph4 minCellSize: (0).
	unnamedMorph4 wrapCentering: (#topLeft).
	unnamedMorph4 wrapDirection: (#none).
	unnamedMorph4 frameFractions: (0@0 corner: 1@1).
	unnamedMorph4 frameOffsets: (0@0 corner: 0@0).
	unnamedMorph4 balloonText: (nil).
	unnamedMorph4 balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1.0 alpha: 0.922)).
	unnamedMorph4 color: (Color transparent).
	unnamedMorph4 borderWidth: (0).
	unnamedMorph4 borderStyle2: (#simple).
	unnamedMorph4 borderColor: (Color black).
	findBtn := UiToolButton new.
	findBtn changeTableLayout.
	findBtn extent: (22@18).
	findBtn position: (2@28).
	findBtn hResizing: (#shrinkWrap).
	findBtn vResizing: (#shrinkWrap).
	findBtn minWidth: (2).
	findBtn minHeight: (2).
	findBtn cellInset: (4).
	findBtn cellPositioning: (#center).
	findBtn cellSpacing: (#none).
	findBtn layoutInset: (2@0 corner: 2@0).
	findBtn listCentering: (#topLeft).
	findBtn listDirection: (#leftToRight).
	findBtn listSpacing: (#none).
	findBtn maxCellSize: (1073741823).
	findBtn minCellSize: (0).
	findBtn wrapCentering: (#topLeft).
	findBtn wrapDirection: (#none).
	findBtn frameFractions: (0@0 corner: 1@1).
	findBtn frameOffsets: (0@0 corner: 0@0).
	findBtn balloonText: ('Find Method (CMD+F)').
	findBtn balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1.0 alpha: 0.922)).
	findBtn enabled: (true).
	findBtn setProperty: #iconByDesigner toValue: 'UiFugueIcons magnifierIcon'.
	findBtn icon: (UiFugueIcons magnifierIcon).
	findBtn text: ('ToolButton').
	findBtn color: ((Color r: 0.85 g: 0.85 b: 0.85)).
	findBtn checkable: (true).
	findBtn checked: (false).
	findBtn autoExclusive: (false).
	findBtn autoRaise: (true).
	findBtn buttonStyle: (#iconOnly).
	findBtn setProperty: #objectName toValue: 'findBtn'.
	unnamedMorph4 addMorphBack: findBtn.
	commentBtn := UiToolButton new.
	commentBtn changeTableLayout.
	commentBtn extent: (22@18).
	commentBtn position: (26@28).
	commentBtn hResizing: (#shrinkWrap).
	commentBtn vResizing: (#shrinkWrap).
	commentBtn minWidth: (2).
	commentBtn minHeight: (2).
	commentBtn cellInset: (4).
	commentBtn cellPositioning: (#center).
	commentBtn cellSpacing: (#none).
	commentBtn layoutInset: (2@0 corner: 2@0).
	commentBtn listCentering: (#topLeft).
	commentBtn listDirection: (#leftToRight).
	commentBtn listSpacing: (#none).
	commentBtn maxCellSize: (1073741823).
	commentBtn minCellSize: (0).
	commentBtn wrapCentering: (#topLeft).
	commentBtn wrapDirection: (#none).
	commentBtn frameFractions: (0@0 corner: 1@1).
	commentBtn frameOffsets: (0@0 corner: 0@0).
	commentBtn balloonText: ('Edit class comment').
	commentBtn balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1.0 alpha: 0.922)).
	commentBtn enabled: (true).
	commentBtn setProperty: #iconByDesigner toValue: 'UiSilkIcons commentIcon'.
	commentBtn icon: (UiSilkIcons commentIcon).
	commentBtn text: ('ToolButton').
	commentBtn color: ((Color r: 0.85 g: 0.85 b: 0.85)).
	commentBtn checkable: (true).
	commentBtn checked: (false).
	commentBtn autoExclusive: (false).
	commentBtn autoRaise: (true).
	commentBtn buttonStyle: (#iconOnly).
	commentBtn setProperty: #objectName toValue: 'commentBtn'.
	unnamedMorph4 addMorphBack: commentBtn.
	definitionBtn := UiToolButton new.
	definitionBtn changeTableLayout.
	definitionBtn extent: (22@18).
	definitionBtn position: (50@28).
	definitionBtn hResizing: (#shrinkWrap).
	definitionBtn vResizing: (#shrinkWrap).
	definitionBtn minWidth: (2).
	definitionBtn minHeight: (2).
	definitionBtn cellInset: (4).
	definitionBtn cellPositioning: (#center).
	definitionBtn cellSpacing: (#none).
	definitionBtn layoutInset: (2@0 corner: 2@0).
	definitionBtn listCentering: (#topLeft).
	definitionBtn listDirection: (#leftToRight).
	definitionBtn listSpacing: (#none).
	definitionBtn maxCellSize: (1073741823).
	definitionBtn minCellSize: (0).
	definitionBtn wrapCentering: (#topLeft).
	definitionBtn wrapDirection: (#none).
	definitionBtn frameFractions: (0@0 corner: 1@1).
	definitionBtn frameOffsets: (0@0 corner: 0@0).
	definitionBtn balloonText: (nil).
	definitionBtn balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1.0 alpha: 0.922)).
	definitionBtn enabled: (true).
	definitionBtn setProperty: #iconByDesigner toValue: 'UiSilkIcons wrenchOrangeIcon'.
	definitionBtn icon: (UiSilkIcons wrenchOrangeIcon).
	definitionBtn text: ('ToolButton').
	definitionBtn color: ((Color r: 0.85 g: 0.85 b: 0.85)).
	definitionBtn checkable: (true).
	definitionBtn checked: (false).
	definitionBtn autoExclusive: (false).
	definitionBtn autoRaise: (true).
	definitionBtn buttonStyle: (#iconOnly).
	definitionBtn setProperty: #objectName toValue: 'definitionBtn'.
	unnamedMorph4 addMorphBack: definitionBtn.
	testBtn := UiToolButton new.
	testBtn changeTableLayout.
	testBtn extent: (22@18).
	testBtn position: (74@28).
	testBtn hResizing: (#shrinkWrap).
	testBtn vResizing: (#shrinkWrap).
	testBtn minWidth: (2).
	testBtn minHeight: (2).
	testBtn cellInset: (4).
	testBtn cellPositioning: (#center).
	testBtn cellSpacing: (#none).
	testBtn layoutInset: (2@0 corner: 2@0).
	testBtn listCentering: (#topLeft).
	testBtn listDirection: (#leftToRight).
	testBtn listSpacing: (#none).
	testBtn maxCellSize: (1073741823).
	testBtn minCellSize: (0).
	testBtn wrapCentering: (#topLeft).
	testBtn wrapDirection: (#none).
	testBtn frameFractions: (0@0 corner: 1@1).
	testBtn frameOffsets: (0@0 corner: 0@0).
	testBtn balloonText: ('Indicates result of last
test run and allows to run
all tests.').
	testBtn balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1.0 alpha: 0.929)).
	testBtn enabled: (true).
	testBtn setProperty: #iconByDesigner toValue: 'UiDiagonaIcons icon0402Normal'.
	testBtn icon: (UiDiagonaIcons icon0402Normal).
	testBtn text: ('ToolButton').
	testBtn color: ((Color r: 0.85 g: 0.85 b: 0.85)).
	testBtn checkable: (false).
	testBtn checked: (false).
	testBtn autoExclusive: (false).
	testBtn autoRaise: (true).
	testBtn buttonStyle: (#iconOnly).
	testBtn setProperty: #objectName toValue: 'testBtn'.
	unnamedMorph4 addMorphBack: testBtn.
	unnamedMorph5 := UiSpacer new.
	unnamedMorph5 extent: (96@10).
	unnamedMorph5 position: (98@33).
	unnamedMorph5 hResizing: (#spaceFill).
	unnamedMorph5 vResizing: (#rigid).
	unnamedMorph5 minWidth: (2).
	unnamedMorph5 minHeight: (2).
	unnamedMorph5 cellInset: (4).
	unnamedMorph5 cellPositioning: (#center).
	unnamedMorph5 cellSpacing: (#none).
	unnamedMorph5 layoutInset: (4).
	unnamedMorph5 listCentering: (#topLeft).
	unnamedMorph5 listDirection: (#topToBottom).
	unnamedMorph5 listSpacing: (#none).
	unnamedMorph5 maxCellSize: (1073741823).
	unnamedMorph5 minCellSize: (0).
	unnamedMorph5 wrapCentering: (#topLeft).
	unnamedMorph5 wrapDirection: (#none).
	unnamedMorph5 frameFractions: (0@0 corner: 1@1).
	unnamedMorph5 frameOffsets: (0@0 corner: 0@0).
	unnamedMorph5 balloonText: (nil).
	unnamedMorph5 balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1.0 alpha: 0.922)).
	unnamedMorph5 color: (Color blue).
	unnamedMorph5 borderWidth: (0).
	unnamedMorph5 borderStyle2: (#simple).
	unnamedMorph5 borderColor: (Color black).
	unnamedMorph5 orientation: (#horizontal).
	unnamedMorph4 addMorphBack: unnamedMorph5.
	saveAllBtn := UiToolButton new.
	saveAllBtn changeTableLayout.
	saveAllBtn extent: (22@18).
	saveAllBtn position: (194@28).
	saveAllBtn hResizing: (#shrinkWrap).
	saveAllBtn vResizing: (#shrinkWrap).
	saveAllBtn minWidth: (2).
	saveAllBtn minHeight: (2).
	saveAllBtn cellInset: (4).
	saveAllBtn cellPositioning: (#center).
	saveAllBtn cellSpacing: (#none).
	saveAllBtn layoutInset: (2@0 corner: 2@0).
	saveAllBtn listCentering: (#topLeft).
	saveAllBtn listDirection: (#leftToRight).
	saveAllBtn listSpacing: (#none).
	saveAllBtn maxCellSize: (1073741823).
	saveAllBtn minCellSize: (0).
	saveAllBtn wrapCentering: (#topLeft).
	saveAllBtn wrapDirection: (#none).
	saveAllBtn frameFractions: (0@0 corner: 1@1).
	saveAllBtn frameOffsets: (0@0 corner: 0@0).
	saveAllBtn balloonText: ('Save all changed methods').
	saveAllBtn balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1.0 alpha: 0.922)).
	saveAllBtn enabled: (true).
	saveAllBtn setProperty: #iconByDesigner toValue: 'UiSilkIcons diskMultipleIcon'.
	saveAllBtn icon: (UiSilkIcons diskMultipleIcon).
	saveAllBtn text: ('ToolButton').
	saveAllBtn color: ((Color r: 0.85 g: 0.85 b: 0.85)).
	saveAllBtn checkable: (false).
	saveAllBtn checked: (false).
	saveAllBtn autoExclusive: (false).
	saveAllBtn autoRaise: (true).
	saveAllBtn buttonStyle: (#iconOnly).
	saveAllBtn setProperty: #objectName toValue: 'saveAllBtn'.
	unnamedMorph4 addMorphBack: saveAllBtn.
	closeAllBtn := UiToolButton new.
	closeAllBtn changeTableLayout.
	closeAllBtn extent: (22@18).
	closeAllBtn position: (218@28).
	closeAllBtn hResizing: (#shrinkWrap).
	closeAllBtn vResizing: (#shrinkWrap).
	closeAllBtn minWidth: (2).
	closeAllBtn minHeight: (2).
	closeAllBtn cellInset: (4).
	closeAllBtn cellPositioning: (#center).
	closeAllBtn cellSpacing: (#none).
	closeAllBtn layoutInset: (2@0 corner: 2@0).
	closeAllBtn listCentering: (#topLeft).
	closeAllBtn listDirection: (#leftToRight).
	closeAllBtn listSpacing: (#none).
	closeAllBtn maxCellSize: (1073741823).
	closeAllBtn minCellSize: (0).
	closeAllBtn wrapCentering: (#topLeft).
	closeAllBtn wrapDirection: (#none).
	closeAllBtn frameFractions: (0@0 corner: 1@1).
	closeAllBtn frameOffsets: (0@0 corner: 0@0).
	closeAllBtn balloonText: ('Close all editors for this
class').
	closeAllBtn balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1.0 alpha: 0.922)).
	closeAllBtn enabled: (true).
	closeAllBtn setProperty: #iconByDesigner toValue: 'UiFugueIcons broomIcon'.
	closeAllBtn icon: (UiFugueIcons broomIcon).
	closeAllBtn text: ('ToolButton').
	closeAllBtn color: ((Color r: 0.85 g: 0.85 b: 0.85)).
	closeAllBtn checkable: (false).
	closeAllBtn checked: (false).
	closeAllBtn autoExclusive: (false).
	closeAllBtn autoRaise: (true).
	closeAllBtn buttonStyle: (#iconOnly).
	closeAllBtn setProperty: #objectName toValue: 'closeAllBtn'.
	unnamedMorph4 addMorphBack: closeAllBtn.
	topContainer addMorphBack: unnamedMorph4.
	panel addMorphBack: topContainer.
	codeArea := SdScrollArea new.
	codeArea extent: (240@518).
	codeArea position: (2@49).
	codeArea hResizing: (#spaceFill).
	codeArea vResizing: (#spaceFill).
	codeArea minWidth: (2).
	codeArea minHeight: (2).
	codeArea cellInset: (0).
	codeArea cellPositioning: (#center).
	codeArea cellSpacing: (#none).
	codeArea layoutInset: (0).
	codeArea listCentering: (#topLeft).
	codeArea listDirection: (#topToBottom).
	codeArea listSpacing: (#none).
	codeArea maxCellSize: (1073741823).
	codeArea minCellSize: (0).
	codeArea wrapCentering: (#topLeft).
	codeArea wrapDirection: (#none).
	codeArea frameFractions: (0@0 corner: 1@1).
	codeArea frameOffsets: (0@0 corner: 0@0).
	codeArea balloonText: (nil).
	codeArea balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1.0 alpha: 0.922)).
	codeArea widgetResizable: (true).
	codeArea horizontalScrollBarPolicy: (#alwaysOff).
	codeArea verticalScrollBarPolicy: (#asNeeded).
	codeArea outerBorderWidth: (0).
	codeArea scrollBarThickness: (9).
	codeArea setProperty: #objectName toValue: 'codeArea'.
	panel addMorphBack: codeArea.
	panel setProperty: #uiClassName toValue: 'SdClassEditor'.! !

!SdClassEditorUi methodsFor: 'accessing' stamp: 'mt 6/15/2012 14:58:04.915'!
pinBtn
	"No description given."
	
	^ pinBtn! !

!SdClassEditorUi methodsFor: 'accessing' stamp: 'mt 6/15/2012 14:58:05.106'!
saveAllBtn
	"No description given."
	
	^ saveAllBtn! !

!SdClassEditorUi methodsFor: 'accessing' stamp: 'mt 6/15/2012 14:58:04.984'!
subClassBtn
	"No description given."
	
	^ subClassBtn! !

!SdClassEditorUi methodsFor: 'accessing' stamp: 'mt 6/15/2012 14:58:04.95'!
superClassBtn
	"No description given."
	
	^ superClassBtn! !

!SdClassEditorUi methodsFor: 'accessing' stamp: 'mt 6/15/2012 14:58:05.088'!
testBtn
	"No description given."
	
	^ testBtn! !

!SdClassEditorUi methodsFor: 'accessing' stamp: 'mt 6/15/2012 14:58:05.019'!
topContainer
	"No description given."
	
	^ topContainer! !

UserInterface subclass: #SdClassSelectorUi
	instanceVariableNames: 'unnamedMorph1 pinBtn hideBtn unnamedMorph2 headerBtn unnamedMorph3 unnamedMorph4 closeBtn container unnamedMorph5 recentlyList'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sight-Dynamic-UI-Designs'!

!SdClassSelectorUi methodsFor: 'accessing' stamp: 'mt 7/2/2011 15:28:02.027'!
closeBtn
	"nil"
	
	^ closeBtn! !

!SdClassSelectorUi methodsFor: 'accessing' stamp: 'mt 7/2/2011 15:28:02.066'!
container
	"nil"
	
	^ container! !

!SdClassSelectorUi methodsFor: 'accessing' stamp: 'mt 7/2/2011 15:28:01.968'!
headerBtn
	"nil"
	
	^ headerBtn! !

!SdClassSelectorUi methodsFor: 'accessing' stamp: 'mt 7/2/2011 15:28:01.899'!
hideBtn
	"nil"
	
	^ hideBtn! !

!SdClassSelectorUi methodsFor: 'ui - private' stamp: 'mt 7/2/2011 15:28:02.194'!
initializePanel
	"This code is auto-generated. DO NOT modify it because another generation step will overwrite all changes."
	
	panel := UiContainer new.
	panel changeTableLayout.
	panel extent: (248@388).
	panel position: (0@0).
	panel hResizing: (#rigid).
	panel vResizing: (#rigid).
	panel cellInset: (4).
	panel cellPositioning: (#center).
	panel cellSpacing: (#none).
	panel layoutInset: (2).
	panel listCentering: (#topLeft).
	panel listDirection: (#topToBottom).
	panel listSpacing: (#none).
	panel maxCellSize: (1073741823).
	panel minCellSize: (0).
	panel wrapCentering: (#topLeft).
	panel wrapDirection: (#none).
	panel frameFractions: (0@0 corner: 1@1).
	panel frameOffsets: (0@0 corner: 0@0).
	panel balloonText: (nil).
	panel balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1.0 alpha: 0.925)).
	panel color: (Color transparent).
	panel borderWidth: (0).
	panel borderStyle2: (#simple).
	panel borderColor: (Color black).
	panel setProperty: #objectName toValue: 'panel'.
	unnamedMorph1 := UiContainer new.
	unnamedMorph1 changeTableLayout.
	unnamedMorph1 extent: (244@21).
	unnamedMorph1 position: (2@2).
	unnamedMorph1 hResizing: (#spaceFill).
	unnamedMorph1 vResizing: (#shrinkWrap).
	unnamedMorph1 cellInset: (0).
	unnamedMorph1 cellPositioning: (#center).
	unnamedMorph1 cellSpacing: (#none).
	unnamedMorph1 layoutInset: (0).
	unnamedMorph1 listCentering: (#topLeft).
	unnamedMorph1 listDirection: (#leftToRight).
	unnamedMorph1 listSpacing: (#none).
	unnamedMorph1 maxCellSize: (1073741823).
	unnamedMorph1 minCellSize: (0).
	unnamedMorph1 wrapCentering: (#topLeft).
	unnamedMorph1 wrapDirection: (#none).
	unnamedMorph1 frameFractions: (0@0 corner: 1@1).
	unnamedMorph1 frameOffsets: (0@0 corner: 0@0).
	unnamedMorph1 balloonText: (nil).
	unnamedMorph1 balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1.0 alpha: 0.945)).
	unnamedMorph1 color: (Color transparent).
	unnamedMorph1 borderWidth: (0).
	unnamedMorph1 borderStyle2: (#simple).
	unnamedMorph1 borderColor: (Color black).
	pinBtn := UiToolButton new.
	pinBtn changeTableLayout.
	pinBtn extent: (18@18).
	pinBtn position: (2@3).
	pinBtn hResizing: (#shrinkWrap).
	pinBtn vResizing: (#shrinkWrap).
	pinBtn cellInset: (4).
	pinBtn cellPositioning: (#center).
	pinBtn cellSpacing: (#none).
	pinBtn layoutInset: (0).
	pinBtn listCentering: (#topLeft).
	pinBtn listDirection: (#leftToRight).
	pinBtn listSpacing: (#none).
	pinBtn maxCellSize: (1073741823).
	pinBtn minCellSize: (0).
	pinBtn wrapCentering: (#topLeft).
	pinBtn wrapDirection: (#none).
	pinBtn frameFractions: (0@0 corner: 1@1).
	pinBtn frameOffsets: (0@0 corner: 0@0).
	pinBtn balloonText: (nil).
	pinBtn balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1.0 alpha: 0.937)).
	pinBtn enabled: (true).
	pinBtn setProperty: #iconByDesigner toValue: 'UiFugueIcons pinSmallIcon'.
	pinBtn icon: (UiFugueIcons pinSmallIcon).
	pinBtn text: ('ToolButton').
	pinBtn color: ((Color r: 0.85 g: 0.85 b: 0.85)).
	pinBtn checkable: (true).
	pinBtn checked: (false).
	pinBtn autoExclusive: (false).
	pinBtn autoRaise: (true).
	pinBtn buttonStyle: (#iconOnly).
	pinBtn setProperty: #objectName toValue: 'pinBtn'.
	unnamedMorph1 addMorphBack: pinBtn.
	hideBtn := UiToolButton new.
	hideBtn changeTableLayout.
	hideBtn extent: (18@18).
	hideBtn position: (20@3).
	hideBtn hResizing: (#shrinkWrap).
	hideBtn vResizing: (#shrinkWrap).
	hideBtn cellInset: (4).
	hideBtn cellPositioning: (#center).
	hideBtn cellSpacing: (#none).
	hideBtn layoutInset: (0).
	hideBtn listCentering: (#topLeft).
	hideBtn listDirection: (#leftToRight).
	hideBtn listSpacing: (#none).
	hideBtn maxCellSize: (1073741823).
	hideBtn minCellSize: (0).
	hideBtn wrapCentering: (#topLeft).
	hideBtn wrapDirection: (#none).
	hideBtn frameFractions: (0@0 corner: 1@1).
	hideBtn frameOffsets: (0@0 corner: 0@0).
	hideBtn balloonText: (nil).
	hideBtn balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1.0 alpha: 0.941)).
	hideBtn enabled: (true).
	hideBtn setProperty: #iconByDesigner toValue: 'UiSilkIcons eyeIcon'.
	hideBtn icon: (UiSilkIcons eyeIcon).
	hideBtn text: ('ToolButton').
	hideBtn color: ((Color r: 0.85 g: 0.85 b: 0.85)).
	hideBtn checkable: (true).
	hideBtn checked: (true).
	hideBtn autoExclusive: (false).
	hideBtn autoRaise: (true).
	hideBtn buttonStyle: (#iconOnly).
	hideBtn setProperty: #objectName toValue: 'hideBtn'.
	unnamedMorph1 addMorphBack: hideBtn.
	unnamedMorph2 := UiSpacer new.
	unnamedMorph2 extent: (41@10).
	unnamedMorph2 position: (38@7).
	unnamedMorph2 hResizing: (#spaceFill).
	unnamedMorph2 vResizing: (#rigid).
	unnamedMorph2 cellInset: (0).
	unnamedMorph2 cellPositioning: (#center).
	unnamedMorph2 cellSpacing: (#none).
	unnamedMorph2 layoutInset: (0).
	unnamedMorph2 listCentering: (#topLeft).
	unnamedMorph2 listDirection: (#topToBottom).
	unnamedMorph2 listSpacing: (#none).
	unnamedMorph2 maxCellSize: (1073741823).
	unnamedMorph2 minCellSize: (0).
	unnamedMorph2 wrapCentering: (#topLeft).
	unnamedMorph2 wrapDirection: (#none).
	unnamedMorph2 frameFractions: (0@0 corner: 1@1).
	unnamedMorph2 frameOffsets: (0@0 corner: 0@0).
	unnamedMorph2 balloonText: (nil).
	unnamedMorph2 balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1.0 alpha: 0.945)).
	unnamedMorph2 color: (Color blue).
	unnamedMorph2 borderWidth: (0).
	unnamedMorph2 borderStyle2: (#simple).
	unnamedMorph2 borderColor: (Color black).
	unnamedMorph2 orientation: (#horizontal).
	unnamedMorph1 addMorphBack: unnamedMorph2.
	headerBtn := SdDraggableButton new.
	headerBtn changeTableLayout.
	headerBtn extent: (85@21).
	headerBtn position: (79@2).
	headerBtn hResizing: (#shrinkWrap).
	headerBtn vResizing: (#shrinkWrap).
	headerBtn cellInset: (4).
	headerBtn cellPositioning: (#center).
	headerBtn cellSpacing: (#none).
	headerBtn layoutInset: (2@0 corner: 2@0).
	headerBtn listCentering: (#topLeft).
	headerBtn listDirection: (#leftToRight).
	headerBtn listSpacing: (#none).
	headerBtn maxCellSize: (1073741823).
	headerBtn minCellSize: (0).
	headerBtn wrapCentering: (#topLeft).
	headerBtn wrapDirection: (#none).
	headerBtn frameFractions: (0@0 corner: 1@1).
	headerBtn frameOffsets: (0@0 corner: 0@0).
	headerBtn balloonText: (nil).
	headerBtn balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1.0 alpha: 0.941)).
	headerBtn enabled: (true).
	headerBtn setProperty: #iconByDesigner toValue: 'nil'.
	headerBtn icon: (nil).
	headerBtn text: ('Choose a Class').
	headerBtn color: ((Color r: 0.85 g: 0.85 b: 0.85)).
	headerBtn checkable: (false).
	headerBtn checked: (false).
	headerBtn autoExclusive: (false).
	headerBtn autoRaise: (true).
	headerBtn buttonStyle: (#textBesideIcon).
	headerBtn setProperty: #objectName toValue: 'headerBtn'.
	unnamedMorph1 addMorphBack: headerBtn.
	unnamedMorph3 := UiSpacer new.
	unnamedMorph3 extent: (42@10).
	unnamedMorph3 position: (164@7).
	unnamedMorph3 hResizing: (#spaceFill).
	unnamedMorph3 vResizing: (#rigid).
	unnamedMorph3 cellInset: (0).
	unnamedMorph3 cellPositioning: (#center).
	unnamedMorph3 cellSpacing: (#none).
	unnamedMorph3 layoutInset: (0).
	unnamedMorph3 listCentering: (#topLeft).
	unnamedMorph3 listDirection: (#topToBottom).
	unnamedMorph3 listSpacing: (#none).
	unnamedMorph3 maxCellSize: (1073741823).
	unnamedMorph3 minCellSize: (0).
	unnamedMorph3 wrapCentering: (#topLeft).
	unnamedMorph3 wrapDirection: (#none).
	unnamedMorph3 frameFractions: (0@0 corner: 1@1).
	unnamedMorph3 frameOffsets: (0@0 corner: 0@0).
	unnamedMorph3 balloonText: (nil).
	unnamedMorph3 balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1.0 alpha: 0.945)).
	unnamedMorph3 color: (Color blue).
	unnamedMorph3 borderWidth: (0).
	unnamedMorph3 borderStyle2: (#simple).
	unnamedMorph3 borderColor: (Color black).
	unnamedMorph3 orientation: (#horizontal).
	unnamedMorph1 addMorphBack: unnamedMorph3.
	unnamedMorph4 := UiContainer new.
	unnamedMorph4 extent: (16@10).
	unnamedMorph4 position: (209@7).
	unnamedMorph4 hResizing: (#rigid).
	unnamedMorph4 vResizing: (#rigid).
	unnamedMorph4 cellInset: (4).
	unnamedMorph4 cellPositioning: (#center).
	unnamedMorph4 cellSpacing: (#none).
	unnamedMorph4 layoutInset: (4).
	unnamedMorph4 listCentering: (#topLeft).
	unnamedMorph4 listDirection: (#topToBottom).
	unnamedMorph4 listSpacing: (#none).
	unnamedMorph4 maxCellSize: (1073741823).
	unnamedMorph4 minCellSize: (0).
	unnamedMorph4 wrapCentering: (#topLeft).
	unnamedMorph4 wrapDirection: (#none).
	unnamedMorph4 frameFractions: (0@0 corner: 1@1).
	unnamedMorph4 frameOffsets: (0@0 corner: 0@0).
	unnamedMorph4 balloonText: (nil).
	unnamedMorph4 balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1.0 alpha: 0.949)).
	unnamedMorph4 color: (Color transparent).
	unnamedMorph4 borderWidth: (0).
	unnamedMorph4 borderStyle2: (#simple).
	unnamedMorph4 borderColor: (Color black).
	unnamedMorph1 addMorphBack: unnamedMorph4.
	closeBtn := UiToolButton new.
	closeBtn changeTableLayout.
	closeBtn extent: (18@18).
	closeBtn position: (228@3).
	closeBtn hResizing: (#shrinkWrap).
	closeBtn vResizing: (#shrinkWrap).
	closeBtn cellInset: (4).
	closeBtn cellPositioning: (#center).
	closeBtn cellSpacing: (#none).
	closeBtn layoutInset: (0).
	closeBtn listCentering: (#topLeft).
	closeBtn listDirection: (#leftToRight).
	closeBtn listSpacing: (#none).
	closeBtn maxCellSize: (1073741823).
	closeBtn minCellSize: (0).
	closeBtn wrapCentering: (#topLeft).
	closeBtn wrapDirection: (#none).
	closeBtn frameFractions: (0@0 corner: 1@1).
	closeBtn frameOffsets: (0@0 corner: 0@0).
	closeBtn balloonText: (nil).
	closeBtn balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1.0 alpha: 0.945)).
	closeBtn enabled: (true).
	closeBtn setProperty: #iconByDesigner toValue: 'UiFugueIcons minusWhiteIcon'.
	closeBtn icon: (UiFugueIcons minusWhiteIcon).
	closeBtn text: ('Choose a Class').
	closeBtn color: ((Color r: 0.85 g: 0.85 b: 0.85)).
	closeBtn checkable: (false).
	closeBtn checked: (false).
	closeBtn autoExclusive: (false).
	closeBtn autoRaise: (true).
	closeBtn buttonStyle: (#iconOnly).
	closeBtn setProperty: #objectName toValue: 'closeBtn'.
	unnamedMorph1 addMorphBack: closeBtn.
	panel addMorphBack: unnamedMorph1.
	container := UiContainer new.
	container changeTableLayout.
	container extent: (244@18).
	container position: (2@30).
	container hResizing: (#spaceFill).
	container vResizing: (#shrinkWrap).
	container cellInset: (2).
	container cellPositioning: (#center).
	container cellSpacing: (#none).
	container layoutInset: (0).
	container listCentering: (#topLeft).
	container listDirection: (#topToBottom).
	container listSpacing: (#none).
	container maxCellSize: (1073741823).
	container minCellSize: (0).
	container wrapCentering: (#topLeft).
	container wrapDirection: (#none).
	container frameFractions: (0@0 corner: 1@1).
	container frameOffsets: (0@0 corner: 0@0).
	container balloonText: (nil).
	container balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1.0 alpha: 0.925)).
	container color: (Color transparent).
	container borderWidth: (0).
	container borderStyle2: (#simple).
	container borderColor: (Color black).
	container setProperty: #objectName toValue: 'container'.
	panel addMorphBack: container.
	unnamedMorph5 := UiLabel new.
	unnamedMorph5 changeTableLayout.
	unnamedMorph5 extent: (74@19).
	unnamedMorph5 position: (87@55).
	unnamedMorph5 hResizing: (#shrinkWrap).
	unnamedMorph5 vResizing: (#shrinkWrap).
	unnamedMorph5 cellInset: (0).
	unnamedMorph5 cellPositioning: (#center).
	unnamedMorph5 cellSpacing: (#none).
	unnamedMorph5 layoutInset: (0).
	unnamedMorph5 listCentering: (#topLeft).
	unnamedMorph5 listDirection: (#leftToRight).
	unnamedMorph5 listSpacing: (#none).
	unnamedMorph5 maxCellSize: (1073741823).
	unnamedMorph5 minCellSize: (0).
	unnamedMorph5 wrapCentering: (#topLeft).
	unnamedMorph5 wrapDirection: (#none).
	unnamedMorph5 frameFractions: (0@0 corner: 1@1).
	unnamedMorph5 frameOffsets: (0@0 corner: 0@0).
	unnamedMorph5 balloonText: (nil).
	unnamedMorph5 balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1.0 alpha: 0.922)).
	unnamedMorph5 text: ('Recently Used').
	unnamedMorph5 setProperty: #formByDesigner toValue: 'nil'.
	unnamedMorph5 form: (nil).
	panel addMorphBack: unnamedMorph5.
	recentlyList := UiListWidget new.
	recentlyList extent: (244@308).
	recentlyList position: (2@78).
	recentlyList hResizing: (#spaceFill).
	recentlyList vResizing: (#spaceFill).
	recentlyList cellInset: (0).
	recentlyList cellPositioning: (#center).
	recentlyList cellSpacing: (#none).
	recentlyList layoutInset: (0).
	recentlyList listCentering: (#topLeft).
	recentlyList listDirection: (#topToBottom).
	recentlyList listSpacing: (#none).
	recentlyList maxCellSize: (1073741823).
	recentlyList minCellSize: (0).
	recentlyList wrapCentering: (#topLeft).
	recentlyList wrapDirection: (#none).
	recentlyList frameFractions: (0@0 corner: 1@1).
	recentlyList frameOffsets: (0@0 corner: 0@0).
	recentlyList balloonText: (nil).
	recentlyList balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1.0 alpha: 0.929)).
	recentlyList widgetResizable: (false).
	recentlyList horizontalScrollBarPolicy: (#alwaysOff).
	recentlyList verticalScrollBarPolicy: (#asNeeded).
	recentlyList outerBorderWidth: (0).
	recentlyList scrollBarThickness: (9).
	recentlyList modelClass: (UiListWidgetModel).
	recentlyList horizontalHeaderVisible: (false).
	recentlyList verticalHeaderVisible: (false).
	recentlyList selectionBehavior: (#selectRows).
	recentlyList selectionColor: ((Color r: 0.772 g: 0.858 b: 1.0)).
	recentlyList selectionMode: (UiViewSingleSelection).
	recentlyList setProperty: #objectName toValue: 'recentlyList'.
	panel addMorphBack: recentlyList.
	panel setProperty: #uiClassName toValue: 'SdClassSelector'.! !

!SdClassSelectorUi methodsFor: 'accessing' stamp: 'mt 7/2/2011 15:28:01.816'!
pinBtn
	"nil"
	
	^ pinBtn! !

!SdClassSelectorUi methodsFor: 'accessing' stamp: 'mt 7/2/2011 15:28:02.128'!
recentlyList
	"nil"
	
	^ recentlyList! !

UserInterface subclass: #SdEditorTemplate
	instanceVariableNames: 'unnamedMorph1 pinBtn hideBtn unnamedMorph2 headerBtn unnamedMorph3 unnamedMorph4 closeBtn'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sight-Dynamic-UI-Designs'!

!SdEditorTemplate class methodsFor: 'testing' stamp: 'mt 5/18/2012 10:09:23.049'!
isTemplate

	^ true! !

!SdEditorTemplate methodsFor: 'accessing' stamp: 'mt 5/18/2012 10:09:01.6'!
closeBtn
	"nil"
	
	^ closeBtn! !

!SdEditorTemplate methodsFor: 'accessing' stamp: 'mt 5/18/2012 10:09:01.582'!
headerBtn
	"nil"
	
	^ headerBtn! !

!SdEditorTemplate methodsFor: 'accessing' stamp: 'mt 5/18/2012 10:09:01.565'!
hideBtn
	"nil"
	
	^ hideBtn! !

!SdEditorTemplate methodsFor: 'ui - private' stamp: 'mt 5/18/2012 10:32:27.125'!
initializePanel
	"This code is auto-generated. DO NOT modify it because another generation step will overwrite all changes."
	
	panel := UiContainer new.
	panel changeTableLayout.
	panel extent: (240@330).
	panel position: (0@0).
	panel hResizing: (#rigid).
	panel vResizing: (#rigid).
	panel minWidth: (2).
	panel minHeight: (2).
	panel cellInset: (2).
	panel cellPositioning: (#center).
	panel cellSpacing: (#none).
	panel layoutInset: (2).
	panel listCentering: (#topLeft).
	panel listDirection: (#topToBottom).
	panel listSpacing: (#none).
	panel maxCellSize: (1073741823).
	panel minCellSize: (0).
	panel wrapCentering: (#topLeft).
	panel wrapDirection: (#none).
	panel frameFractions: (0@0 corner: 1@1).
	panel frameOffsets: (0@0 corner: 0@0).
	panel balloonText: (nil).
	panel balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1.0 alpha: 0.922)).
	panel color: (Color transparent).
	panel borderWidth: (0).
	panel borderStyle2: (#simple).
	panel borderColor: (Color black).
	panel setProperty: #objectName toValue: 'panel'.
	unnamedMorph1 := UiContainer new.
	unnamedMorph1 changeTableLayout.
	unnamedMorph1 extent: (236@22).
	unnamedMorph1 position: (2@2).
	unnamedMorph1 hResizing: (#spaceFill).
	unnamedMorph1 vResizing: (#shrinkWrap).
	unnamedMorph1 minWidth: (2).
	unnamedMorph1 minHeight: (2).
	unnamedMorph1 cellInset: (0).
	unnamedMorph1 cellPositioning: (#center).
	unnamedMorph1 cellSpacing: (#none).
	unnamedMorph1 layoutInset: (0).
	unnamedMorph1 listCentering: (#topLeft).
	unnamedMorph1 listDirection: (#leftToRight).
	unnamedMorph1 listSpacing: (#none).
	unnamedMorph1 maxCellSize: (1073741823).
	unnamedMorph1 minCellSize: (0).
	unnamedMorph1 wrapCentering: (#topLeft).
	unnamedMorph1 wrapDirection: (#none).
	unnamedMorph1 frameFractions: (0@0 corner: 1@1).
	unnamedMorph1 frameOffsets: (0@0 corner: 0@0).
	unnamedMorph1 balloonText: (nil).
	unnamedMorph1 balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1.0 alpha: 0.922)).
	unnamedMorph1 color: (Color transparent).
	unnamedMorph1 borderWidth: (0).
	unnamedMorph1 borderStyle2: (#simple).
	unnamedMorph1 borderColor: (Color black).
	pinBtn := UiToolButton new.
	pinBtn changeTableLayout.
	pinBtn extent: (18@18).
	pinBtn position: (3@4).
	pinBtn hResizing: (#shrinkWrap).
	pinBtn vResizing: (#shrinkWrap).
	pinBtn minWidth: (2).
	pinBtn minHeight: (2).
	pinBtn cellInset: (4).
	pinBtn cellPositioning: (#center).
	pinBtn cellSpacing: (#none).
	pinBtn layoutInset: (0).
	pinBtn listCentering: (#topLeft).
	pinBtn listDirection: (#leftToRight).
	pinBtn listSpacing: (#none).
	pinBtn maxCellSize: (1073741823).
	pinBtn minCellSize: (0).
	pinBtn wrapCentering: (#topLeft).
	pinBtn wrapDirection: (#none).
	pinBtn frameFractions: (0@0 corner: 1@1).
	pinBtn frameOffsets: (0@0 corner: 0@0).
	pinBtn balloonText: (nil).
	pinBtn balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1.0 alpha: 0.922)).
	pinBtn enabled: (true).
	pinBtn setProperty: #iconByDesigner toValue: 'UiFugueIcons pinSmallIcon'.
	pinBtn icon: (UiFugueIcons pinSmallIcon).
	pinBtn text: ('ToolButton').
	pinBtn color: ((Color r: 0.85 g: 0.85 b: 0.85)).
	pinBtn checkable: (true).
	pinBtn checked: (false).
	pinBtn autoExclusive: (false).
	pinBtn autoRaise: (true).
	pinBtn buttonStyle: (#iconOnly).
	pinBtn setProperty: #objectName toValue: 'pinBtn'.
	unnamedMorph1 addMorphBack: pinBtn.
	hideBtn := UiToolButton new.
	hideBtn changeTableLayout.
	hideBtn extent: (18@18).
	hideBtn position: (23@4).
	hideBtn hResizing: (#shrinkWrap).
	hideBtn vResizing: (#shrinkWrap).
	hideBtn minWidth: (2).
	hideBtn minHeight: (2).
	hideBtn cellInset: (4).
	hideBtn cellPositioning: (#center).
	hideBtn cellSpacing: (#none).
	hideBtn layoutInset: (0).
	hideBtn listCentering: (#topLeft).
	hideBtn listDirection: (#leftToRight).
	hideBtn listSpacing: (#none).
	hideBtn maxCellSize: (1073741823).
	hideBtn minCellSize: (0).
	hideBtn wrapCentering: (#topLeft).
	hideBtn wrapDirection: (#none).
	hideBtn frameFractions: (0@0 corner: 1@1).
	hideBtn frameOffsets: (0@0 corner: 0@0).
	hideBtn balloonText: (nil).
	hideBtn balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1.0 alpha: 0.933)).
	hideBtn enabled: (true).
	hideBtn setProperty: #iconByDesigner toValue: 'UiSilkIcons eyeIcon'.
	hideBtn icon: (UiSilkIcons eyeIcon).
	hideBtn text: ('ToolButton').
	hideBtn color: ((Color r: 0.85 g: 0.85 b: 0.85)).
	hideBtn checkable: (true).
	hideBtn checked: (true).
	hideBtn autoExclusive: (false).
	hideBtn autoRaise: (true).
	hideBtn buttonStyle: (#iconOnly).
	hideBtn setProperty: #objectName toValue: 'hideBtn'.
	unnamedMorph1 addMorphBack: hideBtn.
	unnamedMorph2 := UiSpacer new.
	unnamedMorph2 extent: (57@10).
	unnamedMorph2 position: (42@8).
	unnamedMorph2 hResizing: (#spaceFill).
	unnamedMorph2 vResizing: (#rigid).
	unnamedMorph2 minWidth: (2).
	unnamedMorph2 minHeight: (2).
	unnamedMorph2 cellInset: (0).
	unnamedMorph2 cellPositioning: (#center).
	unnamedMorph2 cellSpacing: (#none).
	unnamedMorph2 layoutInset: (0).
	unnamedMorph2 listCentering: (#topLeft).
	unnamedMorph2 listDirection: (#topToBottom).
	unnamedMorph2 listSpacing: (#none).
	unnamedMorph2 maxCellSize: (1073741823).
	unnamedMorph2 minCellSize: (0).
	unnamedMorph2 wrapCentering: (#topLeft).
	unnamedMorph2 wrapDirection: (#none).
	unnamedMorph2 frameFractions: (0@0 corner: 1@1).
	unnamedMorph2 frameOffsets: (0@0 corner: 0@0).
	unnamedMorph2 balloonText: (nil).
	unnamedMorph2 balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1.0 alpha: 0.922)).
	unnamedMorph2 color: (Color blue).
	unnamedMorph2 borderWidth: (0).
	unnamedMorph2 borderStyle2: (#simple).
	unnamedMorph2 borderColor: (Color black).
	unnamedMorph2 orientation: (#horizontal).
	unnamedMorph1 addMorphBack: unnamedMorph2.
	headerBtn := SdDraggableButton new.
	headerBtn changeTableLayout.
	headerBtn extent: (44@21).
	headerBtn position: (99@2).
	headerBtn hResizing: (#shrinkWrap).
	headerBtn vResizing: (#shrinkWrap).
	headerBtn minWidth: (2).
	headerBtn minHeight: (2).
	headerBtn cellInset: (4).
	headerBtn cellPositioning: (#center).
	headerBtn cellSpacing: (#none).
	headerBtn layoutInset: (2@0 corner: 2@0).
	headerBtn listCentering: (#topLeft).
	headerBtn listDirection: (#leftToRight).
	headerBtn listSpacing: (#none).
	headerBtn maxCellSize: (1073741823).
	headerBtn minCellSize: (0).
	headerBtn wrapCentering: (#topLeft).
	headerBtn wrapDirection: (#none).
	headerBtn frameFractions: (0@0 corner: 1@1).
	headerBtn frameOffsets: (0@0 corner: 0@0).
	headerBtn balloonText: (nil).
	headerBtn balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1.0 alpha: 0.922)).
	headerBtn enabled: (true).
	headerBtn setProperty: #iconByDesigner toValue: 'nil'.
	headerBtn icon: (nil).
	headerBtn text: ('Header').
	headerBtn color: ((Color r: 0.85 g: 0.85 b: 0.85)).
	headerBtn checkable: (false).
	headerBtn checked: (false).
	headerBtn autoExclusive: (false).
	headerBtn autoRaise: (true).
	headerBtn buttonStyle: (#textBesideIcon).
	headerBtn setProperty: #objectName toValue: 'headerBtn'.
	unnamedMorph1 addMorphBack: headerBtn.
	unnamedMorph3 := UiSpacer new.
	unnamedMorph3 extent: (57@10).
	unnamedMorph3 position: (145@8).
	unnamedMorph3 hResizing: (#spaceFill).
	unnamedMorph3 vResizing: (#rigid).
	unnamedMorph3 minWidth: (2).
	unnamedMorph3 minHeight: (2).
	unnamedMorph3 cellInset: (0).
	unnamedMorph3 cellPositioning: (#center).
	unnamedMorph3 cellSpacing: (#none).
	unnamedMorph3 layoutInset: (0).
	unnamedMorph3 listCentering: (#topLeft).
	unnamedMorph3 listDirection: (#topToBottom).
	unnamedMorph3 listSpacing: (#none).
	unnamedMorph3 maxCellSize: (1073741823).
	unnamedMorph3 minCellSize: (0).
	unnamedMorph3 wrapCentering: (#topLeft).
	unnamedMorph3 wrapDirection: (#none).
	unnamedMorph3 frameFractions: (0@0 corner: 1@1).
	unnamedMorph3 frameOffsets: (0@0 corner: 0@0).
	unnamedMorph3 balloonText: (nil).
	unnamedMorph3 balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1.0 alpha: 0.922)).
	unnamedMorph3 color: (Color blue).
	unnamedMorph3 borderWidth: (0).
	unnamedMorph3 borderStyle2: (#simple).
	unnamedMorph3 borderColor: (Color black).
	unnamedMorph3 orientation: (#horizontal).
	unnamedMorph1 addMorphBack: unnamedMorph3.
	unnamedMorph4 := UiContainer new.
	unnamedMorph4 extent: (16@10).
	unnamedMorph4 position: (202@8).
	unnamedMorph4 hResizing: (#rigid).
	unnamedMorph4 vResizing: (#rigid).
	unnamedMorph4 minWidth: (2).
	unnamedMorph4 minHeight: (2).
	unnamedMorph4 cellInset: (4).
	unnamedMorph4 cellPositioning: (#center).
	unnamedMorph4 cellSpacing: (#none).
	unnamedMorph4 layoutInset: (4).
	unnamedMorph4 listCentering: (#topLeft).
	unnamedMorph4 listDirection: (#topToBottom).
	unnamedMorph4 listSpacing: (#none).
	unnamedMorph4 maxCellSize: (1073741823).
	unnamedMorph4 minCellSize: (0).
	unnamedMorph4 wrapCentering: (#topLeft).
	unnamedMorph4 wrapDirection: (#none).
	unnamedMorph4 frameFractions: (0@0 corner: 1@1).
	unnamedMorph4 frameOffsets: (0@0 corner: 0@0).
	unnamedMorph4 balloonText: (nil).
	unnamedMorph4 balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1.0 alpha: 0.937)).
	unnamedMorph4 color: (Color transparent).
	unnamedMorph4 borderWidth: (0).
	unnamedMorph4 borderStyle2: (#simple).
	unnamedMorph4 borderColor: (Color black).
	unnamedMorph1 addMorphBack: unnamedMorph4.
	closeBtn := UiToolButton new.
	closeBtn changeTableLayout.
	closeBtn extent: (18@18).
	closeBtn position: (219@4).
	closeBtn hResizing: (#shrinkWrap).
	closeBtn vResizing: (#shrinkWrap).
	closeBtn minWidth: (2).
	closeBtn minHeight: (2).
	closeBtn cellInset: (4).
	closeBtn cellPositioning: (#center).
	closeBtn cellSpacing: (#none).
	closeBtn layoutInset: (0).
	closeBtn listCentering: (#topLeft).
	closeBtn listDirection: (#leftToRight).
	closeBtn listSpacing: (#none).
	closeBtn maxCellSize: (1073741823).
	closeBtn minCellSize: (0).
	closeBtn wrapCentering: (#topLeft).
	closeBtn wrapDirection: (#none).
	closeBtn frameFractions: (0@0 corner: 1@1).
	closeBtn frameOffsets: (0@0 corner: 0@0).
	closeBtn balloonText: (nil).
	closeBtn balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1.0 alpha: 0.922)).
	closeBtn enabled: (true).
	closeBtn setProperty: #iconByDesigner toValue: 'UiFugueIcons minusWhiteIcon'.
	closeBtn icon: (UiFugueIcons minusWhiteIcon).
	closeBtn text: ('Call Graph').
	closeBtn color: ((Color r: 0.85 g: 0.85 b: 0.85)).
	closeBtn checkable: (false).
	closeBtn checked: (false).
	closeBtn autoExclusive: (false).
	closeBtn autoRaise: (true).
	closeBtn buttonStyle: (#iconOnly).
	closeBtn setProperty: #objectName toValue: 'closeBtn'.
	unnamedMorph1 addMorphBack: closeBtn.
	panel addMorphBack: unnamedMorph1.
	panel setProperty: #uiClassName toValue: 'SdEditorTemplate'.! !

!SdEditorTemplate methodsFor: 'accessing' stamp: 'mt 5/18/2012 10:09:01.546'!
pinBtn
	"nil"
	
	^ pinBtn! !

UserInterface subclass: #SdFinderUi
	instanceVariableNames: 'inputContainer categoryFilterBtn searchField categoryActionBtn elementActionBtn resultList'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sight-Dynamic-UI-Designs'!

!SdFinderUi methodsFor: 'accessing' stamp: 'mt 5/10/2012 15:48:39.111'!
categoryActionBtn
	"nil"
	
	^ categoryActionBtn! !

!SdFinderUi methodsFor: 'accessing' stamp: 'mt 5/10/2012 15:48:39.077'!
categoryFilterBtn
	"nil"
	
	^ categoryFilterBtn! !

!SdFinderUi methodsFor: 'accessing' stamp: 'mt 5/10/2012 15:48:39.127'!
elementActionBtn
	"nil"
	
	^ elementActionBtn! !

!SdFinderUi methodsFor: 'ui - private' stamp: 'mt 5/10/2012 15:48:39.175'!
initializePanel
	"This code is auto-generated. DO NOT modify it because another generation step will overwrite all changes."
	
	panel := UiContainer new.
	panel changeTableLayout.
	panel extent: (218@103).
	panel position: (0@0).
	panel hResizing: (#rigid).
	panel vResizing: (#shrinkWrap).
	panel minWidth: (2).
	panel minHeight: (2).
	panel cellInset: (0).
	panel cellPositioning: (#center).
	panel cellSpacing: (#none).
	panel layoutInset: (4).
	panel listCentering: (#topLeft).
	panel listDirection: (#topToBottom).
	panel listSpacing: (#none).
	panel maxCellSize: (1073741823).
	panel minCellSize: (0).
	panel wrapCentering: (#topLeft).
	panel wrapDirection: (#none).
	panel frameFractions: (0@0 corner: 1@1).
	panel frameOffsets: (0@0 corner: 0@0).
	panel balloonText: (nil).
	panel balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1.0 alpha: 0.922)).
	panel color: (Color transparent).
	panel borderWidth: (0).
	panel borderStyle2: (#simple).
	panel borderColor: (Color black).
	panel setProperty: #objectName toValue: 'panel'.
	inputContainer := UiContainer new.
	inputContainer changeTableLayout.
	inputContainer extent: (210@24).
	inputContainer position: (4@4).
	inputContainer hResizing: (#spaceFill).
	inputContainer vResizing: (#shrinkWrap).
	inputContainer minWidth: (2).
	inputContainer minHeight: (2).
	inputContainer cellInset: (2).
	inputContainer cellPositioning: (#center).
	inputContainer cellSpacing: (#none).
	inputContainer layoutInset: (0).
	inputContainer listCentering: (#topLeft).
	inputContainer listDirection: (#leftToRight).
	inputContainer listSpacing: (#none).
	inputContainer maxCellSize: (1073741823).
	inputContainer minCellSize: (0).
	inputContainer wrapCentering: (#topLeft).
	inputContainer wrapDirection: (#none).
	inputContainer frameFractions: (0@0 corner: 1@1).
	inputContainer frameOffsets: (0@0 corner: 0@0).
	inputContainer balloonText: (nil).
	inputContainer balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1.0 alpha: 0.922)).
	inputContainer color: (Color white).
	inputContainer borderWidth: (1).
	inputContainer borderStyle2: (#inset).
	inputContainer borderColor: (#inset).
	inputContainer setProperty: #objectName toValue: 'inputContainer'.
	categoryFilterBtn := UiToolButton new.
	categoryFilterBtn changeTableLayout.
	categoryFilterBtn extent: (72@21).
	categoryFilterBtn position: (5@5).
	categoryFilterBtn hResizing: (#shrinkWrap).
	categoryFilterBtn vResizing: (#shrinkWrap).
	categoryFilterBtn minWidth: (2).
	categoryFilterBtn minHeight: (2).
	categoryFilterBtn cellInset: (4).
	categoryFilterBtn cellPositioning: (#center).
	categoryFilterBtn cellSpacing: (#none).
	categoryFilterBtn layoutInset: (2@0 corner: 2@0).
	categoryFilterBtn listCentering: (#topLeft).
	categoryFilterBtn listDirection: (#leftToRight).
	categoryFilterBtn listSpacing: (#none).
	categoryFilterBtn maxCellSize: (1073741823).
	categoryFilterBtn minCellSize: (0).
	categoryFilterBtn wrapCentering: (#topLeft).
	categoryFilterBtn wrapDirection: (#none).
	categoryFilterBtn frameFractions: (0@0 corner: 1@1).
	categoryFilterBtn frameOffsets: (0@0 corner: 0@0).
	categoryFilterBtn balloonText: ('Discard category filter').
	categoryFilterBtn balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1.0 alpha: 0.922)).
	categoryFilterBtn enabled: (true).
	categoryFilterBtn setProperty: #iconByDesigner toValue: 'UiSilkIcons tagOrangeIcon'.
	categoryFilterBtn icon: (UiSilkIcons tagOrangeIcon).
	categoryFilterBtn text: ('category').
	categoryFilterBtn color: (Color white).
	categoryFilterBtn checkable: (false).
	categoryFilterBtn checked: (false).
	categoryFilterBtn autoExclusive: (false).
	categoryFilterBtn autoRaise: (true).
	categoryFilterBtn buttonStyle: (#textBesideIcon).
	categoryFilterBtn setProperty: #objectName toValue: 'categoryFilterBtn'.
	inputContainer addMorphBack: categoryFilterBtn.
	searchField := UiLineEdit new.
	searchField extent: (80@20).
	searchField position: (81@6).
	searchField hResizing: (#spaceFill).
	searchField vResizing: (#rigid).
	searchField minWidth: (2).
	searchField minHeight: (2).
	searchField cellInset: (0).
	searchField cellPositioning: (#center).
	searchField cellSpacing: (#none).
	searchField layoutInset: (0).
	searchField listCentering: (#topLeft).
	searchField listDirection: (#topToBottom).
	searchField listSpacing: (#none).
	searchField maxCellSize: (1073741823).
	searchField minCellSize: (0).
	searchField wrapCentering: (#topLeft).
	searchField wrapDirection: (#none).
	searchField frameFractions: (0@0 corner: 1@1).
	searchField frameOffsets: (0@0 corner: 0@0).
	searchField balloonText: (nil).
	searchField balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1.0 alpha: 0.922)).
	searchField widgetResizable: (false).
	searchField horizontalScrollBarPolicy: (#alwaysOff).
	searchField verticalScrollBarPolicy: (#alwaysOff).
	searchField outerBorderWidth: (0).
	searchField scrollBarThickness: (9).
	searchField theText: ('').
	searchField readOnly: (false).
	searchField autoConvert: (false).
	searchField autoAccept: (false).
	searchField acceptOnFocusLost: (true).
	searchField scrollingMode: (#none).
	searchField scrollingLimit: (10).
	searchField helpText: ('Search...').
	searchField hideCursor: (true).
	searchField setProperty: #objectName toValue: 'searchField'.
	inputContainer addMorphBack: searchField.
	categoryActionBtn := UiToolButton new.
	categoryActionBtn changeTableLayout.
	categoryActionBtn extent: (22@18).
	categoryActionBtn position: (164@7).
	categoryActionBtn hResizing: (#shrinkWrap).
	categoryActionBtn vResizing: (#shrinkWrap).
	categoryActionBtn minWidth: (2).
	categoryActionBtn minHeight: (2).
	categoryActionBtn cellInset: (4).
	categoryActionBtn cellPositioning: (#center).
	categoryActionBtn cellSpacing: (#none).
	categoryActionBtn layoutInset: (2@0 corner: 2@0).
	categoryActionBtn listCentering: (#topLeft).
	categoryActionBtn listDirection: (#leftToRight).
	categoryActionBtn listSpacing: (#none).
	categoryActionBtn maxCellSize: (1073741823).
	categoryActionBtn minCellSize: (0).
	categoryActionBtn wrapCentering: (#topLeft).
	categoryActionBtn wrapDirection: (#none).
	categoryActionBtn frameFractions: (0@0 corner: 1@1).
	categoryActionBtn frameOffsets: (0@0 corner: 0@0).
	categoryActionBtn balloonText: (nil).
	categoryActionBtn balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1.0 alpha: 0.922)).
	categoryActionBtn enabled: (true).
	categoryActionBtn setProperty: #iconByDesigner toValue: 'UiSilkIcons addIcon'.
	categoryActionBtn icon: (UiSilkIcons addIcon).
	categoryActionBtn text: ('ToolButton').
	categoryActionBtn color: ((Color r: 1.0 g: 0.871 b: 0.0)).
	categoryActionBtn checkable: (false).
	categoryActionBtn checked: (false).
	categoryActionBtn autoExclusive: (false).
	categoryActionBtn autoRaise: (true).
	categoryActionBtn buttonStyle: (#iconOnly).
	categoryActionBtn setProperty: #objectName toValue: 'categoryActionBtn'.
	categoryActionBtn setProperty: #objectDescription toValue: 'This button triggers category-related action for the given text.'.
	inputContainer addMorphBack: categoryActionBtn.
	elementActionBtn := UiToolButton new.
	elementActionBtn changeTableLayout.
	elementActionBtn extent: (22@18).
	elementActionBtn position: (190@7).
	elementActionBtn hResizing: (#shrinkWrap).
	elementActionBtn vResizing: (#shrinkWrap).
	elementActionBtn minWidth: (2).
	elementActionBtn minHeight: (2).
	elementActionBtn cellInset: (4).
	elementActionBtn cellPositioning: (#center).
	elementActionBtn cellSpacing: (#none).
	elementActionBtn layoutInset: (2@0 corner: 2@0).
	elementActionBtn listCentering: (#topLeft).
	elementActionBtn listDirection: (#leftToRight).
	elementActionBtn listSpacing: (#none).
	elementActionBtn maxCellSize: (1073741823).
	elementActionBtn minCellSize: (0).
	elementActionBtn wrapCentering: (#topLeft).
	elementActionBtn wrapDirection: (#none).
	elementActionBtn frameFractions: (0@0 corner: 1@1).
	elementActionBtn frameOffsets: (0@0 corner: 0@0).
	elementActionBtn balloonText: (nil).
	elementActionBtn balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1.0 alpha: 0.922)).
	elementActionBtn enabled: (true).
	elementActionBtn setProperty: #iconByDesigner toValue: 'UiSilkIcons addIcon'.
	elementActionBtn icon: (UiSilkIcons addIcon).
	elementActionBtn text: ('ToolButton').
	elementActionBtn color: ((Color r: 1.0 g: 0.871 b: 0.0)).
	elementActionBtn checkable: (false).
	elementActionBtn checked: (false).
	elementActionBtn autoExclusive: (false).
	elementActionBtn autoRaise: (true).
	elementActionBtn buttonStyle: (#iconOnly).
	elementActionBtn setProperty: #objectName toValue: 'elementActionBtn'.
	elementActionBtn setProperty: #objectDescription toValue: 'This button triggers the main action for the given text.'.
	inputContainer addMorphBack: elementActionBtn.
	panel addMorphBack: inputContainer.
	resultList := UiListWidget new.
	resultList extent: (210@70).
	resultList position: (4@29).
	resultList hResizing: (#spaceFill).
	resultList vResizing: (#rigid).
	resultList minWidth: (2).
	resultList minHeight: (2).
	resultList cellInset: (0).
	resultList cellPositioning: (#center).
	resultList cellSpacing: (#none).
	resultList layoutInset: (0).
	resultList listCentering: (#topLeft).
	resultList listDirection: (#topToBottom).
	resultList listSpacing: (#none).
	resultList maxCellSize: (1073741823).
	resultList minCellSize: (0).
	resultList wrapCentering: (#topLeft).
	resultList wrapDirection: (#none).
	resultList frameFractions: (0@0 corner: 1@1).
	resultList frameOffsets: (0@0 corner: 0@0).
	resultList balloonText: (nil).
	resultList balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1.0 alpha: 0.922)).
	resultList widgetResizable: (false).
	resultList horizontalScrollBarPolicy: (#alwaysOff).
	resultList verticalScrollBarPolicy: (#asNeeded).
	resultList outerBorderWidth: (0).
	resultList scrollBarThickness: (9).
	resultList modelClass: (UiListWidgetModel).
	resultList horizontalHeaderVisible: (false).
	resultList verticalHeaderVisible: (false).
	resultList selectionBehavior: (#selectRows).
	resultList selectionColor: ((Color r: 0.772 g: 0.858 b: 1.0)).
	resultList selectionMode: (UiViewSingleSelection).
	resultList setProperty: #objectName toValue: 'resultList'.
	panel addMorphBack: resultList.
	panel setProperty: #uiClassName toValue: 'SdFinder'.! !

!SdFinderUi methodsFor: 'accessing' stamp: 'mt 5/10/2012 15:48:39.059'!
inputContainer
	"nil"
	
	^ inputContainer! !

!SdFinderUi methodsFor: 'accessing' stamp: 'mt 5/10/2012 15:48:39.144'!
resultList
	"nil"
	
	^ resultList! !

!SdFinderUi methodsFor: 'accessing' stamp: 'mt 5/10/2012 15:48:39.094'!
searchField
	"nil"
	
	^ searchField! !

UserInterface subclass: #SdMethodContainerUi
	instanceVariableNames: 'headerContainer headerBtn closeBtn codeArea'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sight-Dynamic-UI-Designs'!

!SdMethodContainerUi methodsFor: 'accessing' stamp: 'mt 6/19/2012 18:48:47.007'!
closeBtn
	"No description given."
	
	^ closeBtn! !

!SdMethodContainerUi methodsFor: 'accessing' stamp: 'mt 6/19/2012 18:48:47.037'!
codeArea
	"No description given."
	
	^ codeArea! !

!SdMethodContainerUi methodsFor: 'accessing' stamp: 'mt 6/19/2012 18:48:46.976'!
headerBtn
	"No description given."
	
	^ headerBtn! !

!SdMethodContainerUi methodsFor: 'accessing' stamp: 'mt 6/19/2012 18:48:46.944'!
headerContainer
	"No description given."
	
	^ headerContainer! !

!SdMethodContainerUi methodsFor: 'ui - private' stamp: 'mt 6/19/2012 18:48:47.081'!
initializePanel
	"This code is auto-generated. DO NOT modify it because another generation step will overwrite all changes."
	
	| unnamedMorph1 |
	
	panel := UiContainer new.
	panel changeTableLayout.
	panel extent: (244@569).
	panel position: (0@0).
	panel hResizing: (#rigid).
	panel vResizing: (#rigid).
	panel minWidth: (2).
	panel minHeight: (2).
	panel cellInset: (2).
	panel cellPositioning: (#center).
	panel cellSpacing: (#none).
	panel layoutInset: (2).
	panel listCentering: (#topLeft).
	panel listDirection: (#topToBottom).
	panel listSpacing: (#none).
	panel maxCellSize: (1073741823).
	panel minCellSize: (0).
	panel wrapCentering: (#topLeft).
	panel wrapDirection: (#none).
	panel frameFractions: (0@0 corner: 1@1).
	panel frameOffsets: (0@0 corner: 0@0).
	panel balloonText: (nil).
	panel balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1.0 alpha: 0.922)).
	panel color: (Color transparent).
	panel borderWidth: (0).
	panel borderStyle2: (#simple).
	panel borderColor: (Color black).
	panel setProperty: #objectName toValue: 'panel'.
	headerContainer := UiContainer new.
	headerContainer changeTableLayout.
	headerContainer extent: (240@23).
	headerContainer position: (2@3).
	headerContainer hResizing: (#spaceFill).
	headerContainer vResizing: (#shrinkWrap).
	headerContainer minWidth: (2).
	headerContainer minHeight: (2).
	headerContainer cellInset: (0).
	headerContainer cellPositioning: (#center).
	headerContainer cellSpacing: (#none).
	headerContainer layoutInset: (2).
	headerContainer listCentering: (#center).
	headerContainer listDirection: (#leftToRight).
	headerContainer listSpacing: (#none).
	headerContainer maxCellSize: (1073741823).
	headerContainer minCellSize: (0).
	headerContainer wrapCentering: (#topLeft).
	headerContainer wrapDirection: (#none).
	headerContainer frameFractions: (0@0 corner: 1@1).
	headerContainer frameOffsets: (0@0 corner: 0@0).
	headerContainer balloonText: (nil).
	headerContainer balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1.0 alpha: 0.922)).
	headerContainer color: (Color transparent).
	headerContainer borderWidth: (0).
	headerContainer borderStyle2: (#simple).
	headerContainer borderColor: (Color black).
	headerContainer setProperty: #objectName toValue: 'headerContainer'.
	headerBtn := SdDraggableButton new.
	headerBtn changeTableLayout.
	headerBtn extent: (18@18).
	headerBtn position: (4@5).
	headerBtn hResizing: (#shrinkWrap).
	headerBtn vResizing: (#shrinkWrap).
	headerBtn minWidth: (2).
	headerBtn minHeight: (2).
	headerBtn cellInset: (4).
	headerBtn cellPositioning: (#center).
	headerBtn cellSpacing: (#none).
	headerBtn layoutInset: (0).
	headerBtn listCentering: (#topLeft).
	headerBtn listDirection: (#leftToRight).
	headerBtn listSpacing: (#none).
	headerBtn maxCellSize: (1073741823).
	headerBtn minCellSize: (0).
	headerBtn wrapCentering: (#topLeft).
	headerBtn wrapDirection: (#none).
	headerBtn frameFractions: (0@0 corner: 1@1).
	headerBtn frameOffsets: (0@0 corner: 0@0).
	headerBtn balloonText: (nil).
	headerBtn balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1.0 alpha: 0.922)).
	headerBtn enabled: (true).
	headerBtn setProperty: #iconByDesigner toValue: 'UiFugueIcons arrowMoveIcon'.
	headerBtn icon: (UiFugueIcons arrowMoveIcon).
	headerBtn text: ('ToolButton').
	headerBtn color: ((Color r: 0.85 g: 0.85 b: 0.85)).
	headerBtn checkable: (false).
	headerBtn checked: (false).
	headerBtn autoExclusive: (false).
	headerBtn autoRaise: (true).
	headerBtn buttonStyle: (#iconOnly).
	headerBtn setProperty: #objectName toValue: 'headerBtn'.
	headerContainer addMorphBack: headerBtn.
	unnamedMorph1 := UiSpacer new.
	unnamedMorph1 extent: (196@12).
	unnamedMorph1 position: (24@9).
	unnamedMorph1 hResizing: (#spaceFill).
	unnamedMorph1 vResizing: (#rigid).
	unnamedMorph1 minWidth: (2).
	unnamedMorph1 minHeight: (2).
	unnamedMorph1 cellInset: (4).
	unnamedMorph1 cellPositioning: (#center).
	unnamedMorph1 cellSpacing: (#none).
	unnamedMorph1 layoutInset: (4).
	unnamedMorph1 listCentering: (#topLeft).
	unnamedMorph1 listDirection: (#topToBottom).
	unnamedMorph1 listSpacing: (#none).
	unnamedMorph1 maxCellSize: (1073741823).
	unnamedMorph1 minCellSize: (0).
	unnamedMorph1 wrapCentering: (#topLeft).
	unnamedMorph1 wrapDirection: (#none).
	unnamedMorph1 frameFractions: (0@0 corner: 1@1).
	unnamedMorph1 frameOffsets: (0@0 corner: 0@0).
	unnamedMorph1 balloonText: (nil).
	unnamedMorph1 balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1.0 alpha: 0.922)).
	unnamedMorph1 color: (Color blue).
	unnamedMorph1 borderWidth: (0).
	unnamedMorph1 borderStyle2: (#simple).
	unnamedMorph1 borderColor: (Color black).
	unnamedMorph1 orientation: (#horizontal).
	headerContainer addMorphBack: unnamedMorph1.
	closeBtn := UiToolButton new.
	closeBtn changeTableLayout.
	closeBtn extent: (18@18).
	closeBtn position: (220@5).
	closeBtn hResizing: (#shrinkWrap).
	closeBtn vResizing: (#shrinkWrap).
	closeBtn minWidth: (2).
	closeBtn minHeight: (2).
	closeBtn cellInset: (4).
	closeBtn cellPositioning: (#center).
	closeBtn cellSpacing: (#none).
	closeBtn layoutInset: (0).
	closeBtn listCentering: (#topLeft).
	closeBtn listDirection: (#leftToRight).
	closeBtn listSpacing: (#none).
	closeBtn maxCellSize: (1073741823).
	closeBtn minCellSize: (0).
	closeBtn wrapCentering: (#topLeft).
	closeBtn wrapDirection: (#none).
	closeBtn frameFractions: (0@0 corner: 1@1).
	closeBtn frameOffsets: (0@0 corner: 0@0).
	closeBtn balloonText: (nil).
	closeBtn balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1.0 alpha: 0.922)).
	closeBtn enabled: (true).
	closeBtn setProperty: #iconByDesigner toValue: 'UiFugueIcons minusWhiteIcon'.
	closeBtn icon: (UiFugueIcons minusWhiteIcon).
	closeBtn text: ('ToolButton').
	closeBtn color: ((Color r: 0.85 g: 0.85 b: 0.85)).
	closeBtn checkable: (false).
	closeBtn checked: (false).
	closeBtn autoExclusive: (false).
	closeBtn autoRaise: (true).
	closeBtn buttonStyle: (#iconOnly).
	closeBtn setProperty: #objectName toValue: 'closeBtn'.
	headerContainer addMorphBack: closeBtn.
	panel addMorphBack: headerContainer.
	codeArea := UiScrollArea new.
	codeArea extent: (240@539).
	codeArea position: (2@28).
	codeArea hResizing: (#spaceFill).
	codeArea vResizing: (#spaceFill).
	codeArea minWidth: (2).
	codeArea minHeight: (2).
	codeArea cellInset: (0).
	codeArea cellPositioning: (#center).
	codeArea cellSpacing: (#none).
	codeArea layoutInset: (0).
	codeArea listCentering: (#topLeft).
	codeArea listDirection: (#topToBottom).
	codeArea listSpacing: (#none).
	codeArea maxCellSize: (1073741823).
	codeArea minCellSize: (0).
	codeArea wrapCentering: (#topLeft).
	codeArea wrapDirection: (#none).
	codeArea frameFractions: (0@0 corner: 1@1).
	codeArea frameOffsets: (0@0 corner: 0@0).
	codeArea balloonText: (nil).
	codeArea balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1.0 alpha: 0.922)).
	codeArea widgetResizable: (true).
	codeArea horizontalScrollBarPolicy: (#alwaysOff).
	codeArea verticalScrollBarPolicy: (#asNeeded).
	codeArea outerBorderWidth: (0).
	codeArea scrollBarThickness: (9).
	codeArea setProperty: #objectName toValue: 'codeArea'.
	panel addMorphBack: codeArea.
	panel setProperty: #uiClassName toValue: 'SdMethodContainer'.! !

UserInterface subclass: #SdMethodFinderUi
	instanceVariableNames: 'inputContainer protocolBtn searchField actionBtn resultList'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sight-Dynamic-UI-Designs'!

!SdMethodFinderUi methodsFor: 'accessing' stamp: 'mt 4/25/2011 14:40:38.182'!
actionBtn
	"nil"
	
	^ actionBtn! !

!SdMethodFinderUi methodsFor: 'ui - private' stamp: 'mt 2/15/2012 16:04:08.422'!
initializePanel
	"This code is auto-generated. DO NOT modify it because another generation step will overwrite all changes."
	
	panel := UiContainer new.
	panel changeTableLayout.
	panel extent: (218@101).
	panel position: (0@0).
	panel hResizing: (#rigid).
	panel vResizing: (#shrinkWrap).
	panel cellInset: (0).
	panel cellPositioning: (#center).
	panel cellSpacing: (#none).
	panel layoutInset: (4).
	panel listCentering: (#topLeft).
	panel listDirection: (#topToBottom).
	panel listSpacing: (#none).
	panel maxCellSize: (1073741823).
	panel minCellSize: (0).
	panel wrapCentering: (#topLeft).
	panel wrapDirection: (#none).
	panel frameFractions: (0@0 corner: 1@1).
	panel frameOffsets: (0@0 corner: 0@0).
	panel balloonText: (nil).
	panel balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1.0 alpha: 0.922)).
	panel color: (Color transparent).
	panel borderWidth: (0).
	panel borderStyle2: (#simple).
	panel borderColor: (Color black).
	panel setProperty: #objectName toValue: 'panel'.
	inputContainer := UiContainer new.
	inputContainer changeTableLayout.
	inputContainer extent: (210@23).
	inputContainer position: (4@4).
	inputContainer hResizing: (#spaceFill).
	inputContainer vResizing: (#shrinkWrap).
	inputContainer cellInset: (2).
	inputContainer cellPositioning: (#center).
	inputContainer cellSpacing: (#none).
	inputContainer layoutInset: (0).
	inputContainer listCentering: (#topLeft).
	inputContainer listDirection: (#leftToRight).
	inputContainer listSpacing: (#none).
	inputContainer maxCellSize: (1073741823).
	inputContainer minCellSize: (0).
	inputContainer wrapCentering: (#topLeft).
	inputContainer wrapDirection: (#none).
	inputContainer frameFractions: (0@0 corner: 1@1).
	inputContainer frameOffsets: (0@0 corner: 0@0).
	inputContainer balloonText: (nil).
	inputContainer balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1.0 alpha: 0.922)).
	inputContainer color: (Color white).
	inputContainer borderWidth: (1).
	inputContainer borderStyle2: (#inset).
	inputContainer borderColor: (#inset).
	inputContainer setProperty: #objectName toValue: 'inputContainer'.
	protocolBtn := UiToolButton new.
	protocolBtn changeTableLayout.
	protocolBtn extent: (71@21).
	protocolBtn position: (5@5).
	protocolBtn hResizing: (#shrinkWrap).
	protocolBtn vResizing: (#shrinkWrap).
	protocolBtn cellInset: (4).
	protocolBtn cellPositioning: (#center).
	protocolBtn cellSpacing: (#none).
	protocolBtn layoutInset: (2@0 corner: 2@0).
	protocolBtn listCentering: (#topLeft).
	protocolBtn listDirection: (#leftToRight).
	protocolBtn listSpacing: (#none).
	protocolBtn maxCellSize: (1073741823).
	protocolBtn minCellSize: (0).
	protocolBtn wrapCentering: (#topLeft).
	protocolBtn wrapDirection: (#none).
	protocolBtn frameFractions: (0@0 corner: 1@1).
	protocolBtn frameOffsets: (0@0 corner: 0@0).
	protocolBtn balloonText: ('').
	protocolBtn balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1.0 alpha: 0.937)).
	protocolBtn enabled: (true).
	protocolBtn setProperty: #iconByDesigner toValue: 'UiSilkIcons tagOrangeIcon'.
	protocolBtn icon: (UiSilkIcons tagOrangeIcon).
	protocolBtn text: ('protocol').
	protocolBtn checkable: (false).
	protocolBtn checked: (false).
	protocolBtn autoExclusive: (false).
	protocolBtn autoRaise: (true).
	protocolBtn buttonStyle: (#textBesideIcon).
	protocolBtn setProperty: #objectName toValue: 'protocolBtn'.
	inputContainer addMorphBack: protocolBtn.
	searchField := UiLineEdit new.
	searchField extent: (111@20).
	searchField position: (78@5).
	searchField hResizing: (#spaceFill).
	searchField vResizing: (#rigid).
	searchField cellInset: (0).
	searchField cellPositioning: (#center).
	searchField cellSpacing: (#none).
	searchField layoutInset: (0).
	searchField listCentering: (#topLeft).
	searchField listDirection: (#topToBottom).
	searchField listSpacing: (#none).
	searchField maxCellSize: (1073741823).
	searchField minCellSize: (0).
	searchField wrapCentering: (#topLeft).
	searchField wrapDirection: (#none).
	searchField frameFractions: (0@0 corner: 1@1).
	searchField frameOffsets: (0@0 corner: 0@0).
	searchField balloonText: (nil).
	searchField balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1.0 alpha: 0.922)).
	searchField widgetResizable: (false).
	searchField horizontalScrollBarPolicy: (#alwaysOff).
	searchField verticalScrollBarPolicy: (#alwaysOff).
	searchField outerBorderWidth: (0).
	searchField scrollBarThickness: (9).
	searchField theText: ('').
	searchField readOnly: (false).
	searchField autoConvert: (false).
	searchField autoAccept: (false).
	searchField acceptOnFocusLost: (true).
	searchField helpText: ('Search...').
	searchField setProperty: #objectName toValue: 'searchField'.
	inputContainer addMorphBack: searchField.
	actionBtn := UiToolButton new.
	actionBtn changeTableLayout.
	actionBtn extent: (22@18).
	actionBtn position: (191@6).
	actionBtn hResizing: (#shrinkWrap).
	actionBtn vResizing: (#shrinkWrap).
	actionBtn cellInset: (4).
	actionBtn cellPositioning: (#center).
	actionBtn cellSpacing: (#none).
	actionBtn layoutInset: (2@0 corner: 2@0).
	actionBtn listCentering: (#topLeft).
	actionBtn listDirection: (#leftToRight).
	actionBtn listSpacing: (#none).
	actionBtn maxCellSize: (1073741823).
	actionBtn minCellSize: (0).
	actionBtn wrapCentering: (#topLeft).
	actionBtn wrapDirection: (#none).
	actionBtn frameFractions: (0@0 corner: 1@1).
	actionBtn frameOffsets: (0@0 corner: 0@0).
	actionBtn balloonText: (nil).
	actionBtn balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1.0 alpha: 0.922)).
	actionBtn enabled: (true).
	actionBtn setProperty: #iconByDesigner toValue: 'UiSilkIcons addIcon'.
	actionBtn icon: (UiSilkIcons addIcon).
	actionBtn text: ('ToolButton').
	actionBtn checkable: (false).
	actionBtn checked: (false).
	actionBtn autoExclusive: (false).
	actionBtn autoRaise: (true).
	actionBtn buttonStyle: (#iconOnly).
	actionBtn setProperty: #objectName toValue: 'actionBtn'.
	actionBtn setProperty: #objectDescription toValue: 'This button triggers the main action for the given text.'.
	inputContainer addMorphBack: actionBtn.
	panel addMorphBack: inputContainer.
	resultList := UiListWidget new.
	resultList extent: (210@70).
	resultList position: (4@27).
	resultList hResizing: (#spaceFill).
	resultList vResizing: (#rigid).
	resultList cellInset: (0).
	resultList cellPositioning: (#center).
	resultList cellSpacing: (#none).
	resultList layoutInset: (0).
	resultList listCentering: (#topLeft).
	resultList listDirection: (#topToBottom).
	resultList listSpacing: (#none).
	resultList maxCellSize: (1073741823).
	resultList minCellSize: (0).
	resultList wrapCentering: (#topLeft).
	resultList wrapDirection: (#none).
	resultList frameFractions: (0@0 corner: 1@1).
	resultList frameOffsets: (0@0 corner: 0@0).
	resultList balloonText: (nil).
	resultList balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1.0 alpha: 0.922)).
	resultList widgetResizable: (false).
	resultList horizontalScrollBarPolicy: (#alwaysOff).
	resultList verticalScrollBarPolicy: (#asNeeded).
	resultList outerBorderWidth: (0).
	resultList scrollBarThickness: (9).
	resultList modelClass: (UiListWidgetModel).
	resultList horizontalHeaderVisible: (false).
	resultList verticalHeaderVisible: (false).
	resultList selectionBehavior: (#selectRows).
	resultList selectionColor: ((Color r: 0.772 g: 0.858 b: 1.0)).
	resultList selectionMode: (UiViewSingleSelection).
	resultList setProperty: #objectName toValue: 'resultList'.
	panel addMorphBack: resultList.
	panel setProperty: #uiClassName toValue: 'SdMethodFinder'.! !

!SdMethodFinderUi methodsFor: 'accessing' stamp: 'mt 4/25/2011 14:40:38'!
inputContainer
	"nil"
	
	^ inputContainer! !

!SdMethodFinderUi methodsFor: 'accessing' stamp: 'mt 4/25/2011 14:40:38.094'!
protocolBtn
	"nil"
	
	^ protocolBtn! !

!SdMethodFinderUi methodsFor: 'accessing' stamp: 'mt 4/25/2011 14:40:38.217'!
resultList
	"nil"
	
	^ resultList! !

!SdMethodFinderUi methodsFor: 'accessing' stamp: 'mt 4/25/2011 14:40:38.135'!
searchField
	"nil"
	
	^ searchField! !

UserInterface subclass: #SdObjectExplorerUi
	instanceVariableNames: 'hideBtn headerBtn closeBtn treeView sourceCodeEdit'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sight-Dynamic-UI-Designs'!

!SdObjectExplorerUi methodsFor: 'accessing' stamp: 'mt 6/20/2012 14:04:08.826'!
closeBtn
	"No description given."
	
	^ closeBtn! !

!SdObjectExplorerUi methodsFor: 'accessing' stamp: 'mt 6/20/2012 14:04:08.809'!
headerBtn
	"No description given."
	
	^ headerBtn! !

!SdObjectExplorerUi methodsFor: 'accessing' stamp: 'mt 6/20/2012 14:04:08.79'!
hideBtn
	"No description given."
	
	^ hideBtn! !

!SdObjectExplorerUi methodsFor: 'ui - private' stamp: 'mt 6/20/2012 14:04:08.895'!
initializePanel
	"This code is auto-generated. DO NOT modify it because another generation step will overwrite all changes."
	
	| unnamedMorph1 unnamedMorph2 unnamedMorph3 |
	
	panel := UiContainer new.
	panel changeTableLayout.
	panel extent: (300@530).
	panel position: (0@0).
	panel hResizing: (#rigid).
	panel vResizing: (#rigid).
	panel minWidth: (2).
	panel minHeight: (2).
	panel cellInset: (3).
	panel cellPositioning: (#center).
	panel cellSpacing: (#none).
	panel layoutInset: (2).
	panel listCentering: (#topLeft).
	panel listDirection: (#topToBottom).
	panel listSpacing: (#none).
	panel maxCellSize: (1073741823).
	panel minCellSize: (0).
	panel wrapCentering: (#topLeft).
	panel wrapDirection: (#none).
	panel frameFractions: (0@0 corner: 1@1).
	panel frameOffsets: (0@0 corner: 0@0).
	panel balloonText: (nil).
	panel balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1.0 alpha: 0.922)).
	panel color: (Color transparent).
	panel borderWidth: (0).
	panel borderStyle2: (#simple).
	panel borderColor: (Color black).
	panel setProperty: #objectName toValue: 'panel'.
	unnamedMorph1 := UiContainer new.
	unnamedMorph1 changeTableLayout.
	unnamedMorph1 extent: (296@22).
	unnamedMorph1 position: (2@2).
	unnamedMorph1 hResizing: (#spaceFill).
	unnamedMorph1 vResizing: (#shrinkWrap).
	unnamedMorph1 minWidth: (2).
	unnamedMorph1 minHeight: (2).
	unnamedMorph1 cellInset: (0).
	unnamedMorph1 cellPositioning: (#center).
	unnamedMorph1 cellSpacing: (#none).
	unnamedMorph1 layoutInset: (0).
	unnamedMorph1 listCentering: (#topLeft).
	unnamedMorph1 listDirection: (#leftToRight).
	unnamedMorph1 listSpacing: (#none).
	unnamedMorph1 maxCellSize: (1073741823).
	unnamedMorph1 minCellSize: (0).
	unnamedMorph1 wrapCentering: (#topLeft).
	unnamedMorph1 wrapDirection: (#none).
	unnamedMorph1 frameFractions: (0@0 corner: 1@1).
	unnamedMorph1 frameOffsets: (0@0 corner: 0@0).
	unnamedMorph1 balloonText: (nil).
	unnamedMorph1 balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1.0 alpha: 0.922)).
	unnamedMorph1 color: (Color transparent).
	unnamedMorph1 borderWidth: (0).
	unnamedMorph1 borderStyle2: (#simple).
	unnamedMorph1 borderColor: (Color black).
	hideBtn := UiToolButton new.
	hideBtn changeTableLayout.
	hideBtn extent: (18@18).
	hideBtn position: (3@4).
	hideBtn hResizing: (#shrinkWrap).
	hideBtn vResizing: (#shrinkWrap).
	hideBtn minWidth: (2).
	hideBtn minHeight: (2).
	hideBtn cellInset: (4).
	hideBtn cellPositioning: (#center).
	hideBtn cellSpacing: (#none).
	hideBtn layoutInset: (0).
	hideBtn listCentering: (#topLeft).
	hideBtn listDirection: (#leftToRight).
	hideBtn listSpacing: (#none).
	hideBtn maxCellSize: (1073741823).
	hideBtn minCellSize: (0).
	hideBtn wrapCentering: (#topLeft).
	hideBtn wrapDirection: (#none).
	hideBtn frameFractions: (0@0 corner: 1@1).
	hideBtn frameOffsets: (0@0 corner: 0@0).
	hideBtn balloonText: (nil).
	hideBtn balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1.0 alpha: 0.933)).
	hideBtn enabled: (true).
	hideBtn setProperty: #iconByDesigner toValue: 'UiSilkIcons eyeIcon'.
	hideBtn icon: (UiSilkIcons eyeIcon).
	hideBtn text: ('ToolButton').
	hideBtn color: ((Color r: 0.85 g: 0.85 b: 0.85)).
	hideBtn checkable: (true).
	hideBtn checked: (true).
	hideBtn autoExclusive: (false).
	hideBtn autoRaise: (true).
	hideBtn buttonStyle: (#iconOnly).
	hideBtn setProperty: #objectName toValue: 'hideBtn'.
	unnamedMorph1 addMorphBack: hideBtn.
	unnamedMorph2 := UiSpacer new.
	unnamedMorph2 extent: (82@10).
	unnamedMorph2 position: (22@8).
	unnamedMorph2 hResizing: (#spaceFill).
	unnamedMorph2 vResizing: (#rigid).
	unnamedMorph2 minWidth: (2).
	unnamedMorph2 minHeight: (2).
	unnamedMorph2 cellInset: (0).
	unnamedMorph2 cellPositioning: (#center).
	unnamedMorph2 cellSpacing: (#none).
	unnamedMorph2 layoutInset: (0).
	unnamedMorph2 listCentering: (#topLeft).
	unnamedMorph2 listDirection: (#topToBottom).
	unnamedMorph2 listSpacing: (#none).
	unnamedMorph2 maxCellSize: (1073741823).
	unnamedMorph2 minCellSize: (0).
	unnamedMorph2 wrapCentering: (#topLeft).
	unnamedMorph2 wrapDirection: (#none).
	unnamedMorph2 frameFractions: (0@0 corner: 1@1).
	unnamedMorph2 frameOffsets: (0@0 corner: 0@0).
	unnamedMorph2 balloonText: (nil).
	unnamedMorph2 balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1.0 alpha: 0.922)).
	unnamedMorph2 color: (Color blue).
	unnamedMorph2 borderWidth: (0).
	unnamedMorph2 borderStyle2: (#simple).
	unnamedMorph2 borderColor: (Color black).
	unnamedMorph2 orientation: (#horizontal).
	unnamedMorph1 addMorphBack: unnamedMorph2.
	headerBtn := SdDraggableButton new.
	headerBtn changeTableLayout.
	headerBtn extent: (89@21).
	headerBtn position: (104@2).
	headerBtn hResizing: (#shrinkWrap).
	headerBtn vResizing: (#shrinkWrap).
	headerBtn minWidth: (2).
	headerBtn minHeight: (2).
	headerBtn cellInset: (4).
	headerBtn cellPositioning: (#center).
	headerBtn cellSpacing: (#none).
	headerBtn layoutInset: (2@0 corner: 2@0).
	headerBtn listCentering: (#topLeft).
	headerBtn listDirection: (#leftToRight).
	headerBtn listSpacing: (#none).
	headerBtn maxCellSize: (1073741823).
	headerBtn minCellSize: (0).
	headerBtn wrapCentering: (#topLeft).
	headerBtn wrapDirection: (#none).
	headerBtn frameFractions: (0@0 corner: 1@1).
	headerBtn frameOffsets: (0@0 corner: 0@0).
	headerBtn balloonText: (nil).
	headerBtn balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1.0 alpha: 0.922)).
	headerBtn enabled: (true).
	headerBtn setProperty: #iconByDesigner toValue: 'nil'.
	headerBtn icon: (nil).
	headerBtn text: ('anObject (1234)').
	headerBtn color: ((Color r: 0.85 g: 0.85 b: 0.85)).
	headerBtn checkable: (false).
	headerBtn checked: (false).
	headerBtn autoExclusive: (false).
	headerBtn autoRaise: (true).
	headerBtn buttonStyle: (#textBesideIcon).
	headerBtn setProperty: #objectName toValue: 'headerBtn'.
	unnamedMorph1 addMorphBack: headerBtn.
	unnamedMorph3 := UiSpacer new.
	unnamedMorph3 extent: (83@10).
	unnamedMorph3 position: (195@8).
	unnamedMorph3 hResizing: (#spaceFill).
	unnamedMorph3 vResizing: (#rigid).
	unnamedMorph3 minWidth: (2).
	unnamedMorph3 minHeight: (2).
	unnamedMorph3 cellInset: (0).
	unnamedMorph3 cellPositioning: (#center).
	unnamedMorph3 cellSpacing: (#none).
	unnamedMorph3 layoutInset: (0).
	unnamedMorph3 listCentering: (#topLeft).
	unnamedMorph3 listDirection: (#topToBottom).
	unnamedMorph3 listSpacing: (#none).
	unnamedMorph3 maxCellSize: (1073741823).
	unnamedMorph3 minCellSize: (0).
	unnamedMorph3 wrapCentering: (#topLeft).
	unnamedMorph3 wrapDirection: (#none).
	unnamedMorph3 frameFractions: (0@0 corner: 1@1).
	unnamedMorph3 frameOffsets: (0@0 corner: 0@0).
	unnamedMorph3 balloonText: (nil).
	unnamedMorph3 balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1.0 alpha: 0.922)).
	unnamedMorph3 color: (Color blue).
	unnamedMorph3 borderWidth: (0).
	unnamedMorph3 borderStyle2: (#simple).
	unnamedMorph3 borderColor: (Color black).
	unnamedMorph3 orientation: (#horizontal).
	unnamedMorph1 addMorphBack: unnamedMorph3.
	closeBtn := UiToolButton new.
	closeBtn changeTableLayout.
	closeBtn extent: (18@18).
	closeBtn position: (279@4).
	closeBtn hResizing: (#shrinkWrap).
	closeBtn vResizing: (#shrinkWrap).
	closeBtn minWidth: (2).
	closeBtn minHeight: (2).
	closeBtn cellInset: (4).
	closeBtn cellPositioning: (#center).
	closeBtn cellSpacing: (#none).
	closeBtn layoutInset: (0).
	closeBtn listCentering: (#topLeft).
	closeBtn listDirection: (#leftToRight).
	closeBtn listSpacing: (#none).
	closeBtn maxCellSize: (1073741823).
	closeBtn minCellSize: (0).
	closeBtn wrapCentering: (#topLeft).
	closeBtn wrapDirection: (#none).
	closeBtn frameFractions: (0@0 corner: 1@1).
	closeBtn frameOffsets: (0@0 corner: 0@0).
	closeBtn balloonText: (nil).
	closeBtn balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1.0 alpha: 0.922)).
	closeBtn enabled: (true).
	closeBtn setProperty: #iconByDesigner toValue: 'UiFugueIcons minusWhiteIcon'.
	closeBtn icon: (UiFugueIcons minusWhiteIcon).
	closeBtn text: ('Call Graph').
	closeBtn color: ((Color r: 0.85 g: 0.85 b: 0.85)).
	closeBtn checkable: (false).
	closeBtn checked: (false).
	closeBtn autoExclusive: (false).
	closeBtn autoRaise: (true).
	closeBtn buttonStyle: (#iconOnly).
	closeBtn setProperty: #objectName toValue: 'closeBtn'.
	unnamedMorph1 addMorphBack: closeBtn.
	panel addMorphBack: unnamedMorph1.
	treeView := UiTreeView new.
	treeView extent: (296@465).
	treeView position: (2@28).
	treeView hResizing: (#spaceFill).
	treeView vResizing: (#spaceFill).
	treeView minWidth: (2).
	treeView minHeight: (2).
	treeView cellInset: (0).
	treeView cellPositioning: (#center).
	treeView cellSpacing: (#none).
	treeView layoutInset: (0).
	treeView listCentering: (#topLeft).
	treeView listDirection: (#topToBottom).
	treeView listSpacing: (#none).
	treeView maxCellSize: (1073741823).
	treeView minCellSize: (0).
	treeView wrapCentering: (#topLeft).
	treeView wrapDirection: (#none).
	treeView frameFractions: (0@0 corner: 1@1).
	treeView frameOffsets: (0@0 corner: 0@0).
	treeView balloonText: (nil).
	treeView balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1.0 alpha: 0.922)).
	treeView widgetResizable: (false).
	treeView horizontalScrollBarPolicy: (#asNeeded).
	treeView verticalScrollBarPolicy: (#asNeeded).
	treeView outerBorderWidth: (1).
	treeView scrollBarThickness: (9).
	treeView modelClass: (nil).
	treeView horizontalHeaderVisible: (false).
	treeView verticalHeaderVisible: (false).
	treeView selectionBehavior: (#selectRows).
	treeView selectionColor: ((Color r: 0.772 g: 0.858 b: 1.0)).
	treeView selectionMode: (UiViewSingleSelection).
	treeView setProperty: #objectName toValue: 'treeView'.
	panel addMorphBack: treeView.
	sourceCodeEdit := SdSourceCodeEdit new.
	sourceCodeEdit extent: (296@16).
	sourceCodeEdit position: (2@504).
	sourceCodeEdit hResizing: (#spaceFill).
	sourceCodeEdit vResizing: (#rigid).
	sourceCodeEdit minWidth: (2).
	sourceCodeEdit minHeight: (2).
	sourceCodeEdit cellInset: (0).
	sourceCodeEdit cellPositioning: (#center).
	sourceCodeEdit cellSpacing: (#none).
	sourceCodeEdit layoutInset: (0).
	sourceCodeEdit listCentering: (#topLeft).
	sourceCodeEdit listDirection: (#topToBottom).
	sourceCodeEdit listSpacing: (#none).
	sourceCodeEdit maxCellSize: (1073741823).
	sourceCodeEdit minCellSize: (0).
	sourceCodeEdit wrapCentering: (#topLeft).
	sourceCodeEdit wrapDirection: (#none).
	sourceCodeEdit frameFractions: (0@0 corner: 1@1).
	sourceCodeEdit frameOffsets: (0@0 corner: 0@0).
	sourceCodeEdit balloonText: (nil).
	sourceCodeEdit balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1.0 alpha: 0.925)).
	sourceCodeEdit widgetResizable: (true).
	sourceCodeEdit horizontalScrollBarPolicy: (#alwaysOff).
	sourceCodeEdit verticalScrollBarPolicy: (#alwaysOff).
	sourceCodeEdit outerBorderWidth: (1).
	sourceCodeEdit scrollBarThickness: (9).
	sourceCodeEdit theText: ('').
	sourceCodeEdit readOnly: (false).
	sourceCodeEdit autoConvert: (false).
	sourceCodeEdit autoAccept: (true).
	sourceCodeEdit acceptOnFocusLost: (false).
	sourceCodeEdit scrollingMode: (#never).
	sourceCodeEdit scrollingLimit: (10).
	sourceCodeEdit setProperty: #objectName toValue: 'sourceCodeEdit'.
	panel addMorphBack: sourceCodeEdit.
	panel setProperty: #uiClassName toValue: 'SdObjectExplorer'.! !

!SdObjectExplorerUi methodsFor: 'accessing' stamp: 'mt 6/20/2012 14:04:08.86'!
sourceCodeEdit
	"No description given."
	
	^ sourceCodeEdit! !

!SdObjectExplorerUi methodsFor: 'accessing' stamp: 'mt 6/20/2012 14:04:08.843'!
treeView
	"No description given."
	
	^ treeView! !

UserInterface subclass: #SdOverlayMessageBoxUi
	instanceVariableNames: 'messageContainer iconLbl messageLbl titleLbl buttonContainer'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sight-Dynamic-UI-Designs'!

!SdOverlayMessageBoxUi methodsFor: 'accessing' stamp: 'mt 4/29/2011 10:31:27.241'!
buttonContainer
	"nil"
	
	^ buttonContainer! !

!SdOverlayMessageBoxUi methodsFor: 'accessing' stamp: 'mt 4/29/2011 10:31:27.043'!
iconLbl
	"nil"
	
	^ iconLbl! !

!SdOverlayMessageBoxUi methodsFor: 'ui - private' stamp: 'mt 4/29/2011 10:31:27.326'!
initializePanel
	"This code is auto-generated. DO NOT modify it because another generation step will overwrite all changes."
	
	panel := UiContainer new.
	panel changeProportionalLayout.
	panel extent: (181@276).
	panel position: (0@0).
	panel hResizing: (#rigid).
	panel vResizing: (#rigid).
	panel cellInset: (4).
	panel cellPositioning: (#center).
	panel cellSpacing: (#none).
	panel layoutInset: (4).
	panel listCentering: (#topLeft).
	panel listDirection: (#topToBottom).
	panel listSpacing: (#none).
	panel maxCellSize: (1073741823).
	panel minCellSize: (0).
	panel wrapCentering: (#topLeft).
	panel wrapDirection: (#none).
	panel frameFractions: (0@0 corner: 1@1).
	panel frameOffsets: (0@0 corner: 0@0).
	panel balloonText: ('').
	panel balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1.0 alpha: 0.941)).
	panel color: ((TranslucentColor r: 0.0 g: 0.0 b: 0.0 alpha: 0.486)).
	panel borderWidth: (0).
	panel borderStyle2: (#simple).
	panel borderColor: (Color black).
	panel setProperty: #objectName toValue: 'panel'.
	messageContainer := UiContainer new.
	messageContainer changeTableLayout.
	messageContainer extent: (74@80).
	messageContainer position: (53@58).
	messageContainer hResizing: (#shrinkWrap).
	messageContainer vResizing: (#spaceFill).
	messageContainer cellInset: (4).
	messageContainer cellPositioning: (#center).
	messageContainer cellSpacing: (#none).
	messageContainer layoutInset: (4).
	messageContainer listCentering: (#topLeft).
	messageContainer listDirection: (#leftToRight).
	messageContainer listSpacing: (#none).
	messageContainer maxCellSize: (1073741823).
	messageContainer minCellSize: (0).
	messageContainer wrapCentering: (#topLeft).
	messageContainer wrapDirection: (#none).
	messageContainer frameFractions: (0@0.2 corner: 1@0.5).
	messageContainer frameOffsets: (0@0 corner: 0@0).
	messageContainer balloonText: ('').
	messageContainer balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1.0 alpha: 0.945)).
	messageContainer color: (Color transparent).
	messageContainer borderWidth: (0).
	messageContainer borderStyle2: (#simple).
	messageContainer borderColor: (Color black).
	messageContainer setProperty: #objectName toValue: 'messageContainer'.
	iconLbl := UiLabel new.
	iconLbl changeTableLayout.
	iconLbl extent: (16@72).
	iconLbl position: (57@62).
	iconLbl hResizing: (#shrinkWrap).
	iconLbl vResizing: (#spaceFill).
	iconLbl cellInset: (0).
	iconLbl cellPositioning: (#center).
	iconLbl cellSpacing: (#none).
	iconLbl layoutInset: (0).
	iconLbl listCentering: (#topLeft).
	iconLbl listDirection: (#leftToRight).
	iconLbl listSpacing: (#none).
	iconLbl maxCellSize: (1073741823).
	iconLbl minCellSize: (0).
	iconLbl wrapCentering: (#topLeft).
	iconLbl wrapDirection: (#none).
	iconLbl frameFractions: (0@0 corner: 1@1).
	iconLbl frameOffsets: (0@0 corner: 0@0).
	iconLbl balloonText: ('').
	iconLbl balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1.0 alpha: 0.941)).
	iconLbl text: ('Label').
	iconLbl setProperty: #formByDesigner toValue: 'UiSilkIcons informationIcon'.
	iconLbl form: (UiSilkIcons informationIcon).
	iconLbl setProperty: #objectName toValue: 'iconLbl'.
	messageContainer addMorphBack: iconLbl.
	messageLbl := UiLabel new.
	messageLbl changeTableLayout.
	messageLbl extent: (46@72).
	messageLbl position: (77@62).
	messageLbl hResizing: (#shrinkWrap).
	messageLbl vResizing: (#spaceFill).
	messageLbl cellInset: (0).
	messageLbl cellPositioning: (#center).
	messageLbl cellSpacing: (#none).
	messageLbl layoutInset: (0).
	messageLbl listCentering: (#topLeft).
	messageLbl listDirection: (#leftToRight).
	messageLbl listSpacing: (#none).
	messageLbl maxCellSize: (1073741823).
	messageLbl minCellSize: (0).
	messageLbl wrapCentering: (#topLeft).
	messageLbl wrapDirection: (#none).
	messageLbl frameFractions: (0@0.2 corner: 1@0.4).
	messageLbl frameOffsets: (0@0 corner: 0@0).
	messageLbl balloonText: (nil).
	messageLbl balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1.0 alpha: 0.941)).
	messageLbl text: ('Message').
	messageLbl setProperty: #formByDesigner toValue: 'nil'.
	messageLbl form: (nil).
	messageLbl setProperty: #objectName toValue: 'messageLbl'.
	messageContainer addMorphBack: messageLbl.
	panel addMorphBack: messageContainer.
	titleLbl := UiLabel new.
	titleLbl changeTableLayout.
	titleLbl extent: (23@19).
	titleLbl position: (79@22).
	titleLbl hResizing: (#shrinkWrap).
	titleLbl vResizing: (#shrinkWrap).
	titleLbl cellInset: (0).
	titleLbl cellPositioning: (#center).
	titleLbl cellSpacing: (#none).
	titleLbl layoutInset: (0).
	titleLbl listCentering: (#topLeft).
	titleLbl listDirection: (#leftToRight).
	titleLbl listSpacing: (#none).
	titleLbl maxCellSize: (1073741823).
	titleLbl minCellSize: (0).
	titleLbl wrapCentering: (#topLeft).
	titleLbl wrapDirection: (#none).
	titleLbl frameFractions: (0@0 corner: 1@0.2).
	titleLbl frameOffsets: (0@0 corner: 0@0).
	titleLbl balloonText: ('').
	titleLbl balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1.0 alpha: 0.929)).
	titleLbl text: ('Title').
	titleLbl setProperty: #formByDesigner toValue: 'nil'.
	titleLbl form: (nil).
	titleLbl setProperty: #objectName toValue: 'titleLbl'.
	panel addMorphBack: titleLbl.
	buttonContainer := UiContainer new.
	buttonContainer changeTableLayout.
	buttonContainer extent: (173@134).
	buttonContainer position: (4@138).
	buttonContainer hResizing: (#spaceFill).
	buttonContainer vResizing: (#spaceFill).
	buttonContainer cellInset: (4).
	buttonContainer cellPositioning: (#center).
	buttonContainer cellSpacing: (#none).
	buttonContainer layoutInset: (16).
	buttonContainer listCentering: (#topLeft).
	buttonContainer listDirection: (#topToBottom).
	buttonContainer listSpacing: (#none).
	buttonContainer maxCellSize: (1073741823).
	buttonContainer minCellSize: (0).
	buttonContainer wrapCentering: (#topLeft).
	buttonContainer wrapDirection: (#none).
	buttonContainer frameFractions: (0@0.5 corner: 1@1).
	buttonContainer frameOffsets: (0@0 corner: 0@0).
	buttonContainer balloonText: (nil).
	buttonContainer balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1.0 alpha: 0.941)).
	buttonContainer color: (Color transparent).
	buttonContainer borderWidth: (0).
	buttonContainer borderStyle2: (#simple).
	buttonContainer borderColor: (Color black).
	buttonContainer setProperty: #objectName toValue: 'buttonContainer'.
	panel addMorphBack: buttonContainer.
	panel setProperty: #uiClassName toValue: 'SdOverlayMessageBox'.! !

!SdOverlayMessageBoxUi methodsFor: 'accessing' stamp: 'mt 4/29/2011 10:31:26.936'!
messageContainer
	"nil"
	
	^ messageContainer! !

!SdOverlayMessageBoxUi methodsFor: 'accessing' stamp: 'mt 4/29/2011 10:31:27.108'!
messageLbl
	"nil"
	
	^ messageLbl! !

!SdOverlayMessageBoxUi methodsFor: 'accessing' stamp: 'mt 4/29/2011 10:31:27.178'!
titleLbl
	"nil"
	
	^ titleLbl! !

UserInterface subclass: #SdPackageViewerUi
	instanceVariableNames: 'hideBtn headerBtn closeBtn packageCombo synchBtn treeView'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sight-Dynamic-UI-Designs'!

!SdPackageViewerUi methodsFor: 'accessing' stamp: 'mt 6/20/2012 14:04:49.911'!
closeBtn
	"No description given."
	
	^ closeBtn! !

!SdPackageViewerUi methodsFor: 'accessing' stamp: 'mt 6/20/2012 14:04:49.893'!
headerBtn
	"No description given."
	
	^ headerBtn! !

!SdPackageViewerUi methodsFor: 'accessing' stamp: 'mt 6/20/2012 14:04:49.874'!
hideBtn
	"No description given."
	
	^ hideBtn! !

!SdPackageViewerUi methodsFor: 'ui - private' stamp: 'mt 6/20/2012 14:04:50.001'!
initializePanel
	"This code is auto-generated. DO NOT modify it because another generation step will overwrite all changes."
	
	| unnamedMorph1 unnamedMorph2 unnamedMorph3 unnamedMorph4 |
	
	panel := UiContainer new.
	panel changeTableLayout.
	panel extent: (194@197).
	panel position: (0@0).
	panel hResizing: (#rigid).
	panel vResizing: (#rigid).
	panel minWidth: (2).
	panel minHeight: (2).
	panel cellInset: (2).
	panel cellPositioning: (#center).
	panel cellSpacing: (#none).
	panel layoutInset: (2).
	panel listCentering: (#topLeft).
	panel listDirection: (#topToBottom).
	panel listSpacing: (#none).
	panel maxCellSize: (1073741823).
	panel minCellSize: (0).
	panel wrapCentering: (#topLeft).
	panel wrapDirection: (#none).
	panel frameFractions: (0@0 corner: 1@1).
	panel frameOffsets: (0@0 corner: 0@0).
	panel balloonText: (nil).
	panel balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1.0 alpha: 0.922)).
	panel color: (Color transparent).
	panel borderWidth: (0).
	panel borderStyle2: (#simple).
	panel borderColor: (Color black).
	panel setProperty: #objectName toValue: 'panel'.
	unnamedMorph1 := UiContainer new.
	unnamedMorph1 changeTableLayout.
	unnamedMorph1 extent: (190@22).
	unnamedMorph1 position: (2@2).
	unnamedMorph1 hResizing: (#spaceFill).
	unnamedMorph1 vResizing: (#shrinkWrap).
	unnamedMorph1 minWidth: (2).
	unnamedMorph1 minHeight: (2).
	unnamedMorph1 cellInset: (0).
	unnamedMorph1 cellPositioning: (#center).
	unnamedMorph1 cellSpacing: (#none).
	unnamedMorph1 layoutInset: (0).
	unnamedMorph1 listCentering: (#topLeft).
	unnamedMorph1 listDirection: (#leftToRight).
	unnamedMorph1 listSpacing: (#none).
	unnamedMorph1 maxCellSize: (1073741823).
	unnamedMorph1 minCellSize: (0).
	unnamedMorph1 wrapCentering: (#topLeft).
	unnamedMorph1 wrapDirection: (#none).
	unnamedMorph1 frameFractions: (0@0 corner: 1@1).
	unnamedMorph1 frameOffsets: (0@0 corner: 0@0).
	unnamedMorph1 balloonText: (nil).
	unnamedMorph1 balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1.0 alpha: 0.922)).
	unnamedMorph1 color: (Color transparent).
	unnamedMorph1 borderWidth: (0).
	unnamedMorph1 borderStyle2: (#simple).
	unnamedMorph1 borderColor: (Color black).
	hideBtn := UiToolButton new.
	hideBtn changeTableLayout.
	hideBtn extent: (18@18).
	hideBtn position: (3@4).
	hideBtn hResizing: (#shrinkWrap).
	hideBtn vResizing: (#shrinkWrap).
	hideBtn minWidth: (2).
	hideBtn minHeight: (2).
	hideBtn cellInset: (4).
	hideBtn cellPositioning: (#center).
	hideBtn cellSpacing: (#none).
	hideBtn layoutInset: (0).
	hideBtn listCentering: (#topLeft).
	hideBtn listDirection: (#leftToRight).
	hideBtn listSpacing: (#none).
	hideBtn maxCellSize: (1073741823).
	hideBtn minCellSize: (0).
	hideBtn wrapCentering: (#topLeft).
	hideBtn wrapDirection: (#none).
	hideBtn frameFractions: (0@0 corner: 1@1).
	hideBtn frameOffsets: (0@0 corner: 0@0).
	hideBtn balloonText: (nil).
	hideBtn balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1.0 alpha: 0.933)).
	hideBtn enabled: (true).
	hideBtn setProperty: #iconByDesigner toValue: 'UiSilkIcons eyeIcon'.
	hideBtn icon: (UiSilkIcons eyeIcon).
	hideBtn text: ('ToolButton').
	hideBtn color: ((Color r: 0.85 g: 0.85 b: 0.85)).
	hideBtn checkable: (true).
	hideBtn checked: (true).
	hideBtn autoExclusive: (false).
	hideBtn autoRaise: (true).
	hideBtn buttonStyle: (#iconOnly).
	hideBtn setProperty: #objectName toValue: 'hideBtn'.
	unnamedMorph1 addMorphBack: hideBtn.
	unnamedMorph2 := UiSpacer new.
	unnamedMorph2 extent: (30@10).
	unnamedMorph2 position: (22@8).
	unnamedMorph2 hResizing: (#spaceFill).
	unnamedMorph2 vResizing: (#rigid).
	unnamedMorph2 minWidth: (2).
	unnamedMorph2 minHeight: (2).
	unnamedMorph2 cellInset: (0).
	unnamedMorph2 cellPositioning: (#center).
	unnamedMorph2 cellSpacing: (#none).
	unnamedMorph2 layoutInset: (0).
	unnamedMorph2 listCentering: (#topLeft).
	unnamedMorph2 listDirection: (#topToBottom).
	unnamedMorph2 listSpacing: (#none).
	unnamedMorph2 maxCellSize: (1073741823).
	unnamedMorph2 minCellSize: (0).
	unnamedMorph2 wrapCentering: (#topLeft).
	unnamedMorph2 wrapDirection: (#none).
	unnamedMorph2 frameFractions: (0@0 corner: 1@1).
	unnamedMorph2 frameOffsets: (0@0 corner: 0@0).
	unnamedMorph2 balloonText: (nil).
	unnamedMorph2 balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1.0 alpha: 0.922)).
	unnamedMorph2 color: (Color blue).
	unnamedMorph2 borderWidth: (0).
	unnamedMorph2 borderStyle2: (#simple).
	unnamedMorph2 borderColor: (Color black).
	unnamedMorph2 orientation: (#horizontal).
	unnamedMorph1 addMorphBack: unnamedMorph2.
	headerBtn := SdDraggableButton new.
	headerBtn changeTableLayout.
	headerBtn extent: (88@21).
	headerBtn position: (52@2).
	headerBtn hResizing: (#shrinkWrap).
	headerBtn vResizing: (#shrinkWrap).
	headerBtn minWidth: (2).
	headerBtn minHeight: (2).
	headerBtn cellInset: (4).
	headerBtn cellPositioning: (#center).
	headerBtn cellSpacing: (#none).
	headerBtn layoutInset: (2@0 corner: 2@0).
	headerBtn listCentering: (#topLeft).
	headerBtn listDirection: (#leftToRight).
	headerBtn listSpacing: (#none).
	headerBtn maxCellSize: (1073741823).
	headerBtn minCellSize: (0).
	headerBtn wrapCentering: (#topLeft).
	headerBtn wrapDirection: (#none).
	headerBtn frameFractions: (0@0 corner: 1@1).
	headerBtn frameOffsets: (0@0 corner: 0@0).
	headerBtn balloonText: (nil).
	headerBtn balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1.0 alpha: 0.922)).
	headerBtn enabled: (true).
	headerBtn setProperty: #iconByDesigner toValue: 'nil'.
	headerBtn icon: (nil).
	headerBtn text: ('Package Viewer').
	headerBtn color: ((Color r: 0.85 g: 0.85 b: 0.85)).
	headerBtn checkable: (false).
	headerBtn checked: (false).
	headerBtn autoExclusive: (false).
	headerBtn autoRaise: (true).
	headerBtn buttonStyle: (#textBesideIcon).
	headerBtn setProperty: #objectName toValue: 'headerBtn'.
	unnamedMorph1 addMorphBack: headerBtn.
	unnamedMorph3 := UiSpacer new.
	unnamedMorph3 extent: (30@10).
	unnamedMorph3 position: (142@8).
	unnamedMorph3 hResizing: (#spaceFill).
	unnamedMorph3 vResizing: (#rigid).
	unnamedMorph3 minWidth: (2).
	unnamedMorph3 minHeight: (2).
	unnamedMorph3 cellInset: (0).
	unnamedMorph3 cellPositioning: (#center).
	unnamedMorph3 cellSpacing: (#none).
	unnamedMorph3 layoutInset: (0).
	unnamedMorph3 listCentering: (#topLeft).
	unnamedMorph3 listDirection: (#topToBottom).
	unnamedMorph3 listSpacing: (#none).
	unnamedMorph3 maxCellSize: (1073741823).
	unnamedMorph3 minCellSize: (0).
	unnamedMorph3 wrapCentering: (#topLeft).
	unnamedMorph3 wrapDirection: (#none).
	unnamedMorph3 frameFractions: (0@0 corner: 1@1).
	unnamedMorph3 frameOffsets: (0@0 corner: 0@0).
	unnamedMorph3 balloonText: (nil).
	unnamedMorph3 balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1.0 alpha: 0.922)).
	unnamedMorph3 color: (Color blue).
	unnamedMorph3 borderWidth: (0).
	unnamedMorph3 borderStyle2: (#simple).
	unnamedMorph3 borderColor: (Color black).
	unnamedMorph3 orientation: (#horizontal).
	unnamedMorph1 addMorphBack: unnamedMorph3.
	closeBtn := UiToolButton new.
	closeBtn changeTableLayout.
	closeBtn extent: (18@18).
	closeBtn position: (173@4).
	closeBtn hResizing: (#shrinkWrap).
	closeBtn vResizing: (#shrinkWrap).
	closeBtn minWidth: (2).
	closeBtn minHeight: (2).
	closeBtn cellInset: (4).
	closeBtn cellPositioning: (#center).
	closeBtn cellSpacing: (#none).
	closeBtn layoutInset: (0).
	closeBtn listCentering: (#topLeft).
	closeBtn listDirection: (#leftToRight).
	closeBtn listSpacing: (#none).
	closeBtn maxCellSize: (1073741823).
	closeBtn minCellSize: (0).
	closeBtn wrapCentering: (#topLeft).
	closeBtn wrapDirection: (#none).
	closeBtn frameFractions: (0@0 corner: 1@1).
	closeBtn frameOffsets: (0@0 corner: 0@0).
	closeBtn balloonText: (nil).
	closeBtn balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1.0 alpha: 0.922)).
	closeBtn enabled: (true).
	closeBtn setProperty: #iconByDesigner toValue: 'UiFugueIcons minusWhiteIcon'.
	closeBtn icon: (UiFugueIcons minusWhiteIcon).
	closeBtn text: ('Close').
	closeBtn color: ((Color r: 0.85 g: 0.85 b: 0.85)).
	closeBtn checkable: (false).
	closeBtn checked: (false).
	closeBtn autoExclusive: (false).
	closeBtn autoRaise: (true).
	closeBtn buttonStyle: (#iconOnly).
	closeBtn setProperty: #objectName toValue: 'closeBtn'.
	unnamedMorph1 addMorphBack: closeBtn.
	panel addMorphBack: unnamedMorph1.
	unnamedMorph4 := UiContainer new.
	unnamedMorph4 changeTableLayout.
	unnamedMorph4 extent: (190@29).
	unnamedMorph4 position: (2@27).
	unnamedMorph4 hResizing: (#spaceFill).
	unnamedMorph4 vResizing: (#shrinkWrap).
	unnamedMorph4 minWidth: (2).
	unnamedMorph4 minHeight: (2).
	unnamedMorph4 cellInset: (3).
	unnamedMorph4 cellPositioning: (#center).
	unnamedMorph4 cellSpacing: (#none).
	unnamedMorph4 layoutInset: (0@2 corner: 0@3).
	unnamedMorph4 listCentering: (#topLeft).
	unnamedMorph4 listDirection: (#leftToRight).
	unnamedMorph4 listSpacing: (#none).
	unnamedMorph4 maxCellSize: (1073741823).
	unnamedMorph4 minCellSize: (0).
	unnamedMorph4 wrapCentering: (#topLeft).
	unnamedMorph4 wrapDirection: (#none).
	unnamedMorph4 frameFractions: (0@0 corner: 1@1).
	unnamedMorph4 frameOffsets: (0@0 corner: 0@0).
	unnamedMorph4 balloonText: (nil).
	unnamedMorph4 balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1.0 alpha: 0.922)).
	unnamedMorph4 color: (Color transparent).
	unnamedMorph4 borderWidth: (0).
	unnamedMorph4 borderStyle2: (#simple).
	unnamedMorph4 borderColor: (Color black).
	packageCombo := UiComboBox new.
	packageCombo extent: (163@22).
	packageCombo position: (2@30).
	packageCombo hResizing: (#spaceFill).
	packageCombo vResizing: (#shrinkWrap).
	packageCombo minWidth: (2).
	packageCombo minHeight: (2).
	packageCombo cellInset: (0).
	packageCombo cellPositioning: (#topLeft).
	packageCombo cellSpacing: (#none).
	packageCombo layoutInset: (0).
	packageCombo listCentering: (#topLeft).
	packageCombo listDirection: (#leftToRight).
	packageCombo listSpacing: (#none).
	packageCombo maxCellSize: (1073741823).
	packageCombo minCellSize: (0).
	packageCombo wrapCentering: (#topLeft).
	packageCombo wrapDirection: (#none).
	packageCombo frameFractions: (0@0 corner: 1@1).
	packageCombo frameOffsets: (0@0 corner: 0@0).
	packageCombo balloonText: (nil).
	packageCombo balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1.0 alpha: 0.922)).
	packageCombo readOnly: (true).
	packageCombo setProperty: #objectName toValue: 'packageCombo'.
	unnamedMorph4 addMorphBack: packageCombo.
	synchBtn := UiToolButton new.
	synchBtn changeTableLayout.
	synchBtn extent: (22@22).
	synchBtn position: (168@29).
	synchBtn hResizing: (#shrinkWrap).
	synchBtn vResizing: (#shrinkWrap).
	synchBtn minWidth: (2).
	synchBtn minHeight: (2).
	synchBtn cellInset: (4).
	synchBtn cellPositioning: (#center).
	synchBtn cellSpacing: (#none).
	synchBtn layoutInset: (2).
	synchBtn listCentering: (#topLeft).
	synchBtn listDirection: (#leftToRight).
	synchBtn listSpacing: (#none).
	synchBtn maxCellSize: (1073741823).
	synchBtn minCellSize: (0).
	synchBtn wrapCentering: (#topLeft).
	synchBtn wrapDirection: (#none).
	synchBtn frameFractions: (0@0 corner: 1@1).
	synchBtn frameOffsets: (0@0 corner: 0@0).
	synchBtn balloonText: ('Synchronize').
	synchBtn balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1.0 alpha: 0.922)).
	synchBtn enabled: (true).
	synchBtn setProperty: #iconByDesigner toValue: 'UiSilkIcons databaseRefreshIcon'.
	synchBtn icon: (UiSilkIcons databaseRefreshIcon).
	synchBtn text: ('Synchronize').
	synchBtn color: ((Color r: 0.85 g: 0.85 b: 0.85)).
	synchBtn checkable: (false).
	synchBtn checked: (false).
	synchBtn autoExclusive: (false).
	synchBtn autoRaise: (true).
	synchBtn buttonStyle: (#iconOnly).
	synchBtn setProperty: #objectName toValue: 'synchBtn'.
	unnamedMorph4 addMorphBack: synchBtn.
	panel addMorphBack: unnamedMorph4.
	treeView := UiTreeView new.
	treeView extent: (190@137).
	treeView position: (2@58).
	treeView hResizing: (#spaceFill).
	treeView vResizing: (#spaceFill).
	treeView minWidth: (2).
	treeView minHeight: (2).
	treeView cellInset: (0).
	treeView cellPositioning: (#center).
	treeView cellSpacing: (#none).
	treeView layoutInset: (0).
	treeView listCentering: (#topLeft).
	treeView listDirection: (#topToBottom).
	treeView listSpacing: (#none).
	treeView maxCellSize: (1073741823).
	treeView minCellSize: (0).
	treeView wrapCentering: (#topLeft).
	treeView wrapDirection: (#none).
	treeView frameFractions: (0@0 corner: 1@1).
	treeView frameOffsets: (0@0 corner: 0@0).
	treeView balloonText: (nil).
	treeView balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1.0 alpha: 0.922)).
	treeView widgetResizable: (false).
	treeView horizontalScrollBarPolicy: (#asNeeded).
	treeView verticalScrollBarPolicy: (#asNeeded).
	treeView outerBorderWidth: (1).
	treeView scrollBarThickness: (9).
	treeView modelClass: (nil).
	treeView horizontalHeaderVisible: (true).
	treeView verticalHeaderVisible: (false).
	treeView selectionBehavior: (#selectRows).
	treeView selectionColor: ((Color r: 0.772 g: 0.858 b: 1.0)).
	treeView selectionMode: (UiViewSingleSelection).
	treeView setProperty: #objectName toValue: 'treeView'.
	panel addMorphBack: treeView.
	panel setProperty: #uiClassName toValue: 'SdPackageViewer'.! !

!SdPackageViewerUi methodsFor: 'accessing' stamp: 'mt 6/20/2012 14:04:49.928'!
packageCombo
	"No description given."
	
	^ packageCombo! !

!SdPackageViewerUi methodsFor: 'accessing' stamp: 'mt 6/20/2012 14:04:49.946'!
synchBtn
	"No description given."
	
	^ synchBtn! !

!SdPackageViewerUi methodsFor: 'accessing' stamp: 'mt 6/20/2012 14:04:49.963'!
treeView
	"No description given."
	
	^ treeView! !

UserInterface subclass: #SdQueryEditorUi
	instanceVariableNames: 'hideBtn headerBtn closeBtn treeView controlsContainer fromBtn selectBtn groupByBtn collectBtn'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sight-Dynamic-UI-Designs'!

!SdQueryEditorUi methodsFor: 'accessing' stamp: 'mt 7/11/2012 11:29:28.692'!
closeBtn
	"No description given."
	
	^ closeBtn! !

!SdQueryEditorUi methodsFor: 'accessing' stamp: 'mt 7/11/2012 11:29:28.804'!
collectBtn
	"No description given."
	
	^ collectBtn! !

!SdQueryEditorUi methodsFor: 'accessing' stamp: 'mt 7/11/2012 11:29:28.729'!
controlsContainer
	"No description given."
	
	^ controlsContainer! !

!SdQueryEditorUi methodsFor: 'accessing' stamp: 'mt 7/11/2012 11:29:28.748'!
fromBtn
	"No description given."
	
	^ fromBtn! !

!SdQueryEditorUi methodsFor: 'accessing' stamp: 'mt 7/10/2012 14:20:16.579'!
groupBtn
	"No description given."
	
	^ groupBtn! !

!SdQueryEditorUi methodsFor: 'accessing' stamp: 'mt 7/11/2012 11:29:28.786'!
groupByBtn
	"No description given."
	
	^ groupByBtn! !

!SdQueryEditorUi methodsFor: 'accessing' stamp: 'mt 7/11/2012 11:29:28.673'!
headerBtn
	"No description given."
	
	^ headerBtn! !

!SdQueryEditorUi methodsFor: 'accessing' stamp: 'mt 7/11/2012 11:29:28.652'!
hideBtn
	"No description given."
	
	^ hideBtn! !

!SdQueryEditorUi methodsFor: 'ui - private' stamp: 'mt 7/11/2012 11:29:28.85'!
initializePanel
	"This code is auto-generated. DO NOT modify it because another generation step will overwrite all changes."
	
	| unnamedMorph1 unnamedMorph2 unnamedMorph3 |
	
	panel := UiContainer new.
	panel changeTableLayout.
	panel extent: (330@364).
	panel position: (0@0).
	panel hResizing: (#rigid).
	panel vResizing: (#rigid).
	panel minWidth: (2).
	panel minHeight: (2).
	panel cellInset: (2).
	panel cellPositioning: (#center).
	panel cellSpacing: (#none).
	panel layoutInset: (2).
	panel listCentering: (#topLeft).
	panel listDirection: (#topToBottom).
	panel listSpacing: (#none).
	panel maxCellSize: (1073741823).
	panel minCellSize: (0).
	panel wrapCentering: (#topLeft).
	panel wrapDirection: (#none).
	panel frameFractions: (0@0 corner: 1@1).
	panel frameOffsets: (0@0 corner: 0@0).
	panel balloonText: (nil).
	panel balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1.0 alpha: 0.922)).
	panel color: (Color transparent).
	panel borderWidth: (0).
	panel borderStyle2: (#simple).
	panel borderColor: (Color black).
	panel setProperty: #objectName toValue: 'panel'.
	unnamedMorph1 := UiContainer new.
	unnamedMorph1 changeTableLayout.
	unnamedMorph1 extent: (326@22).
	unnamedMorph1 position: (2@2).
	unnamedMorph1 hResizing: (#spaceFill).
	unnamedMorph1 vResizing: (#shrinkWrap).
	unnamedMorph1 minWidth: (2).
	unnamedMorph1 minHeight: (2).
	unnamedMorph1 cellInset: (0).
	unnamedMorph1 cellPositioning: (#center).
	unnamedMorph1 cellSpacing: (#none).
	unnamedMorph1 layoutInset: (0).
	unnamedMorph1 listCentering: (#topLeft).
	unnamedMorph1 listDirection: (#leftToRight).
	unnamedMorph1 listSpacing: (#none).
	unnamedMorph1 maxCellSize: (1073741823).
	unnamedMorph1 minCellSize: (0).
	unnamedMorph1 wrapCentering: (#topLeft).
	unnamedMorph1 wrapDirection: (#none).
	unnamedMorph1 frameFractions: (0@0 corner: 1@1).
	unnamedMorph1 frameOffsets: (0@0 corner: 0@0).
	unnamedMorph1 balloonText: (nil).
	unnamedMorph1 balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1.0 alpha: 0.922)).
	unnamedMorph1 color: (Color transparent).
	unnamedMorph1 borderWidth: (0).
	unnamedMorph1 borderStyle2: (#simple).
	unnamedMorph1 borderColor: (Color black).
	hideBtn := UiToolButton new.
	hideBtn changeTableLayout.
	hideBtn extent: (18@18).
	hideBtn position: (3@4).
	hideBtn hResizing: (#shrinkWrap).
	hideBtn vResizing: (#shrinkWrap).
	hideBtn minWidth: (2).
	hideBtn minHeight: (2).
	hideBtn cellInset: (4).
	hideBtn cellPositioning: (#center).
	hideBtn cellSpacing: (#none).
	hideBtn layoutInset: (0).
	hideBtn listCentering: (#topLeft).
	hideBtn listDirection: (#leftToRight).
	hideBtn listSpacing: (#none).
	hideBtn maxCellSize: (1073741823).
	hideBtn minCellSize: (0).
	hideBtn wrapCentering: (#topLeft).
	hideBtn wrapDirection: (#none).
	hideBtn frameFractions: (0@0 corner: 1@1).
	hideBtn frameOffsets: (0@0 corner: 0@0).
	hideBtn balloonText: (nil).
	hideBtn balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1.0 alpha: 0.922)).
	hideBtn enabled: (true).
	hideBtn setProperty: #iconByDesigner toValue: 'UiSilkIcons eyeIcon'.
	hideBtn icon: (UiSilkIcons eyeIcon).
	hideBtn text: ('ToolButton').
	hideBtn color: ((Color r: 0.85 g: 0.85 b: 0.85)).
	hideBtn checkable: (true).
	hideBtn checked: (true).
	hideBtn autoExclusive: (false).
	hideBtn autoRaise: (true).
	hideBtn buttonStyle: (#iconOnly).
	hideBtn setProperty: #objectName toValue: 'hideBtn'.
	unnamedMorph1 addMorphBack: hideBtn.
	unnamedMorph2 := UiSpacer new.
	unnamedMorph2 extent: (104@10).
	unnamedMorph2 position: (22@8).
	unnamedMorph2 hResizing: (#spaceFill).
	unnamedMorph2 vResizing: (#rigid).
	unnamedMorph2 minWidth: (2).
	unnamedMorph2 minHeight: (2).
	unnamedMorph2 cellInset: (0).
	unnamedMorph2 cellPositioning: (#center).
	unnamedMorph2 cellSpacing: (#none).
	unnamedMorph2 layoutInset: (0).
	unnamedMorph2 listCentering: (#topLeft).
	unnamedMorph2 listDirection: (#topToBottom).
	unnamedMorph2 listSpacing: (#none).
	unnamedMorph2 maxCellSize: (1073741823).
	unnamedMorph2 minCellSize: (0).
	unnamedMorph2 wrapCentering: (#topLeft).
	unnamedMorph2 wrapDirection: (#none).
	unnamedMorph2 frameFractions: (0@0 corner: 1@1).
	unnamedMorph2 frameOffsets: (0@0 corner: 0@0).
	unnamedMorph2 balloonText: (nil).
	unnamedMorph2 balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1.0 alpha: 0.922)).
	unnamedMorph2 color: (Color blue).
	unnamedMorph2 borderWidth: (0).
	unnamedMorph2 borderStyle2: (#simple).
	unnamedMorph2 borderColor: (Color black).
	unnamedMorph2 orientation: (#horizontal).
	unnamedMorph1 addMorphBack: unnamedMorph2.
	headerBtn := SdDraggableButton new.
	headerBtn changeTableLayout.
	headerBtn extent: (76@21).
	headerBtn position: (126@2).
	headerBtn hResizing: (#shrinkWrap).
	headerBtn vResizing: (#shrinkWrap).
	headerBtn minWidth: (2).
	headerBtn minHeight: (2).
	headerBtn cellInset: (4).
	headerBtn cellPositioning: (#center).
	headerBtn cellSpacing: (#none).
	headerBtn layoutInset: (2@0 corner: 2@0).
	headerBtn listCentering: (#topLeft).
	headerBtn listDirection: (#leftToRight).
	headerBtn listSpacing: (#none).
	headerBtn maxCellSize: (1073741823).
	headerBtn minCellSize: (0).
	headerBtn wrapCentering: (#topLeft).
	headerBtn wrapDirection: (#none).
	headerBtn frameFractions: (0@0 corner: 1@1).
	headerBtn frameOffsets: (0@0 corner: 0@0).
	headerBtn balloonText: (nil).
	headerBtn balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1.0 alpha: 0.922)).
	headerBtn enabled: (true).
	headerBtn setProperty: #iconByDesigner toValue: 'nil'.
	headerBtn icon: (nil).
	headerBtn text: ('Code Query').
	headerBtn color: ((Color r: 0.85 g: 0.85 b: 0.85)).
	headerBtn checkable: (false).
	headerBtn checked: (false).
	headerBtn autoExclusive: (false).
	headerBtn autoRaise: (true).
	headerBtn buttonStyle: (#textBesideIcon).
	headerBtn setProperty: #objectName toValue: 'headerBtn'.
	unnamedMorph1 addMorphBack: headerBtn.
	unnamedMorph3 := UiSpacer new.
	unnamedMorph3 extent: (104@10).
	unnamedMorph3 position: (204@8).
	unnamedMorph3 hResizing: (#spaceFill).
	unnamedMorph3 vResizing: (#rigid).
	unnamedMorph3 minWidth: (2).
	unnamedMorph3 minHeight: (2).
	unnamedMorph3 cellInset: (0).
	unnamedMorph3 cellPositioning: (#center).
	unnamedMorph3 cellSpacing: (#none).
	unnamedMorph3 layoutInset: (0).
	unnamedMorph3 listCentering: (#topLeft).
	unnamedMorph3 listDirection: (#topToBottom).
	unnamedMorph3 listSpacing: (#none).
	unnamedMorph3 maxCellSize: (1073741823).
	unnamedMorph3 minCellSize: (0).
	unnamedMorph3 wrapCentering: (#topLeft).
	unnamedMorph3 wrapDirection: (#none).
	unnamedMorph3 frameFractions: (0@0 corner: 1@1).
	unnamedMorph3 frameOffsets: (0@0 corner: 0@0).
	unnamedMorph3 balloonText: (nil).
	unnamedMorph3 balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1.0 alpha: 0.922)).
	unnamedMorph3 color: (Color blue).
	unnamedMorph3 borderWidth: (0).
	unnamedMorph3 borderStyle2: (#simple).
	unnamedMorph3 borderColor: (Color black).
	unnamedMorph3 orientation: (#horizontal).
	unnamedMorph1 addMorphBack: unnamedMorph3.
	closeBtn := UiToolButton new.
	closeBtn changeTableLayout.
	closeBtn extent: (18@18).
	closeBtn position: (309@4).
	closeBtn hResizing: (#shrinkWrap).
	closeBtn vResizing: (#shrinkWrap).
	closeBtn minWidth: (2).
	closeBtn minHeight: (2).
	closeBtn cellInset: (4).
	closeBtn cellPositioning: (#center).
	closeBtn cellSpacing: (#none).
	closeBtn layoutInset: (0).
	closeBtn listCentering: (#topLeft).
	closeBtn listDirection: (#leftToRight).
	closeBtn listSpacing: (#none).
	closeBtn maxCellSize: (1073741823).
	closeBtn minCellSize: (0).
	closeBtn wrapCentering: (#topLeft).
	closeBtn wrapDirection: (#none).
	closeBtn frameFractions: (0@0 corner: 1@1).
	closeBtn frameOffsets: (0@0 corner: 0@0).
	closeBtn balloonText: (nil).
	closeBtn balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1.0 alpha: 0.922)).
	closeBtn enabled: (true).
	closeBtn setProperty: #iconByDesigner toValue: 'UiFugueIcons minusWhiteIcon'.
	closeBtn icon: (UiFugueIcons minusWhiteIcon).
	closeBtn text: ('Call Graph').
	closeBtn color: ((Color r: 0.85 g: 0.85 b: 0.85)).
	closeBtn checkable: (false).
	closeBtn checked: (false).
	closeBtn autoExclusive: (false).
	closeBtn autoRaise: (true).
	closeBtn buttonStyle: (#iconOnly).
	closeBtn setProperty: #objectName toValue: 'closeBtn'.
	unnamedMorph1 addMorphBack: closeBtn.
	panel addMorphBack: unnamedMorph1.
	treeView := UiTreeView new.
	treeView extent: (326@313).
	treeView position: (2@27).
	treeView hResizing: (#spaceFill).
	treeView vResizing: (#spaceFill).
	treeView minWidth: (2).
	treeView minHeight: (2).
	treeView cellInset: (0).
	treeView cellPositioning: (#center).
	treeView cellSpacing: (#none).
	treeView layoutInset: (0).
	treeView listCentering: (#topLeft).
	treeView listDirection: (#topToBottom).
	treeView listSpacing: (#none).
	treeView maxCellSize: (1073741823).
	treeView minCellSize: (0).
	treeView wrapCentering: (#topLeft).
	treeView wrapDirection: (#none).
	treeView frameFractions: (0@0 corner: 1@1).
	treeView frameOffsets: (0@0 corner: 0@0).
	treeView balloonText: (nil).
	treeView balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1.0 alpha: 0.925)).
	treeView widgetResizable: (false).
	treeView horizontalScrollBarPolicy: (#asNeeded).
	treeView verticalScrollBarPolicy: (#asNeeded).
	treeView outerBorderWidth: (0).
	treeView scrollBarThickness: (9).
	treeView modelClass: (nil).
	treeView horizontalHeaderVisible: (true).
	treeView verticalHeaderVisible: (false).
	treeView selectionBehavior: (#selectRows).
	treeView selectionColor: ((Color r: 0.772 g: 0.858 b: 1.0)).
	treeView selectionMode: (UiViewSingleSelection).
	treeView setProperty: #objectName toValue: 'treeView'.
	panel addMorphBack: treeView.
	controlsContainer := UiContainer new.
	controlsContainer changeTableLayout.
	controlsContainer extent: (326@19).
	controlsContainer position: (2@343).
	controlsContainer hResizing: (#spaceFill).
	controlsContainer vResizing: (#shrinkWrap).
	controlsContainer minWidth: (2).
	controlsContainer minHeight: (2).
	controlsContainer cellInset: (0).
	controlsContainer cellPositioning: (#center).
	controlsContainer cellSpacing: (#none).
	controlsContainer layoutInset: (0).
	controlsContainer listCentering: (#topLeft).
	controlsContainer listDirection: (#leftToRight).
	controlsContainer listSpacing: (#none).
	controlsContainer maxCellSize: (1073741823).
	controlsContainer minCellSize: (0).
	controlsContainer wrapCentering: (#topLeft).
	controlsContainer wrapDirection: (#none).
	controlsContainer frameFractions: (0@0 corner: 1@1).
	controlsContainer frameOffsets: (0@0 corner: 0@0).
	controlsContainer balloonText: (nil).
	controlsContainer balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1.0 alpha: 0.941)).
	controlsContainer color: (Color transparent).
	controlsContainer borderWidth: (0).
	controlsContainer borderStyle2: (#simple).
	controlsContainer borderColor: (Color black).
	controlsContainer setProperty: #objectName toValue: 'controlsContainer'.
	fromBtn := SdNotificationToolButton new.
	fromBtn changeTableLayout.
	fromBtn extent: (22@18).
	fromBtn position: (2@343).
	fromBtn hResizing: (#shrinkWrap).
	fromBtn vResizing: (#shrinkWrap).
	fromBtn minWidth: (2).
	fromBtn minHeight: (2).
	fromBtn cellInset: (4).
	fromBtn cellPositioning: (#center).
	fromBtn cellSpacing: (#none).
	fromBtn layoutInset: (2@0 corner: 2@0).
	fromBtn listCentering: (#topLeft).
	fromBtn listDirection: (#leftToRight).
	fromBtn listSpacing: (#none).
	fromBtn maxCellSize: (1073741823).
	fromBtn minCellSize: (0).
	fromBtn wrapCentering: (#topLeft).
	fromBtn wrapDirection: (#none).
	fromBtn frameFractions: (0@0 corner: 1@1).
	fromBtn frameOffsets: (0@0 corner: 0@0).
	fromBtn balloonText: (nil).
	fromBtn balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1.0 alpha: 0.933)).
	fromBtn enabled: (true).
	fromBtn setProperty: #iconByDesigner toValue: 'UiFugueIcons databaseIcon'.
	fromBtn icon: (UiFugueIcons databaseIcon).
	fromBtn text: ('FROM').
	fromBtn color: ((Color r: 1.0 g: 0.871 b: 0.0)).
	fromBtn checkable: (true).
	fromBtn checked: (false).
	fromBtn autoExclusive: (false).
	fromBtn autoRaise: (true).
	fromBtn buttonStyle: (#iconOnly).
	fromBtn setProperty: #objectName toValue: 'fromBtn'.
	controlsContainer addMorphBack: fromBtn.
	selectBtn := SdNotificationToolButton new.
	selectBtn changeTableLayout.
	selectBtn extent: (22@18).
	selectBtn position: (26@343).
	selectBtn hResizing: (#shrinkWrap).
	selectBtn vResizing: (#shrinkWrap).
	selectBtn minWidth: (2).
	selectBtn minHeight: (2).
	selectBtn cellInset: (4).
	selectBtn cellPositioning: (#center).
	selectBtn cellSpacing: (#none).
	selectBtn layoutInset: (2@0 corner: 2@0).
	selectBtn listCentering: (#topLeft).
	selectBtn listDirection: (#leftToRight).
	selectBtn listSpacing: (#none).
	selectBtn maxCellSize: (1073741823).
	selectBtn minCellSize: (0).
	selectBtn wrapCentering: (#topLeft).
	selectBtn wrapDirection: (#none).
	selectBtn frameFractions: (0@0 corner: 1@1).
	selectBtn frameOffsets: (0@0 corner: 0@0).
	selectBtn balloonText: (nil).
	selectBtn balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1.0 alpha: 0.933)).
	selectBtn enabled: (true).
	selectBtn setProperty: #iconByDesigner toValue: 'UiFugueIcons funnelIcon'.
	selectBtn icon: (UiFugueIcons funnelIcon).
	selectBtn text: ('GROUP').
	selectBtn color: ((Color r: 1.0 g: 0.871 b: 0.0)).
	selectBtn checkable: (true).
	selectBtn checked: (false).
	selectBtn autoExclusive: (false).
	selectBtn autoRaise: (true).
	selectBtn buttonStyle: (#iconOnly).
	selectBtn setProperty: #objectName toValue: 'selectBtn'.
	controlsContainer addMorphBack: selectBtn.
	groupByBtn := SdNotificationToolButton new.
	groupByBtn changeTableLayout.
	groupByBtn extent: (22@18).
	groupByBtn position: (50@343).
	groupByBtn hResizing: (#shrinkWrap).
	groupByBtn vResizing: (#shrinkWrap).
	groupByBtn minWidth: (2).
	groupByBtn minHeight: (2).
	groupByBtn cellInset: (4).
	groupByBtn cellPositioning: (#center).
	groupByBtn cellSpacing: (#none).
	groupByBtn layoutInset: (2@0 corner: 2@0).
	groupByBtn listCentering: (#topLeft).
	groupByBtn listDirection: (#leftToRight).
	groupByBtn listSpacing: (#none).
	groupByBtn maxCellSize: (1073741823).
	groupByBtn minCellSize: (0).
	groupByBtn wrapCentering: (#topLeft).
	groupByBtn wrapDirection: (#none).
	groupByBtn frameFractions: (0@0 corner: 1@1).
	groupByBtn frameOffsets: (0@0 corner: 0@0).
	groupByBtn balloonText: (nil).
	groupByBtn balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1.0 alpha: 0.933)).
	groupByBtn enabled: (true).
	groupByBtn setProperty: #iconByDesigner toValue: 'UiFugueIcons categoryIcon'.
	groupByBtn icon: (UiFugueIcons categoryIcon).
	groupByBtn text: ('GROUP').
	groupByBtn color: ((Color r: 1.0 g: 0.871 b: 0.0)).
	groupByBtn checkable: (true).
	groupByBtn checked: (false).
	groupByBtn autoExclusive: (false).
	groupByBtn autoRaise: (true).
	groupByBtn buttonStyle: (#iconOnly).
	groupByBtn setProperty: #objectName toValue: 'groupByBtn'.
	controlsContainer addMorphBack: groupByBtn.
	collectBtn := SdNotificationToolButton new.
	collectBtn changeTableLayout.
	collectBtn extent: (22@18).
	collectBtn position: (74@343).
	collectBtn hResizing: (#shrinkWrap).
	collectBtn vResizing: (#shrinkWrap).
	collectBtn minWidth: (2).
	collectBtn minHeight: (2).
	collectBtn cellInset: (4).
	collectBtn cellPositioning: (#center).
	collectBtn cellSpacing: (#none).
	collectBtn layoutInset: (2@0 corner: 2@0).
	collectBtn listCentering: (#topLeft).
	collectBtn listDirection: (#leftToRight).
	collectBtn listSpacing: (#none).
	collectBtn maxCellSize: (1073741823).
	collectBtn minCellSize: (0).
	collectBtn wrapCentering: (#topLeft).
	collectBtn wrapDirection: (#none).
	collectBtn frameFractions: (0@0 corner: 1@1).
	collectBtn frameOffsets: (0@0 corner: 0@0).
	collectBtn balloonText: (nil).
	collectBtn balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1.0 alpha: 0.933)).
	collectBtn enabled: (true).
	collectBtn setProperty: #iconByDesigner toValue: 'UiFugueIcons documentConvertIcon'.
	collectBtn icon: (UiFugueIcons documentConvertIcon).
	collectBtn text: ('COLLECT').
	collectBtn color: ((Color r: 1.0 g: 0.871 b: 0.0)).
	collectBtn checkable: (true).
	collectBtn checked: (false).
	collectBtn autoExclusive: (false).
	collectBtn autoRaise: (true).
	collectBtn buttonStyle: (#iconOnly).
	collectBtn setProperty: #objectName toValue: 'collectBtn'.
	controlsContainer addMorphBack: collectBtn.
	panel addMorphBack: controlsContainer.
	panel setProperty: #uiClassName toValue: 'SdQueryEditor'.! !

!SdQueryEditorUi methodsFor: 'accessing' stamp: 'mt 7/11/2012 11:29:28.767'!
selectBtn
	"No description given."
	
	^ selectBtn! !

!SdQueryEditorUi methodsFor: 'accessing' stamp: 'mt 7/11/2012 11:29:28.71'!
treeView
	"No description given."
	
	^ treeView! !

UserInterface subclass: #SdSystemBrowserCategoriesUi
	instanceVariableNames: 'hideBtn headerBtn closeBtn list'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sight-Dynamic-UI-Designs'!

!SdSystemBrowserCategoriesUi methodsFor: 'accessing' stamp: 'mt 6/20/2012 14:09:24.926'!
closeBtn
	"No description given."
	
	^ closeBtn! !

!SdSystemBrowserCategoriesUi methodsFor: 'accessing' stamp: 'mt 6/20/2012 14:09:24.907'!
headerBtn
	"No description given."
	
	^ headerBtn! !

!SdSystemBrowserCategoriesUi methodsFor: 'accessing' stamp: 'mt 6/20/2012 14:09:24.888'!
hideBtn
	"No description given."
	
	^ hideBtn! !

!SdSystemBrowserCategoriesUi methodsFor: 'ui - private' stamp: 'mt 6/20/2012 14:09:24.977'!
initializePanel
	"This code is auto-generated. DO NOT modify it because another generation step will overwrite all changes."
	
	| unnamedMorph1 unnamedMorph2 unnamedMorph3 |
	
	panel := UiContainer new.
	panel changeTableLayout.
	panel extent: (248@382).
	panel position: (0@0).
	panel hResizing: (#rigid).
	panel vResizing: (#rigid).
	panel minWidth: (2).
	panel minHeight: (2).
	panel cellInset: (2).
	panel cellPositioning: (#center).
	panel cellSpacing: (#none).
	panel layoutInset: (2).
	panel listCentering: (#topLeft).
	panel listDirection: (#topToBottom).
	panel listSpacing: (#none).
	panel maxCellSize: (1073741823).
	panel minCellSize: (0).
	panel wrapCentering: (#topLeft).
	panel wrapDirection: (#none).
	panel frameFractions: (0@0 corner: 1@1).
	panel frameOffsets: (0@0 corner: 0@0).
	panel balloonText: (nil).
	panel balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1.0 alpha: 0.922)).
	panel color: (Color transparent).
	panel borderWidth: (0).
	panel borderStyle2: (#simple).
	panel borderColor: (Color black).
	panel setProperty: #objectName toValue: 'panel'.
	unnamedMorph1 := UiContainer new.
	unnamedMorph1 changeTableLayout.
	unnamedMorph1 extent: (244@22).
	unnamedMorph1 position: (2@2).
	unnamedMorph1 hResizing: (#spaceFill).
	unnamedMorph1 vResizing: (#shrinkWrap).
	unnamedMorph1 minWidth: (2).
	unnamedMorph1 minHeight: (2).
	unnamedMorph1 cellInset: (0).
	unnamedMorph1 cellPositioning: (#center).
	unnamedMorph1 cellSpacing: (#none).
	unnamedMorph1 layoutInset: (0).
	unnamedMorph1 listCentering: (#topLeft).
	unnamedMorph1 listDirection: (#leftToRight).
	unnamedMorph1 listSpacing: (#none).
	unnamedMorph1 maxCellSize: (1073741823).
	unnamedMorph1 minCellSize: (0).
	unnamedMorph1 wrapCentering: (#topLeft).
	unnamedMorph1 wrapDirection: (#none).
	unnamedMorph1 frameFractions: (0@0 corner: 1@1).
	unnamedMorph1 frameOffsets: (0@0 corner: 0@0).
	unnamedMorph1 balloonText: (nil).
	unnamedMorph1 balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1.0 alpha: 0.922)).
	unnamedMorph1 color: (Color transparent).
	unnamedMorph1 borderWidth: (0).
	unnamedMorph1 borderStyle2: (#simple).
	unnamedMorph1 borderColor: (Color black).
	hideBtn := UiToolButton new.
	hideBtn changeTableLayout.
	hideBtn extent: (18@18).
	hideBtn position: (3@4).
	hideBtn hResizing: (#shrinkWrap).
	hideBtn vResizing: (#shrinkWrap).
	hideBtn minWidth: (2).
	hideBtn minHeight: (2).
	hideBtn cellInset: (4).
	hideBtn cellPositioning: (#center).
	hideBtn cellSpacing: (#none).
	hideBtn layoutInset: (0).
	hideBtn listCentering: (#topLeft).
	hideBtn listDirection: (#leftToRight).
	hideBtn listSpacing: (#none).
	hideBtn maxCellSize: (1073741823).
	hideBtn minCellSize: (0).
	hideBtn wrapCentering: (#topLeft).
	hideBtn wrapDirection: (#none).
	hideBtn frameFractions: (0@0 corner: 1@1).
	hideBtn frameOffsets: (0@0 corner: 0@0).
	hideBtn balloonText: (nil).
	hideBtn balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1.0 alpha: 0.925)).
	hideBtn enabled: (true).
	hideBtn setProperty: #iconByDesigner toValue: 'UiSilkIcons eyeIcon'.
	hideBtn icon: (UiSilkIcons eyeIcon).
	hideBtn text: ('ToolButton').
	hideBtn color: ((Color r: 0.85 g: 0.85 b: 0.85)).
	hideBtn checkable: (true).
	hideBtn checked: (true).
	hideBtn autoExclusive: (false).
	hideBtn autoRaise: (true).
	hideBtn buttonStyle: (#iconOnly).
	hideBtn setProperty: #objectName toValue: 'hideBtn'.
	unnamedMorph1 addMorphBack: hideBtn.
	unnamedMorph2 := UiSpacer new.
	unnamedMorph2 extent: (49@10).
	unnamedMorph2 position: (22@8).
	unnamedMorph2 hResizing: (#spaceFill).
	unnamedMorph2 vResizing: (#rigid).
	unnamedMorph2 minWidth: (2).
	unnamedMorph2 minHeight: (2).
	unnamedMorph2 cellInset: (0).
	unnamedMorph2 cellPositioning: (#center).
	unnamedMorph2 cellSpacing: (#none).
	unnamedMorph2 layoutInset: (0).
	unnamedMorph2 listCentering: (#topLeft).
	unnamedMorph2 listDirection: (#topToBottom).
	unnamedMorph2 listSpacing: (#none).
	unnamedMorph2 maxCellSize: (1073741823).
	unnamedMorph2 minCellSize: (0).
	unnamedMorph2 wrapCentering: (#topLeft).
	unnamedMorph2 wrapDirection: (#none).
	unnamedMorph2 frameFractions: (0@0 corner: 1@1).
	unnamedMorph2 frameOffsets: (0@0 corner: 0@0).
	unnamedMorph2 balloonText: (nil).
	unnamedMorph2 balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1.0 alpha: 0.922)).
	unnamedMorph2 color: (Color blue).
	unnamedMorph2 borderWidth: (0).
	unnamedMorph2 borderStyle2: (#simple).
	unnamedMorph2 borderColor: (Color black).
	unnamedMorph2 orientation: (#horizontal).
	unnamedMorph1 addMorphBack: unnamedMorph2.
	headerBtn := SdDraggableButton new.
	headerBtn changeTableLayout.
	headerBtn extent: (103@21).
	headerBtn position: (71@2).
	headerBtn hResizing: (#shrinkWrap).
	headerBtn vResizing: (#shrinkWrap).
	headerBtn minWidth: (2).
	headerBtn minHeight: (2).
	headerBtn cellInset: (4).
	headerBtn cellPositioning: (#center).
	headerBtn cellSpacing: (#none).
	headerBtn layoutInset: (2@0 corner: 2@0).
	headerBtn listCentering: (#topLeft).
	headerBtn listDirection: (#leftToRight).
	headerBtn listSpacing: (#none).
	headerBtn maxCellSize: (1073741823).
	headerBtn minCellSize: (0).
	headerBtn wrapCentering: (#topLeft).
	headerBtn wrapDirection: (#none).
	headerBtn frameFractions: (0@0 corner: 1@1).
	headerBtn frameOffsets: (0@0 corner: 0@0).
	headerBtn balloonText: (nil).
	headerBtn balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1.0 alpha: 0.922)).
	headerBtn enabled: (true).
	headerBtn setProperty: #iconByDesigner toValue: 'nil'.
	headerBtn icon: (nil).
	headerBtn text: ('System Categories').
	headerBtn color: ((Color r: 0.85 g: 0.85 b: 0.85)).
	headerBtn checkable: (false).
	headerBtn checked: (false).
	headerBtn autoExclusive: (false).
	headerBtn autoRaise: (true).
	headerBtn buttonStyle: (#textBesideIcon).
	headerBtn setProperty: #objectName toValue: 'headerBtn'.
	unnamedMorph1 addMorphBack: headerBtn.
	unnamedMorph3 := UiSpacer new.
	unnamedMorph3 extent: (50@10).
	unnamedMorph3 position: (176@8).
	unnamedMorph3 hResizing: (#spaceFill).
	unnamedMorph3 vResizing: (#rigid).
	unnamedMorph3 minWidth: (2).
	unnamedMorph3 minHeight: (2).
	unnamedMorph3 cellInset: (0).
	unnamedMorph3 cellPositioning: (#center).
	unnamedMorph3 cellSpacing: (#none).
	unnamedMorph3 layoutInset: (0).
	unnamedMorph3 listCentering: (#topLeft).
	unnamedMorph3 listDirection: (#topToBottom).
	unnamedMorph3 listSpacing: (#none).
	unnamedMorph3 maxCellSize: (1073741823).
	unnamedMorph3 minCellSize: (0).
	unnamedMorph3 wrapCentering: (#topLeft).
	unnamedMorph3 wrapDirection: (#none).
	unnamedMorph3 frameFractions: (0@0 corner: 1@1).
	unnamedMorph3 frameOffsets: (0@0 corner: 0@0).
	unnamedMorph3 balloonText: (nil).
	unnamedMorph3 balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1.0 alpha: 0.922)).
	unnamedMorph3 color: (Color blue).
	unnamedMorph3 borderWidth: (0).
	unnamedMorph3 borderStyle2: (#simple).
	unnamedMorph3 borderColor: (Color black).
	unnamedMorph3 orientation: (#horizontal).
	unnamedMorph1 addMorphBack: unnamedMorph3.
	closeBtn := UiToolButton new.
	closeBtn changeTableLayout.
	closeBtn extent: (18@18).
	closeBtn position: (227@4).
	closeBtn hResizing: (#shrinkWrap).
	closeBtn vResizing: (#shrinkWrap).
	closeBtn minWidth: (2).
	closeBtn minHeight: (2).
	closeBtn cellInset: (4).
	closeBtn cellPositioning: (#center).
	closeBtn cellSpacing: (#none).
	closeBtn layoutInset: (0).
	closeBtn listCentering: (#topLeft).
	closeBtn listDirection: (#leftToRight).
	closeBtn listSpacing: (#none).
	closeBtn maxCellSize: (1073741823).
	closeBtn minCellSize: (0).
	closeBtn wrapCentering: (#topLeft).
	closeBtn wrapDirection: (#none).
	closeBtn frameFractions: (0@0 corner: 1@1).
	closeBtn frameOffsets: (0@0 corner: 0@0).
	closeBtn balloonText: (nil).
	closeBtn balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1.0 alpha: 0.922)).
	closeBtn enabled: (true).
	closeBtn setProperty: #iconByDesigner toValue: 'UiFugueIcons minusWhiteIcon'.
	closeBtn icon: (UiFugueIcons minusWhiteIcon).
	closeBtn text: ('Call Graph').
	closeBtn color: ((Color r: 0.85 g: 0.85 b: 0.85)).
	closeBtn checkable: (false).
	closeBtn checked: (false).
	closeBtn autoExclusive: (false).
	closeBtn autoRaise: (true).
	closeBtn buttonStyle: (#iconOnly).
	closeBtn setProperty: #objectName toValue: 'closeBtn'.
	unnamedMorph1 addMorphBack: closeBtn.
	panel addMorphBack: unnamedMorph1.
	list := UiListView new.
	list extent: (244@353).
	list position: (2@27).
	list hResizing: (#spaceFill).
	list vResizing: (#spaceFill).
	list minWidth: (2).
	list minHeight: (2).
	list cellInset: (0).
	list cellPositioning: (#center).
	list cellSpacing: (#none).
	list layoutInset: (0).
	list listCentering: (#topLeft).
	list listDirection: (#topToBottom).
	list listSpacing: (#none).
	list maxCellSize: (1073741823).
	list minCellSize: (0).
	list wrapCentering: (#topLeft).
	list wrapDirection: (#none).
	list frameFractions: (0@0 corner: 1@1).
	list frameOffsets: (0@0 corner: 0@0).
	list balloonText: (nil).
	list balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1.0 alpha: 0.945)).
	list widgetResizable: (false).
	list horizontalScrollBarPolicy: (#alwaysOff).
	list verticalScrollBarPolicy: (#asNeeded).
	list outerBorderWidth: (0).
	list scrollBarThickness: (9).
	list modelClass: (nil).
	list horizontalHeaderVisible: (false).
	list verticalHeaderVisible: (false).
	list selectionBehavior: (#selectRows).
	list selectionColor: ((Color r: 0.772 g: 0.858 b: 1.0)).
	list selectionMode: (UiViewSingleSelection).
	list setProperty: #objectName toValue: 'list'.
	panel addMorphBack: list.
	panel setProperty: #uiClassName toValue: 'SdSystemBrowserCategories'.! !

!SdSystemBrowserCategoriesUi methodsFor: 'accessing' stamp: 'mt 6/20/2012 14:09:24.944'!
list
	"No description given."
	
	^ list! !

UserInterface subclass: #SdSystemBrowserClassesUi
	instanceVariableNames: 'hideBtn headerBtn closeBtn list'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sight-Dynamic-UI-Designs'!

!SdSystemBrowserClassesUi methodsFor: 'accessing' stamp: 'mt 6/20/2012 14:09:40.686'!
closeBtn
	"No description given."
	
	^ closeBtn! !

!SdSystemBrowserClassesUi methodsFor: 'accessing' stamp: 'mt 6/20/2012 14:09:40.668'!
headerBtn
	"No description given."
	
	^ headerBtn! !

!SdSystemBrowserClassesUi methodsFor: 'accessing' stamp: 'mt 6/20/2012 14:09:40.649'!
hideBtn
	"No description given."
	
	^ hideBtn! !

!SdSystemBrowserClassesUi methodsFor: 'ui - private' stamp: 'mt 6/20/2012 14:09:40.738'!
initializePanel
	"This code is auto-generated. DO NOT modify it because another generation step will overwrite all changes."
	
	| unnamedMorph1 unnamedMorph2 unnamedMorph3 |
	
	panel := UiContainer new.
	panel changeTableLayout.
	panel extent: (248@382).
	panel position: (0@0).
	panel hResizing: (#rigid).
	panel vResizing: (#rigid).
	panel minWidth: (2).
	panel minHeight: (2).
	panel cellInset: (2).
	panel cellPositioning: (#center).
	panel cellSpacing: (#none).
	panel layoutInset: (2).
	panel listCentering: (#topLeft).
	panel listDirection: (#topToBottom).
	panel listSpacing: (#none).
	panel maxCellSize: (1073741823).
	panel minCellSize: (0).
	panel wrapCentering: (#topLeft).
	panel wrapDirection: (#none).
	panel frameFractions: (0@0 corner: 1@1).
	panel frameOffsets: (0@0 corner: 0@0).
	panel balloonText: (nil).
	panel balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1.0 alpha: 0.922)).
	panel color: (Color transparent).
	panel borderWidth: (0).
	panel borderStyle2: (#simple).
	panel borderColor: (Color black).
	panel setProperty: #objectName toValue: 'panel'.
	unnamedMorph1 := UiContainer new.
	unnamedMorph1 changeTableLayout.
	unnamedMorph1 extent: (244@22).
	unnamedMorph1 position: (2@2).
	unnamedMorph1 hResizing: (#spaceFill).
	unnamedMorph1 vResizing: (#shrinkWrap).
	unnamedMorph1 minWidth: (2).
	unnamedMorph1 minHeight: (2).
	unnamedMorph1 cellInset: (0).
	unnamedMorph1 cellPositioning: (#center).
	unnamedMorph1 cellSpacing: (#none).
	unnamedMorph1 layoutInset: (0).
	unnamedMorph1 listCentering: (#topLeft).
	unnamedMorph1 listDirection: (#leftToRight).
	unnamedMorph1 listSpacing: (#none).
	unnamedMorph1 maxCellSize: (1073741823).
	unnamedMorph1 minCellSize: (0).
	unnamedMorph1 wrapCentering: (#topLeft).
	unnamedMorph1 wrapDirection: (#none).
	unnamedMorph1 frameFractions: (0@0 corner: 1@1).
	unnamedMorph1 frameOffsets: (0@0 corner: 0@0).
	unnamedMorph1 balloonText: (nil).
	unnamedMorph1 balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1.0 alpha: 0.922)).
	unnamedMorph1 color: (Color transparent).
	unnamedMorph1 borderWidth: (0).
	unnamedMorph1 borderStyle2: (#simple).
	unnamedMorph1 borderColor: (Color black).
	hideBtn := UiToolButton new.
	hideBtn changeTableLayout.
	hideBtn extent: (18@18).
	hideBtn position: (3@4).
	hideBtn hResizing: (#shrinkWrap).
	hideBtn vResizing: (#shrinkWrap).
	hideBtn minWidth: (2).
	hideBtn minHeight: (2).
	hideBtn cellInset: (4).
	hideBtn cellPositioning: (#center).
	hideBtn cellSpacing: (#none).
	hideBtn layoutInset: (0).
	hideBtn listCentering: (#topLeft).
	hideBtn listDirection: (#leftToRight).
	hideBtn listSpacing: (#none).
	hideBtn maxCellSize: (1073741823).
	hideBtn minCellSize: (0).
	hideBtn wrapCentering: (#topLeft).
	hideBtn wrapDirection: (#none).
	hideBtn frameFractions: (0@0 corner: 1@1).
	hideBtn frameOffsets: (0@0 corner: 0@0).
	hideBtn balloonText: (nil).
	hideBtn balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1.0 alpha: 0.925)).
	hideBtn enabled: (true).
	hideBtn setProperty: #iconByDesigner toValue: 'UiSilkIcons eyeIcon'.
	hideBtn icon: (UiSilkIcons eyeIcon).
	hideBtn text: ('ToolButton').
	hideBtn color: ((Color r: 0.85 g: 0.85 b: 0.85)).
	hideBtn checkable: (true).
	hideBtn checked: (true).
	hideBtn autoExclusive: (false).
	hideBtn autoRaise: (true).
	hideBtn buttonStyle: (#iconOnly).
	hideBtn setProperty: #objectName toValue: 'hideBtn'.
	unnamedMorph1 addMorphBack: hideBtn.
	unnamedMorph2 := UiSpacer new.
	unnamedMorph2 extent: (79@10).
	unnamedMorph2 position: (22@8).
	unnamedMorph2 hResizing: (#spaceFill).
	unnamedMorph2 vResizing: (#rigid).
	unnamedMorph2 minWidth: (2).
	unnamedMorph2 minHeight: (2).
	unnamedMorph2 cellInset: (0).
	unnamedMorph2 cellPositioning: (#center).
	unnamedMorph2 cellSpacing: (#none).
	unnamedMorph2 layoutInset: (0).
	unnamedMorph2 listCentering: (#topLeft).
	unnamedMorph2 listDirection: (#topToBottom).
	unnamedMorph2 listSpacing: (#none).
	unnamedMorph2 maxCellSize: (1073741823).
	unnamedMorph2 minCellSize: (0).
	unnamedMorph2 wrapCentering: (#topLeft).
	unnamedMorph2 wrapDirection: (#none).
	unnamedMorph2 frameFractions: (0@0 corner: 1@1).
	unnamedMorph2 frameOffsets: (0@0 corner: 0@0).
	unnamedMorph2 balloonText: (nil).
	unnamedMorph2 balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1.0 alpha: 0.922)).
	unnamedMorph2 color: (Color blue).
	unnamedMorph2 borderWidth: (0).
	unnamedMorph2 borderStyle2: (#simple).
	unnamedMorph2 borderColor: (Color black).
	unnamedMorph2 orientation: (#horizontal).
	unnamedMorph1 addMorphBack: unnamedMorph2.
	headerBtn := SdDraggableButton new.
	headerBtn changeTableLayout.
	headerBtn extent: (44@21).
	headerBtn position: (101@2).
	headerBtn hResizing: (#shrinkWrap).
	headerBtn vResizing: (#shrinkWrap).
	headerBtn minWidth: (2).
	headerBtn minHeight: (2).
	headerBtn cellInset: (4).
	headerBtn cellPositioning: (#center).
	headerBtn cellSpacing: (#none).
	headerBtn layoutInset: (2@0 corner: 2@0).
	headerBtn listCentering: (#topLeft).
	headerBtn listDirection: (#leftToRight).
	headerBtn listSpacing: (#none).
	headerBtn maxCellSize: (1073741823).
	headerBtn minCellSize: (0).
	headerBtn wrapCentering: (#topLeft).
	headerBtn wrapDirection: (#none).
	headerBtn frameFractions: (0@0 corner: 1@1).
	headerBtn frameOffsets: (0@0 corner: 0@0).
	headerBtn balloonText: (nil).
	headerBtn balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1.0 alpha: 0.922)).
	headerBtn enabled: (true).
	headerBtn setProperty: #iconByDesigner toValue: 'nil'.
	headerBtn icon: (nil).
	headerBtn text: ('Classes').
	headerBtn color: ((Color r: 0.85 g: 0.85 b: 0.85)).
	headerBtn checkable: (false).
	headerBtn checked: (false).
	headerBtn autoExclusive: (false).
	headerBtn autoRaise: (true).
	headerBtn buttonStyle: (#textBesideIcon).
	headerBtn setProperty: #objectName toValue: 'headerBtn'.
	unnamedMorph1 addMorphBack: headerBtn.
	unnamedMorph3 := UiSpacer new.
	unnamedMorph3 extent: (79@10).
	unnamedMorph3 position: (147@8).
	unnamedMorph3 hResizing: (#spaceFill).
	unnamedMorph3 vResizing: (#rigid).
	unnamedMorph3 minWidth: (2).
	unnamedMorph3 minHeight: (2).
	unnamedMorph3 cellInset: (0).
	unnamedMorph3 cellPositioning: (#center).
	unnamedMorph3 cellSpacing: (#none).
	unnamedMorph3 layoutInset: (0).
	unnamedMorph3 listCentering: (#topLeft).
	unnamedMorph3 listDirection: (#topToBottom).
	unnamedMorph3 listSpacing: (#none).
	unnamedMorph3 maxCellSize: (1073741823).
	unnamedMorph3 minCellSize: (0).
	unnamedMorph3 wrapCentering: (#topLeft).
	unnamedMorph3 wrapDirection: (#none).
	unnamedMorph3 frameFractions: (0@0 corner: 1@1).
	unnamedMorph3 frameOffsets: (0@0 corner: 0@0).
	unnamedMorph3 balloonText: (nil).
	unnamedMorph3 balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1.0 alpha: 0.922)).
	unnamedMorph3 color: (Color blue).
	unnamedMorph3 borderWidth: (0).
	unnamedMorph3 borderStyle2: (#simple).
	unnamedMorph3 borderColor: (Color black).
	unnamedMorph3 orientation: (#horizontal).
	unnamedMorph1 addMorphBack: unnamedMorph3.
	closeBtn := UiToolButton new.
	closeBtn changeTableLayout.
	closeBtn extent: (18@18).
	closeBtn position: (227@4).
	closeBtn hResizing: (#shrinkWrap).
	closeBtn vResizing: (#shrinkWrap).
	closeBtn minWidth: (2).
	closeBtn minHeight: (2).
	closeBtn cellInset: (4).
	closeBtn cellPositioning: (#center).
	closeBtn cellSpacing: (#none).
	closeBtn layoutInset: (0).
	closeBtn listCentering: (#topLeft).
	closeBtn listDirection: (#leftToRight).
	closeBtn listSpacing: (#none).
	closeBtn maxCellSize: (1073741823).
	closeBtn minCellSize: (0).
	closeBtn wrapCentering: (#topLeft).
	closeBtn wrapDirection: (#none).
	closeBtn frameFractions: (0@0 corner: 1@1).
	closeBtn frameOffsets: (0@0 corner: 0@0).
	closeBtn balloonText: (nil).
	closeBtn balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1.0 alpha: 0.922)).
	closeBtn enabled: (true).
	closeBtn setProperty: #iconByDesigner toValue: 'UiFugueIcons minusWhiteIcon'.
	closeBtn icon: (UiFugueIcons minusWhiteIcon).
	closeBtn text: ('Call Graph').
	closeBtn color: ((Color r: 0.85 g: 0.85 b: 0.85)).
	closeBtn checkable: (false).
	closeBtn checked: (false).
	closeBtn autoExclusive: (false).
	closeBtn autoRaise: (true).
	closeBtn buttonStyle: (#iconOnly).
	closeBtn setProperty: #objectName toValue: 'closeBtn'.
	unnamedMorph1 addMorphBack: closeBtn.
	panel addMorphBack: unnamedMorph1.
	list := UiListView new.
	list extent: (244@353).
	list position: (2@27).
	list hResizing: (#spaceFill).
	list vResizing: (#spaceFill).
	list minWidth: (2).
	list minHeight: (2).
	list cellInset: (0).
	list cellPositioning: (#center).
	list cellSpacing: (#none).
	list layoutInset: (0).
	list listCentering: (#topLeft).
	list listDirection: (#topToBottom).
	list listSpacing: (#none).
	list maxCellSize: (1073741823).
	list minCellSize: (0).
	list wrapCentering: (#topLeft).
	list wrapDirection: (#none).
	list frameFractions: (0@0 corner: 1@1).
	list frameOffsets: (0@0 corner: 0@0).
	list balloonText: (nil).
	list balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1.0 alpha: 0.945)).
	list widgetResizable: (false).
	list horizontalScrollBarPolicy: (#alwaysOff).
	list verticalScrollBarPolicy: (#asNeeded).
	list outerBorderWidth: (0).
	list scrollBarThickness: (9).
	list modelClass: (nil).
	list horizontalHeaderVisible: (false).
	list verticalHeaderVisible: (false).
	list selectionBehavior: (#selectRows).
	list selectionColor: ((Color r: 0.772 g: 0.858 b: 1.0)).
	list selectionMode: (UiViewSingleSelection).
	list setProperty: #objectName toValue: 'list'.
	panel addMorphBack: list.
	panel setProperty: #uiClassName toValue: 'SdSystemBrowserClasses'.! !

!SdSystemBrowserClassesUi methodsFor: 'accessing' stamp: 'mt 6/20/2012 14:09:40.705'!
list
	"No description given."
	
	^ list! !

UserInterface subclass: #SdSystemBrowserMessagesUi
	instanceVariableNames: 'hideBtn headerBtn closeBtn list'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sight-Dynamic-UI-Designs'!

!SdSystemBrowserMessagesUi methodsFor: 'accessing' stamp: 'mt 6/20/2012 14:13:40.582'!
closeBtn
	"No description given."
	
	^ closeBtn! !

!SdSystemBrowserMessagesUi methodsFor: 'accessing' stamp: 'mt 6/20/2012 14:13:40.563'!
headerBtn
	"No description given."
	
	^ headerBtn! !

!SdSystemBrowserMessagesUi methodsFor: 'accessing' stamp: 'mt 6/20/2012 14:13:40.544'!
hideBtn
	"No description given."
	
	^ hideBtn! !

!SdSystemBrowserMessagesUi methodsFor: 'ui - private' stamp: 'mt 6/20/2012 14:13:40.634'!
initializePanel
	"This code is auto-generated. DO NOT modify it because another generation step will overwrite all changes."
	
	| unnamedMorph1 unnamedMorph2 unnamedMorph3 |
	
	panel := UiContainer new.
	panel changeTableLayout.
	panel extent: (248@382).
	panel position: (0@0).
	panel hResizing: (#rigid).
	panel vResizing: (#rigid).
	panel minWidth: (2).
	panel minHeight: (2).
	panel cellInset: (2).
	panel cellPositioning: (#center).
	panel cellSpacing: (#none).
	panel layoutInset: (2).
	panel listCentering: (#topLeft).
	panel listDirection: (#topToBottom).
	panel listSpacing: (#none).
	panel maxCellSize: (1073741823).
	panel minCellSize: (0).
	panel wrapCentering: (#topLeft).
	panel wrapDirection: (#none).
	panel frameFractions: (0@0 corner: 1@1).
	panel frameOffsets: (0@0 corner: 0@0).
	panel balloonText: (nil).
	panel balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1.0 alpha: 0.922)).
	panel color: (Color transparent).
	panel borderWidth: (0).
	panel borderStyle2: (#simple).
	panel borderColor: (Color black).
	panel setProperty: #objectName toValue: 'panel'.
	unnamedMorph1 := UiContainer new.
	unnamedMorph1 changeTableLayout.
	unnamedMorph1 extent: (244@22).
	unnamedMorph1 position: (2@2).
	unnamedMorph1 hResizing: (#spaceFill).
	unnamedMorph1 vResizing: (#shrinkWrap).
	unnamedMorph1 minWidth: (2).
	unnamedMorph1 minHeight: (2).
	unnamedMorph1 cellInset: (0).
	unnamedMorph1 cellPositioning: (#center).
	unnamedMorph1 cellSpacing: (#none).
	unnamedMorph1 layoutInset: (0).
	unnamedMorph1 listCentering: (#topLeft).
	unnamedMorph1 listDirection: (#leftToRight).
	unnamedMorph1 listSpacing: (#none).
	unnamedMorph1 maxCellSize: (1073741823).
	unnamedMorph1 minCellSize: (0).
	unnamedMorph1 wrapCentering: (#topLeft).
	unnamedMorph1 wrapDirection: (#none).
	unnamedMorph1 frameFractions: (0@0 corner: 1@1).
	unnamedMorph1 frameOffsets: (0@0 corner: 0@0).
	unnamedMorph1 balloonText: (nil).
	unnamedMorph1 balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1.0 alpha: 0.922)).
	unnamedMorph1 color: (Color transparent).
	unnamedMorph1 borderWidth: (0).
	unnamedMorph1 borderStyle2: (#simple).
	unnamedMorph1 borderColor: (Color black).
	hideBtn := UiToolButton new.
	hideBtn changeTableLayout.
	hideBtn extent: (18@18).
	hideBtn position: (3@4).
	hideBtn hResizing: (#shrinkWrap).
	hideBtn vResizing: (#shrinkWrap).
	hideBtn minWidth: (2).
	hideBtn minHeight: (2).
	hideBtn cellInset: (4).
	hideBtn cellPositioning: (#center).
	hideBtn cellSpacing: (#none).
	hideBtn layoutInset: (0).
	hideBtn listCentering: (#topLeft).
	hideBtn listDirection: (#leftToRight).
	hideBtn listSpacing: (#none).
	hideBtn maxCellSize: (1073741823).
	hideBtn minCellSize: (0).
	hideBtn wrapCentering: (#topLeft).
	hideBtn wrapDirection: (#none).
	hideBtn frameFractions: (0@0 corner: 1@1).
	hideBtn frameOffsets: (0@0 corner: 0@0).
	hideBtn balloonText: (nil).
	hideBtn balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1.0 alpha: 0.925)).
	hideBtn enabled: (true).
	hideBtn setProperty: #iconByDesigner toValue: 'UiSilkIcons eyeIcon'.
	hideBtn icon: (UiSilkIcons eyeIcon).
	hideBtn text: ('ToolButton').
	hideBtn color: ((Color r: 0.85 g: 0.85 b: 0.85)).
	hideBtn checkable: (true).
	hideBtn checked: (true).
	hideBtn autoExclusive: (false).
	hideBtn autoRaise: (true).
	hideBtn buttonStyle: (#iconOnly).
	hideBtn setProperty: #objectName toValue: 'hideBtn'.
	unnamedMorph1 addMorphBack: hideBtn.
	unnamedMorph2 := UiSpacer new.
	unnamedMorph2 extent: (72@10).
	unnamedMorph2 position: (22@8).
	unnamedMorph2 hResizing: (#spaceFill).
	unnamedMorph2 vResizing: (#rigid).
	unnamedMorph2 minWidth: (2).
	unnamedMorph2 minHeight: (2).
	unnamedMorph2 cellInset: (0).
	unnamedMorph2 cellPositioning: (#center).
	unnamedMorph2 cellSpacing: (#none).
	unnamedMorph2 layoutInset: (0).
	unnamedMorph2 listCentering: (#topLeft).
	unnamedMorph2 listDirection: (#topToBottom).
	unnamedMorph2 listSpacing: (#none).
	unnamedMorph2 maxCellSize: (1073741823).
	unnamedMorph2 minCellSize: (0).
	unnamedMorph2 wrapCentering: (#topLeft).
	unnamedMorph2 wrapDirection: (#none).
	unnamedMorph2 frameFractions: (0@0 corner: 1@1).
	unnamedMorph2 frameOffsets: (0@0 corner: 0@0).
	unnamedMorph2 balloonText: (nil).
	unnamedMorph2 balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1.0 alpha: 0.922)).
	unnamedMorph2 color: (Color blue).
	unnamedMorph2 borderWidth: (0).
	unnamedMorph2 borderStyle2: (#simple).
	unnamedMorph2 borderColor: (Color black).
	unnamedMorph2 orientation: (#horizontal).
	unnamedMorph1 addMorphBack: unnamedMorph2.
	headerBtn := SdDraggableButton new.
	headerBtn changeTableLayout.
	headerBtn extent: (57@21).
	headerBtn position: (94@2).
	headerBtn hResizing: (#shrinkWrap).
	headerBtn vResizing: (#shrinkWrap).
	headerBtn minWidth: (2).
	headerBtn minHeight: (2).
	headerBtn cellInset: (4).
	headerBtn cellPositioning: (#center).
	headerBtn cellSpacing: (#none).
	headerBtn layoutInset: (2@0 corner: 2@0).
	headerBtn listCentering: (#topLeft).
	headerBtn listDirection: (#leftToRight).
	headerBtn listSpacing: (#none).
	headerBtn maxCellSize: (1073741823).
	headerBtn minCellSize: (0).
	headerBtn wrapCentering: (#topLeft).
	headerBtn wrapDirection: (#none).
	headerBtn frameFractions: (0@0 corner: 1@1).
	headerBtn frameOffsets: (0@0 corner: 0@0).
	headerBtn balloonText: (nil).
	headerBtn balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1.0 alpha: 0.922)).
	headerBtn enabled: (true).
	headerBtn setProperty: #iconByDesigner toValue: 'nil'.
	headerBtn icon: (nil).
	headerBtn text: ('Messages').
	headerBtn color: ((Color r: 0.85 g: 0.85 b: 0.85)).
	headerBtn checkable: (false).
	headerBtn checked: (false).
	headerBtn autoExclusive: (false).
	headerBtn autoRaise: (true).
	headerBtn buttonStyle: (#textBesideIcon).
	headerBtn setProperty: #objectName toValue: 'headerBtn'.
	unnamedMorph1 addMorphBack: headerBtn.
	unnamedMorph3 := UiSpacer new.
	unnamedMorph3 extent: (73@10).
	unnamedMorph3 position: (153@8).
	unnamedMorph3 hResizing: (#spaceFill).
	unnamedMorph3 vResizing: (#rigid).
	unnamedMorph3 minWidth: (2).
	unnamedMorph3 minHeight: (2).
	unnamedMorph3 cellInset: (0).
	unnamedMorph3 cellPositioning: (#center).
	unnamedMorph3 cellSpacing: (#none).
	unnamedMorph3 layoutInset: (0).
	unnamedMorph3 listCentering: (#topLeft).
	unnamedMorph3 listDirection: (#topToBottom).
	unnamedMorph3 listSpacing: (#none).
	unnamedMorph3 maxCellSize: (1073741823).
	unnamedMorph3 minCellSize: (0).
	unnamedMorph3 wrapCentering: (#topLeft).
	unnamedMorph3 wrapDirection: (#none).
	unnamedMorph3 frameFractions: (0@0 corner: 1@1).
	unnamedMorph3 frameOffsets: (0@0 corner: 0@0).
	unnamedMorph3 balloonText: (nil).
	unnamedMorph3 balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1.0 alpha: 0.922)).
	unnamedMorph3 color: (Color blue).
	unnamedMorph3 borderWidth: (0).
	unnamedMorph3 borderStyle2: (#simple).
	unnamedMorph3 borderColor: (Color black).
	unnamedMorph3 orientation: (#horizontal).
	unnamedMorph1 addMorphBack: unnamedMorph3.
	closeBtn := UiToolButton new.
	closeBtn changeTableLayout.
	closeBtn extent: (18@18).
	closeBtn position: (227@4).
	closeBtn hResizing: (#shrinkWrap).
	closeBtn vResizing: (#shrinkWrap).
	closeBtn minWidth: (2).
	closeBtn minHeight: (2).
	closeBtn cellInset: (4).
	closeBtn cellPositioning: (#center).
	closeBtn cellSpacing: (#none).
	closeBtn layoutInset: (0).
	closeBtn listCentering: (#topLeft).
	closeBtn listDirection: (#leftToRight).
	closeBtn listSpacing: (#none).
	closeBtn maxCellSize: (1073741823).
	closeBtn minCellSize: (0).
	closeBtn wrapCentering: (#topLeft).
	closeBtn wrapDirection: (#none).
	closeBtn frameFractions: (0@0 corner: 1@1).
	closeBtn frameOffsets: (0@0 corner: 0@0).
	closeBtn balloonText: (nil).
	closeBtn balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1.0 alpha: 0.922)).
	closeBtn enabled: (true).
	closeBtn setProperty: #iconByDesigner toValue: 'UiFugueIcons minusWhiteIcon'.
	closeBtn icon: (UiFugueIcons minusWhiteIcon).
	closeBtn text: ('Call Graph').
	closeBtn color: ((Color r: 0.85 g: 0.85 b: 0.85)).
	closeBtn checkable: (false).
	closeBtn checked: (false).
	closeBtn autoExclusive: (false).
	closeBtn autoRaise: (true).
	closeBtn buttonStyle: (#iconOnly).
	closeBtn setProperty: #objectName toValue: 'closeBtn'.
	unnamedMorph1 addMorphBack: closeBtn.
	panel addMorphBack: unnamedMorph1.
	list := UiListView new.
	list extent: (244@353).
	list position: (2@27).
	list hResizing: (#spaceFill).
	list vResizing: (#spaceFill).
	list minWidth: (2).
	list minHeight: (2).
	list cellInset: (0).
	list cellPositioning: (#center).
	list cellSpacing: (#none).
	list layoutInset: (0).
	list listCentering: (#topLeft).
	list listDirection: (#topToBottom).
	list listSpacing: (#none).
	list maxCellSize: (1073741823).
	list minCellSize: (0).
	list wrapCentering: (#topLeft).
	list wrapDirection: (#none).
	list frameFractions: (0@0 corner: 1@1).
	list frameOffsets: (0@0 corner: 0@0).
	list balloonText: (nil).
	list balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1.0 alpha: 0.945)).
	list widgetResizable: (false).
	list horizontalScrollBarPolicy: (#alwaysOff).
	list verticalScrollBarPolicy: (#asNeeded).
	list outerBorderWidth: (0).
	list scrollBarThickness: (9).
	list modelClass: (nil).
	list horizontalHeaderVisible: (false).
	list verticalHeaderVisible: (false).
	list selectionBehavior: (#selectRows).
	list selectionColor: ((Color r: 0.772 g: 0.858 b: 1.0)).
	list selectionMode: (UiViewSingleSelection).
	list setProperty: #objectName toValue: 'list'.
	panel addMorphBack: list.
	panel setProperty: #uiClassName toValue: 'SdSystemBrowserMessages'.! !

!SdSystemBrowserMessagesUi methodsFor: 'accessing' stamp: 'mt 6/20/2012 14:13:40.6'!
list
	"No description given."
	
	^ list! !

UserInterface subclass: #SdSystemBrowserProtocolsUi
	instanceVariableNames: 'hideBtn headerBtn closeBtn list'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sight-Dynamic-UI-Designs'!

!SdSystemBrowserProtocolsUi methodsFor: 'accessing' stamp: 'mt 6/20/2012 14:13:26.648'!
closeBtn
	"No description given."
	
	^ closeBtn! !

!SdSystemBrowserProtocolsUi methodsFor: 'accessing' stamp: 'mt 6/20/2012 14:13:26.63'!
headerBtn
	"No description given."
	
	^ headerBtn! !

!SdSystemBrowserProtocolsUi methodsFor: 'accessing' stamp: 'mt 6/20/2012 14:13:26.611'!
hideBtn
	"No description given."
	
	^ hideBtn! !

!SdSystemBrowserProtocolsUi methodsFor: 'ui - private' stamp: 'mt 6/20/2012 14:13:26.7'!
initializePanel
	"This code is auto-generated. DO NOT modify it because another generation step will overwrite all changes."
	
	| unnamedMorph1 unnamedMorph2 unnamedMorph3 |
	
	panel := UiContainer new.
	panel changeTableLayout.
	panel extent: (248@382).
	panel position: (0@0).
	panel hResizing: (#rigid).
	panel vResizing: (#rigid).
	panel minWidth: (2).
	panel minHeight: (2).
	panel cellInset: (2).
	panel cellPositioning: (#center).
	panel cellSpacing: (#none).
	panel layoutInset: (2).
	panel listCentering: (#topLeft).
	panel listDirection: (#topToBottom).
	panel listSpacing: (#none).
	panel maxCellSize: (1073741823).
	panel minCellSize: (0).
	panel wrapCentering: (#topLeft).
	panel wrapDirection: (#none).
	panel frameFractions: (0@0 corner: 1@1).
	panel frameOffsets: (0@0 corner: 0@0).
	panel balloonText: (nil).
	panel balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1.0 alpha: 0.922)).
	panel color: (Color transparent).
	panel borderWidth: (0).
	panel borderStyle2: (#simple).
	panel borderColor: (Color black).
	panel setProperty: #objectName toValue: 'panel'.
	unnamedMorph1 := UiContainer new.
	unnamedMorph1 changeTableLayout.
	unnamedMorph1 extent: (244@22).
	unnamedMorph1 position: (2@2).
	unnamedMorph1 hResizing: (#spaceFill).
	unnamedMorph1 vResizing: (#shrinkWrap).
	unnamedMorph1 minWidth: (2).
	unnamedMorph1 minHeight: (2).
	unnamedMorph1 cellInset: (0).
	unnamedMorph1 cellPositioning: (#center).
	unnamedMorph1 cellSpacing: (#none).
	unnamedMorph1 layoutInset: (0).
	unnamedMorph1 listCentering: (#topLeft).
	unnamedMorph1 listDirection: (#leftToRight).
	unnamedMorph1 listSpacing: (#none).
	unnamedMorph1 maxCellSize: (1073741823).
	unnamedMorph1 minCellSize: (0).
	unnamedMorph1 wrapCentering: (#topLeft).
	unnamedMorph1 wrapDirection: (#none).
	unnamedMorph1 frameFractions: (0@0 corner: 1@1).
	unnamedMorph1 frameOffsets: (0@0 corner: 0@0).
	unnamedMorph1 balloonText: (nil).
	unnamedMorph1 balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1.0 alpha: 0.922)).
	unnamedMorph1 color: (Color transparent).
	unnamedMorph1 borderWidth: (0).
	unnamedMorph1 borderStyle2: (#simple).
	unnamedMorph1 borderColor: (Color black).
	hideBtn := UiToolButton new.
	hideBtn changeTableLayout.
	hideBtn extent: (18@18).
	hideBtn position: (3@4).
	hideBtn hResizing: (#shrinkWrap).
	hideBtn vResizing: (#shrinkWrap).
	hideBtn minWidth: (2).
	hideBtn minHeight: (2).
	hideBtn cellInset: (4).
	hideBtn cellPositioning: (#center).
	hideBtn cellSpacing: (#none).
	hideBtn layoutInset: (0).
	hideBtn listCentering: (#topLeft).
	hideBtn listDirection: (#leftToRight).
	hideBtn listSpacing: (#none).
	hideBtn maxCellSize: (1073741823).
	hideBtn minCellSize: (0).
	hideBtn wrapCentering: (#topLeft).
	hideBtn wrapDirection: (#none).
	hideBtn frameFractions: (0@0 corner: 1@1).
	hideBtn frameOffsets: (0@0 corner: 0@0).
	hideBtn balloonText: (nil).
	hideBtn balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1.0 alpha: 0.925)).
	hideBtn enabled: (true).
	hideBtn setProperty: #iconByDesigner toValue: 'UiSilkIcons eyeIcon'.
	hideBtn icon: (UiSilkIcons eyeIcon).
	hideBtn text: ('ToolButton').
	hideBtn color: ((Color r: 0.85 g: 0.85 b: 0.85)).
	hideBtn checkable: (true).
	hideBtn checked: (true).
	hideBtn autoExclusive: (false).
	hideBtn autoRaise: (true).
	hideBtn buttonStyle: (#iconOnly).
	hideBtn setProperty: #objectName toValue: 'hideBtn'.
	unnamedMorph1 addMorphBack: hideBtn.
	unnamedMorph2 := UiSpacer new.
	unnamedMorph2 extent: (73@10).
	unnamedMorph2 position: (22@8).
	unnamedMorph2 hResizing: (#spaceFill).
	unnamedMorph2 vResizing: (#rigid).
	unnamedMorph2 minWidth: (2).
	unnamedMorph2 minHeight: (2).
	unnamedMorph2 cellInset: (0).
	unnamedMorph2 cellPositioning: (#center).
	unnamedMorph2 cellSpacing: (#none).
	unnamedMorph2 layoutInset: (0).
	unnamedMorph2 listCentering: (#topLeft).
	unnamedMorph2 listDirection: (#topToBottom).
	unnamedMorph2 listSpacing: (#none).
	unnamedMorph2 maxCellSize: (1073741823).
	unnamedMorph2 minCellSize: (0).
	unnamedMorph2 wrapCentering: (#topLeft).
	unnamedMorph2 wrapDirection: (#none).
	unnamedMorph2 frameFractions: (0@0 corner: 1@1).
	unnamedMorph2 frameOffsets: (0@0 corner: 0@0).
	unnamedMorph2 balloonText: (nil).
	unnamedMorph2 balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1.0 alpha: 0.922)).
	unnamedMorph2 color: (Color blue).
	unnamedMorph2 borderWidth: (0).
	unnamedMorph2 borderStyle2: (#simple).
	unnamedMorph2 borderColor: (Color black).
	unnamedMorph2 orientation: (#horizontal).
	unnamedMorph1 addMorphBack: unnamedMorph2.
	headerBtn := SdDraggableButton new.
	headerBtn changeTableLayout.
	headerBtn extent: (56@21).
	headerBtn position: (95@2).
	headerBtn hResizing: (#shrinkWrap).
	headerBtn vResizing: (#shrinkWrap).
	headerBtn minWidth: (2).
	headerBtn minHeight: (2).
	headerBtn cellInset: (4).
	headerBtn cellPositioning: (#center).
	headerBtn cellSpacing: (#none).
	headerBtn layoutInset: (2@0 corner: 2@0).
	headerBtn listCentering: (#topLeft).
	headerBtn listDirection: (#leftToRight).
	headerBtn listSpacing: (#none).
	headerBtn maxCellSize: (1073741823).
	headerBtn minCellSize: (0).
	headerBtn wrapCentering: (#topLeft).
	headerBtn wrapDirection: (#none).
	headerBtn frameFractions: (0@0 corner: 1@1).
	headerBtn frameOffsets: (0@0 corner: 0@0).
	headerBtn balloonText: (nil).
	headerBtn balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1.0 alpha: 0.922)).
	headerBtn enabled: (true).
	headerBtn setProperty: #iconByDesigner toValue: 'nil'.
	headerBtn icon: (nil).
	headerBtn text: ('Protocols').
	headerBtn color: ((Color r: 0.85 g: 0.85 b: 0.85)).
	headerBtn checkable: (false).
	headerBtn checked: (false).
	headerBtn autoExclusive: (false).
	headerBtn autoRaise: (true).
	headerBtn buttonStyle: (#textBesideIcon).
	headerBtn setProperty: #objectName toValue: 'headerBtn'.
	unnamedMorph1 addMorphBack: headerBtn.
	unnamedMorph3 := UiSpacer new.
	unnamedMorph3 extent: (73@10).
	unnamedMorph3 position: (153@8).
	unnamedMorph3 hResizing: (#spaceFill).
	unnamedMorph3 vResizing: (#rigid).
	unnamedMorph3 minWidth: (2).
	unnamedMorph3 minHeight: (2).
	unnamedMorph3 cellInset: (0).
	unnamedMorph3 cellPositioning: (#center).
	unnamedMorph3 cellSpacing: (#none).
	unnamedMorph3 layoutInset: (0).
	unnamedMorph3 listCentering: (#topLeft).
	unnamedMorph3 listDirection: (#topToBottom).
	unnamedMorph3 listSpacing: (#none).
	unnamedMorph3 maxCellSize: (1073741823).
	unnamedMorph3 minCellSize: (0).
	unnamedMorph3 wrapCentering: (#topLeft).
	unnamedMorph3 wrapDirection: (#none).
	unnamedMorph3 frameFractions: (0@0 corner: 1@1).
	unnamedMorph3 frameOffsets: (0@0 corner: 0@0).
	unnamedMorph3 balloonText: (nil).
	unnamedMorph3 balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1.0 alpha: 0.922)).
	unnamedMorph3 color: (Color blue).
	unnamedMorph3 borderWidth: (0).
	unnamedMorph3 borderStyle2: (#simple).
	unnamedMorph3 borderColor: (Color black).
	unnamedMorph3 orientation: (#horizontal).
	unnamedMorph1 addMorphBack: unnamedMorph3.
	closeBtn := UiToolButton new.
	closeBtn changeTableLayout.
	closeBtn extent: (18@18).
	closeBtn position: (227@4).
	closeBtn hResizing: (#shrinkWrap).
	closeBtn vResizing: (#shrinkWrap).
	closeBtn minWidth: (2).
	closeBtn minHeight: (2).
	closeBtn cellInset: (4).
	closeBtn cellPositioning: (#center).
	closeBtn cellSpacing: (#none).
	closeBtn layoutInset: (0).
	closeBtn listCentering: (#topLeft).
	closeBtn listDirection: (#leftToRight).
	closeBtn listSpacing: (#none).
	closeBtn maxCellSize: (1073741823).
	closeBtn minCellSize: (0).
	closeBtn wrapCentering: (#topLeft).
	closeBtn wrapDirection: (#none).
	closeBtn frameFractions: (0@0 corner: 1@1).
	closeBtn frameOffsets: (0@0 corner: 0@0).
	closeBtn balloonText: (nil).
	closeBtn balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1.0 alpha: 0.922)).
	closeBtn enabled: (true).
	closeBtn setProperty: #iconByDesigner toValue: 'UiFugueIcons minusWhiteIcon'.
	closeBtn icon: (UiFugueIcons minusWhiteIcon).
	closeBtn text: ('Call Graph').
	closeBtn color: ((Color r: 0.85 g: 0.85 b: 0.85)).
	closeBtn checkable: (false).
	closeBtn checked: (false).
	closeBtn autoExclusive: (false).
	closeBtn autoRaise: (true).
	closeBtn buttonStyle: (#iconOnly).
	closeBtn setProperty: #objectName toValue: 'closeBtn'.
	unnamedMorph1 addMorphBack: closeBtn.
	panel addMorphBack: unnamedMorph1.
	list := UiListView new.
	list extent: (244@353).
	list position: (2@27).
	list hResizing: (#spaceFill).
	list vResizing: (#spaceFill).
	list minWidth: (2).
	list minHeight: (2).
	list cellInset: (0).
	list cellPositioning: (#center).
	list cellSpacing: (#none).
	list layoutInset: (0).
	list listCentering: (#topLeft).
	list listDirection: (#topToBottom).
	list listSpacing: (#none).
	list maxCellSize: (1073741823).
	list minCellSize: (0).
	list wrapCentering: (#topLeft).
	list wrapDirection: (#none).
	list frameFractions: (0@0 corner: 1@1).
	list frameOffsets: (0@0 corner: 0@0).
	list balloonText: (nil).
	list balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1.0 alpha: 0.945)).
	list widgetResizable: (false).
	list horizontalScrollBarPolicy: (#alwaysOff).
	list verticalScrollBarPolicy: (#asNeeded).
	list outerBorderWidth: (0).
	list scrollBarThickness: (9).
	list modelClass: (nil).
	list horizontalHeaderVisible: (false).
	list verticalHeaderVisible: (false).
	list selectionBehavior: (#selectRows).
	list selectionColor: ((Color r: 0.772 g: 0.858 b: 1.0)).
	list selectionMode: (UiViewSingleSelection).
	list setProperty: #objectName toValue: 'list'.
	panel addMorphBack: list.
	panel setProperty: #uiClassName toValue: 'SdSystemBrowserProtocols'.! !

!SdSystemBrowserProtocolsUi methodsFor: 'accessing' stamp: 'mt 6/20/2012 14:13:26.665'!
list
	"No description given."
	
	^ list! !

UserInterface subclass: #SdTranscriptEditorUi
	instanceVariableNames: 'hideBtn headerBtn closeBtn transcriptEdit transcriptToolbar timestampBtn redrawBtn clearTranscriptBtn'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sight-Dynamic-UI-Designs'!

!SdTranscriptEditorUi methodsFor: 'accessing' stamp: 'mt 6/20/2012 14:05:55.093'!
clearTranscriptBtn
	"No description given."
	
	^ clearTranscriptBtn! !

!SdTranscriptEditorUi methodsFor: 'accessing' stamp: 'mt 6/20/2012 14:05:55.002'!
closeBtn
	"No description given."
	
	^ closeBtn! !

!SdTranscriptEditorUi methodsFor: 'accessing' stamp: 'mt 6/20/2012 14:05:54.984'!
headerBtn
	"No description given."
	
	^ headerBtn! !

!SdTranscriptEditorUi methodsFor: 'accessing' stamp: 'mt 6/20/2012 14:05:54.964'!
hideBtn
	"No description given."
	
	^ hideBtn! !

!SdTranscriptEditorUi methodsFor: 'ui - private' stamp: 'mt 6/20/2012 14:05:55.136'!
initializePanel
	"This code is auto-generated. DO NOT modify it because another generation step will overwrite all changes."
	
	| unnamedMorph1 unnamedMorph2 unnamedMorph3 unnamedMorph4 |
	
	panel := UiContainer new.
	panel changeTableLayout.
	panel extent: (252@487).
	panel position: (0@0).
	panel hResizing: (#rigid).
	panel vResizing: (#rigid).
	panel minWidth: (2).
	panel minHeight: (2).
	panel cellInset: (1).
	panel cellPositioning: (#center).
	panel cellSpacing: (#none).
	panel layoutInset: (2).
	panel listCentering: (#topLeft).
	panel listDirection: (#topToBottom).
	panel listSpacing: (#none).
	panel maxCellSize: (1073741823).
	panel minCellSize: (0).
	panel wrapCentering: (#topLeft).
	panel wrapDirection: (#none).
	panel frameFractions: (0@0 corner: 1@1).
	panel frameOffsets: (0@0 corner: 0@0).
	panel balloonText: (nil).
	panel balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1.0 alpha: 0.922)).
	panel color: (Color transparent).
	panel borderWidth: (0).
	panel borderStyle2: (#simple).
	panel borderColor: (Color black).
	panel setProperty: #objectName toValue: 'panel'.
	unnamedMorph1 := UiContainer new.
	unnamedMorph1 changeTableLayout.
	unnamedMorph1 extent: (248@22).
	unnamedMorph1 position: (2@2).
	unnamedMorph1 hResizing: (#spaceFill).
	unnamedMorph1 vResizing: (#shrinkWrap).
	unnamedMorph1 minWidth: (2).
	unnamedMorph1 minHeight: (2).
	unnamedMorph1 cellInset: (0).
	unnamedMorph1 cellPositioning: (#center).
	unnamedMorph1 cellSpacing: (#none).
	unnamedMorph1 layoutInset: (0).
	unnamedMorph1 listCentering: (#topLeft).
	unnamedMorph1 listDirection: (#leftToRight).
	unnamedMorph1 listSpacing: (#none).
	unnamedMorph1 maxCellSize: (1073741823).
	unnamedMorph1 minCellSize: (0).
	unnamedMorph1 wrapCentering: (#topLeft).
	unnamedMorph1 wrapDirection: (#none).
	unnamedMorph1 frameFractions: (0@0 corner: 1@1).
	unnamedMorph1 frameOffsets: (0@0 corner: 0@0).
	unnamedMorph1 balloonText: (nil).
	unnamedMorph1 balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1.0 alpha: 0.922)).
	unnamedMorph1 color: (Color transparent).
	unnamedMorph1 borderWidth: (0).
	unnamedMorph1 borderStyle2: (#simple).
	unnamedMorph1 borderColor: (Color black).
	hideBtn := UiToolButton new.
	hideBtn changeTableLayout.
	hideBtn extent: (18@18).
	hideBtn position: (3@4).
	hideBtn hResizing: (#shrinkWrap).
	hideBtn vResizing: (#shrinkWrap).
	hideBtn minWidth: (2).
	hideBtn minHeight: (2).
	hideBtn cellInset: (4).
	hideBtn cellPositioning: (#center).
	hideBtn cellSpacing: (#none).
	hideBtn layoutInset: (0).
	hideBtn listCentering: (#topLeft).
	hideBtn listDirection: (#leftToRight).
	hideBtn listSpacing: (#none).
	hideBtn maxCellSize: (1073741823).
	hideBtn minCellSize: (0).
	hideBtn wrapCentering: (#topLeft).
	hideBtn wrapDirection: (#none).
	hideBtn frameFractions: (0@0 corner: 1@1).
	hideBtn frameOffsets: (0@0 corner: 0@0).
	hideBtn balloonText: (nil).
	hideBtn balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1.0 alpha: 0.945)).
	hideBtn enabled: (true).
	hideBtn setProperty: #iconByDesigner toValue: 'UiSilkIcons eyeIcon'.
	hideBtn icon: (UiSilkIcons eyeIcon).
	hideBtn text: ('ToolButton').
	hideBtn color: ((Color r: 0.85 g: 0.85 b: 0.85)).
	hideBtn checkable: (true).
	hideBtn checked: (true).
	hideBtn autoExclusive: (false).
	hideBtn autoRaise: (true).
	hideBtn buttonStyle: (#iconOnly).
	hideBtn setProperty: #objectName toValue: 'hideBtn'.
	unnamedMorph1 addMorphBack: hideBtn.
	unnamedMorph2 := UiSpacer new.
	unnamedMorph2 extent: (73@10).
	unnamedMorph2 position: (22@8).
	unnamedMorph2 hResizing: (#spaceFill).
	unnamedMorph2 vResizing: (#rigid).
	unnamedMorph2 minWidth: (2).
	unnamedMorph2 minHeight: (2).
	unnamedMorph2 cellInset: (0).
	unnamedMorph2 cellPositioning: (#center).
	unnamedMorph2 cellSpacing: (#none).
	unnamedMorph2 layoutInset: (0).
	unnamedMorph2 listCentering: (#topLeft).
	unnamedMorph2 listDirection: (#topToBottom).
	unnamedMorph2 listSpacing: (#none).
	unnamedMorph2 maxCellSize: (1073741823).
	unnamedMorph2 minCellSize: (0).
	unnamedMorph2 wrapCentering: (#topLeft).
	unnamedMorph2 wrapDirection: (#none).
	unnamedMorph2 frameFractions: (0@0 corner: 1@1).
	unnamedMorph2 frameOffsets: (0@0 corner: 0@0).
	unnamedMorph2 balloonText: (nil).
	unnamedMorph2 balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1.0 alpha: 0.922)).
	unnamedMorph2 color: (Color blue).
	unnamedMorph2 borderWidth: (0).
	unnamedMorph2 borderStyle2: (#simple).
	unnamedMorph2 borderColor: (Color black).
	unnamedMorph2 orientation: (#horizontal).
	unnamedMorph1 addMorphBack: unnamedMorph2.
	headerBtn := SdDraggableButton new.
	headerBtn changeTableLayout.
	headerBtn extent: (59@21).
	headerBtn position: (95@2).
	headerBtn hResizing: (#shrinkWrap).
	headerBtn vResizing: (#shrinkWrap).
	headerBtn minWidth: (2).
	headerBtn minHeight: (2).
	headerBtn cellInset: (4).
	headerBtn cellPositioning: (#center).
	headerBtn cellSpacing: (#none).
	headerBtn layoutInset: (2@0 corner: 2@0).
	headerBtn listCentering: (#topLeft).
	headerBtn listDirection: (#leftToRight).
	headerBtn listSpacing: (#none).
	headerBtn maxCellSize: (1073741823).
	headerBtn minCellSize: (0).
	headerBtn wrapCentering: (#topLeft).
	headerBtn wrapDirection: (#none).
	headerBtn frameFractions: (0@0 corner: 1@1).
	headerBtn frameOffsets: (0@0 corner: 0@0).
	headerBtn balloonText: (nil).
	headerBtn balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1.0 alpha: 0.922)).
	headerBtn enabled: (true).
	headerBtn setProperty: #iconByDesigner toValue: 'nil'.
	headerBtn icon: (nil).
	headerBtn text: ('Transcript').
	headerBtn color: ((Color r: 0.85 g: 0.85 b: 0.85)).
	headerBtn checkable: (false).
	headerBtn checked: (false).
	headerBtn autoExclusive: (false).
	headerBtn autoRaise: (true).
	headerBtn buttonStyle: (#textBesideIcon).
	headerBtn setProperty: #objectName toValue: 'headerBtn'.
	unnamedMorph1 addMorphBack: headerBtn.
	unnamedMorph3 := UiSpacer new.
	unnamedMorph3 extent: (74@10).
	unnamedMorph3 position: (156@8).
	unnamedMorph3 hResizing: (#spaceFill).
	unnamedMorph3 vResizing: (#rigid).
	unnamedMorph3 minWidth: (2).
	unnamedMorph3 minHeight: (2).
	unnamedMorph3 cellInset: (0).
	unnamedMorph3 cellPositioning: (#center).
	unnamedMorph3 cellSpacing: (#none).
	unnamedMorph3 layoutInset: (0).
	unnamedMorph3 listCentering: (#topLeft).
	unnamedMorph3 listDirection: (#topToBottom).
	unnamedMorph3 listSpacing: (#none).
	unnamedMorph3 maxCellSize: (1073741823).
	unnamedMorph3 minCellSize: (0).
	unnamedMorph3 wrapCentering: (#topLeft).
	unnamedMorph3 wrapDirection: (#none).
	unnamedMorph3 frameFractions: (0@0 corner: 1@1).
	unnamedMorph3 frameOffsets: (0@0 corner: 0@0).
	unnamedMorph3 balloonText: (nil).
	unnamedMorph3 balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1.0 alpha: 0.922)).
	unnamedMorph3 color: (Color blue).
	unnamedMorph3 borderWidth: (0).
	unnamedMorph3 borderStyle2: (#simple).
	unnamedMorph3 borderColor: (Color black).
	unnamedMorph3 orientation: (#horizontal).
	unnamedMorph1 addMorphBack: unnamedMorph3.
	closeBtn := UiToolButton new.
	closeBtn changeTableLayout.
	closeBtn extent: (18@18).
	closeBtn position: (231@4).
	closeBtn hResizing: (#shrinkWrap).
	closeBtn vResizing: (#shrinkWrap).
	closeBtn minWidth: (2).
	closeBtn minHeight: (2).
	closeBtn cellInset: (4).
	closeBtn cellPositioning: (#center).
	closeBtn cellSpacing: (#none).
	closeBtn layoutInset: (0).
	closeBtn listCentering: (#topLeft).
	closeBtn listDirection: (#leftToRight).
	closeBtn listSpacing: (#none).
	closeBtn maxCellSize: (1073741823).
	closeBtn minCellSize: (0).
	closeBtn wrapCentering: (#topLeft).
	closeBtn wrapDirection: (#none).
	closeBtn frameFractions: (0@0 corner: 1@1).
	closeBtn frameOffsets: (0@0 corner: 0@0).
	closeBtn balloonText: (nil).
	closeBtn balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1.0 alpha: 0.922)).
	closeBtn enabled: (true).
	closeBtn setProperty: #iconByDesigner toValue: 'UiFugueIcons minusWhiteIcon'.
	closeBtn icon: (UiFugueIcons minusWhiteIcon).
	closeBtn text: ('ToolButton').
	closeBtn color: ((Color r: 0.85 g: 0.85 b: 0.85)).
	closeBtn checkable: (false).
	closeBtn checked: (false).
	closeBtn autoExclusive: (false).
	closeBtn autoRaise: (true).
	closeBtn buttonStyle: (#iconOnly).
	closeBtn setProperty: #objectName toValue: 'closeBtn'.
	unnamedMorph1 addMorphBack: closeBtn.
	panel addMorphBack: unnamedMorph1.
	transcriptEdit := UiTextEdit new.
	transcriptEdit extent: (248@438).
	transcriptEdit position: (2@26).
	transcriptEdit hResizing: (#spaceFill).
	transcriptEdit vResizing: (#spaceFill).
	transcriptEdit minWidth: (2).
	transcriptEdit minHeight: (2).
	transcriptEdit cellInset: (0).
	transcriptEdit cellPositioning: (#center).
	transcriptEdit cellSpacing: (#none).
	transcriptEdit layoutInset: (0).
	transcriptEdit listCentering: (#topLeft).
	transcriptEdit listDirection: (#topToBottom).
	transcriptEdit listSpacing: (#none).
	transcriptEdit maxCellSize: (1073741823).
	transcriptEdit minCellSize: (0).
	transcriptEdit wrapCentering: (#topLeft).
	transcriptEdit wrapDirection: (#none).
	transcriptEdit frameFractions: (0@0 corner: 1@1).
	transcriptEdit frameOffsets: (0@0 corner: 0@0).
	transcriptEdit balloonText: ('Transcript').
	transcriptEdit balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1.0 alpha: 0.922)).
	transcriptEdit widgetResizable: (true).
	transcriptEdit horizontalScrollBarPolicy: (#alwaysOff).
	transcriptEdit verticalScrollBarPolicy: (#alwaysOn).
	transcriptEdit outerBorderWidth: (1).
	transcriptEdit scrollBarThickness: (9).
	transcriptEdit theText: ('').
	transcriptEdit readOnly: (false).
	transcriptEdit autoConvert: (false).
	transcriptEdit autoAccept: (true).
	transcriptEdit acceptOnFocusLost: (false).
	transcriptEdit scrollingMode: (#none).
	transcriptEdit scrollingLimit: (10).
	transcriptEdit setProperty: #objectName toValue: 'transcriptEdit'.
	panel addMorphBack: transcriptEdit.
	transcriptToolbar := UiContainer new.
	transcriptToolbar changeTableLayout.
	transcriptToolbar extent: (248@19).
	transcriptToolbar position: (2@466).
	transcriptToolbar hResizing: (#spaceFill).
	transcriptToolbar vResizing: (#shrinkWrap).
	transcriptToolbar minWidth: (2).
	transcriptToolbar minHeight: (2).
	transcriptToolbar cellInset: (4).
	transcriptToolbar cellPositioning: (#center).
	transcriptToolbar cellSpacing: (#none).
	transcriptToolbar layoutInset: (0).
	transcriptToolbar listCentering: (#topLeft).
	transcriptToolbar listDirection: (#leftToRight).
	transcriptToolbar listSpacing: (#none).
	transcriptToolbar maxCellSize: (1073741823).
	transcriptToolbar minCellSize: (0).
	transcriptToolbar wrapCentering: (#topLeft).
	transcriptToolbar wrapDirection: (#none).
	transcriptToolbar frameFractions: (0@0 corner: 1@1).
	transcriptToolbar frameOffsets: (0@0 corner: 0@0).
	transcriptToolbar balloonText: (nil).
	transcriptToolbar balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1.0 alpha: 0.922)).
	transcriptToolbar color: (Color transparent).
	transcriptToolbar borderWidth: (0).
	transcriptToolbar borderStyle2: (#simple).
	transcriptToolbar borderColor: (Color black).
	transcriptToolbar setProperty: #objectName toValue: 'transcriptToolbar'.
	timestampBtn := UiToolButton new.
	timestampBtn changeTableLayout.
	timestampBtn extent: (22@18).
	timestampBtn position: (2@466).
	timestampBtn hResizing: (#shrinkWrap).
	timestampBtn vResizing: (#shrinkWrap).
	timestampBtn minWidth: (2).
	timestampBtn minHeight: (2).
	timestampBtn cellInset: (4).
	timestampBtn cellPositioning: (#center).
	timestampBtn cellSpacing: (#none).
	timestampBtn layoutInset: (2@0 corner: 2@0).
	timestampBtn listCentering: (#topLeft).
	timestampBtn listDirection: (#leftToRight).
	timestampBtn listSpacing: (#none).
	timestampBtn maxCellSize: (1073741823).
	timestampBtn minCellSize: (0).
	timestampBtn wrapCentering: (#topLeft).
	timestampBtn wrapDirection: (#none).
	timestampBtn frameFractions: (0@0 corner: 1@1).
	timestampBtn frameOffsets: (0@0 corner: 0@0).
	timestampBtn balloonText: ('Show timestamp on
linebreaks.').
	timestampBtn balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1.0 alpha: 0.922)).
	timestampBtn enabled: (true).
	timestampBtn setProperty: #iconByDesigner toValue: 'UiFugueIcons clockFrameIcon'.
	timestampBtn icon: (UiFugueIcons clockFrameIcon).
	timestampBtn text: ('ToolButton').
	timestampBtn color: ((Color r: 0.85 g: 0.85 b: 0.85)).
	timestampBtn checkable: (true).
	timestampBtn checked: (true).
	timestampBtn autoExclusive: (false).
	timestampBtn autoRaise: (true).
	timestampBtn buttonStyle: (#iconOnly).
	timestampBtn setProperty: #objectName toValue: 'timestampBtn'.
	transcriptToolbar addMorphBack: timestampBtn.
	redrawBtn := UiToolButton new.
	redrawBtn changeTableLayout.
	redrawBtn extent: (22@18).
	redrawBtn position: (30@466).
	redrawBtn hResizing: (#shrinkWrap).
	redrawBtn vResizing: (#shrinkWrap).
	redrawBtn minWidth: (2).
	redrawBtn minHeight: (2).
	redrawBtn cellInset: (4).
	redrawBtn cellPositioning: (#center).
	redrawBtn cellSpacing: (#none).
	redrawBtn layoutInset: (2@0 corner: 2@0).
	redrawBtn listCentering: (#topLeft).
	redrawBtn listDirection: (#leftToRight).
	redrawBtn listSpacing: (#none).
	redrawBtn maxCellSize: (1073741823).
	redrawBtn minCellSize: (0).
	redrawBtn wrapCentering: (#topLeft).
	redrawBtn wrapDirection: (#none).
	redrawBtn frameFractions: (0@0 corner: 1@1).
	redrawBtn frameOffsets: (0@0 corner: 0@0).
	redrawBtn balloonText: ('Force immediate redraw.').
	redrawBtn balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1.0 alpha: 0.922)).
	redrawBtn enabled: (true).
	redrawBtn setProperty: #iconByDesigner toValue: 'UiFugueIcons arrowCircleDouble135Icon'.
	redrawBtn icon: (UiFugueIcons arrowCircleDouble135Icon).
	redrawBtn text: ('ToolButton').
	redrawBtn color: ((Color r: 0.85 g: 0.85 b: 0.85)).
	redrawBtn checkable: (true).
	redrawBtn checked: (true).
	redrawBtn autoExclusive: (false).
	redrawBtn autoRaise: (true).
	redrawBtn buttonStyle: (#iconOnly).
	redrawBtn setProperty: #objectName toValue: 'redrawBtn'.
	transcriptToolbar addMorphBack: redrawBtn.
	unnamedMorph4 := UiSpacer new.
	unnamedMorph4 extent: (164@10).
	unnamedMorph4 position: (58@471).
	unnamedMorph4 hResizing: (#spaceFill).
	unnamedMorph4 vResizing: (#rigid).
	unnamedMorph4 minWidth: (2).
	unnamedMorph4 minHeight: (2).
	unnamedMorph4 cellInset: (0).
	unnamedMorph4 cellPositioning: (#center).
	unnamedMorph4 cellSpacing: (#none).
	unnamedMorph4 layoutInset: (0).
	unnamedMorph4 listCentering: (#topLeft).
	unnamedMorph4 listDirection: (#topToBottom).
	unnamedMorph4 listSpacing: (#none).
	unnamedMorph4 maxCellSize: (1073741823).
	unnamedMorph4 minCellSize: (0).
	unnamedMorph4 wrapCentering: (#topLeft).
	unnamedMorph4 wrapDirection: (#none).
	unnamedMorph4 frameFractions: (0@0 corner: 1@1).
	unnamedMorph4 frameOffsets: (0@0 corner: 0@0).
	unnamedMorph4 balloonText: (nil).
	unnamedMorph4 balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1.0 alpha: 0.922)).
	unnamedMorph4 color: (Color blue).
	unnamedMorph4 borderWidth: (0).
	unnamedMorph4 borderStyle2: (#simple).
	unnamedMorph4 borderColor: (Color black).
	unnamedMorph4 orientation: (#horizontal).
	transcriptToolbar addMorphBack: unnamedMorph4.
	clearTranscriptBtn := UiToolButton new.
	clearTranscriptBtn changeTableLayout.
	clearTranscriptBtn extent: (22@18).
	clearTranscriptBtn position: (226@466).
	clearTranscriptBtn hResizing: (#shrinkWrap).
	clearTranscriptBtn vResizing: (#shrinkWrap).
	clearTranscriptBtn minWidth: (2).
	clearTranscriptBtn minHeight: (2).
	clearTranscriptBtn cellInset: (4).
	clearTranscriptBtn cellPositioning: (#center).
	clearTranscriptBtn cellSpacing: (#none).
	clearTranscriptBtn layoutInset: (2@0 corner: 2@0).
	clearTranscriptBtn listCentering: (#topLeft).
	clearTranscriptBtn listDirection: (#leftToRight).
	clearTranscriptBtn listSpacing: (#none).
	clearTranscriptBtn maxCellSize: (1073741823).
	clearTranscriptBtn minCellSize: (0).
	clearTranscriptBtn wrapCentering: (#topLeft).
	clearTranscriptBtn wrapDirection: (#none).
	clearTranscriptBtn frameFractions: (0@0 corner: 1@1).
	clearTranscriptBtn frameOffsets: (0@0 corner: 0@0).
	clearTranscriptBtn balloonText: ('Clear transcript').
	clearTranscriptBtn balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1.0 alpha: 0.922)).
	clearTranscriptBtn enabled: (true).
	clearTranscriptBtn setProperty: #iconByDesigner toValue: 'UiFugueIcons broomIcon'.
	clearTranscriptBtn icon: (UiFugueIcons broomIcon).
	clearTranscriptBtn text: ('ToolButton').
	clearTranscriptBtn color: ((Color r: 0.85 g: 0.85 b: 0.85)).
	clearTranscriptBtn checkable: (false).
	clearTranscriptBtn checked: (false).
	clearTranscriptBtn autoExclusive: (false).
	clearTranscriptBtn autoRaise: (true).
	clearTranscriptBtn buttonStyle: (#iconOnly).
	clearTranscriptBtn setProperty: #objectName toValue: 'clearTranscriptBtn'.
	transcriptToolbar addMorphBack: clearTranscriptBtn.
	panel addMorphBack: transcriptToolbar.
	panel setProperty: #uiClassName toValue: 'SdTranscriptEditor'.! !

!SdTranscriptEditorUi methodsFor: 'accessing' stamp: 'mt 6/20/2012 14:05:55.075'!
redrawBtn
	"No description given."
	
	^ redrawBtn! !

!SdTranscriptEditorUi methodsFor: 'accessing' stamp: 'mt 6/20/2012 14:05:55.057'!
timestampBtn
	"No description given."
	
	^ timestampBtn! !

!SdTranscriptEditorUi methodsFor: 'accessing' stamp: 'mt 6/20/2012 14:05:55.021'!
transcriptEdit
	"No description given."
	
	^ transcriptEdit! !

!SdTranscriptEditorUi methodsFor: 'accessing' stamp: 'mt 6/20/2012 14:05:55.039'!
transcriptToolbar
	"No description given."
	
	^ transcriptToolbar! !

UserInterface subclass: #SdWorkspaceEditorUi
	instanceVariableNames: 'hideBtn headerBtn closeBtn workspaceEdit workspaceToolbar clearWorkspaceBtn'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sight-Dynamic-UI-Designs'!

!SdWorkspaceEditorUi methodsFor: 'accessing' stamp: 'mt 6/20/2012 14:06:26.384'!
clearWorkspaceBtn
	"No description given."
	
	^ clearWorkspaceBtn! !

!SdWorkspaceEditorUi methodsFor: 'accessing' stamp: 'mt 6/20/2012 14:06:26.33'!
closeBtn
	"No description given."
	
	^ closeBtn! !

!SdWorkspaceEditorUi methodsFor: 'accessing' stamp: 'mt 6/20/2012 14:06:26.312'!
headerBtn
	"No description given."
	
	^ headerBtn! !

!SdWorkspaceEditorUi methodsFor: 'accessing' stamp: 'mt 6/20/2012 14:06:26.293'!
hideBtn
	"No description given."
	
	^ hideBtn! !

!SdWorkspaceEditorUi methodsFor: 'ui - private' stamp: 'mt 6/20/2012 14:06:26.422'!
initializePanel
	"This code is auto-generated. DO NOT modify it because another generation step will overwrite all changes."
	
	| unnamedMorph1 unnamedMorph2 unnamedMorph3 unnamedMorph4 |
	
	panel := UiContainer new.
	panel changeTableLayout.
	panel extent: (252@487).
	panel position: (0@0).
	panel hResizing: (#rigid).
	panel vResizing: (#rigid).
	panel minWidth: (2).
	panel minHeight: (2).
	panel cellInset: (1).
	panel cellPositioning: (#center).
	panel cellSpacing: (#none).
	panel layoutInset: (2).
	panel listCentering: (#topLeft).
	panel listDirection: (#topToBottom).
	panel listSpacing: (#none).
	panel maxCellSize: (1073741823).
	panel minCellSize: (0).
	panel wrapCentering: (#topLeft).
	panel wrapDirection: (#none).
	panel frameFractions: (0@0 corner: 1@1).
	panel frameOffsets: (0@0 corner: 0@0).
	panel balloonText: (nil).
	panel balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1.0 alpha: 0.922)).
	panel color: (Color transparent).
	panel borderWidth: (0).
	panel borderStyle2: (#simple).
	panel borderColor: (Color black).
	panel setProperty: #objectName toValue: 'panel'.
	unnamedMorph1 := UiContainer new.
	unnamedMorph1 changeTableLayout.
	unnamedMorph1 extent: (248@22).
	unnamedMorph1 position: (2@2).
	unnamedMorph1 hResizing: (#spaceFill).
	unnamedMorph1 vResizing: (#shrinkWrap).
	unnamedMorph1 minWidth: (2).
	unnamedMorph1 minHeight: (2).
	unnamedMorph1 cellInset: (0).
	unnamedMorph1 cellPositioning: (#center).
	unnamedMorph1 cellSpacing: (#none).
	unnamedMorph1 layoutInset: (0).
	unnamedMorph1 listCentering: (#topLeft).
	unnamedMorph1 listDirection: (#leftToRight).
	unnamedMorph1 listSpacing: (#none).
	unnamedMorph1 maxCellSize: (1073741823).
	unnamedMorph1 minCellSize: (0).
	unnamedMorph1 wrapCentering: (#topLeft).
	unnamedMorph1 wrapDirection: (#none).
	unnamedMorph1 frameFractions: (0@0 corner: 1@1).
	unnamedMorph1 frameOffsets: (0@0 corner: 0@0).
	unnamedMorph1 balloonText: (nil).
	unnamedMorph1 balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1.0 alpha: 0.922)).
	unnamedMorph1 color: (Color transparent).
	unnamedMorph1 borderWidth: (0).
	unnamedMorph1 borderStyle2: (#simple).
	unnamedMorph1 borderColor: (Color black).
	hideBtn := UiToolButton new.
	hideBtn changeTableLayout.
	hideBtn extent: (18@18).
	hideBtn position: (3@4).
	hideBtn hResizing: (#shrinkWrap).
	hideBtn vResizing: (#shrinkWrap).
	hideBtn minWidth: (2).
	hideBtn minHeight: (2).
	hideBtn cellInset: (4).
	hideBtn cellPositioning: (#center).
	hideBtn cellSpacing: (#none).
	hideBtn layoutInset: (0).
	hideBtn listCentering: (#topLeft).
	hideBtn listDirection: (#leftToRight).
	hideBtn listSpacing: (#none).
	hideBtn maxCellSize: (1073741823).
	hideBtn minCellSize: (0).
	hideBtn wrapCentering: (#topLeft).
	hideBtn wrapDirection: (#none).
	hideBtn frameFractions: (0@0 corner: 1@1).
	hideBtn frameOffsets: (0@0 corner: 0@0).
	hideBtn balloonText: (nil).
	hideBtn balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1.0 alpha: 0.933)).
	hideBtn enabled: (true).
	hideBtn setProperty: #iconByDesigner toValue: 'UiSilkIcons eyeIcon'.
	hideBtn icon: (UiSilkIcons eyeIcon).
	hideBtn text: ('ToolButton').
	hideBtn color: ((Color r: 0.85 g: 0.85 b: 0.85)).
	hideBtn checkable: (true).
	hideBtn checked: (true).
	hideBtn autoExclusive: (false).
	hideBtn autoRaise: (true).
	hideBtn buttonStyle: (#iconOnly).
	hideBtn setProperty: #objectName toValue: 'hideBtn'.
	unnamedMorph1 addMorphBack: hideBtn.
	unnamedMorph2 := UiSpacer new.
	unnamedMorph2 extent: (71@10).
	unnamedMorph2 position: (22@8).
	unnamedMorph2 hResizing: (#spaceFill).
	unnamedMorph2 vResizing: (#rigid).
	unnamedMorph2 minWidth: (2).
	unnamedMorph2 minHeight: (2).
	unnamedMorph2 cellInset: (0).
	unnamedMorph2 cellPositioning: (#center).
	unnamedMorph2 cellSpacing: (#none).
	unnamedMorph2 layoutInset: (0).
	unnamedMorph2 listCentering: (#topLeft).
	unnamedMorph2 listDirection: (#topToBottom).
	unnamedMorph2 listSpacing: (#none).
	unnamedMorph2 maxCellSize: (1073741823).
	unnamedMorph2 minCellSize: (0).
	unnamedMorph2 wrapCentering: (#topLeft).
	unnamedMorph2 wrapDirection: (#none).
	unnamedMorph2 frameFractions: (0@0 corner: 1@1).
	unnamedMorph2 frameOffsets: (0@0 corner: 0@0).
	unnamedMorph2 balloonText: (nil).
	unnamedMorph2 balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1.0 alpha: 0.922)).
	unnamedMorph2 color: (Color blue).
	unnamedMorph2 borderWidth: (0).
	unnamedMorph2 borderStyle2: (#simple).
	unnamedMorph2 borderColor: (Color black).
	unnamedMorph2 orientation: (#horizontal).
	unnamedMorph1 addMorphBack: unnamedMorph2.
	headerBtn := SdDraggableButton new.
	headerBtn changeTableLayout.
	headerBtn extent: (64@21).
	headerBtn position: (93@2).
	headerBtn hResizing: (#shrinkWrap).
	headerBtn vResizing: (#shrinkWrap).
	headerBtn minWidth: (2).
	headerBtn minHeight: (2).
	headerBtn cellInset: (4).
	headerBtn cellPositioning: (#center).
	headerBtn cellSpacing: (#none).
	headerBtn layoutInset: (2@0 corner: 2@0).
	headerBtn listCentering: (#topLeft).
	headerBtn listDirection: (#leftToRight).
	headerBtn listSpacing: (#none).
	headerBtn maxCellSize: (1073741823).
	headerBtn minCellSize: (0).
	headerBtn wrapCentering: (#topLeft).
	headerBtn wrapDirection: (#none).
	headerBtn frameFractions: (0@0 corner: 1@1).
	headerBtn frameOffsets: (0@0 corner: 0@0).
	headerBtn balloonText: (nil).
	headerBtn balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1.0 alpha: 0.922)).
	headerBtn enabled: (true).
	headerBtn setProperty: #iconByDesigner toValue: 'nil'.
	headerBtn icon: (nil).
	headerBtn text: ('Workspace').
	headerBtn color: ((Color r: 0.85 g: 0.85 b: 0.85)).
	headerBtn checkable: (false).
	headerBtn checked: (false).
	headerBtn autoExclusive: (false).
	headerBtn autoRaise: (true).
	headerBtn buttonStyle: (#textBesideIcon).
	headerBtn setProperty: #objectName toValue: 'headerBtn'.
	unnamedMorph1 addMorphBack: headerBtn.
	unnamedMorph3 := UiSpacer new.
	unnamedMorph3 extent: (71@10).
	unnamedMorph3 position: (159@8).
	unnamedMorph3 hResizing: (#spaceFill).
	unnamedMorph3 vResizing: (#rigid).
	unnamedMorph3 minWidth: (2).
	unnamedMorph3 minHeight: (2).
	unnamedMorph3 cellInset: (0).
	unnamedMorph3 cellPositioning: (#center).
	unnamedMorph3 cellSpacing: (#none).
	unnamedMorph3 layoutInset: (0).
	unnamedMorph3 listCentering: (#topLeft).
	unnamedMorph3 listDirection: (#topToBottom).
	unnamedMorph3 listSpacing: (#none).
	unnamedMorph3 maxCellSize: (1073741823).
	unnamedMorph3 minCellSize: (0).
	unnamedMorph3 wrapCentering: (#topLeft).
	unnamedMorph3 wrapDirection: (#none).
	unnamedMorph3 frameFractions: (0@0 corner: 1@1).
	unnamedMorph3 frameOffsets: (0@0 corner: 0@0).
	unnamedMorph3 balloonText: (nil).
	unnamedMorph3 balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1.0 alpha: 0.922)).
	unnamedMorph3 color: (Color blue).
	unnamedMorph3 borderWidth: (0).
	unnamedMorph3 borderStyle2: (#simple).
	unnamedMorph3 borderColor: (Color black).
	unnamedMorph3 orientation: (#horizontal).
	unnamedMorph1 addMorphBack: unnamedMorph3.
	closeBtn := UiToolButton new.
	closeBtn changeTableLayout.
	closeBtn extent: (18@18).
	closeBtn position: (231@4).
	closeBtn hResizing: (#shrinkWrap).
	closeBtn vResizing: (#shrinkWrap).
	closeBtn minWidth: (2).
	closeBtn minHeight: (2).
	closeBtn cellInset: (4).
	closeBtn cellPositioning: (#center).
	closeBtn cellSpacing: (#none).
	closeBtn layoutInset: (0).
	closeBtn listCentering: (#topLeft).
	closeBtn listDirection: (#leftToRight).
	closeBtn listSpacing: (#none).
	closeBtn maxCellSize: (1073741823).
	closeBtn minCellSize: (0).
	closeBtn wrapCentering: (#topLeft).
	closeBtn wrapDirection: (#none).
	closeBtn frameFractions: (0@0 corner: 1@1).
	closeBtn frameOffsets: (0@0 corner: 0@0).
	closeBtn balloonText: (nil).
	closeBtn balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1.0 alpha: 0.922)).
	closeBtn enabled: (true).
	closeBtn setProperty: #iconByDesigner toValue: 'UiFugueIcons minusWhiteIcon'.
	closeBtn icon: (UiFugueIcons minusWhiteIcon).
	closeBtn text: ('ToolButton').
	closeBtn color: ((Color r: 0.85 g: 0.85 b: 0.85)).
	closeBtn checkable: (false).
	closeBtn checked: (false).
	closeBtn autoExclusive: (false).
	closeBtn autoRaise: (true).
	closeBtn buttonStyle: (#iconOnly).
	closeBtn setProperty: #objectName toValue: 'closeBtn'.
	unnamedMorph1 addMorphBack: closeBtn.
	panel addMorphBack: unnamedMorph1.
	workspaceEdit := SdSourceCodeEdit new.
	workspaceEdit extent: (248@438).
	workspaceEdit position: (2@26).
	workspaceEdit hResizing: (#spaceFill).
	workspaceEdit vResizing: (#spaceFill).
	workspaceEdit minWidth: (2).
	workspaceEdit minHeight: (2).
	workspaceEdit cellInset: (0).
	workspaceEdit cellPositioning: (#center).
	workspaceEdit cellSpacing: (#none).
	workspaceEdit layoutInset: (0).
	workspaceEdit listCentering: (#topLeft).
	workspaceEdit listDirection: (#topToBottom).
	workspaceEdit listSpacing: (#none).
	workspaceEdit maxCellSize: (1073741823).
	workspaceEdit minCellSize: (0).
	workspaceEdit wrapCentering: (#topLeft).
	workspaceEdit wrapDirection: (#none).
	workspaceEdit frameFractions: (0@0 corner: 1@1).
	workspaceEdit frameOffsets: (0@0 corner: 0@0).
	workspaceEdit balloonText: ('Workspace').
	workspaceEdit balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1.0 alpha: 0.922)).
	workspaceEdit widgetResizable: (true).
	workspaceEdit horizontalScrollBarPolicy: (#alwaysOff).
	workspaceEdit verticalScrollBarPolicy: (#alwaysOn).
	workspaceEdit outerBorderWidth: (1).
	workspaceEdit scrollBarThickness: (9).
	workspaceEdit theText: ('').
	workspaceEdit readOnly: (false).
	workspaceEdit autoConvert: (false).
	workspaceEdit autoAccept: (true).
	workspaceEdit acceptOnFocusLost: (false).
	workspaceEdit scrollingMode: (#none).
	workspaceEdit scrollingLimit: (10).
	workspaceEdit setProperty: #objectName toValue: 'workspaceEdit'.
	panel addMorphBack: workspaceEdit.
	workspaceToolbar := UiContainer new.
	workspaceToolbar changeTableLayout.
	workspaceToolbar extent: (248@19).
	workspaceToolbar position: (2@465).
	workspaceToolbar hResizing: (#spaceFill).
	workspaceToolbar vResizing: (#shrinkWrap).
	workspaceToolbar minWidth: (2).
	workspaceToolbar minHeight: (2).
	workspaceToolbar cellInset: (4).
	workspaceToolbar cellPositioning: (#center).
	workspaceToolbar cellSpacing: (#none).
	workspaceToolbar layoutInset: (0).
	workspaceToolbar listCentering: (#topLeft).
	workspaceToolbar listDirection: (#leftToRight).
	workspaceToolbar listSpacing: (#none).
	workspaceToolbar maxCellSize: (1073741823).
	workspaceToolbar minCellSize: (0).
	workspaceToolbar wrapCentering: (#topLeft).
	workspaceToolbar wrapDirection: (#none).
	workspaceToolbar frameFractions: (0@0 corner: 1@1).
	workspaceToolbar frameOffsets: (0@0 corner: 0@0).
	workspaceToolbar balloonText: (nil).
	workspaceToolbar balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1.0 alpha: 0.922)).
	workspaceToolbar color: (Color transparent).
	workspaceToolbar borderWidth: (0).
	workspaceToolbar borderStyle2: (#simple).
	workspaceToolbar borderColor: (Color black).
	workspaceToolbar setProperty: #objectName toValue: 'workspaceToolbar'.
	unnamedMorph4 := UiSpacer new.
	unnamedMorph4 extent: (220@10).
	unnamedMorph4 position: (2@470).
	unnamedMorph4 hResizing: (#spaceFill).
	unnamedMorph4 vResizing: (#rigid).
	unnamedMorph4 minWidth: (2).
	unnamedMorph4 minHeight: (2).
	unnamedMorph4 cellInset: (0).
	unnamedMorph4 cellPositioning: (#center).
	unnamedMorph4 cellSpacing: (#none).
	unnamedMorph4 layoutInset: (0).
	unnamedMorph4 listCentering: (#topLeft).
	unnamedMorph4 listDirection: (#topToBottom).
	unnamedMorph4 listSpacing: (#none).
	unnamedMorph4 maxCellSize: (1073741823).
	unnamedMorph4 minCellSize: (0).
	unnamedMorph4 wrapCentering: (#topLeft).
	unnamedMorph4 wrapDirection: (#none).
	unnamedMorph4 frameFractions: (0@0 corner: 1@1).
	unnamedMorph4 frameOffsets: (0@0 corner: 0@0).
	unnamedMorph4 balloonText: (nil).
	unnamedMorph4 balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1.0 alpha: 0.922)).
	unnamedMorph4 color: (Color blue).
	unnamedMorph4 borderWidth: (0).
	unnamedMorph4 borderStyle2: (#simple).
	unnamedMorph4 borderColor: (Color black).
	unnamedMorph4 orientation: (#horizontal).
	workspaceToolbar addMorphBack: unnamedMorph4.
	clearWorkspaceBtn := UiToolButton new.
	clearWorkspaceBtn changeTableLayout.
	clearWorkspaceBtn extent: (22@18).
	clearWorkspaceBtn position: (226@465).
	clearWorkspaceBtn hResizing: (#shrinkWrap).
	clearWorkspaceBtn vResizing: (#shrinkWrap).
	clearWorkspaceBtn minWidth: (2).
	clearWorkspaceBtn minHeight: (2).
	clearWorkspaceBtn cellInset: (4).
	clearWorkspaceBtn cellPositioning: (#center).
	clearWorkspaceBtn cellSpacing: (#none).
	clearWorkspaceBtn layoutInset: (2@0 corner: 2@0).
	clearWorkspaceBtn listCentering: (#topLeft).
	clearWorkspaceBtn listDirection: (#leftToRight).
	clearWorkspaceBtn listSpacing: (#none).
	clearWorkspaceBtn maxCellSize: (1073741823).
	clearWorkspaceBtn minCellSize: (0).
	clearWorkspaceBtn wrapCentering: (#topLeft).
	clearWorkspaceBtn wrapDirection: (#none).
	clearWorkspaceBtn frameFractions: (0@0 corner: 1@1).
	clearWorkspaceBtn frameOffsets: (0@0 corner: 0@0).
	clearWorkspaceBtn balloonText: ('Clear workspace').
	clearWorkspaceBtn balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1.0 alpha: 0.922)).
	clearWorkspaceBtn enabled: (true).
	clearWorkspaceBtn setProperty: #iconByDesigner toValue: 'UiFugueIcons broomIcon'.
	clearWorkspaceBtn icon: (UiFugueIcons broomIcon).
	clearWorkspaceBtn text: ('ToolButton').
	clearWorkspaceBtn color: ((Color r: 0.85 g: 0.85 b: 0.85)).
	clearWorkspaceBtn checkable: (false).
	clearWorkspaceBtn checked: (false).
	clearWorkspaceBtn autoExclusive: (false).
	clearWorkspaceBtn autoRaise: (true).
	clearWorkspaceBtn buttonStyle: (#iconOnly).
	clearWorkspaceBtn setProperty: #objectName toValue: 'clearWorkspaceBtn'.
	workspaceToolbar addMorphBack: clearWorkspaceBtn.
	panel addMorphBack: workspaceToolbar.
	panel setProperty: #uiClassName toValue: 'SdWorkspaceEditor'.! !

!SdWorkspaceEditorUi methodsFor: 'accessing' stamp: 'mt 6/20/2012 14:06:26.348'!
workspaceEdit
	"No description given."
	
	^ workspaceEdit! !

!SdWorkspaceEditorUi methodsFor: 'accessing' stamp: 'mt 6/20/2012 14:06:26.366'!
workspaceToolbar
	"No description given."
	
	^ workspaceToolbar! !

!MouseButtonEvent methodsFor: '*sight-dynamic-override' stamp: 'mt 5/24/2011 14:36:10.059'!
blueButtonChanged
	"Answer true if the blue mouse button has changed. This is the third mouse button or cmd+click on the Mac."

	^ self blueButtonPressed! !

!MouseButtonEvent methodsFor: '*sight-dynamic' stamp: 'mt 5/24/2011 14:45:40.387'!
blueButtonPressed
	"Workaround for wrong VM behavior."
	
	^ super blueButtonPressed and: [super controlKeyPressed not]    ! !

!MouseButtonEvent methodsFor: '*sight-dynamic' stamp: 'mt 5/24/2011 14:45:16.715'!
controlKeyPressed

	^ super controlKeyPressed and: [
		super blueButtonPressed not]! !

!MouseButtonEvent methodsFor: '*sight-dynamic' stamp: 'mt 5/24/2011 14:34:27.038'!
redButtonPressed
	"Workaround for wrong VM behavior."
	
	^ super redButtonPressed or: [
		super blueButtonPressed and: [self controlKeyPressed]]! !

SHTextStylerST80 subclass: #SdTextStyler
	instanceVariableNames: 'customTextAttributes'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sight-Dynamic-Support'!

!SdTextStyler commentStamp: 'mt 4/25/2011 09:38:47.223' prior: 0!
Regular Shout text styler with the ability to override some attributes dynamically.!

!SdTextStyler class methodsFor: 'style table' stamp: 'mt 4/20/2011 17:09:48.067'!
defaultStyleTable
	"color can be a valid argument to Color class>>colorFrom: , or nil to
	use the editor text color.
	Multiple emphases can be specified using an array e.g. #(bold italic).
	If emphasis is not specified, #normal will be used.
	if pixel height is not specified , then the editor font size will be used.
	"
								
^#(
	"(symbol	color		[emphasisSymbolOrArray		[textStyleName [pixelHeight]]])"		
						
	(default 								( black )	)
	(invalid 								( red ) 	)
	(excessCode 							( red )	)
	(comment 								( green	muchDarker ) nil	#'Bitmap Segoe UI' 15)
	(unfinishedComment 					( green	muchDarker )	)
	(#'$'									( magenta muchDarker) 	)
	(character							( magenta muchDarker) 	)
	(integer								( magenta muchDarker) 	)
	(number								( magenta muchDarker) 	)
	(#-										( magenta muchDarker) 	)
	(symbol									( magenta muchDarker) 	)	
	(stringSymbol							( magenta muchDarker) 	)	
	(literalArray							( magenta muchDarker) 	)
	(string									( magenta ) 	)
	(unfinishedString						( magenta ) 	)
	(assignment								( black )					)
	(ansiAssignment 						( black )					)
	(literal									( black )					)
	(keyword								( black )					)
	(binary 								( black )					)
	(unary									( black )					)
	(incompleteKeyword						( black )					)
	(incompleteBinary 						( black )					)
	(incompleteUnary						( black )					)
	(undefinedKeyword						( red )					)
	(undefinedBinary 						( red )					)
	(undefinedUnary						( red )					)													
	(patternKeyword 						( black ) bold				)
	(patternBinary 							( black ) bold				)
	(patternUnary							( black ) bold				)
	(#self 									( cyan muchDarker )	bold	)
	(#super									( cyan muchDarker )	bold	)
	(#true 									( cyan muchDarker )	bold	)
	(#false 									( cyan muchDarker )	bold	)
	(#nil 									( cyan muchDarker )	bold	)
	(#thisContext 							( cyan muchDarker )	bold	)
	(#return								( black )	bold				)
	(patternArg 							( blue muchDarker ) 		)	
	(methodArg 								( blue muchDarker ) 		)		
	(blockPatternArg 						( yellow muchDarker ) 		)		
	(blockArg 								( yellow muchDarker ) 		)	
	(argument 								( blue muchDarker ) 		)		
	(blockArgColon							black		) 
	(leftParenthesis							black		) 
	(rightParenthesis						black		) 
	(leftParenthesis1						black		) 
	(rightParenthesis1						black		) 
	(leftParenthesis2						black		)  
	(rightParenthesis2						black		)  
	(leftParenthesis3						black		) 
	(rightParenthesis3						black		) 
	(leftParenthesis4						black		) 
	(rightParenthesis4						black		) 
	(leftParenthesis5						black		)  
	(rightParenthesis5						black		) 
	(leftParenthesis6						black		) 
	(rightParenthesis6						black		) 
	(leftParenthesis7						black		) 
	(rightParenthesis7						black		) 
	(blockStart 								black		) 
	(blockEnd 								black		) 
	(blockStart1								black		) 
	(blockEnd1								black		) 
	(blockStart2								black		) 
	(blockEnd2								black		) 
	(blockStart3								black		) 
	(blockEnd3								black		) 
	(blockStart4								black		) 
	(blockEnd4								black		) 
	(blockStart5								black		) 
	(blockEnd5								black		) 
	(blockStart6								black		) 
	(blockEnd6								black		) 
	(blockStart7								black		) 
	(blockEnd7								black		) 																																																
	(arrayStart								black		) 
	(arrayEnd								black		) 
	(arrayStart1							black		) 
	(arrayEnd1								black		) 
	(byteArrayStart								black		) 
	(byteArrayEnd								black		) 
	(byteArrayStart1							black		) 
	(byteArrayEnd1								black		) 
	(leftBrace 								black		) 
	(rightBrace 								black		) 
	(cascadeSeparator 						black		) 
	(statementSeparator 						black		) 
	(externalCallType 						black		) 
	(externalCallTypePointerIndicator 		black		) 
	(primitiveOrExternalCallStart 			black		) 
	(primitiveOrExternalCallEnd				black		)
	(methodTempBar							black		) 
	(blockTempBar 							black		) 
	(blockArgsBar							black		) 
	(primitive								gray		)
	(externalFunctionCallingConvention		gray		)
	(module									gray		)
	(blockTempVar 							( gray darker ) 		)	
	(blockPatternTempVar					( gray darker ) 		)	
	(instVar 								( blue muchDarker ) 		)	
	(workspaceVar							( blue muchDarker ) 		)	
	(undefinedIdentifier						( red ) 		)	
	(incompleteIdentifier					( blue muchDarker ) 		)	
	(tempVar								( gray darker ) 		)	
	(patternTempVar						( gray darker ) 		)	
	(poolConstant							( blue muchDarker ) 		)	
	(classVar								( blue muchDarker ) 	bold	)	
	(globalVar								( blue muchDarker ) 	bold	) )
							! !

!SdTextStyler class methodsFor: 'style table' stamp: 'mt 4/20/2011 17:10:02.525'!
subduedStyleTable

	^ self defaultStyleTable! !

!SdTextStyler methodsFor: 'private' stamp: 'mt 4/27/2011 13:30:52.11'!
attributesFor: aSymbol

	^ (((super attributesFor: aSymbol) ifNil: [#()]), 
		(self customTextAttributes at: aSymbol ifAbsent: [#()])) ifEmpty: []! !

!SdTextStyler methodsFor: 'accessing' stamp: 'mt 4/20/2011 17:21:02.301'!
customTextAttributes

	^ customTextAttributes ifNil: [customTextAttributes := IdentityDictionary new].! !

OController subclass: #SdCompletionController
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sight-Dynamic-Support'!

!SdCompletionController methodsFor: 'menu morph' stamp: 'mt 4/28/2011 10:38:15.19'!
openMenuFor: anEditor

	super openMenuFor: anEditor.
	
	menuMorph ifNotNil: [
		menuMorph position: (anEditor morph editView localPointToGlobal: menuMorph position)].! !

!SdCompletionController methodsFor: 'menu morph' stamp: 'mt 4/28/2011 10:38:21.041'!
openXMenuFor: anEditor

	super openXMenuFor: anEditor.
	
	menuMorph ifNotNil: [
		menuMorph position: (anEditor morph editView localPointToGlobal: menuMorph position)].! !

LayoutPolicy subclass: #SdArtifactContainerLayout
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sight-Dynamic-UI-Layouts'!

!SdArtifactContainerLayout methodsFor: 'layout' stamp: 'mt 6/21/2012 09:44:05.578'!
layout: aMorph in: newBounds

	| offset |
	offset := aMorph topLeft + (0@1).
	aMorph submorphsDo: [:s |
		s visible ifTrue: [
			s
				width: aMorph width;
				layoutChanged;
				topLeft: offset.
			s fullBounds.
			offset := offset x @ (offset y + s height + 1)]].
	
	aMorph height: offset y - aMorph top.! !

LayoutPolicy subclass: #SdColumnLayout
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sight-Dynamic-UI-Layouts'!

!SdColumnLayout commentStamp: 'mt 7/2/2011 15:13:57.596' prior: 0!
Just a simple layout that layouts its children in one column making them expanding horizontally.!

!SdColumnLayout methodsFor: 'layout' stamp: 'mt 7/2/2011 15:10:45.562'!
layout: aMorph in: newBounds

	| offset verticalSpace numSpaceFillers |
	verticalSpace := newBounds height.
	numSpaceFillers := 0.
	aMorph submorphsDo: [:morph | 
		morph fullBounds.
		morph vResizing ~= #spaceFill
			ifTrue: [verticalSpace := verticalSpace - morph height]
			ifFalse: [numSpaceFillers := numSpaceFillers + 1]].
	
	verticalSpace := verticalSpace max: 0.
	offset := 0.
	aMorph submorphsDo: [:morph |
		morph vResizing ~= #spaceFill
			ifTrue: [
				morph bounds: (newBounds topLeft + (0@offset)
					corner: newBounds topRight + (0@(offset+morph height)))]
			ifFalse: [
				morph bounds: (newBounds topLeft + (0@offset)
					corner: newBounds topRight + (0@(offset+(verticalSpace // numSpaceFillers)))).
				numSpaceFillers := numSpaceFillers - 1.
				verticalSpace := verticalSpace - morph height].
		offset := offset + morph height].! !

LayoutPolicy subclass: #SdMethodEditorColumnLayout
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sight-Dynamic-UI-Layouts'!

!SdMethodEditorColumnLayout methodsFor: 'layout' stamp: 'mt 6/19/2012 15:51:15.262'!
layout: aMorph in: newBounds

	| offset |
	offset := aMorph topLeft.
	aMorph submorphsDo: [:s | 
		s
			width: aMorph width;
			topLeft: offset.
		s fullBounds.
		offset := offset x @ (offset y + s bounds height)].
	aMorph height: offset y - aMorph top.! !

LayoutPolicy subclass: #SdTapeContainerLayout
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sight-Dynamic-UI-Layouts'!

!SdTapeContainerLayout methodsFor: 'layout' stamp: 'mt 6/18/2012 10:36:30.458'!
layout: aMorph in: newBounds

	| offset verticalSpace |
	offset := aMorph topLeft.
	verticalSpace := (newBounds height - aMorph submorphs size + 1) // aMorph submorphs size.

	aMorph submorphsDo: [:s | 
		s
			width: aMorph width;
			height: verticalSpace;
			topLeft: offset.
		offset := offset x @ (offset y + verticalSpace + 1)].! !

LayoutPolicy subclass: #SdTapeLayout
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sight-Dynamic-UI-Layouts'!

!SdTapeLayout methodsFor: 'layout' stamp: 'mt 6/19/2012 18:00:37.883'!
layout: aMorph in: newBounds

	| offset |
	offset := aMorph topLeft.
	aMorph submorphsDo: [:s | 
		s isOverlayConnector
			ifTrue: [s comeToFront]
			ifFalse: [
				s
					height: aMorph height;
					topLeft: offset.
				offset := (offset x + s fullBounds width -1) @ offset y]].
	aMorph width: offset x - aMorph left.! !

UiIcons subclass: #SdIcons
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sight-Dynamic-UI-Support'!

!SdIcons class methodsFor: 'accessing' stamp: 'mt 4/18/2011 13:51:34.853'!
classSideIcon
	
	^ Icons
		at: #classSide
		ifAbsentPut:[ Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self classSideIconContents readStream) ].! !

!SdIcons class methodsFor: 'contents' stamp: 'mt 4/18/2011 13:50:50.089'!
classSideIconContents

	^ 'iVBORw0KGgoAAAANSUhEUgAAABAAAAAQCAYAAAAf8/9hAAAAAXNSR0IArs4c6QAAAARnQU1B
AACxjwv8YQUAAAAJcEhZcwAADsMAAA7DAcdvqGQAAAAZdEVYdFNvZnR3YXJlAFBhaW50Lk5F
VCB2My41Ljg3O4BdAAABG0lEQVQ4T2NgoCmod9NgqHc1IM2OencFhjq3+UD8nqHe7T8c17kt
J2wYyDZ0jciGgNmuCdhdBHIuVDNHs/f/1oPL/n/4/uU/CIBoEJ+l0QPqIncHTEPAToQ4ee/d
82CN6KDryCqIAXVu51ENqLfnAAp+B0mazsyB6/NZWgvW4LG46v+rL+//r7l66D9Xiy/UFciB
C/I71PaUjX1wA1ACEW9Y1LtYUGiAlwTMAGQvgJwOEteakgL2ws7bZ/6LdIbAotYDNRzq3I4T
CsQN149CA9H1OQMo3FBAvVsAzABQNE46sR4lGkF8kDhUTQGOtODagD/gwFE4H3/SrneNYKgD
OREpGUPiHpi0gRYQDcBeArkIjCMw/Uy0SfgVAgD7EDtPjuUW4gAAAABJRU5ErkJggg=='! !

!SdIcons class methodsFor: 'accessing' stamp: 'mt 4/18/2011 13:51:50.81'!
instanceSideIcon
	
	^ Icons
		at: #instanceSide
		ifAbsentPut:[ Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self instanceSideIconContents readStream) ].! !

!SdIcons class methodsFor: 'contents' stamp: 'mt 4/18/2011 13:50:55.035'!
instanceSideIconContents

	^ 'iVBORw0KGgoAAAANSUhEUgAAABAAAAAQCAYAAAAf8/9hAAAAAXNSR0IArs4c6QAAAARnQU1B
AACxjwv8YQUAAAAJcEhZcwAADsMAAA7DAcdvqGQAAAAZdEVYdFNvZnR3YXJlAFBhaW50Lk5F
VCB2My41Ljg3O4BdAAAAyElEQVQ4T2NgoCmY9F+DYcp/A9LsmP5fgWHqv/kMU/69B2r+j8D/
lhM2DGQbhkZkQ8DsBOwuAjsX1db/UOC4Hs2Qyf8dMA2ZAnYikpNh2v//xzTg33lUA+b/52CY
/O870QZALEIKXLDfMfwKdwKGCyBqkcJi4j8LygyY8l+CdAP+eaCGw5R/x4kOg8n/njOAwg0F
TPofQIIBBdjTwuT/Ddi8giIGSqV4weR/EcAofY5pEDCRgSwgGoC8BNIAxkBDMfxMtEn4FQIA
y3l/8JebCsMAAAAASUVORK5CYII='! !

!SdIcons class methodsFor: 'license' stamp: 'mt 4/18/2011 13:49:52.176'!
license

	^ 'Composed or self-made icons by Marcel Taeumel (c) 2011.'! !

UiTestCase subclass: #SdFinderTests
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sight-Dynamic-Tests'!

SdFinderTests subclass: #SdClassFinderTests
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sight-Dynamic-Tests'!

!SdClassFinderTests methodsFor: 'tests' stamp: 'mt 5/14/2012 16:15:02.44'!
test01Signals

	| spy |
	spy := SignalSpy new
		addSender: sut signals: #(classChosen: classChosen:category:).

	sut
		currentToken: 'SdTestMorph';
		chooseElement.
		
	spy waitForNextSignal ifNotNil: [:signal |
		self
			assert: #classChosen:
			equals: signal first;
			assert: #(SdTestMorph)
			equals: signal second].

	sut
		categoryFilter: 'Sight-Dynamic-New-Category';
		currentToken: 'SdTestMorphNew';
		chooseElement.
		
	spy waitForNextSignal ifNotNil: [:signal |
		self
			assert: #classChosen:category:
			equals: signal first;
			assert: #(SdTestMorphNew 'Sight-Dynamic-New-Category')
			equals: signal second].
				
	sut
		categoryFilter: 'Sight-Dynamic-Tests-Support';
		currentToken: 'SdTestMorph';
		chooseElement.
		
	spy waitForNextSignal ifNotNil: [:signal |
		self
			assert: #classChosen:
			equals: signal first;
			assert: #(SdTestMorph)
			equals: signal second].! !

!SdFinderTests class methodsFor: 'testing' stamp: 'mt 5/14/2012 14:30:33.478'!
isAbstract

	^ self name = #SdFinderTests! !

!SdFinderTests methodsFor: 'running' stamp: 'mt 5/14/2012 14:38:45.364'!
initializeSubject! !

!SdFinderTests methodsFor: 'running' stamp: 'mt 5/14/2012 14:38:25.061'!
setUp

	super setUp.
	self initializeSubject.! !

SdFinderTests subclass: #SdItemFinderTests
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sight-Dynamic-Tests'!

!SdItemFinderTests methodsFor: 'tests' stamp: 'mt 5/15/2012 10:17:32.952'!
test01FilterByClass

	sut currentToken: 'SdTestMorph#.'.
	self assert: SdTestMorph selectors size equals: sut matchedElements size.! !

SdFinderTests subclass: #SdMethodFinderTests
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sight-Dynamic-Tests'!

!SdMethodFinderTests methodsFor: 'running' stamp: 'mt 5/14/2012 14:41:13.439'!
initializeSubject

	sut theClass: SdTestMorph.! !

!SdMethodFinderTests methodsFor: 'tests' stamp: 'mt 5/14/2012 14:45:31.189'!
test01New

	self
		assert: ';' equals: sut currentToken;
		assert: sut currentElement isEmpty;
		assert: sut currentCategory isNil.
! !

!SdMethodFinderTests methodsFor: 'tests' stamp: 'mt 5/14/2012 15:16:54.391'!
test02EmptyToken

	sut currentToken: ''.

	self
		assert: sut matchedCategories isEmpty;
		assert: sut matchedElements isEmpty.
! !

!SdMethodFinderTests methodsFor: 'tests' stamp: 'mt 5/14/2012 15:22:39.276'!
test03TokenForAllCategories

	sut
		currentToken: '';
		currentToken: SdFinder tokenForAllCategories.

	self
		assert: SdTestMorph organization categories size equals: sut matchedCategories size;
		assert: sut matchedElements isEmpty.
! !

!SdMethodFinderTests methodsFor: 'tests' stamp: 'mt 5/14/2012 15:24:32.046'!
test04TokenForAllElements

	sut
		currentToken: '';
		currentToken: SdFinder tokenForAllElements.

	self
		assert: sut matchedCategories isEmpty;
		assert: SdTestMorph selectors size equals: sut matchedElements size.
! !

!SdMethodFinderTests methodsFor: 'tests' stamp: 'mt 5/14/2012 15:29:42.939'!
test05ClassSide

	self
		assert: sut isMeta not;
		assert: SdTestMorph equals: sut theClass.
		
	sut isMeta: true.

	self
		assert: sut isMeta;
		assert: SdTestMorph class equals: sut theClass.! !

!SdMethodFinderTests methodsFor: 'tests' stamp: 'mt 5/14/2012 15:35:52.318'!
test06Search

	sut currentToken: 'valueCh'.
	self
		assert: 2
		equals: sut matchedElements size.! !

!SdMethodFinderTests methodsFor: 'tests' stamp: 'mt 5/14/2012 15:42:17.92'!
test07AutoSelect

	sut currentToken: 'signa'.
	self assert: sut currentCategoryInList isNil.
	
	sut currentToken: 'signals'.
	self assert: #signals equals: sut currentCategoryInList.! !

!SdMethodFinderTests methodsFor: 'tests' stamp: 'mt 5/14/2012 15:47:42.908'!
test08CategoryFilter

	sut
		categoryFilter: nil;
		currentToken: SdFinder tokenForAllElements.
		
	self assert: SdTestMorph selectors size equals: sut matchedElements size.

	sut
		categoryFilter: 'signals';
		currentToken: SdFinder tokenForAllElements.
		
	self
		assert: (SdTestMorph organization listAtCategoryNamed: #signals) size
		equals: sut matchedElements size.
! !

!SdMethodFinderTests methodsFor: 'tests' stamp: 'mt 5/14/2012 15:53:33.831'!
test09Signals

	| spy |
	spy := SignalSpy new
		addSender: sut signals: #(selectorChosen:isMeta: selectorChosen:isMeta:protocol:).
		
	sut
		currentToken: 'foobar';
		chooseElement.
		
	spy waitForNextSignal ifNotNil: [:signal |
		self
			assert: #selectorChosen:isMeta: equals: signal first;
			assert: #(foobar false) equals: signal second].
		
	sut
		isMeta: true;
		categoryFilter: 'instance creation';
		currentToken: 'newFrom:';
		chooseElement.
		
	spy waitForNextSignal ifNotNil: [:signal |
		self
			assert: #selectorChosen:isMeta:protocol: equals: signal first;
			assert: #(newFrom: true 'instance creation') equals: signal second].
! !

UiTestCase subclass: #SdOwnerChainSignalsTests
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sight-Dynamic-Tests'!

!SdOwnerChainSignalsTests methodsFor: 'as yet unclassified' stamp: 'mt 6/28/2011 16:26:29.1'!
subjectClass

	^ SdTestMorph! !

!SdOwnerChainSignalsTests methodsFor: 'tests' stamp: 'mt 6/19/2012 14:03:10.718'!
test01Connect

	sut sgConnectSignal: #valueChanged: toSelector: #value.
	self
		assert: (sut signalConnectionsForOwnerChain includesKey: #valueChanged:);
		assert: 1 equals: (sut signalConnectionsForOwnerChain at: #valueChanged:) size.! !

!SdOwnerChainSignalsTests methodsFor: 'tests' stamp: 'mt 6/19/2012 14:03:10.75'!
test02Signal

	SdTestMorph new addMorph: (
		SdTestMorph new addMorph: sut).
		
	self
		assert: nil equals: sut value;
		assert: nil equals: sut owner value;
		assert: nil equals: sut owner owner value.
	
	sut owner owner sgConnectSignal: #valueChanged: toSelector: #value:.
	sut value: #foobar.
	
	self
		assert: #foobar equals: sut value;
		assert: nil equals: sut owner value;
		assert: #foobar equals: sut owner owner value.! !

!SdOwnerChainSignalsTests methodsFor: 'tests' stamp: 'mt 6/19/2012 14:03:54.265'!
test03Disconnect

	sut sgConnectSignal: #valueChanged: toSelector: #value:.
	self assert: sut signalConnectionsForOwnerChain notEmpty.
	
	sut sgDisconnectSignal: #valueChanged: fromSelector: #value:.
	self assert: sut signalConnectionsForOwnerChain isEmpty.! !

UiPushButton subclass: #SdResizeHandle
	instanceVariableNames: 'flattened fadeAnimation mouseDownEventPosition mouseDownTargetExtent target orientation minSize'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sight-Dynamic-UI-Columns'!

!SdResizeHandle commentStamp: 'mt 4/13/2011 13:23:38.993' prior: 0!
A handle to resize morphs in width.!

!SdResizeHandle class methodsFor: 'testing' stamp: 'mt 4/14/2011 10:35:12.804'!
isWidgetClass

	^ false! !

!SdResizeHandle methodsFor: 'initialization' stamp: 'mt 4/15/2011 10:02:21.155'!
addGrips

	| container |
	container := Morph new
		color: Color transparent;
		changeTableLayout;
		listDirection: (self orientation = #vertical ifTrue: [#topToBottom] ifFalse: [#leftToRight]);  
		vResizing: (self orientation = #vertical ifTrue: [#spaceFill] ifFalse: [#shrinkWrap]);
		hResizing: (self orientation = #vertical ifTrue: [#shrinkWrap] ifFalse: [#spaceFill]);
		cellInset: 1;
		addMorphBack: (UiSpacer new orientation: self orientation; extent: 5@5).
		  
	4 timesRepeat: [container addMorphBack: (
		Morph new
			extent: 3@3;
			color: (Color gray: 0.7);
			borderStyle: (BorderStyle raised width: 1);
			ignoresColorMappings: true)].
		
	container addMorphBack: (UiSpacer new orientation: self orientation; extent: 5@5).
	
	self
		removeAllMorphs;
		addMorphBack: container.  ! !

!SdResizeHandle methodsFor: 'actions' stamp: 'mt 7/11/2012 10:27:28.884'!
doHandleMovement: aMouseMoveEvent

	self target ifNil: [^ self].
	
	self orientation = #vertical ifTrue: [
		self target width:
			((mouseDownTargetExtent
				+ ((aMouseMoveEvent position - mouseDownEventPosition) * ((self left > self target left) ifTrue: [1] ifFalse: [-1]))) x
			max: self minSize)].
		
	self orientation = #horizontal ifTrue: [
		self target height:
			((mouseDownTargetExtent
				+ ((aMouseMoveEvent position - mouseDownEventPosition) * ((self top > self target top) ifTrue: [1] ifFalse: [-1]))) y
			max: self minSize)].! !

!SdResizeHandle methodsFor: 'actions' stamp: 'mt 4/13/2011 13:02:53.838'!
fadeIn

	self visible ifFalse: [^ self].
	
	fadeAnimation
		ifNil: [^ self]
		ifNotNil: [:anim |
			anim unregister.
			fadeAnimation := nil].
	
	super fadeIn.! !

!SdResizeHandle methodsFor: 'actions' stamp: 'mt 4/13/2011 13:19:26.159'!
fadeOut

	self visible ifFalse: [^ self].
	mouseDownEventPosition ifNotNil: [^ self].
	
	fadeAnimation ifNil: [fadeAnimation := (AnimAlphaBlendAnimation
		fadeOutOn: self
		duration: 200)
		register;
		start: #keepWhenFinished].! !

!SdResizeHandle methodsFor: 'actions' stamp: 'mt 4/15/2011 10:17:02.852'!
finishHandleMovement: aMouseEvent

	mouseDownEventPosition := nil.
	mouseDownTargetExtent := nil.
	
	(self bounds containsPoint: aMouseEvent position)
		ifFalse: [self fadeOut].! !

!SdResizeHandle methodsFor: 'initialization' stamp: 'mt 5/9/2011 09:19:32.911'!
initialize

	orientation := #vertical.

	super initialize.
	
	self
		extent: 9@10;
		color: (Color gray: 0.85);
		listCentering: #center;
		layoutInset: 0;
		updateLayout;
		fadeOut.

	self connect: self eventHandler signal: #mouseEntered: toSelector: #fadeIn.
	self connect: self eventHandler signal: #mouseLeft: toSelector: #fadeOut.
	
	self connect: self eventHandler signal: #mousePressed: toSelector: #startHandleMovement:.
	self connect: self eventHandler signal: #mouseMoved: toSelector: #doHandleMovement:.
	self connect: self eventHandler signal: #mouseReleased: toSelector: #finishHandleMovement:.
	
	self connect: self eventHandler signal: #mouseClicked: toSelector: #onClick.
	
	"No keyboard handling."
	self eventHandler setProperty: #handlesKeyboard toValue: [false].
	self eventHandler disconnectSignal: #mousePressed: from: self selector: #grabKeyboard.! !

!SdResizeHandle methodsFor: 'accessing' stamp: 'mt 7/11/2012 10:26:56.128'!
minSize

	^ minSize ifNil: [50]! !

!SdResizeHandle methodsFor: 'accessing' stamp: 'mt 7/11/2012 10:27:07.197'!
minSize: anInteger

	minSize := anInteger.! !

!SdResizeHandle methodsFor: 'actions' stamp: 'mt 9/1/2011 13:15:49.366'!
onClick

	self target ifNil: [^ self].
	
	self orientation = #vertical
		ifTrue: [self target width: (self target optimalWidth max: 250)].! !

!SdResizeHandle methodsFor: 'accessing' stamp: 'mt 4/15/2011 09:50:35.156'!
orientation

	^ orientation! !

!SdResizeHandle methodsFor: 'accessing' stamp: 'mt 4/15/2011 09:55:12.167'!
orientation: aSymbol
	"#horizontal, #vertical"

	orientation = aSymbol ifTrue: [^ self].

	orientation := aSymbol.
	
	self
		extent: self height @ self width; "flip"
		updateLayout.! !

!SdResizeHandle methodsFor: 'actions' stamp: 'mt 5/9/2011 09:22:40.539'!
startHandleMovement: aMouseEvent

	self target ifNil: [^ self].

	mouseDownEventPosition := aMouseEvent position.
	mouseDownTargetExtent := self target extent.
! !

!SdResizeHandle methodsFor: 'accessing' stamp: 'mt 4/15/2011 09:48:53.381'!
target
	"Morph to be resized."
	
	^ target! !

!SdResizeHandle methodsFor: 'accessing' stamp: 'mt 4/15/2011 09:48:08.132'!
target: aMorph

	target := aMorph.! !

!SdResizeHandle methodsFor: 'updating' stamp: 'mt 4/15/2011 09:56:33.897'!
updateLayout

	self removeAllMorphs.
	
	self orientation = #horizontal ifTrue: [
		self
			hResizing: #spaceFill;
			vResizing: #rigid;
			listDirection: #topToBottom].
	
	self orientation = #vertical ifTrue: [
		self
			hResizing: #rigid;
			vResizing: #spaceFill;
			listDirection: #leftToRight].

	self addGrips.! !

AbstractEvent subclass: #SdMessageEvent
	instanceVariableNames: 'text messageKind'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sight-Dynamic-Events'!

!SdMessageEvent commentStamp: 'mt 4/10/2011 11:17:28.228' prior: 0!
This system event is used to send text messages targeted at classes or messages. Different message kinds allow visual customization.!

!SdMessageEvent class methodsFor: 'accessing' stamp: 'mt 4/10/2011 11:05:10.142'!
changeKind

	^ #Message! !

!SdMessageEvent class methodsFor: 'accessing' stamp: 'mt 4/10/2011 11:06:00.826'!
supportedKinds

	^ {self classKind. self methodKind}! !

!SdMessageEvent class methodsFor: 'instance creation' stamp: 'mt 4/10/2011 11:16:43.624'!
text: stringOrText class: aClass

	^ self
		text: stringOrText
		kind: #information
		class: aClass! !

!SdMessageEvent class methodsFor: 'instance creation' stamp: 'mt 4/10/2011 11:16:26.427'!
text: stringOrText kind: messageKind class: aClass

	| instance |
	instance := self class: aClass.
	instance
		messageKind: messageKind;  
		text: stringOrText.
	^ instance! !

!SdMessageEvent methodsFor: 'testing' stamp: 'mt 4/10/2011 11:18:29.019'!
isError

	^ self messageKind = #error! !

!SdMessageEvent methodsFor: 'testing' stamp: 'mt 4/10/2011 11:18:11.069'!
isInformation

	^ self messageKind = #information! !

!SdMessageEvent methodsFor: 'testing' stamp: 'mt 4/10/2011 11:18:19.13'!
isWarning

	^ self messageKind = #warning! !

!SdMessageEvent methodsFor: 'accessing' stamp: 'mt 4/10/2011 11:17:02.382'!
messageKind
	"The kind of a message can be used to display it differently."
	
	^ messageKind ifNil: [#information]! !

!SdMessageEvent methodsFor: 'accessing' stamp: 'mt 4/10/2011 11:15:53.638'!
messageKind: aSymbol
	"#information, #warning, #error"
	
	messageKind := aSymbol! !

!SdMessageEvent methodsFor: 'printing' stamp: 'mt 4/10/2011 11:06:36.472'!
printEventKindOn: aStream

	aStream nextPutAll: 'Message'! !

!SdMessageEvent methodsFor: 'accessing' stamp: 'mt 4/10/2011 11:09:44.207'!
text

	^ text! !

!SdMessageEvent methodsFor: 'accessing' stamp: 'mt 4/10/2011 11:09:54.777'!
text: aText

	text := aText.! !

!SdMessageEvent methodsFor: 'triggering' stamp: 'mt 4/10/2011 11:24:38.657'!
trigger

	SystemChangeNotifier uniqueInstance trigger: self.! !

UiTextEdit subclass: #SdSourceCodeEdit
	instanceVariableNames: 'theClass completionController doItReceiver doItContext'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sight-Dynamic-UI-Support'!

!SdSourceCodeEdit commentStamp: 'mt 3/24/2011 11:22:15.769' prior: 0!
This is a text edit to modify a method's source.!

SdSourceCodeEdit subclass: #SdClassDefinitionEdit
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sight-Dynamic-UI-Support'!

!SdClassDefinitionEdit class methodsFor: 'accessing' stamp: 'mt 4/19/2011 10:29:58.038'!
widgetClassIcon

	^ UiFugueIcons scriptTextIcon! !

!SdClassDefinitionEdit class methodsFor: 'accessing' stamp: 'mt 4/19/2011 10:29:10.332'!
widgetClassName

	^ 'Class Definition Edit'! !

!SdClassDefinitionEdit methodsFor: 'evaluation' stamp: 'mt 6/21/2012 17:12:26.961'!
compile
	"Just evaluate the code to update the class definition."

	self evaluate.
	^ true! !

!SdClassDefinitionEdit methodsFor: 'accessing' stamp: 'mt 6/21/2012 17:42:47.398'!
theClass: aClassOrMetaClass

	theClass := aClassOrMetaClass.
	self textMorph styler classOrMetaClass: nil.! !

SdSourceCodeEdit subclass: #SdMethodSourceCodeEdit
	instanceVariableNames: 'selector'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sight-Dynamic-UI-Support'!

!SdMethodSourceCodeEdit methodsFor: 'evaluation' stamp: 'mt 6/21/2012 17:23:42.102'!
compile

	self theClass ifNil: [^ true].

	[self theClass
		compile: self theText
		classified: (MethodReference
			class: self theClass
			selector: self selector) category.
			
	self updateSelector.
	
	^ true]
		on: SyntaxErrorNotification "Manual catch to disable interactive compilation."
		do: [:err | 
			Transcript cr; show: '[Syntax] ', err asString.
			(SdMessageEvent
				text: 'Compilation failed: ', self theClass asString, ' >> ', self selector asString
				kind: #warning
				class: self theClass) trigger.
				
			self notify: err errorMessage at: err location in: err messageText.
			
			^ false]
		on: Error
		do: [:err |
			Transcript cr; show: '[Error] ', err asString.
			(SdMessageEvent
				text: 'Compilation error: ', self theClass asString, ' >> ', self selector asString
				kind: #error
				class: self theClass) trigger.
				
			^ false].! !

!SdMethodSourceCodeEdit methodsFor: 'drawing' stamp: 'mt 6/21/2012 17:06:45.918'!
drawOverlayOn: aCanvas

	| font overlay |
	super drawOverlayOn: aCanvas.
	
	(self selector isNil or: [self visible not] or: [self hasKeyboard])
		ifTrue: [^ self].

	self displayMode == #highlight
		ifTrue: [^ self].

	font := self textMorph textStyle fontOfPointSize: 11. 
	overlay := self overlayText asMorph.
	overlay font: font.
	overlay
		topLeft: self topLeft + self margins topLeft;
		wrapFlag: true;
		width: self width;
		autoFit: true.
			
	aCanvas
		fillRectangle: overlay bounds
		color: self color.
			
	aCanvas
		fillRectangle: self bounds
		color: (self color alpha: 0.5).
	
	overlay fullDrawOn: aCanvas.! !

!SdMethodSourceCodeEdit methodsFor: 'evaluation - support' stamp: 'mt 6/21/2012 17:04:26.785'!
notify: aMessage at: aLocation in: aSource

	| message |
	self textMorph editor selectAt: aLocation.
	
	"Trigger manual focus changes. Should be automatic on selection changed?"
	self onFocusChanged: (self textMorph editor pointBlock).
	
	message := ((UiMessage information: aMessage)
		topLeft: (self textMorph localPointToGlobal: (self textMorph editor pointBlock bottomLeft))).
	message openInWorld.! !

!SdMethodSourceCodeEdit methodsFor: 'drawing' stamp: 'mt 6/21/2012 17:06:52.667'!
overlayText

	| result |
	result := '<b>{1}{3}{2}</b>' format: {
		"underline metaclass selectors"
		self theClass isMeta ifTrue: ['<u>'] ifFalse: [''].
		self theClass isMeta ifTrue: ['</u>'] ifFalse: [''].
		self selector asString escapeHtmlText escapeHtmlText "due to #format:"}.
	^ result asHtmlText! !

!SdMethodSourceCodeEdit methodsFor: 'evaluation' stamp: 'mt 6/21/2012 17:04:49.592'!
parse

	| helper |
	self theClass ifNil: [^ true].
	
	helper := SdParserHelper new
		text: self theText;
		view: self.
	
	[Parser new
		parse: self theText asString readStream
		class: self theClass
		category: (MethodReference
			class: self theClass
			selector: self selector) category
		noPattern: false
		context: nil
		notifying: helper
		ifFail: [^ false]]
		on: ParserNotification "Manual catch to disable interactive compilation."
		do: [:err |
			(err isKindOf: UnusedVariable) ifTrue: [
				(SdMessageEvent
					text: 'Unused Variable found: ', self theClass asString, ' >> ', self selector asString
					kind: #information
					class: self theClass) trigger.

				err resume: false].
			
			(err isKindOf: UnknownSelector) ifTrue: [
				self notify: err class name at: helper selection first in: self theText.
				err resume: helper selectedText asString asSymbol].
			
			(SdMessageEvent
				text: 'Parsing failed: ', self theClass asString, ' >> ', self selector asString
				kind: #warning
				class: self theClass) trigger.
				
			self notify: err class name at: helper selection first in: self theText.
			self select: helper selection.
			
			^ false].
		
	^ true! !

!SdMethodSourceCodeEdit methodsFor: 'accessing' stamp: 'mt 6/21/2012 17:02:33.763'!
selector

	^ selector! !

!SdMethodSourceCodeEdit methodsFor: 'accessing' stamp: 'mt 6/21/2012 17:02:29.485'!
selector: aSymbol

	selector := aSymbol.! !

!SdMethodSourceCodeEdit methodsFor: 'accessing' stamp: 'mt 6/21/2012 17:23:59.942'!
sourceCode: someCode

	super sourceCode: someCode.
	self updateSelector.! !

!SdMethodSourceCodeEdit methodsFor: 'evaluation - support' stamp: 'mt 6/21/2012 17:23:32.969'!
updateSelector

	self selector: (Compiler parserClass new parseSelector: self theText asString).! !

!SdSourceCodeEdit class methodsFor: 'testing' stamp: 'mt 4/19/2011 10:27:49.834'!
isWidgetClass

	^ true! !

!SdSourceCodeEdit class methodsFor: 'accessing' stamp: 'mt 4/19/2011 10:28:04.954'!
widgetCategory

	^ 'Sight-Dynamic'! !

!SdSourceCodeEdit class methodsFor: 'accessing' stamp: 'mt 4/19/2011 10:28:53.312'!
widgetClassIcon

	^ UiFugueIcons scriptCodeIcon! !

!SdSourceCodeEdit class methodsFor: 'accessing' stamp: 'mt 4/19/2011 10:28:25.21'!
widgetClassName

	^ 'Source Code Edit'! !

!SdSourceCodeEdit methodsFor: 'actions' stamp: 'mt 6/21/2012 17:10:20.518'!
acceptChanges

	self readOnly
		ifTrue: [^ self].

	self hasUnacceptedChanges
		ifFalse: [^ self].
		
	(self parse and: [self compile])
		ifTrue: [^ super acceptChanges].
		
	self grabKeyboard.! !

!SdSourceCodeEdit methodsFor: 'evaluation' stamp: 'mt 6/21/2012 17:11:58.051'!
compile

	^ true! !

!SdSourceCodeEdit methodsFor: 'completion' stamp: 'mt 4/25/2011 17:54:08.899'!
completionController

	^ completionController ifNil: [
		completionController := SdCompletionController model: self]! !

!SdSourceCodeEdit methodsFor: 'do-its' stamp: 'mt 5/23/2011 11:11:00.174'!
doItContext

	^ doItContext! !

!SdSourceCodeEdit methodsFor: 'do-its' stamp: 'mt 5/23/2011 11:11:21.82'!
doItContext: aContext

	doItContext := aContext.! !

!SdSourceCodeEdit methodsFor: 'do-its' stamp: 'mt 5/23/2011 11:11:05.1'!
doItReceiver

	^ doItReceiver! !

!SdSourceCodeEdit methodsFor: 'do-its' stamp: 'mt 5/23/2011 11:11:11.682'!
doItReceiver: anObject

	doItReceiver := anObject.! !

!SdSourceCodeEdit methodsFor: 'drawing' stamp: 'mt 6/21/2012 14:41:03.516'!
drawOn: aCanvas

	| c |
	super drawOn: aCanvas.
	
	self hasKeyboard ifTrue: [c := self colorFocusBorder].
	
	c ifNotNil: [
			
		aCanvas
			line: self topLeft + (0@1) to: self topRight + (-1@1) color: (c alpha: 0.5);
			line: self topLeft + (0@2) to: self topRight + (-1@2) color: (c alpha: 0.2).
			
		aCanvas
			line: self topLeft + (1@1) to: self bottomLeft + (1@ -1) color: (c alpha: 0.5);
			line: self topLeft + (2@2) to: self bottomLeft + (2@ -1) color: (c alpha: 0.2).
		
		aCanvas
			frameRectangle: self innerBounds
			color: (c alpha: 0.8)].! !

!SdSourceCodeEdit methodsFor: 'evaluation' stamp: 'mt 6/21/2012 17:09:02.172'!
evaluate

	^ Compiler evaluate: self theText asString! !

!SdSourceCodeEdit methodsFor: 'evaluation' stamp: 'mt 7/31/2011 15:13:35.64'!
evaluateSelection

	^ self textMorph editor evaluateSelection! !

!SdSourceCodeEdit methodsFor: 'signals' stamp: 'mt 6/28/2011 16:45:56.296'!
focusChanged: aGlobalRectangle

	self emitInOwnerChain.! !

!SdSourceCodeEdit methodsFor: 'completion' stamp: 'mt 4/28/2011 10:46:02.507'!
guessTypeForName: aString

	^ nil! !

!SdSourceCodeEdit methodsFor: 'initialization' stamp: 'mt 6/21/2012 14:49:32.323'!
initialize
	
	super initialize.
	
	self textMorph
		font: Preferences standardCodeFont;
		styler: SdTextStyler new;
		margins: (4@0 corner: 4@0).
	
	self connect: self textMorph signal: #focusChanged: toSelector: #onFocusChanged:.

	self connect: self eventHandler signal: #mouseWheelUp: toSelector: #mouseWheelUp:.
	self connect: self eventHandler signal: #mouseWheelDown: toSelector: #mouseWheelDown:.! !

!SdSourceCodeEdit methodsFor: 'signals' stamp: 'mt 4/28/2011 14:18:09.888'!
mouseWheelDown: aMouseEvent

	self verticalScrollBarPolicy ~= #alwaysOff
		ifTrue: [^ self].
		
	self emitAlways.! !

!SdSourceCodeEdit methodsFor: 'signals' stamp: 'mt 4/28/2011 14:18:15.519'!
mouseWheelUp: aMouseEvent

	self verticalScrollBarPolicy ~= #alwaysOff
		ifTrue: [^ self].

	self emitAlways.! !

!SdSourceCodeEdit methodsFor: 'actions' stamp: 'mt 4/8/2011 12:13:17.821'!
onFocusChanged: aLocalRectangle

	self focusChanged:
		((self textMorph localPointToGlobal: aLocalRectangle topLeft)
		extent: aLocalRectangle extent).! !

!SdSourceCodeEdit methodsFor: 'accessing' stamp: 'mt 6/30/2011 11:54:40.735'!
optimalWidth
	"Override to ignore comments."
	
	| maxWidth |
	maxWidth := 0.

	((self theText asString copyWithRegex: '"[^"]*"' matchesReplacedWith: '')
		copyReplaceAll: String tab with: '   ')
	   linesDo: [:line | 
			maxWidth := maxWidth max: (self textMorph textStyle defaultFont widthOfString: line)].
		
	^ maxWidth + self scrollBarThickness + 20 ! !

!SdSourceCodeEdit methodsFor: 'evaluation' stamp: 'mt 6/21/2012 17:05:10.837'!
parse

	^ true! !

!SdSourceCodeEdit methodsFor: 'do-its' stamp: 'mt 5/23/2011 11:16:24.276'!
selectedClass

	^ self doItReceiver class! !

!SdSourceCodeEdit methodsFor: 'completion' stamp: 'mt 4/25/2011 17:39:48.348'!
selectedClassOrMetaClass

	^ self theClass! !

!SdSourceCodeEdit methodsFor: 'accessing' stamp: 'mt 6/9/2011 13:50:53.428'!
selectedSelector
	"If possible, return the selector that is behind the current selection."
	
	^ self textMorph editor selectedSelector! !

!SdSourceCodeEdit methodsFor: 'accessing' stamp: 'mt 6/21/2012 17:20:27.191'!
sourceCode

	^ self theText! !

!SdSourceCodeEdit methodsFor: 'accessing' stamp: 'mt 6/21/2012 17:20:36.342'!
sourceCode: someCode

	self theText: someCode.! !

!SdSourceCodeEdit methodsFor: 'accessing' stamp: 'mt 3/24/2011 11:01:05.836'!
theClass

	^ theClass! !

!SdSourceCodeEdit methodsFor: 'accessing' stamp: 'mt 6/21/2012 14:25:29.058'!
theClass: aClassOrMetaClass

	theClass := aClassOrMetaClass.
	self textMorph styler classOrMetaClass: theClass.! !

UiTransformMorph subclass: #SdTransformMorph
	instanceVariableNames: 'footer icon text background'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sight-Dynamic-UI-Support'!

!SdTransformMorph methodsFor: 'accessing' stamp: 'mt 7/1/2011 22:15:45.925'!
background

	^ background! !

!SdTransformMorph methodsFor: 'accessing' stamp: 'mt 7/1/2011 22:15:54.341'!
background: aForm

	background := aForm.
	self redrawLater.! !

!SdTransformMorph methodsFor: 'drawing' stamp: 'mt 7/1/2011 22:16:34.181'!
drawBackgroundOn: aCanvas

	self background ifNil: [^ self].
	
	aCanvas
		clipBy: self bounds
		during: [:c | c
			paintImage: self background
			at: self topLeft - ((self background width - self width)@0)].! !

!SdTransformMorph methodsFor: 'drawing' stamp: 'mt 7/1/2011 22:35:32.781'!
drawFooterOn: aCanvas

	footer ifNil: [^ self].

	footer asMorph
		bottomRight: self bottomRight - (5@0);
		fullDrawOn: aCanvas.! !

!SdTransformMorph methodsFor: 'drawing' stamp: 'mt 7/1/2011 16:45:20.185'!
drawInnerShadowOn: aCanvas

	| c |
	c := Color black.

	aCanvas
		line: self topLeft + (0@1) to: self topRight + (-1@1) color: (c alpha: 0.5);
		line: self topLeft + (0@2) to: self topRight + (-1@2) color: (c alpha: 0.2).
			
	aCanvas
		line: self topLeft + (1@1) to: self bottomLeft + (1@ -1) color: (c alpha: 0.5);
		line: self topLeft + (2@2) to: self bottomLeft + (2@ -1) color: (c alpha: 0.2).
		
	aCanvas
		frameRectangle: self innerBounds
		color: (c alpha: 0.8).! !

!SdTransformMorph methodsFor: 'drawing' stamp: 'mt 7/1/2011 22:04:18.184'!
drawMessageOn: aCanvas

	| textMorph |
	self text ifNil: [^ self].
	
	"Only show a message if no real content is there."
	(self firstSubmorph ifNotNil: [:m | m submorphs size > 1])
		ifTrue: [^ self].
		
	textMorph := self text asMorph.
	textMorph topLeft: self topLeft + (self extent - textMorph extent // 2) + (self icon width + 5 @ 0).
	
	textMorph fullDrawOn: aCanvas.
	
	aCanvas
		translucentImage: self icon
		at: textMorph topLeft - (self icon width + 5 @ -2).! !

!SdTransformMorph methodsFor: 'drawing' stamp: 'mt 6/19/2012 16:01:09.157'!
drawOn: aCanvas

	super drawOn: aCanvas.
	
	self
		drawBackgroundOn: aCanvas;
		drawInnerShadowOn: aCanvas;
		drawFooterOn: aCanvas.! !

!SdTransformMorph methodsFor: 'accessing' stamp: 'mt 7/1/2011 22:18:36.034'!
footer

	^ footer! !

!SdTransformMorph methodsFor: 'accessing' stamp: 'mt 7/1/2011 22:18:43.691'!
footer: aText

	footer := aText.
	self redrawLater.! !

!SdTransformMorph methodsFor: 'accessing' stamp: 'mt 7/1/2011 22:09:37.618'!
icon

	^ icon ifNil: [Form extent: 0@0]! !

!SdTransformMorph methodsFor: 'accessing' stamp: 'mt 7/1/2011 21:52:17.797'!
icon: anIcon

	icon := anIcon.
	self redrawLater.! !

!SdTransformMorph methodsFor: 'accessing' stamp: 'mt 7/1/2011 21:52:36.259'!
text

	^ text! !

!SdTransformMorph methodsFor: 'accessing' stamp: 'mt 7/1/2011 21:52:30.03'!
text: aText

	text := aText.
	self redrawLater.! !

UiScrollArea subclass: #SdScrollArea
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sight-Dynamic-UI-Support'!

!SdScrollArea class methodsFor: 'accessing' stamp: 'mt 1/2/2012 17:34:02.777'!
widgetCategory

	^ 'Sight-Dynamic'! !

!SdScrollArea methodsFor: 'accessing' stamp: 'mt 7/1/2011 16:39:50.958'!
transformMorphClass

	^ SdTransformMorph! !

PluggableTextAttribute subclass: #SdInformationLink
	instanceVariableNames: 'color'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sight-Dynamic-Support'!

!SdInformationLink class methodsFor: 'instance creation' stamp: 'mt 7/31/2011 13:59:08.688'!
argument

	^ self new color: (Color r: 69/255 g: 115/255 b: 213/255)! !

!SdInformationLink class methodsFor: 'instance creation' stamp: 'mt 7/31/2011 13:58:54.104'!
message

	^ self new color: (Color r: 69/255 g: 115/255 b: 213/255)! !

!SdInformationLink methodsFor: 'accessing' stamp: 'mt 7/18/2011 16:38:07.651'!
color

	^ color ifNil: [Purple]! !

!SdInformationLink methodsFor: 'accessing' stamp: 'mt 7/18/2011 16:38:15.793'!
color: aColor

	color := aColor.! !

!SdInformationLink methodsFor: 'styling' stamp: 'mt 7/18/2011 16:58:05.489'!
emphasizeScanner: scanner

	scanner
		textColor: self color;
		addEmphasis: 4 "underlined".! !

BorderedMorph subclass: #SdIDE
	instanceVariableNames: 'toolbar finder windowSize windowBounds tapeContainer leftFixedTape rightFixedTape'
	classVariableNames: 'Images'
	poolDictionaries: ''
	category: 'Sight-Dynamic'!

!SdIDE class methodsFor: 'application' stamp: 'mt 3/22/2012 17:06:31.067'!
appName

	^ 'vivide'! !

!SdIDE class methodsFor: 'application' stamp: 'mt 5/2/2011 16:08:42.089'!
appVersion

	^ (Smalltalk at: #ConfigurationOfSightDynamic ifAbsent: [])
		ifNotNil: [:conf | [conf project currentVersion] on: Error do: []]! !

!SdIDE class methodsFor: 'application' stamp: 'mt 5/5/2011 17:11:27.832'!
appVersionString

	^ self appName, ' ', (self appVersion
		ifNil: ['*unknown version*']
		ifNotNil: [:version | version versionString, (version blessing == #development
			ifTrue: [' *dev*']
			ifFalse: [''])])! !

!SdIDE class methodsFor: 'images' stamp: 'mt 7/8/2011 11:59:45.495'!
background1

	^ self images
		at: #background1
		ifAbsentPut:[Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self background1Contents readStream)].! !

!SdIDE class methodsFor: 'images' stamp: 'mt 7/1/2011 16:12:34.84'!
background1Contents

 ^ 'iVBORw0KGgoAAAANSUhEUgAABAAAAAMACAQAAAAQs92GAAAACXBIWXMAAAsTAAALEwEAmpwY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'! !

!SdIDE class methodsFor: 'images' stamp: 'mt 7/8/2011 11:59:36.104'!
images

	^ Images ifNil: [Images := Dictionary new]! !

!SdIDE class methodsFor: 'instance creation' stamp: 'mt 5/1/2011 19:56:17.766'!
open

	^ self new open! !

!SdIDE class methodsFor: 'images' stamp: 'mt 7/1/2011 16:31:32.361'!
resetImages

	Images := Dictionary new.! !

!SdIDE methodsFor: 'initialization' stamp: 'mt 6/20/2012 13:54:32.817'!
addTape

	| scrollArea |
	scrollArea := UiScrollArea new
		verticalScrollBarPolicy: #alwaysOff;
		horizontalScrollBarPolicy: #asNeeded;  
		widgetResizable: true;
		widget: SdUnboundedTape new;
		outerBorderWidth: 0.
		
	scrollArea transformMorph
		color: Color transparent;
		drawCacheActive: true. "speedup redraw"

	scrollArea horizontalScrollBar
		singleStep: 50;
		outerBorderWidth: 1;
		color: Color transparent.
			
	scrollArea sgConnectSignal: #focusChanged: toSelector: #scrollToShowGlobal:.
	
	self connect: scrollArea widget signal: #closed to: scrollArea selector: #delete.
	
	self tapeContainer addMorphBack: scrollArea.! !

!SdIDE methodsFor: 'accessing' stamp: 'mt 6/15/2012 11:25:15.114'!
columns

	^ self columnsFixed, self columnsScrollable! !

!SdIDE methodsFor: 'accessing' stamp: 'mt 6/18/2012 16:13:09.303'!
columnsFixed

	^ self submorphs select: [:m | m isKindOf: SdColumn]

! !

!SdIDE methodsFor: 'accessing' stamp: 'mt 6/18/2012 16:13:02.592'!
columnsScrollable

	^ self tapes gather: [:tape | tape columns]

! !

!SdIDE methodsFor: 'initialization' stamp: 'mt 6/19/2012 15:34:37.919'!
createActionButtons
		
	| actions |
	actions :={
		{'Add tape'. UiFugueIcons layoutSplitVerticalIcon. #addTape}.
		{'Toggle full screen'. UiFugueIcons applicationResizeFullIcon. #toggleFullScreen}}.
		
	^ actions collect: [:spec |
			| button |
			button := UiToolButton new
				color: Color blue muchLighter;
				buttonStyle: #iconOnly;
				icon: spec second;
				balloonText: spec first;
				layoutInset: (2@3 corner: 2@3).
			self connect: button signal: #clicked: toSelector: spec third.
			button].! !

!SdIDE methodsFor: 'initialization' stamp: 'mt 6/19/2012 15:34:50.969'!
createToolbarButtons
		
	^ ((SdEditor allSubclasses sortBy: [:c1 :c2 | c1 editorGroup <= c2 editorGroup])
		select: [:editorClass | editorClass isStandAlone]
		thenCollect: [:editorClass |
			| button |
			button := SdDraggableButton new
				buttonStyle: #iconOnly;
				icon: editorClass editorIcon;
				balloonText: editorClass editorDescription;
				layoutInset: (2@3 corner: 2@3);
				passenger: editorClass editorIcon asMorph;
				target: editorClass.
			button]), self createActionButtons! !

!SdIDE methodsFor: 'accessing' stamp: 'mt 6/18/2012 16:15:30.874'!
editors

	^ self columns gather: [:column | column editors]! !

!SdIDE methodsFor: 'accessing' stamp: 'mt 6/15/2012 16:16:51.972'!
focusedEditor

	self flag: #wrong.
	^ self editors detect: [:editor | editor hasAnyKeyboard] ifNone: []! !

!SdIDE methodsFor: 'events-processing' stamp: 'mt 3/23/2012 14:12:29.057'!
handleListenEvent: aKeyboardEvent

	"<Ctrl-Shift-f>"
	(aKeyboardEvent isKeystroke
		and: [aKeyboardEvent controlKeyPressed]
		and: [aKeyboardEvent shiftPressed]
		and: [aKeyboardEvent keyValue = 6]
		"and: [self hasAnyKeyboard]")
		ifTrue: [self showFinder].! !

!SdIDE methodsFor: 'accessing' stamp: 'mt 6/28/2011 14:53:17.93'!
ide

	^ self! !

!SdIDE methodsFor: 'initialization' stamp: 'mt 6/20/2012 13:49:11.603'!
initialize

	super initialize.
	
	self
		changeTableLayout;
		listDirection: #leftToRight;
		cellInset: -1.  
		
	self
		initializeToolbar;
		initializeFinder;
		initializeEvents;
		initializeTapeContainer; addTape;
		initializeFixedTapes.
	 	
	self addAllMorphs: {toolbar.leftFixedTape.tapeContainer.rightFixedTape}.

	leftFixedTape hideFull.
	rightFixedTape hideFull.! !

!SdIDE methodsFor: 'initialization' stamp: 'mt 6/22/2011 13:18:49.746'!
initializeEvents

	ActiveHand addKeyboardListener: self.! !

!SdIDE methodsFor: 'initialization' stamp: 'mt 6/18/2012 16:54:59.93'!
initializeFinder

	finder := SdItemFinder new.
	
	"self connect: finder signal: #methodChosen: toSelector: #openMethod:.
	self connect: finder signal: #classChosen: toSelector: #openClass:.
	self connect: finder signal: #packageChosen: toSelector: #openPackage:.
	self connect: finder signal: #categoryChosen: toSelector: #openCategory:.
	self connect: finder signal: #protocolChosen:class: toSelector: #openProtocol:class:."! !

!SdIDE methodsFor: 'initialization' stamp: 'mt 6/19/2012 15:15:50.648'!
initializeFixedTapes

	leftFixedTape := SdFixedTape new vResizing: #spaceFill.
	rightFixedTape := SdFixedTape new vResizing: #spaceFill.
	
	self connect: tapeContainer signal: #editorDroppedInFrontOfMe: to: leftFixedTape selector: #addColumnFor:.
	self connect: tapeContainer signal: #editorDroppedAfterMe: to: rightFixedTape selector: #addColumnFor:.! !

!SdIDE methodsFor: 'initialization' stamp: 'mt 6/19/2012 14:03:10.682'!
initializeScrollArea

	scrollArea := SdScrollArea new
		hResizing: #spaceFill;
		vResizing: #spaceFill;
		verticalScrollBarPolicy: #alwaysOff;
		horizontalScrollBarPolicy: #asNeeded;  
		widgetResizable: true;
		widget: (Morph new color: Color transparent);
		outerBorderWidth: 0.
		
	scrollArea transformMorph
		color: (Color gray: 0.3);
		background: SdIDE background1;
		icon: UiFugueIcons arrow180MediumIcon asGrayScale2;
		text: '<font color="#888888">Choose a tool from the side bar and start development.</font>' asHtmlText;
		footer: ('<font color="#888888">', SdIDE appVersion versionString, '</font>') asHtmlText.
	scrollArea horizontalScrollBar
		singleStep: 50;
		outerBorderWidth: 1;
		color: (Color gray: 0.3).  
		
	"Speedup redraw."
	scrollArea transformMorph drawCacheActive: true.  
		
	scrollArea widget
		layoutPolicy: SdTapeLayout new.
		
	border := SdShadow new
		changeTableLayout;
		vResizing: #spaceFill;
		hResizing: #rigid;
		width: 20.
	border addAllMorphs: self createToolbarButtons.
	
	scrollArea widget addMorph: border.
	
	scrollArea sgConnectSignal: #focusChanged: toSelector: #scrollToShowGlobal:.! !

!SdIDE methodsFor: 'initialization' stamp: 'mt 6/19/2012 14:35:47.461'!
initializeTapeContainer

	tapeContainer := SdTapeContainer new.! !

!SdIDE methodsFor: 'initialization' stamp: 'mt 7/2/2011 09:32:00.086'!
initializeToolbar

	toolbar := SdColumnToolBar new.
	toolbar addAllMorphs: self createToolbarButtons.! !

!SdIDE methodsFor: 'visiting' stamp: 'mt 7/4/2011 17:48:24.148'!
loadState: anEditorState

	anEditorState loadIDE: self.! !

!SdIDE methodsFor: 'focus' stamp: 'mt 6/28/2011 14:45:49.441'!
onFocusChanged: aGlobalRectangle

	scrollArea scrollToShow: 
		((scrollArea widget globalPointToLocal: aGlobalRectangle topLeft)
			extent: aGlobalRectangle extent).! !

!SdIDE methodsFor: 'initialization' stamp: 'mt 2/12/2012 15:11:32.309'!
open
	
	| window |

	self extent: 800@500.

	window := (SdSystemWindow
		morph: self
		label: self class appName).
	
	self connect: window signal: #aboutRequested toSelector: #showAbout.
	
	self
		color: (Color gray: 0.85);
		borderColor: Color black.! !

!SdIDE methodsFor: 'visiting' stamp: 'mt 7/4/2011 15:29:59.046'!
saveState: anEditorState

	anEditorState saveIDE: self.! !

!SdIDE methodsFor: 'focus' stamp: 'mt 5/9/2012 11:57:49.672'!
scrollToShow: anEditor
	"Editor needs to be inside the scrolling container."
	
	scrollArea layoutChanged; fullBounds. "force re-layout"
	SdFadingToolbar hideAllToolbars.
	scrollArea
		scrollToShow: (anEditor bounds outsetBy: 50) "show a little bit of the stuff around the editor"
		duration: 250.! !

!SdIDE methodsFor: 'actions' stamp: 'mt 5/5/2011 17:08:16.065'!
showAbout

	| msg |
	msg := SdOverlayMessageBox new
		title: 'About "', self class appName, '"'.

	self class appVersion
		ifNil: [msg message: 'Could not fetch current version information!!' icon: UiFugueIcons exclamationFrameIcon]
		ifNotNil: [:version | | message |
			message := 'Current version:<br>   <font color="#00AA00">', version asString escapeHtmlText, '</font>'.
			message := message, '<br><br>Other modules:'.
			#(Animations Signals Widgets) do: [:suffix | 
				message := message, '<br>   ', (Smalltalk at: (#ConfigurationOf, suffix) asSymbol) project currentVersion asString escapeHtmlText].
			msg message: message icon: UiSilkIcons informationIcon].

	msg addAction: 'Close' icon: UiSilkIcons acceptIcon.
	
	msg showAbove: self.  ! !

!SdIDE methodsFor: 'actions' stamp: 'mt 6/22/2011 13:05:30.79'!
showFinder

	| container |
	finder owner ifNotNil: [:o | o delete].
	
	container := Morph new
		color: (Color black alpha: 0.5);
		changeProportionalLayout;
		disableTableLayout: true;
		cellPositioning: #topCenter.
		
	container addMorph: finder.

	finder
		frameFractions: (0.3@0.5 corner: 0.7@1.0);
		hResizing: #spaceFill.
	
	container bounds: self bounds.

	self addMorphFront: container.
	
	finder grabKeyboard.! !

!SdIDE methodsFor: 'accessing' stamp: 'mt 6/15/2012 16:03:51.418'!
tapeContainer

	^ tapeContainer! !

!SdIDE methodsFor: 'accessing' stamp: 'mt 6/15/2012 16:14:49.436'!
tapes

	^ self tapeContainer submorphs collect: [:scrollArea |
		scrollArea widget].! !

!SdIDE methodsFor: 'actions' stamp: 'mt 3/22/2012 15:17:31.676'!
toggleFullScreen

	| isFullScreen |
	isFullScreen := self owner == ActiveWorld.
	
	isFullScreen
		ifTrue: [self open bounds: windowBounds]
		ifFalse: [windowBounds := self owner bounds. self owner delete. self openInWorld. self bounds: ActiveWorld bounds].! !

!SdIDE methodsFor: 'events-processing' stamp: 'mt 3/23/2012 09:29:59.17'!
yellowButtonActivity: shiftState

	"Do nothing."! !

!Morph methodsFor: '*sight-dynamic-signals' stamp: 'mt 6/28/2011 16:49:50.097'!
emitInOwnerChain
	"Special kind of signals that will be handled by the owner-chain."
	
	| signalCtx signal args owner |
	signalCtx := thisContext sender.
	signal := signalCtx method.
	
	"Extract arguments."
	args := Array new: signal numArgs.
	(1 to: signal numArgs) do: [:index |
		args at: index put: (signalCtx tempAt: index)].
	
	"Start handling"
	owner := self.
	[(owner := owner owner) notNil] whileTrue: [
		(owner emitSignalInOwnerChain: signal selector arguments: args sender: self)
			ifTrue: [^ self "Done."]].
	! !

!Morph methodsFor: '*sight-dynamic-signals' stamp: 'mt 6/19/2012 19:11:23.237'!
emitSignalInOwnerChain: signal arguments: args sender: aSender
	"Private. Performs the triggering of callbacks."
	
	| wasHandled |
	wasHandled := true.
	(self signalConnectionsForOwnerChain
		at: signal ifAbsent: [^ false]) keysAndValuesDo: [:receiver :configurations |
			wasHandled := wasHandled and: [configurations allSatisfy: [ :connectionConfiguration |
				| selector pattern filteredArgs |
				selector := connectionConfiguration selector.
				pattern := connectionConfiguration pattern.
					
				filteredArgs := pattern
					ifNil: [args]
					ifNotNil: [pattern mapArguments: args useSender: aSender].
				
				self flag: #fixMe. "mt: Should be somehow possible to filter events."
				(receiver perform: selector withArguments: filteredArgs). true]]].
	^ wasHandled ! !

!Morph methodsFor: '*sight-dynamic' stamp: 'mt 6/28/2011 14:53:07.534'!
ide

	^ self owner ifNotNil: [:o | o ide]! !

!Morph methodsFor: '*sight-dynamic' stamp: 'mt 6/19/2012 17:59:01.663'!
isOverlayConnector

	^ false! !

!Morph methodsFor: '*sight-dynamic-signals' stamp: 'mt 6/19/2012 14:19:23.152'!
sgConnectSignal: aSignal to: aReceiver selector: aSelector

	self
		sgConnectSignal: aSignal
		to: aReceiver
		selector: aSelector
		pattern: nil.! !

!Morph methodsFor: '*sight-dynamic-signals' stamp: 'mt 6/19/2012 14:18:10.897'!
sgConnectSignal: aSignal to: receiver selector: aSelector pattern: argPattern
	"Connect owner-chain-signals with this receiver. Highly dynamic as sender is unknown at the time of connection setup."
	
	| numArgsSender numArgsReceiver fixedPattern |
	"Convert pattern array to custom pattern object."
	fixedPattern := argPattern ifNotNil: [SignalConnectionPattern new mapping: argPattern].
	
	"Check if messages are available."
	(receiver respondsTo: aSelector)
		ifFalse: [Error signal: 'Could not connect signal to receiver!!'].
	
	"Check if sender sends at least enough arguments if pattern is empty."
	numArgsSender := aSignal count: [:c | c = $:].
	numArgsReceiver := aSelector count: [:c | c = $:].
	(numArgsSender < numArgsReceiver and: [fixedPattern isNil])
		ifTrue: [Error signal: 'Could not connect sender to receiver!! Receiver expects more arguments!!'].
	
	"Check if pattern size is correct."
	fixedPattern ifNotNil: [
		((fixedPattern hasIndices not or: [fixedPattern minIndex >= 0])
			and: [numArgsReceiver == fixedPattern size]
			and: [fixedPattern hasIndices not or: [numArgsSender >= fixedPattern maxIndex]])
			ifFalse: [Error signal: 'Could not connect sender to receiver!! Pattern is invalid!!']].
	
	"Auto-truncate unnecessary arguments if pattern is not given."
	(numArgsSender > numArgsReceiver and: [fixedPattern isNil])
		ifTrue: [fixedPattern := SignalConnectionPattern new
			mapping: ((1 to: numArgsReceiver) collect: [:i | i])].

	"Add the connection."
	((self signalConnectionsForOwnerChain
		at: aSignal ifAbsentPut: [WeakIdentityKeyDictionary new])
		at: receiver ifAbsentPut: [OrderedCollection new])
		add: (SignalConnectionConfiguration new
			selector: aSelector;
			pattern: fixedPattern).! !

!Morph methodsFor: '*sight-dynamic-signals' stamp: 'mt 6/19/2012 14:18:37.641'!
sgConnectSignal: aSignal toSelector: aSelector

	self
		sgConnectSignal: aSignal
		to: self
		selector: aSelector
		pattern: nil.! !

!Morph methodsFor: '*sight-dynamic-signals' stamp: 'mt 6/19/2012 14:19:06.658'!
sgConnectSignal: aSignal toSelector: aSelector pattern: aPattern

	self
		sgConnectSignal: aSignal
		to: self
		selector: aSelector
		pattern: aPattern.! !

!Morph methodsFor: '*sight-dynamic-signals' stamp: 'mt 6/19/2012 14:22:33.946'!
sgDisconnectSignal: aSignal from: aReceiver selector: aSelector

	| connections |
	connections := (self signalConnectionsForOwnerChain
		at: aSignal ifAbsent: [^ self])
		at: aReceiver ifAbsent: [^ self].
		
	connections removeAllSuchThat: [:c | c selector == aSelector].
	
	connections ifEmpty: [(self signalConnectionsForOwnerChain at: aSignal) removeKey: self].
	(self signalConnectionsForOwnerChain at: aSignal) ifEmpty: [
		self signalConnectionsForOwnerChain removeKey: aSignal].! !

!Morph methodsFor: '*sight-dynamic-signals' stamp: 'mt 6/19/2012 14:22:50.959'!
sgDisconnectSignal: aSignal fromSelector: aSelector

	self
		sgDisconnectSignal: aSignal
		from: self
		selector: aSelector.! !

!Morph methodsFor: '*sight-dynamic-signals' stamp: 'mt 6/28/2011 15:45:04.011'!
signalConnectionsForOwnerChain

	^ self
		valueOfProperty: #signalConnectionsForOwnerChain
		ifAbsentPut: [Dictionary new]! !

Morph subclass: #SdArtifactContainer
	uses: TSdMemento
	instanceVariableNames: 'artifact infoPanel resizeHandle toolbar summaryContainer'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sight-Dynamic'!

SdArtifactContainer class
	uses: TSdMemento classTrait
	instanceVariableNames: ''!

!SdArtifactContainer methodsFor: 'memento - cleanup' stamp: 'mt 6/21/2012 10:12:38.33'!
aboutToClose

	self emitInOwnerChain.! !

!SdArtifactContainer methodsFor: 'memento - data' stamp: 'mt 6/21/2012 15:53:26.581'!
acceptChanges

	self artifact acceptChanges.! !

!SdArtifactContainer methodsFor: 'accessing' stamp: 'mt 6/21/2012 10:56:06.052'!
artifact

	^ artifact! !

!SdArtifactContainer methodsFor: 'accessing' stamp: 'mt 6/20/2012 18:00:43.344'!
artifact: aMorph

	aMorph = artifact ifTrue: [^ self].
	artifact := aMorph.
	artifact hResizing: #spaceFill.
	
	self artifactChanged: artifact.! !

!SdArtifactContainer methodsFor: 'signals' stamp: 'mt 6/20/2012 17:24:21.314'!
artifactChanged: aMorph

	self emit.! !

!SdArtifactContainer methodsFor: 'geometry - actions' stamp: 'mt 6/21/2012 10:39:34.195'!
collapse

	self
		hideToolbar;
		removeAllMorphs;
		layoutInset: 0;
		addMorph: self summaryContainer;
		collapsed.! !

!SdArtifactContainer methodsFor: 'signals' stamp: 'mt 6/21/2012 10:39:02.511'!
collapsed

	self emit.! !

!SdArtifactContainer methodsFor: 'geometry' stamp: 'mt 6/21/2012 14:51:46.867'!
defaultWidth

	^ 150! !

!SdArtifactContainer methodsFor: 'geometry - actions' stamp: 'mt 6/21/2012 14:46:57.46'!
expand

	self
		removeAllMorphs;
		layoutInset: ((0@15) corner: (0@0));
		addAllMorphs: {
			self infoPanel.
			self artifact.
			self resizeHandle};
		expanded.! !

!SdArtifactContainer methodsFor: 'signals' stamp: 'mt 6/21/2012 10:39:07.944'!
expanded

	self emit.! !

!SdArtifactContainer methodsFor: 'signals' stamp: 'mt 6/21/2012 10:45:35.668'!
focusLostDownwards
	"Keyboard focus should be passed to the next container."

	self emitInOwnerChain.! !

!SdArtifactContainer methodsFor: 'signals' stamp: 'mt 6/21/2012 10:45:30.486'!
focusLostUpwards
	"Keyboard focus should be passed to the previous container."

	self emitInOwnerChain.! !

!SdArtifactContainer methodsFor: 'events' stamp: 'mt 6/21/2012 10:29:47.552'!
grabKeyboard

	self expand.
	self artifact grabKeyboard.! !

!SdArtifactContainer methodsFor: 'events' stamp: 'mt 6/21/2012 10:30:03.698'!
handleMouseMove: evt
	"Handle every mouse move event."

	"Do not handle mouse moves if dragging something."
	evt hand submorphs ifNotEmpty: [^ self].

	^ self mouseMove: evt! !

!SdArtifactContainer methodsFor: 'memento - data' stamp: 'mt 6/21/2012 15:53:24.502'!
hasUnacceptedChanges

	^ self artifact hasUnacceptedChanges! !

!SdArtifactContainer methodsFor: 'toolbar' stamp: 'mt 6/20/2012 17:39:24.447'!
hideToolbar

	self isToolbarVisible
		ifTrue: [self toolbar delete].! !

!SdArtifactContainer methodsFor: 'accessing' stamp: 'mt 6/20/2012 17:08:51.214'!
infoPanel
	^ infoPanel! !

!SdArtifactContainer methodsFor: 'accessing' stamp: 'mt 6/20/2012 17:08:51.268'!
infoPanel: anObject
	infoPanel := anObject! !

!SdArtifactContainer methodsFor: 'initialization' stamp: 'mt 6/21/2012 14:51:38.956'!
initialize
		
	super initialize.
	
	self connect: self signal: #artifactChanged: toSelector: #expand.
	
	self
		initializeEventHandler;
		initializeToolbar;
		initializeResizeHandle;
		initializeSummaryContainer;
		initializeInfoPanel;
		initializeArtifact.
	
	self
		width: self defaultWidth;
		color: Color white;
		clipSubmorphs: true;
		layoutPolicy: SdArtifactContainerLayout new.! !

!SdArtifactContainer methodsFor: 'initialization' stamp: 'mt 6/21/2012 10:23:30.057'!
initializeArtifact! !

!SdArtifactContainer methodsFor: 'initialization' stamp: 'mt 6/21/2012 14:47:31.648'!
initializeEventHandler

	self eventHandler: UiEventHandler new.
	
	self connect: self eventHandler signal: #mouseEntered: toSelector: #showToolbar.
	self connect: self eventHandler signal: #mouseMoved: toSelector: #reopenToolbar.! !

!SdArtifactContainer methodsFor: 'initialization' stamp: 'mt 6/21/2012 14:55:26.888'!
initializeInfoPanel

	infoPanel := 'Artifact' asMorph.! !

!SdArtifactContainer methodsFor: 'initialization' stamp: 'mt 6/20/2012 17:25:13.721'!
initializeResizeHandle

	resizeHandle := SdResizeHandle new
		orientation: #horizontal.
		
	self connect: self signal: #artifactChanged: to: resizeHandle selector: #target:.! !

!SdArtifactContainer methodsFor: 'initialization' stamp: 'mt 6/20/2012 17:33:02.562'!
initializeSummaryContainer

	| closeBtn summaryBtn |
	summaryContainer := Morph new
		color: (Color gray: 0.85);
		changeTableLayout;
		listDirection: #leftToRight;
		vResizing: #shrinkWrap;
		hResizing: #spaceFill.  
	
	summaryBtn := SdDraggableButton new
		color: (Color gray: 0.85);
		autoRaise: true;
		target: self;
		hResizing: #spaceFill.
	
	closeBtn := UiToolButton new
		color: (Color gray: 0.85);
		autoRaise: true;  
		buttonStyle: #iconOnly;
		icon: UiFugueIcons minusWhiteIcon.
	
	summaryContainer
		addMorphBack: summaryBtn;
		addMorphBack: closeBtn.
	
	self connect: summaryBtn signal: #clicked: toSelector: #expand.
	self connect: closeBtn signal: #clicked: toSelector: #tryClose.! !

!SdArtifactContainer methodsFor: 'initialization' stamp: 'mt 6/21/2012 17:34:20.212'!
initializeToolbar

	self toolbar: SdFadingToolbar new.
	self connect: self signal: #expanded toSelector: #showToolbar.
	
	self toolbarActions do: [:action |
		| button |
		action size = 1
			ifTrue: [self toolbar addSpacerToEdge: action first]
			ifFalse: [button := (action sixth ifNil: [UiToolButton]) new
				autoRaise: true;
				color: (Color gray: 0.3);  
				buttonStyle: #iconOnly;
				icon: action third;
				balloonText: action fourth.
		
				self connect: button signal: #clicked: toSelector: action fifth.
				self toolbar addButton: button edge: action first.
				action second ifNotNil: [:iname | self setProperty: iname toValue: button]]].

	"Configure move button for dragging of method editors."
	(self valueOfProperty: #moveBtn) target: self.
	self connect: (self valueOfProperty: #moveBtn) eventHandler signal: #mouseDragStarted: toSelector: #hideToolbar.! !

!SdArtifactContainer methodsFor: 'geometry - testing' stamp: 'mt 6/20/2012 17:41:04.612'!
isCollapsed

	^ self submorphs size = 1 and: [self submorphs first == self summaryContainer]! !

!SdArtifactContainer methodsFor: 'geometry - testing' stamp: 'mt 6/20/2012 17:41:10.656'!
isExpanded

	^ self isCollapsed not! !

!SdArtifactContainer methodsFor: 'toolbar' stamp: 'mt 6/20/2012 17:38:36.002'!
isToolbarVisible

	^ self toolbar notNil and: [self isExpanded]! !

!SdArtifactContainer methodsFor: 'accessing' stamp: 'mt 6/21/2012 10:49:22.906'!
morphsOfInterest

	^ {self artifact}! !

!SdArtifactContainer methodsFor: 'geometry' stamp: 'mt 6/21/2012 10:28:39.171'!
optimalWidth

	^ self isCollapsed
		ifTrue: [0]
		ifFalse: [self artifact width]! !

!SdArtifactContainer methodsFor: 'toolbar' stamp: 'mt 6/20/2012 17:39:10.057'!
reopenToolbar

	self isToolbarVisible
		ifTrue: [self toolbar reopen].! !

!SdArtifactContainer methodsFor: 'accessing' stamp: 'mt 6/20/2012 17:08:51.293'!
resizeHandle
	^ resizeHandle! !

!SdArtifactContainer methodsFor: 'accessing' stamp: 'mt 6/20/2012 17:08:51.308'!
resizeHandle: anObject
	resizeHandle := anObject! !

!SdArtifactContainer methodsFor: 'toolbar' stamp: 'mt 6/20/2012 17:38:55.466'!
showToolbar

	self isToolbarVisible
		ifTrue: [self toolbar popUpFor: self].! !

!SdArtifactContainer methodsFor: 'accessing' stamp: 'mt 6/21/2012 10:38:48.95'!
summaryBtn

	^ self summaryContainer submorphs first! !

!SdArtifactContainer methodsFor: 'accessing' stamp: 'mt 6/20/2012 16:57:14.613'!
summaryContainer
	^ summaryContainer! !

!SdArtifactContainer methodsFor: 'accessing' stamp: 'mt 6/20/2012 16:57:14.628'!
summaryContainer: anObject
	summaryContainer := anObject! !

!SdArtifactContainer methodsFor: 'accessing' stamp: 'mt 6/20/2012 16:57:14.582'!
toolbar
	^ toolbar! !

!SdArtifactContainer methodsFor: 'accessing' stamp: 'mt 6/20/2012 16:57:14.597'!
toolbar: anObject
	toolbar := anObject! !

!SdArtifactContainer methodsFor: 'toolbar' stamp: 'mt 6/21/2012 17:32:57.827'!
toolbarActions

	^ {
	{#top. #moveBtn. UiFugueIcons arrowMoveIcon. 'Move method editor'. #yourself. SdDraggableButton}.
	{#top}.
	{#top. #saveBtn. UiSilkIcons diskIcon. 'Save changed source'. #acceptChanges. nil}.
	{#top. #revertBtn. UiFugueIcons arrowReturn180LeftIcon. 'Discard changed source'. #clear. nil}.

	{#right. nil. UiFugueIcons minusWhiteIcon. 'Close method editor (CMD+W)'. #tryClose. nil}.
	{#right. nil. UiSilkIcons eyeIcon. 'Collapse method editor'. #collapse. nil}.
	}	! !

SdArtifactContainer subclass: #SdClassDefinitionEditor
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sight-Dynamic'!

!SdClassDefinitionEditor methodsFor: 'memento - cleanup' stamp: 'mt 6/21/2012 17:39:14.338'!
clear

	SdFadingToolbar hideAllToolbars.
	self artifact revertChanges.! !

!SdClassDefinitionEditor methodsFor: 'initialization' stamp: 'mt 6/21/2012 17:38:22.913'!
initializeArtifact

	| sourceCodeEdit |
	sourceCodeEdit := SdClassDefinitionEdit new
		outerBorderWidth: 0;
		scrollingMode: #limit;
		colorFocusBackground: Color white;
		colorFocusBorder: (Color gray: 0.3);
		colorBackground: (Color gray: 0.85).
		
	self connect: sourceCodeEdit signal: #editingFinished: toSelector: #updateToolbarButtons.
	self connect: sourceCodeEdit signal: #textChanged: toSelector: #updateToolbarButtons.
	
	"keyboard shortcuts"
	sourceCodeEdit eventHandler on: #(cmd) -> $W send: #tryClose to: self.
	sourceCodeEdit eventHandler on: #(cmd) -> Character arrowUp send: #focusLostUpwards to: self.
	sourceCodeEdit eventHandler on: #(cmd) -> Character arrowDown send: #focusLostDownwards to: self.

	self artifact: sourceCodeEdit.! !

!SdClassDefinitionEditor methodsFor: 'initialization' stamp: 'mt 6/21/2012 17:27:03.231'!
initializeInfoPanel

	infoPanel := UiLabel new.! !

!SdClassDefinitionEditor methodsFor: 'initialization' stamp: 'mt 6/21/2012 17:41:19.533'!
initializeToolbar

	super initializeToolbar.
	self updateToolbarButtons.! !

!SdClassDefinitionEditor methodsFor: 'accessing' stamp: 'mt 6/21/2012 17:25:49.687'!
theClass

	^ self artifact theClass! !

!SdClassDefinitionEditor methodsFor: 'initialization' stamp: 'mt 6/21/2012 17:28:46.076'!
theClass: aClassOrMetaClass

	self artifact
		theClass: aClassOrMetaClass theNonMetaClass;
		sourceCode:
			aClassOrMetaClass theNonMetaClass definition,
			'.', String cr,
			aClassOrMetaClass theMetaClass definition.
		
	self infoPanel text: aClassOrMetaClass theNonMetaClass name.! !

!SdClassDefinitionEditor methodsFor: 'toolbar' stamp: 'mt 6/21/2012 17:48:32.32'!
updateToolbarButtons

	self artifact ifNil: [^ self].

	(self valueOfProperty: #revertBtn)
		visible: self artifact hasUnacceptedChanges.
	(self valueOfProperty: #saveBtn)
		visible: self artifact hasUnacceptedChanges.! !

SdArtifactContainer subclass: #SdMemoEditor
	instanceVariableNames: 'fontList sizeList'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sight-Dynamic'!

!SdMemoEditor methodsFor: 'memento - cleanup' stamp: 'mt 6/25/2012 16:52:32.373'!
clear

	SdFadingToolbar hideAllToolbars.
	self artifact revertChanges.! !

!SdMemoEditor methodsFor: 'initialization' stamp: 'mt 6/25/2012 17:25:26.483'!
initializeArtifact

	| memoEdit |
	memoEdit := UiTextEdit new
		outerBorderWidth: 0.
"		scrollingMode: #always;
		scrollingLimit: 5.
"		
	self connect: memoEdit signal: #editingFinished: toSelector: #updateToolbarButtons.
	self connect: memoEdit signal: #textChanged: toSelector: #updateToolbarButtons.
	self connect: memoEdit textMorph signal: #focusChanged: toSelector: #updateToolbarButtons.
	
	"keyboard shortcuts"
	memoEdit eventHandler on: #(cmd) -> $W send: #tryClose to: self.
	memoEdit eventHandler on: #(cmd) -> Character arrowUp send: #focusLostUpwards to: self.
	memoEdit eventHandler on: #(cmd) -> Character arrowDown send: #focusLostDownwards to: self.

	self artifact: memoEdit.! !

!SdMemoEditor methodsFor: 'initialization' stamp: 'mt 6/25/2012 17:01:47.97'!
initializeInfoPanel

	infoPanel := UiLabel new.
	infoPanel text: '<font color="#AAAAAA"> Memo</font>' asHtmlText.! !

!SdMemoEditor methodsFor: 'initialization' stamp: 'mt 6/25/2012 17:23:04.084'!
initializeToolbar

	super initializeToolbar.

	fontList := UiComboBox new width: 80.
	fontList
		addItemListFrom: {'Text Font' -> Preferences standardDefaultTextFont. 'Code Font' -> Preferences standardCodeFont}
		using: [:fontDescr :item |
			| family |
			family := UiFont getFontFamily: fontDescr value.
			
			item
				text: ((('<font family="{1}" size="9">{2}</font>') format: {family. fontDescr key})) asHtmlText;
				data: family].
	
	self connect: fontList signal: #currentIndexChanged:text: toSelector: #setFontFaceAndSize.	
	self toolbar topPanel addMorphBack: fontList.
	
	sizeList := UiComboBox new width: 40.
	sizeList
		addItemListFrom: #(8 9 10 11 12 14 16)
		using: [:fontSize :item | item text: fontSize asString; data: fontSize].
		
	self connect: sizeList signal: #currentIndexChanged:text: toSelector: #setFontFaceAndSize.	
	self toolbar topPanel addMorphBack: sizeList.
! !

!SdMemoEditor methodsFor: 'as yet unclassified' stamp: 'mt 6/25/2012 17:35:04.728'!
setFontFaceAndSize

	self artifact ifNil: [^ self].
	
	self artifact theText
		addAttribute: (TextFontReference toFont: (StrikeFont
			familyName: fontList currentItem data
			pointSize: sizeList currentItem data))
		from: self artifact selection first
		to: self artifact selection last.
	
	self artifact textMorph stylerStyled: self artifact theText.
"		recompose."
"		updateFromParagraph."
	
	self artifact grabKeyboard.! !

!SdMemoEditor methodsFor: 'as yet unclassified' stamp: 'mt 6/25/2012 17:27:29.897'!
updateToolbarButtons

	| textAttributes |
	textAttributes := self artifact theText attributesAt: self artifact cursorPosition.
	
	textAttributes do: [:textAttribute |
		(textAttribute isKindOf: TextFontReference) ifTrue: [
			fontList currentItem: (fontList list detect: [:item | item data = (UiFont getFontFamily: textAttribute font)]).
			sizeList currentItem: (sizeList list detect: [:item | item data = textAttribute font pointSize])].
		]! !

SdArtifactContainer subclass: #SdMethodEditor
	uses: TSdDynamicAccessor + TSdDynamicMenusForMethod
	instanceVariableNames: 'deleteBtn dynamicBtn'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sight-Dynamic'!

SdMethodEditor class
	uses: TSdDynamicAccessor classTrait + TSdDynamicMenusForMethod classTrait
	instanceVariableNames: ''!

!SdMethodEditor methodsFor: 'converting' stamp: 'mt 5/2/2011 10:47:46.783'!
asString

	^ '{1} >> {2}' format: {
		self theClass name.
		self selector}! !

!SdMethodEditor methodsFor: 'actions' stamp: 'mt 6/21/2012 14:30:04.638'!
changeProtocol: newProtocolName

	self theClass organization
		classify: self selector
		under: newProtocolName
		suppressIfDefault: false.! !

!SdMethodEditor methodsFor: 'memento - cleanup' stamp: 'mt 6/21/2012 17:32:34.497'!
clear

	SdFadingToolbar hideAllToolbars.
	self artifact revertChanges.! !

!SdMethodEditor methodsFor: 'actions' stamp: 'mt 6/21/2012 13:50:56.256'!
createMethodFor: aMethodReference

	aMethodReference isValid ifTrue: [Error signal: 'Method already exists!!'].
	
	(self theClass canUnderstand:
		(Compiler parserClass new parseSelector: self selector))
		ifTrue: ["Will be overridden. Add super call."
			self selector:
				self selector, String cr, String cr, String tab,
				'^ super ', self selector].! !

!SdMethodEditor methodsFor: 'actions' stamp: 'mt 6/21/2012 10:05:40.176'!
deleteMethod

	deleteBtn buttonStyle = #iconOnly
		"User needs to confirm deletion!!"
		ifTrue: [
			deleteBtn buttonStyle: #textBesideIcon.
			self toolbar updateLayout. "new toolbar extent"
			^ self]  
		"User confirmed the deletion..."
		ifFalse: [
			self theClass removeSelector: self selector.
			deleteBtn buttonStyle: #iconOnly.
			self close].! !

!SdMethodEditor methodsFor: 'events - testing' stamp: 'mt 6/21/2012 10:50:52.217'!
hasKeyboard

	^ self artifact hasKeyboard! !

!SdMethodEditor methodsFor: 'dynamic context' stamp: 'mt 6/21/2012 13:28:51.434'!
hideDynamicContext

	self artifact textMorph style.! !

!SdMethodEditor methodsFor: 'initialization' stamp: 'mt 6/21/2012 17:11:05.31'!
initializeArtifact

	| sourceCodeEdit |
	sourceCodeEdit := SdMethodSourceCodeEdit new
		outerBorderWidth: 0;
		scrollingMode: #limit;
		colorFocusBackground: Color white;
		colorFocusBorder: (Color gray: 0.3);
		colorBackground: (Color gray: 0.85).
		
	self connect: sourceCodeEdit signal: #editingFinished: toSelector: #updateToolbarButtons.
	self connect: sourceCodeEdit signal: #textChanged: toSelector: #updateToolbarButtons.

	self connect: sourceCodeEdit eventHandler signal: #keyPressed: toSelector: #toggleDynamicContext:.
	self connect: sourceCodeEdit eventHandler signal: #keyReleased: toSelector: #toggleDynamicContext:.

	"keyboard shortcuts"
	sourceCodeEdit eventHandler on: #(cmd) -> $W send: #tryClose to: self.
	sourceCodeEdit eventHandler on: #(cmd) -> $O send: #requestOpenSelection to: self.
	
	sourceCodeEdit eventHandler on: #(cmd) -> Character arrowUp send: #focusLostUpwards to: self.
	sourceCodeEdit eventHandler on: #(cmd) -> Character arrowDown send: #focusLostDownwards to: self.

	self artifact: sourceCodeEdit.! !

!SdMethodEditor methodsFor: 'initialization' stamp: 'mt 6/21/2012 14:59:25.036'!
initializeInfoPanel

	infoPanel := SdBreadcrumbTrail new.! !

!SdMethodEditor methodsFor: 'initialization' stamp: 'mt 6/21/2012 10:42:10.934'!
initializeSummaryContainer

	super initializeSummaryContainer.
	
	self connect: self signal: #collapsed toSelector: #updateSummaryBtn.! !

!SdMethodEditor methodsFor: 'initialization' stamp: 'mt 6/21/2012 17:36:39.792'!
initializeToolbar

	super initializeToolbar.

	"Set the message, that is displayed to the user to confirm the deletion."	
	(self valueOfProperty: #deleteBtn)
		text: '<font color="#FFFFFF">Sure?</font>'.

	self updateToolbarButtons.! !

!SdMethodEditor methodsFor: 'accessing' stamp: 'mt 7/31/2011 20:16:29.855'!
method

	^ [self theClass >> self selector]
		on: Error do: []! !

!SdMethodEditor methodsFor: 'actions' stamp: 'mt 6/21/2012 16:55:56.984'!
openSymbol: aSymbol
	
	"Guess local selectors."
	(self theClass selectors includes: aSymbol)
		ifTrue: [^ self methodActivated: (MethodReference class: self theClass selector: aSymbol)].
		
	(self theClass theMetaClass selectors includes: aSymbol)
		ifTrue: [^ self methodActivated: (MethodReference class: self theClass theMetaClass selector: aSymbol)].

	"Guess other classes."
	(Smalltalk includesKey: aSymbol) ifTrue: [ | obj |
		obj := Smalltalk at: aSymbol.
		obj isBehavior
			ifTrue: [self classActivated: obj]
			ifFalse: [self objectActivated: obj]].! !

!SdMethodEditor methodsFor: 'geometry' stamp: 'mt 6/21/2012 10:28:18.221'!
optimalWidth

	^ self isCollapsed
		ifTrue: [0]
		ifFalse: [self artifact optimalWidth]! !

!SdMethodEditor methodsFor: 'accessing' stamp: 'mt 4/28/2011 17:54:25.114'!
reference

	^ MethodReference
		class: self theClass
		selector: self selector! !

!SdMethodEditor methodsFor: 'actions' stamp: 'mt 6/21/2012 17:13:39.783'!
requestOpenSelection
	"Take the current selection, convert it into a symbol and request open operation."
	
	self artifact selectedText ifEmpty: [
		"If the cursor is at a text link, follow that link."
		((self artifact theText attributesAt: self artifact cursorPosition)
			detect: [:attr | attr isKindOf: PluggableTextAttribute]
			ifNone: [^ self]) actOnClickFor: nil].
	
	self artifact selectedSelector
		ifNotNil: [:s | self openSymbol: s]
		ifNil: [self openSymbol: self artifact selectedText asString withBlanksTrimmed asSymbol].! !

!SdMethodEditor methodsFor: 'accessing' stamp: 'mt 6/21/2012 10:52:53.459'!
selector

	^ self artifact selector! !

!SdMethodEditor methodsFor: 'dynamic context' stamp: 'mt 6/21/2012 13:33:05.956'!
showDynamicContext
	
	self theClass ifNil: [^ self].
	self method ifNil: [^ self].
	
	"Check whether dynamic information are available at all."
	self method hasMethodExtension ifFalse: [^ self].
	self method methodExtension tests ifEmpty: [^ self].
	
	self
		showDynamicContextForMessageSends;
		showDynamicContextForArguments.
	
	"Redraw text links."
	self artifact textMorph redrawLater.! !

!SdMethodEditor methodsFor: 'dynamic context' stamp: 'mt 6/21/2012 13:35:13.475'!
showDynamicContextForArguments
		
	((SHParserST80 new
		source: self artifact theText asString;
		classOrMetaClass: self theClass;
		parse;
		ranges) select: [:range | range type == #patternArg])
		withIndexDo: [:range :idx |
			self artifact theText
				addAttribute: (SdInformationLink argument
					evalBlock: [self showMenuForArgument: idx])
				from: range start
				to: range end].! !

!SdMethodEditor methodsFor: 'dynamic context' stamp: 'mt 6/21/2012 13:35:30.028'!
showDynamicContextForMessageSends
	"Add a text link to all message sends."
	
	| rootNode searcher |
	[rootNode := RBParser parseMethod: self artifact theText asString]
		on: Error do: [^ self].
	
	searcher := RBParseTreeSearcher new.
	searcher matches: '``@rcv `@msg: ``@args'
		do: [:aNode :answer | answer add: aNode; yourself].
	
	(searcher executeTree: rootNode initialAnswer: OrderedCollection new)
		do: [:node | | selector |
			selector := node selector.
			node selectorParts do: [:token |
				self artifact theText
					addAttribute: (SdInformationLink message
						evalBlock: [self showMenuForMessage: selector])
					from: token start
					to: token stop]].! !

!SdMethodEditor methodsFor: 'dynamic context' stamp: 'mt 6/21/2012 13:28:29.053'!
showMenuForArgument: argIndex
	
	(self menuForArgument: argIndex method: self method)
		popUpAt: ActiveHand position
		forHand: ActiveHand
		in: ActiveWorld
		allowKeyboard: false.! !

!SdMethodEditor methodsFor: 'dynamic context' stamp: 'mt 6/21/2012 13:28:29.165'!
showMenuForMessage: aSymbol
	
	(self menuForMessage: aSymbol method: self method)
		popUpAt: ActiveHand position
		forHand: ActiveHand
		in: ActiveWorld
		allowKeyboard: false.! !

!SdMethodEditor methodsFor: 'actions' stamp: 'mt 6/21/2012 10:36:04.13'!
showMenuForMethod
	
	(self menuForMethod: self method) ifNotNil: [:m | m
		popUpAt: ActiveHand position
		forHand: ActiveHand
		in: ActiveWorld
		allowKeyboard: false].! !

!SdMethodEditor methodsFor: 'accessing' stamp: 'mt 6/21/2012 10:52:48.621'!
theClass

	^ self artifact theClass! !

!SdMethodEditor methodsFor: 'initialization' stamp: 'mt 6/21/2012 17:21:57.565'!
theClass: aClassOrMetaClass selector: aSymbol

	self artifact
		theClass: aClassOrMetaClass;
		selector: aSymbol;
		sourceCode: self method getSource.
		
	self infoPanel setMethod: self method.! !

!SdMethodEditor methodsFor: 'dynamic context' stamp: 'mt 6/21/2012 13:28:29.275'!
toggleDynamicContext: aKeyboardEvent

	"Press control key."
	(aKeyboardEvent isKeyDown
		and: [aKeyboardEvent keyValue == 17
		or: [aKeyboardEvent keyValue == 113]])
		ifTrue: [self showDynamicContext].
	
	"Release control key."	
	(aKeyboardEvent isKeyUp
		and: [aKeyboardEvent keyValue == 17])	
		ifTrue: [self hideDynamicContext].
		
	
	! !

!SdMethodEditor methodsFor: 'toolbar' stamp: 'mt 6/21/2012 17:30:19.256'!
toolbarActions

	^ super toolbarActions, {
		{#top}.
		{#top. #dynamicBtn. UiFugueIcons lightningIcon. 'Access Dynamic Information'. #showMenuForMethod. nil}.
		{#top}.
		{#top. #deleteBtn. UiSilkIcons binIcon. 'Delete selector'. #deleteMethod. nil}.
	
	"EXPERIMENTAL"
	"{#bottom. nil. UiFugueIcons lightningIcon. 'Highlight'. #xToggleHighlight. nil}.
	{#left. nil. UiFugueIcons arrowReturn180LeftIcon. 'Reset'. #xReset}.
	{#left. nil. UiFugueIcons magnifierZoomInIcon. 'Zoom in'. #xScaleUp}.
	{#left. nil. UiFugueIcons magnifierZoomOutIcon. 'Zoom out'. #xScaleDown}.
	{#left. nil. UiSilkIcons fontIcon. 'Change Font'. #xChangeFont}.
	{#left. nil. UiFugueIcons editSizeIcon. 'Override Signature Size'. #xOverrideSignatureSize}.
	{#left. nil. UiSilkIcons commentsDeleteIcon. 'Remove comments'. #xRemoveComments}.
	{#left. nil. UiFugueIcons arrowResizeIcon. 'Remove leading tabs'. #xRemoveLeadingTabs}.
	{#left. nil. UiFugueIcons wandIcon. 'Replace tabs with spaces'. #xReplaceTabsWithSpaces}.
	{#left. nil. UiFugueIcons balloonEllipsisIcon. 'Reduce to four lines'. #xReduceToFourLines}.
	{#left. nil. UiFugueIcons uiScrollBarIcon. 'Use vertical scroll bars'. #xUseScrollBars}"}! !

!SdMethodEditor methodsFor: 'updating' stamp: 'mt 6/21/2012 14:46:00.828'!
updateSummaryBtn

	| result |
	result := (self theClass name, ' >> ', self selector asString) asText.
	self artifact hasUnacceptedChanges
		ifTrue: [result addAttribute: TextEmphasis bold].
	(self theClass notNil and: [self theClass isMeta])
		ifTrue: [result addAttribute: TextEmphasis underlined].
	
	self summaryBtn
		icon: UiFugueIcons scriptCodeIcon;
		text: result.! !

!SdMethodEditor methodsFor: 'toolbar' stamp: 'mt 6/21/2012 17:35:27.636'!
updateToolbarButtons

	self artifact ifNil: [^ self].

	(self valueOfProperty: #revertBtn)
		visible: self artifact hasUnacceptedChanges.
	(self valueOfProperty: #saveBtn)
		visible: self artifact hasUnacceptedChanges.
	(self valueOfProperty: #dynamicBtn)
		visible: (self method ifNil: [false] ifNotNil: [:m | m isTestMethod not]).! !

!SdMethodEditor methodsFor: 'actions - experimental' stamp: 'mt 4/20/2011 16:44:10.34'!
xChangeFont

	| menu |
	menu := MenuMorph new
		defaultTarget: self;
		add: 'Envy Code R' action: #xUseEnvy;
		add: 'Segoe UI' action: #xUseSegoe;
		add: 'Accujen' action: #xUseAccujen.
		
	menu popUpForHand: ActiveHand in: ActiveWorld.! !

!SdMethodEditor methodsFor: 'actions - experimental' stamp: 'mt 4/20/2011 17:38:37.35'!
xOverrideSignatureSize

	| attrs symbols anythingRemoved |
	attrs := self sourceCodeEdit textMorph styler customTextAttributes.
	symbols := #(patternBinary patternKeyword patternUnary).
	anythingRemoved := false.

	symbols do: [:s | (attrs includesKey: s)	ifTrue: [
		anythingRemoved := true.
		attrs removeKey: s]].

	anythingRemoved ifTrue: [^ self].

	symbols do: [:s |
		attrs at: s put: {TextFontReference toFont:
			(self sourceCodeEdit textMorph textStyle fontOfPointSize: 10)}].
		
	self sourceCodeEdit textMorph style.! !

!SdMethodEditor methodsFor: 'actions - experimental' stamp: 'mt 4/20/2011 18:55:32.157'!
xReduceToFourLines
	
	self sourceCodeEdit readOnly: true.  
	
	self sourceCodeEdit theText:
		((((((self theClass >> self selector) getSource asString copyWithRegex: '"[^"]*"' matchesReplacedWith: '')
		lines inject: '' into: [:sum :each | each withBlanksTrimmed
			ifNotEmpty: [sum, ((each startsWith: String tab)
					ifTrue: [each allButFirst: 1]
					ifFalse: [each]), String cr] ifEmpty: [sum]])
		copyWithRegex: '\t' matchesReplacedWith: ' ')
		lines first: 5) inject: '' into: [:sum :each | sum, each, String cr]).
		
	self sourceCodeEdit textMorph style.
	self sourceCodeEdit append: '...'.! !

!SdMethodEditor methodsFor: 'actions - experimental' stamp: 'mt 4/20/2011 18:02:51.206'!
xRemoveComments

	self sourceCodeEdit readOnly: true.
	
	self sourceCodeEdit theText:
		((self sourceCodeEdit theText asString copyWithRegex: '"[^"]*"' matchesReplacedWith: '')
		lines inject: '' into: [:sum :each | each withBlanksTrimmed ifNotEmpty: [sum, each, String cr] ifEmpty: [sum]])
		withBlanksTrimmed.
		
	self sourceCodeEdit textMorph style.! !

!SdMethodEditor methodsFor: 'actions - experimental' stamp: 'mt 4/20/2011 18:15:02.322'!
xRemoveLeadingTabs

	self sourceCodeEdit readOnly: true.
	
	self sourceCodeEdit theText:
		((self theClass >> self selector) getSource asString lines inject: '' into: [:sum :each |
			each withBlanksTrimmed
				ifNotEmpty: [sum, ((each startsWith: String tab)
					ifTrue: [each allButFirst: 1]
					ifFalse: [each]), String cr]
				ifEmpty: [sum]])
		withBlanksTrimmed.
		
	self sourceCodeEdit textMorph style.! !

!SdMethodEditor methodsFor: 'actions - experimental' stamp: 'mt 4/20/2011 18:39:46.937'!
xReplaceTabsWithSpaces

	self sourceCodeEdit readOnly: true.
	
	self sourceCodeEdit theText:
		(self sourceCodeEdit theText asString lines inject: '' into: [:sum :each |
			each withBlanksTrimmed
				ifNotEmpty: [sum, (each copyWithRegex: '\t' matchesReplacedWith: '  '), String cr]
				ifEmpty: [sum]])
		withBlanksTrimmed.
		
	self sourceCodeEdit textMorph style.! !

!SdMethodEditor methodsFor: 'actions - experimental' stamp: 'mt 4/20/2011 18:03:28.368'!
xReset

	self sourceCodeEdit readOnly: false; reset.  ! !

!SdMethodEditor methodsFor: 'actions - experimental' stamp: 'mt 4/20/2011 16:36:23.432'!
xScaleDown

	| textStyle |
	textStyle := self sourceCodeEdit textMorph textStyle.
	self sourceCodeEdit textMorph
		font: (textStyle fontOfPointSize: textStyle defaultFont pointSize - 1);
		recompose.
! !

!SdMethodEditor methodsFor: 'actions - experimental' stamp: 'mt 4/20/2011 16:38:04.541'!
xScaleUp

	| textStyle |
	textStyle := self sourceCodeEdit textMorph textStyle.
	self sourceCodeEdit textMorph
		font: (textStyle fontOfPointSize: textStyle defaultFont pointSize + 1);
		recompose.! !

!SdMethodEditor methodsFor: 'actions - experimental' stamp: 'mt 5/10/2011 17:25:55.129'!
xToggleHighlight

	self ignoresColorMappings
		ifTrue: [self disableHightlight]  
		ifFalse: [self enableHightlight].! !

!SdMethodEditor methodsFor: 'actions - experimental' stamp: 'mt 4/20/2011 16:45:22.452'!
xUseAccujen

	self sourceCodeEdit textMorph
		font: (TextStyle named: #Accujen) defaultFont;
		recompose.! !

!SdMethodEditor methodsFor: 'actions - experimental' stamp: 'mt 4/20/2011 16:45:17.3'!
xUseEnvy

	self sourceCodeEdit textMorph
		font: (TextStyle named: #'Bitmap Envy Code R') defaultFont;
		recompose.! !

!SdMethodEditor methodsFor: 'actions - experimental' stamp: 'mt 4/21/2011 17:01:45.95'!
xUseScrollBars

	self sourceCodeEdit verticalScrollBarPolicy: #alwaysOn.
	self sourceCodeEdit scrollBarThickness: 9.
	self sourceCodeEdit height: 100.! !

!SdMethodEditor methodsFor: 'actions - experimental' stamp: 'mt 4/20/2011 16:45:14.615'!
xUseSegoe

	self sourceCodeEdit textMorph
		font: (TextStyle named: #'Bitmap Segoe UI') defaultFont;
		recompose.! !

Morph subclass: #SdBreadcrumbTrail
	instanceVariableNames: 'packageBtn categoryBtn classBtn protocolBtn categoryListBtn classListBtn protocolListBtn'
	classVariableNames: 'ArrowIcon'
	poolDictionaries: ''
	category: 'Sight-Dynamic-UI-Support'!

!SdBreadcrumbTrail methodsFor: 'accessing' stamp: 'mt 7/5/2011 15:57:34.258'!
category

	^ categoryBtn valueOfProperty: #category! !

!SdBreadcrumbTrail methodsFor: 'accessing' stamp: 'mt 7/5/2011 16:02:05.699'!
category: aString

	| packageName shortName |
	packageName := (PackageOrganizer default packageOfSystemCategory: aString) name.
	shortName := aString size == packageName size
		ifTrue: [packageName]
		ifFalse: [aString allButFirst: packageName size + 1].
		
	categoryBtn
		setProperty: #category toValue: aString;
		text: shortName.
		
	self packageName: packageName.! !

!SdBreadcrumbTrail methodsFor: 'signals' stamp: 'mt 7/5/2011 16:17:30.029'!
classActivated: aClass

	self emitInOwnerChain.! !

!SdBreadcrumbTrail methodsFor: 'initialization' stamp: 'mt 6/20/2012 17:22:19.276'!
initialize

	super initialize.
	
	self
		color: Color transparent;
		changeTableLayout;
		listDirection: #leftToRight;
		hResizing: #shrinkWrap;
		height: 13.
		
	packageBtn := SdFadingButton new text: 'Morphic'; color: Color blue muchLighter; autoRaise: true; layoutInset: (0@ -5 corner: 0@ -3).
	categoryBtn := SdFadingButton new text: 'Kernel'; color: Color orange; autoRaise: true;layoutInset: (0@ -5 corner: 0@ -3).
	classBtn := SdFadingButton new text: 'Morph'; color: Color green; autoRaise: true;layoutInset: (0@ -5 corner: 0@ -3).
	protocolBtn := SdProtocolButton new text: 'initialization'.
	
	self connect: protocolBtn signal: #protocolChanged: toSelector: #protocolChanged:.
	
	ArrowIcon ifNil: [ArrowIcon := (UiFugueIcons control000SmallIcon clippedTo: 8@19) asGrayScale2].
	
	categoryListBtn := SdFadingButton new
		buttonStyle: #iconOnly; icon: ArrowIcon;
		layoutInset: (0@ -5 corner: 0@ -3);
		autoRaise: true;
		color: packageBtn color.
	classListBtn := SdFadingButton new
		buttonStyle: #iconOnly; icon: ArrowIcon;
		layoutInset: (0@ -5 corner: 0@ -3);
		autoRaise: true;
		color: categoryBtn color.
	protocolListBtn := SdFadingButton new
		buttonStyle: #iconOnly; icon: ArrowIcon;
		layoutInset: (0@ -5 corner: 0@ -3);
		autoRaise: true;
		color: classBtn color.
		
	self addAllMorphs: {packageBtn. categoryListBtn. categoryBtn. classListBtn. classBtn. protocolListBtn. protocolBtn}.
! !

!SdBreadcrumbTrail methodsFor: 'accessing' stamp: 'mt 7/5/2011 15:51:46.866'!
packageName

	^ packageBtn valueOfProperty: #packageName! !

!SdBreadcrumbTrail methodsFor: 'accessing' stamp: 'mt 7/5/2011 15:52:32.187'!
packageName: aString

	packageBtn
		setProperty: #packageName toValue: aString;
		text: aString.! !

!SdBreadcrumbTrail methodsFor: 'accessing' stamp: 'mt 7/5/2011 16:00:50.139'!
protocol

	^ protocolBtn valueOfProperty: #protocol! !

!SdBreadcrumbTrail methodsFor: 'accessing' stamp: 'mt 6/21/2012 15:09:34.982'!
protocol: aProtocol

	protocolBtn setProperty: #protocol toValue: aProtocol.
	protocolBtn text: aProtocol.! !

!SdBreadcrumbTrail methodsFor: 'signals' stamp: 'mt 7/5/2011 16:18:05.933'!
protocolChanged: aProtocol

	self emitAlways.! !

!SdBreadcrumbTrail methodsFor: 'initialization' stamp: 'mt 6/21/2012 15:04:50.737'!
setMethod: aCompiledMethod

	self
		theClass: aCompiledMethod methodClass
		protocol: (aCompiledMethod methodClass organization categoryOfElement: aCompiledMethod selector).! !

!SdBreadcrumbTrail methodsFor: 'accessing' stamp: 'mt 7/5/2011 15:59:51.077'!
theClass

	^ classBtn valueOfProperty: #class! !

!SdBreadcrumbTrail methodsFor: 'accessing' stamp: 'mt 7/5/2011 16:16:35.329'!
theClass: aClass

	classBtn
		setProperty: #class toValue: aClass;
		text: ('<b>', aClass name, '</b>') asHtmlText.
	
	protocolBtn organization: aClass organization.
	
	self category: aClass theNonMetaClass category.! !

!SdBreadcrumbTrail methodsFor: 'accessing' stamp: 'mt 7/5/2011 16:11:21.292'!
theClass: aClass protocol: aProtocol

	self
		theClass: aClass;
		protocol: aProtocol.! !

Morph subclass: #SdColumnSeparator
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sight-Dynamic-UI-Columns'!

!SdColumnSeparator methodsFor: 'drawing' stamp: 'mt 7/1/2011 17:33:50.436'!
drawOn: aCanvas
	
	super drawOn: aCanvas.
	self drawTopLineOn: aCanvas.! !

!SdColumnSeparator methodsFor: 'drawing' stamp: 'mt 7/1/2011 17:34:35.493'!
drawTopLineOn: aCanvas
	
	aCanvas
		line: self topLeft to: self topRight - (1@0) color: (Color gray: 0.5);
		line: self topLeft + (0@1) to: self topRight + (-1 @1) color: (Color gray: 0.7).! !

!SdColumnSeparator methodsFor: 'initialization' stamp: 'mt 6/18/2012 17:03:58.177'!
initialize

	super initialize.
	
	self
		color: (Color gray: 0.85);
		hResizing: #shrinkWrap;
		vResizing: #spaceFill;
		changeTableLayout;
		cellInset: 1;
		layoutInset: (1@2 corner: 0@1);
		listDirection: #topToBottom.! !

Morph subclass: #SdColumnToolBar
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sight-Dynamic-UI-Columns'!

!SdColumnToolBar methodsFor: 'drawing' stamp: 'mt 7/1/2011 18:07:05.949'!
drawOn: aCanvas

	aCanvas
		fillRectangle: (self innerBounds insetBy: (0@0 corner: 1@0))
		fillStyle: self gradient.! !

!SdColumnToolBar methodsFor: 'drawing' stamp: 'mt 7/1/2011 18:03:52.504'!
gradient

	^ (GradientFillStyle ramp: {
			0.0 -> (self color adjustBrightness: 0.1).
			0.1-> (self color adjustBrightness: 0.05).
			0.6 -> (self color darker)})
		origin: self innerBounds topLeft;
		direction: self innerBounds width @ 0.! !

!SdColumnToolBar methodsFor: 'initialization' stamp: 'mt 6/19/2012 15:36:09.874'!
initialize

	super initialize.

	self
		color: (Color gray: 0.85);
		changeTableLayout;
		vResizing: #spaceFill;
		hResizing: #shrinkWrap;
		layoutInset: (0@0 corner: 1@0).! !

Morph subclass: #SdDropTarget
	instanceVariableNames: 'dropTargetPosition lastDropRectangle acceptedDropAreas acceptedDropBlock dropColor convertSourceBlock'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sight-Dynamic-UI-Columns'!

SdDropTarget subclass: #SdColumn
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sight-Dynamic-UI-Columns'!

!SdColumn methodsFor: 'submorphs-add/remove' stamp: 'mt 4/25/2011 10:34:43.351'!
delete

	super delete.
	self deleted.! !

!SdColumn methodsFor: 'signals' stamp: 'mt 4/25/2011 10:28:47.558'!
deleted

	self emit.! !

!SdColumn methodsFor: 'accessing' stamp: 'mt 6/18/2012 16:15:03.669'!
editors

	^  self submorphs! !

!SdColumn methodsFor: 'initialization' stamp: 'mt 6/18/2012 11:29:44.838'!
initialize

	super initialize.
	self color: Color transparent.! !

!SdColumn methodsFor: 'visiting' stamp: 'mt 7/4/2011 17:48:37.616'!
loadState: anEditorState

	anEditorState loadColumn: self.! !

!SdColumn methodsFor: 'geometry' stamp: 'mt 5/11/2011 11:22:29.479'!
optimalWidth

	| maxWidth |
	maxWidth := 200.
	self submorphs do: [:sm |
		maxWidth := maxWidth max: sm optimalWidth].
	^ maxWidth! !

!SdColumn methodsFor: 'submorphs-add/remove' stamp: 'mt 5/4/2011 10:06:15.27'!
removedMorph: aMorph

	self submorphs
		ifEmpty: [self height: 50].! !

!SdColumn methodsFor: 'visiting' stamp: 'mt 7/4/2011 15:23:51.321'!
saveState: anEditorState

	anEditorState saveColumn: self.! !

SdColumn subclass: #SdEditorColumn
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sight-Dynamic-UI-Columns'!

!SdEditorColumn methodsFor: 'accessing' stamp: 'mt 6/19/2012 15:23:10.676'!
areaThicknessLeft

	^ (self width // 5) max: 20! !

!SdEditorColumn methodsFor: 'accessing' stamp: 'mt 6/19/2012 15:23:05.814'!
areaThicknessRight

	^ (self width // 5) max: 20! !

!SdEditorColumn methodsFor: 'initialization' stamp: 'mt 6/18/2012 17:08:36.552'!
initialize

	super initialize.
	
	self
		vResizing: #spaceFill;
		layoutPolicy: SdColumnLayout new;
		acceptedDropBlock: [:object | (object isKindOf: SdEditor) or: [object isBehavior]];
		acceptedDropAreas: #(left right between);
		convertSourceBlock: [:object | object isBehavior ifTrue: [object new] ifFalse: [object]].! !

!SdEditorColumn methodsFor: 'submorphs-add/remove' stamp: 'mt 7/2/2011 14:59:32.548'!
privateAddMorph: anEditor atIndex: index

	"Use the width of the first morph that is added."
	self submorphs ifEmpty: [
		self width: anEditor width].

	super privateAddMorph: anEditor atIndex: index.

	anEditor expand.! !

!SdEditorColumn methodsFor: 'submorphs-add/remove' stamp: 'mt 7/1/2011 22:48:31.289'!
removedMorph: aMorph
	"Update layout for the other morphs."

	super removedMorph: aMorph.  
	
	self submorphs ifEmpty: [self delete].! !

SdColumn subclass: #SdMethodEditorColumn
	instanceVariableNames: 'dropShadow'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sight-Dynamic-UI-Columns'!

!SdMethodEditorColumn methodsFor: 'as yet unclassified' stamp: 'mt 7/2/2011 14:58:49.38'!
addMethodEditor: aMethodEditor

	self assert: self submorphs notEmpty.

	"WORKAROUND for buggy morphic layout."
	aMethodEditor width: self width.
	self addMorph: aMethodEditor inFrontOf: dropShadow.! !

!SdMethodEditorColumn methodsFor: 'as yet unclassified' stamp: 'mt 7/1/2011 22:29:33.681'!
clear

	self removeAllMorphs.
	self addMorphBack: dropShadow.! !

!SdMethodEditorColumn methodsFor: 'drawing' stamp: 'mt 6/19/2012 15:58:08.907'!
drawInnerShadowOn: aCanvas

	| c |
	c := Color black.

	aCanvas
		line: self topLeft + (0@1) to: self topRight + (-1@1) color: (c alpha: 0.5);
		line: self topLeft + (0@2) to: self topRight + (-1@2) color: (c alpha: 0.2).
			
	aCanvas
		line: self topLeft + (1@1) to: self bottomLeft + (1@ -1) color: (c alpha: 0.5);
		line: self topLeft + (2@2) to: self bottomLeft + (2@ -1) color: (c alpha: 0.2).
		
	aCanvas
		frameRectangle: self innerBounds
		color: (c alpha: 0.8).! !

!SdMethodEditorColumn methodsFor: 'drawing' stamp: 'mt 6/19/2012 15:59:11.079'!
drawOn: aCanvas

	super drawOn: aCanvas.
	"self drawInnerShadowOn: aCanvas."! !

!SdMethodEditorColumn methodsFor: 'initialization' stamp: 'mt 6/19/2012 16:03:30.131'!
initialize

	super initialize.
	
	dropColor := Color green muchDarker.
	dropShadow := SdShadow new
		orientation: #horizontal;
		text: '<font color="#888888">Drop source code here.</font>' asHtmlText asMorph;
		acceptedDropBlock: [:object | false].
	
	self
		layoutPolicy: SdMethodEditorColumnLayout new;
		acceptedDropAreas: #(between);
		acceptedDropBlock: [:morph | morph isKindOf: SdMethodEditor];
		addMorphBack: dropShadow.! !

!SdMethodEditorColumn methodsFor: 'as yet unclassified' stamp: 'mt 7/1/2011 22:31:08.388'!
methodEditors

	^ self submorphs copyWithout: dropShadow! !

!SdDropTarget methodsFor: 'dropping/grabbing' stamp: 'mt 6/18/2012 15:56:17.595'!
acceptDroppingMorph: aTransferMorph event: evt

	| area convertedSource |
	"Remove highlighted rectangle."
	self clearDropRectangle.
	
	convertedSource := self convertSourceBlock value: aTransferMorph source.
	area := self dropAreaForEvent: evt.
	
	area == #full
		ifTrue: [^ self editorDropped: convertedSource]	.

	area == #left
		ifTrue: [^ self editorDroppedInFrontOfMe: convertedSource].
	
	area == #right
		ifTrue: [^ self editorDroppedAfterMe: convertedSource].
		
	area == #between ifTrue: [
		| dtr |
		dtr := self dropRectangleForEvent: evt.
		(self submorphs
			detect: [:m | m bounds containsRect: dtr]
			ifNone: []) ifNotNil: [:m |
				dtr topLeft = m topLeft
					ifTrue: [^ self addMorph: convertedSource inFrontOf: m].
				dtr bottomRight = m bottomRight
					ifTrue: [^ self addMorph: convertedSource after: m]]].! !

!SdDropTarget methodsFor: 'accessing' stamp: 'mt 6/18/2012 11:28:18.314'!
acceptedDropAreas

	^ acceptedDropAreas ifNil: [acceptedDropAreas := #(left right between)]! !

!SdDropTarget methodsFor: 'accessing' stamp: 'mt 6/18/2012 11:28:18.503'!
acceptedDropAreas: anArray

	acceptedDropAreas := anArray.! !

!SdDropTarget methodsFor: 'accessing' stamp: 'mt 6/18/2012 11:28:18.607'!
acceptedDropBlock

	^ acceptedDropBlock! !

!SdDropTarget methodsFor: 'accessing' stamp: 'mt 6/18/2012 11:28:18.711'!
acceptedDropBlock: aBlock
	"Decide the behavior of #wantsDropedMorph..."
	
	acceptedDropBlock := aBlock.! !

!SdDropTarget methodsFor: 'accessing' stamp: 'mt 6/19/2012 14:50:02.786'!
areaThicknessLeft

	^ 20! !

!SdDropTarget methodsFor: 'accessing' stamp: 'mt 6/19/2012 14:49:59.214'!
areaThicknessRight

	^ 20! !

!SdDropTarget methodsFor: 'actions' stamp: 'mt 6/18/2012 15:31:38.583'!
clearDropRectangle

	lastDropRectangle := nil.
	self redrawLater.! !

!SdDropTarget methodsFor: 'accessing' stamp: 'mt 6/18/2012 11:44:31.327'!
convertSourceBlock

	^ convertSourceBlock ifNil: [convertSourceBlock := [:object | object]]! !

!SdDropTarget methodsFor: 'accessing' stamp: 'mt 6/18/2012 11:44:14.551'!
convertSourceBlock: aBlock

	convertSourceBlock := aBlock.! !

!SdDropTarget methodsFor: 'drawing' stamp: 'mt 6/18/2012 16:00:01.62'!
drawDropTargetOn: aCanvas

	lastDropRectangle ifNil: [^ self].
	
	aCanvas
		frameAndFillRectangle: lastDropRectangle
		fillColor: (self dropColor alpha: 0.5)
		borderWidth: 2
		borderColor: self dropColor.! !

!SdDropTarget methodsFor: 'dropping/grabbing' stamp: 'mt 6/18/2012 17:03:14.977'!
dropAreaForEvent: aMouseEvent

	self acceptedDropAreas do: [:area |
		(self dropRectanglesForPoint: area) do: [:rect |
			(rect containsPoint: aMouseEvent position)
				ifTrue: [^ area]]].
	^ nil! !

!SdDropTarget methodsFor: 'accessing' stamp: 'mt 6/18/2012 11:28:18.815'!
dropColor

	^ dropColor ifNil: [dropColor := Color blue]! !

!SdDropTarget methodsFor: 'accessing' stamp: 'mt 6/18/2012 11:28:18.919'!
dropColor: aColor

	dropColor = aColor ifTrue: [^ self].

	dropColor := aColor.
	
	self redrawLater.! !

!SdDropTarget methodsFor: 'dropping/grabbing' stamp: 'mt 6/18/2012 17:02:43.631'!
dropRectangleForEvent: aMouseEvent

	self acceptedDropAreas do: [:area |
		(self dropRectanglesForPoint: area) do: [:rect |
			(rect containsPoint: aMouseEvent position)
				ifTrue: [^ rect]]].
	^ nil! !

!SdDropTarget methodsFor: 'dropping/grabbing' stamp: 'mt 6/19/2012 14:50:24.534'!
dropRectanglesForPoint: aTarget

	aTarget == #full
		ifTrue: [^ {self bounds}].
	
	aTarget == #left
		ifTrue: [^ {self topLeft corner: (self left + self areaThicknessLeft) @ self bottom}].
		
	aTarget == #right
		ifTrue: [^ {self right - self areaThicknessRight @ self top corner: self bottomRight}].
	
	aTarget == #between ifTrue: [
		^ self submorphs gather: [:m |
			{m topLeft corner: m bottomRight - (0@ (m height // 2)).
			m topLeft + (0@ (m height // 2)) corner: m bottomRight}]].
	
	^ #()! !

!SdDropTarget methodsFor: 'signals' stamp: 'mt 6/19/2012 15:14:46.305'!
editorDropped: anEditor

	self emit.! !

!SdDropTarget methodsFor: 'signals' stamp: 'mt 6/19/2012 15:14:50.232'!
editorDroppedAfterMe: anEditor

	self emit.! !

!SdDropTarget methodsFor: 'signals' stamp: 'mt 6/19/2012 15:14:54.268'!
editorDroppedInFrontOfMe: anEditor

	self emit.! !

!SdDropTarget methodsFor: 'drawing' stamp: 'mt 6/18/2012 16:00:09.761'!
fullDrawOn: aCanvas

	super fullDrawOn: aCanvas.
	
	self drawDropTargetOn: aCanvas.! !

!SdDropTarget methodsFor: 'events-processing' stamp: 'mt 6/18/2012 15:30:55.627'!
handleMouseMove: aMouseEvent
	"Overridden to handle ANY move event."
	
	super handleMouseMove: aMouseEvent.
	
	"Indicate dropping target visually."
	(aMouseEvent hand hasSubmorphs
		and: [self
			wantsDroppedMorph: aMouseEvent hand submorphs first
			event: aMouseEvent])
		ifTrue: [
			| r |
			r := self dropRectangleForEvent: aMouseEvent.
			lastDropRectangle ~= r ifTrue: [self redrawLater].
			lastDropRectangle := r]
		ifFalse: [self clearDropRectangle].! !

!SdDropTarget methodsFor: 'initialization' stamp: 'mt 6/18/2012 11:29:33.467'!
initialize

	super initialize.
	
	self
		initializeEventHandler;
		dropEnabled: true.! !

!SdDropTarget methodsFor: 'initialization' stamp: 'mt 6/18/2012 11:29:16.562'!
initializeEventHandler

	self eventHandler: UiEventHandler new.

	self connect: self eventHandler signal: #mouseLeftDragging: toSelector: #clearDropRectangle.! !

!SdDropTarget methodsFor: 'dropping/grabbing' stamp: 'mt 6/18/2012 11:28:37.51'!
wantsDroppedMorph: aMorph event: evt

	| result |
	result := (super wantsDroppedMorph: aMorph event: evt)
		and: [aMorph isKindOf: TransferMorph]
		and: [self acceptedDropBlock value: aMorph source].
		
	^ result! !

SdDropTarget subclass: #SdShadow
	instanceVariableNames: 'orientation text'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sight-Dynamic-UI-Columns'!

!SdShadow commentStamp: 'mt 6/18/2012 11:19:47.549' prior: 0!
This is always the last or sometimes only item on a tape. A tape is never empty.!

!SdShadow methodsFor: 'initialization' stamp: 'mt 6/20/2012 16:53:32.801'!
addCloseBtn

	| closeBtn |
	closeBtn := UiToolButton new
		buttonStyle: #iconOnly;
		autoRaise: true;
		balloonText: 'Close this tape';
		color: (Color gray: 0.5);
		icon: UiFugueIcons crossSmallIcon asGrayScale2;
		topLeft: self topLeft + (5@5).
	self addMorph: closeBtn.
	self connect: closeBtn signal: #clicked: toSelector: #closeRequested.! !

!SdShadow methodsFor: 'signals' stamp: 'mt 6/20/2012 10:25:44.535'!
closeRequested

	self emitAlways.! !

!SdShadow methodsFor: 'drawing' stamp: 'mt 6/19/2012 14:56:39.16'!
drawMessageOn: aCanvas
			
	text topLeft: self topLeft + (self extent - text extent // 2).
	text fullDrawOn: aCanvas.! !

!SdShadow methodsFor: 'drawing' stamp: 'mt 6/19/2012 14:55:13.537'!
drawOn: aCanvas

	self
		drawMessageOn: aCanvas;
		drawShadowOn: aCanvas.! !

!SdShadow methodsFor: 'drawing' stamp: 'mt 6/19/2012 15:59:52.682'!
drawShadowOn: aCanvas

	| c |
	self owner ifNotNil: [:o | o submorphs size = 1 ifTrue: [^ self]].
	
	c := Color black.
	
	self orientation == #vertical ifTrue: [	
		aCanvas
			line: self topLeft + (2@1) to: self bottomLeft + (2@ -1) color: (c alpha: 0.5);
			line: self topLeft + (3@2) to: self bottomLeft + (3@ -1) color: (c alpha: 0.2);
			line: self topLeft + (1@0) to: self bottomLeft + (1@ -1) color: (c alpha: 0.8)].
		
	self orientation == #horizontal ifTrue: [	
		aCanvas
			line: self topLeft + (1@1) to: self topRight + (-1 @ 1) color: (c alpha: 0.5);
			line: self topLeft + (2@2) to: self topRight + (-1 @ 2) color: (c alpha: 0.2);
			line: self topLeft         to: self topRight + (-1 @ 0) color: (c alpha: 0.8)].! !

!SdShadow methodsFor: 'initialization' stamp: 'mt 6/20/2012 16:53:41.332'!
initialize

	super initialize.
		
	self
		color: (Color gray: 0.6);
		layoutInset: (3@3 corner: 0@0);
		acceptedDropAreas: #(full).
		
	text := '<font color="#888888">Drop editors here.</font>' asHtmlText asMorph.! !

!SdShadow methodsFor: 'accessing' stamp: 'mt 7/1/2011 22:12:33.503'!
orientation

	^ orientation ifNil: [orientation := #vertical]! !

!SdShadow methodsFor: 'accessing' stamp: 'mt 6/19/2012 15:48:14.185'!
orientation: aSymbol
	"#horizontal, #vertical"
	
	orientation = aSymbol ifTrue: [^ self].
	
	orientation := aSymbol.
	
	orientation == #vertical
		ifTrue: [self vResizing: #spaceFill; hResizing: #rigid; width: 120]
		ifFalse: [self hResizing: #spaceFill; vResizing: #rigid; height: 80].! !

!SdShadow methodsFor: 'accessing' stamp: 'mt 6/19/2012 15:54:42.601'!
text

	^ text text! !

!SdShadow methodsFor: 'accessing' stamp: 'mt 6/19/2012 15:54:34.584'!
text: aText

	text := aText asMorph.! !

SdDropTarget subclass: #SdTapeContainer
	instanceVariableNames: 'footer icon text background'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sight-Dynamic-UI-Columns'!

!SdTapeContainer methodsFor: 'accessing' stamp: 'mt 6/15/2012 16:27:43.593'!
background

	^ background! !

!SdTapeContainer methodsFor: 'accessing' stamp: 'mt 6/15/2012 16:27:50.017'!
background: aForm

	background := aForm.
	self redrawLater.! !

!SdTapeContainer methodsFor: 'drawing' stamp: 'mt 6/15/2012 16:27:56.802'!
drawBackgroundOn: aCanvas

	self background ifNil: [^ self].
	
	aCanvas
		clipBy: self bounds
		during: [:c | c
			paintImage: self background
			at: self topLeft - ((self background width - self width)@0)].! !

!SdTapeContainer methodsFor: 'drawing' stamp: 'mt 6/15/2012 16:28:01.445'!
drawFooterOn: aCanvas

	footer ifNil: [^ self].

	footer asMorph
		bottomRight: self bottomRight - (5@0);
		fullDrawOn: aCanvas.! !

!SdTapeContainer methodsFor: 'drawing' stamp: 'mt 6/15/2012 16:28:05.764'!
drawInnerShadowOn: aCanvas

	| c |
	c := Color black.

	aCanvas
		line: self topLeft + (0@1) to: self topRight + (-1@1) color: (c alpha: 0.5);
		line: self topLeft + (0@2) to: self topRight + (-1@2) color: (c alpha: 0.2).
			
	aCanvas
		line: self topLeft + (1@1) to: self bottomLeft + (1@ -1) color: (c alpha: 0.5);
		line: self topLeft + (2@2) to: self bottomLeft + (2@ -1) color: (c alpha: 0.2).
		
	aCanvas
		frameRectangle: self innerBounds
		color: (c alpha: 0.8).! !

!SdTapeContainer methodsFor: 'drawing' stamp: 'mt 6/15/2012 16:28:11.53'!
drawMessageOn: aCanvas

	| textMorph |
	self text ifNil: [^ self].
	
	"Only show a message if no real content is there."
	(self firstSubmorph ifNotNil: [:m | m submorphs size > 1])
		ifTrue: [^ self].
		
	textMorph := self text asMorph.
	textMorph topLeft: self topLeft + (self extent - textMorph extent // 2) + (self icon width + 5 @ 0).
	
	textMorph fullDrawOn: aCanvas.
	
	aCanvas
		translucentImage: self icon
		at: textMorph topLeft - (self icon width + 5 @ -2).! !

!SdTapeContainer methodsFor: 'drawing' stamp: 'mt 6/18/2012 10:28:00.473'!
drawOn: aCanvas

	super drawOn: aCanvas.
	
	self
		drawBackgroundOn: aCanvas;
		drawInnerShadowOn: aCanvas;
		drawSeparatorsOn: aCanvas;
		drawFooterOn: aCanvas.! !

!SdTapeContainer methodsFor: 'drawing' stamp: 'mt 6/18/2012 10:31:56.053'!
drawSeparatorsOn: aCanvas

	| offset |
	offset := 0.
	self submorphs do: [:s | offset := s bottom] separatedBy: [
		aCanvas
			line: self left @ offset
			to: self right @ offset
			width: 1
			color: (Color gray: 0.85) darker.
		aCanvas line: self left @ (offset+1) to: self right @ (offset+1) width: 1 color: (Color black alpha: 0.8).
		aCanvas line: self left @ (offset-1) to: self right @ (offset-1) width: 1 color: (Color black alpha: 0.8).
		aCanvas line: self left @ (offset+2) to: self right @ (offset+2) width: 1 color: (Color black alpha: 0.5).
		aCanvas line: self left @ (offset+3) to: self right @ (offset+3) width: 1 color: (Color black alpha: 0.2)].! !

!SdTapeContainer methodsFor: 'accessing' stamp: 'mt 6/15/2012 16:28:21.763'!
footer

	^ footer! !

!SdTapeContainer methodsFor: 'accessing' stamp: 'mt 6/15/2012 16:28:30.461'!
footer: aText

	footer := aText.
	self redrawLater.! !

!SdTapeContainer methodsFor: 'accessing' stamp: 'mt 6/15/2012 16:28:36.364'!
icon

	^ icon ifNil: [Form extent: 0@0]! !

!SdTapeContainer methodsFor: 'accessing' stamp: 'mt 6/15/2012 16:28:42.04'!
icon: anIcon

	icon := anIcon.
	self redrawLater.! !

!SdTapeContainer methodsFor: 'initialization' stamp: 'mt 6/19/2012 10:48:29.748'!
initialize

	super initialize.
	
	self
		hResizing: #spaceFill;
		vResizing: #spaceFill;
		layoutPolicy: SdTapeContainerLayout new.
		
	self
		color: (Color gray: 0.3);
		background: SdIDE background1;
		icon: UiFugueIcons arrow180MediumIcon asGrayScale2;
		text: '<font color="#888888">Choose a tool from the side bar and start development.</font>' asHtmlText;
		footer: ('<font color="#888888">', SdIDE appVersion versionString, '</font>') asHtmlText.

	self
		dropColor: (Color gray: 0.7);
		acceptedDropAreas: #(left right);
		acceptedDropBlock: [:object | (object isKindOf: SdEditor) or: [object isBehavior]];
		convertSourceBlock: [:object | object isBehavior ifTrue: [object new] ifFalse: [object]].! !

!SdTapeContainer methodsFor: 'accessing' stamp: 'mt 6/15/2012 16:28:51.516'!
text

	^ text! !

!SdTapeContainer methodsFor: 'accessing' stamp: 'mt 6/15/2012 16:29:06.756'!
text: aText

	text := aText.
	self redrawLater.! !

Morph subclass: #SdEditor
	uses: TSdMemento
	instanceVariableNames: 'ui'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sight-Dynamic'!

!SdEditor commentStamp: 'mt 6/21/2011 10:43:35.761' prior: 0!
This is an editor meant to be placed inside an SdColumn in the IDE.!

SdEditor class
	uses: TSdMemento classTrait
	instanceVariableNames: ''!

SdEditor subclass: #SdCallgraphEditor
	uses: TSdDynamicActivation + TSdMemento
	instanceVariableNames: 'previewPanel finder'
	classVariableNames: 'CallgraphCache'
	poolDictionaries: ''
	category: 'Sight-Dynamic'!

!SdCallgraphEditor commentStamp: '<historical>' prior: 0!
The current trace describes the piece of code or the test method that is associated with this editor.

The current call graph is the result of the last tracing run.!

SdCallgraphEditor class
	uses: TSdDynamicActivation classTrait + TSdMemento classTrait
	instanceVariableNames: ''!

!SdCallgraphEditor class methodsFor: 'caching' stamp: 'mt 7/17/2011 20:54:04.821'!
callgraphAt: aTraceEvent

	^ self callgraphCache at: aTraceEvent hash ifAbsentPut: [SdCallgraph new traceEvent: aTraceEvent]! !

!SdCallgraphEditor class methodsFor: 'caching' stamp: 'mt 2/16/2012 11:10:39.862'!
callgraphAtTest: aTestReference

	^ self callgraphAt: (SdTraceItEvent test: aTestReference)! !

!SdCallgraphEditor class methodsFor: 'caching' stamp: 'mt 7/17/2011 20:43:31.316'!
callgraphCache

	^ CallgraphCache ifNil: [CallgraphCache := Dictionary new]! !

!SdCallgraphEditor class methodsFor: 'caching' stamp: 'mt 4/6/2012 16:30:01.74'!
callgraphCacheInfo

	| nd |
	nd := self callgraphCache values count: [:cg | cg isNonDeterministic].
	
	Transcript
		cr; show: '[cgc] Call Graph Cache Statistics';
		cr; show: '[cgc] Size: ', self callgraphCache keys size asString;
		cr; show: '[cgc] Non-Deterministic: ', nd asString.! !

!SdCallgraphEditor class methodsFor: 'caching' stamp: 'mt 4/6/2012 16:12:22.732'!
callgraphCacheReset

	CallgraphCache := nil.! !

!SdCallgraphEditor class methodsFor: 'accessing' stamp: 'mt 6/28/2011 20:58:27.164'!
editorDescription

	^ 'Explore a new call graph.'! !

!SdCallgraphEditor class methodsFor: 'accessing' stamp: 'mt 7/3/2011 08:57:08.403'!
editorGroup

	^ 2! !

!SdCallgraphEditor class methodsFor: 'accessing' stamp: 'mt 6/28/2011 14:23:57.448'!
editorIcon

	^ UiFugueIcons nodeSelectIcon! !

!SdCallgraphEditor class methodsFor: 'accessing' stamp: 'mt 6/28/2011 20:58:04.597'!
editorName

	^ 'Call Graph'! !

!SdCallgraphEditor class methodsFor: 'tracing' stamp: 'mt 6/29/2012 09:38:25.438'!
traceSourceCode: aString inPackages: somePackagesOrSystemCategories

	self
		traceSourceCode: aString
		receiver: nil
		inPackages: somePackagesOrSystemCategories.! !

!SdCallgraphEditor class methodsFor: 'tracing' stamp: 'mt 6/29/2012 11:07:07.637'!
traceSourceCode: aString receiver: anObject inPackages: somePackagesOrSystemCategories

	| cgt cge |
	cgt := SdCallgraphTracer new tracingMode: #duration.
	cgt
		traceSourceCode: aString
		receiver: anObject
		inPackages: somePackagesOrSystemCategories.

	cge := SdCallgraphEditor new.

	cge ui treeView addColumn: (UiItemViewColumnSpec newFrom: {#text -> #duration}).

	cge height: 500;
		callgraph: cgt callgraph;
		openInWindow.! !

!SdCallgraphEditor methodsFor: 'actions' stamp: 'mt 3/26/2012 15:46:42.938'!
activateMethod: model

	self methodActivated: model node clientReference.! !

!SdCallgraphEditor methodsFor: 'accessing' stamp: 'mt 2/16/2012 15:31:12.155'!
callgraph

	^ self ui treeView model node! !

!SdCallgraphEditor methodsFor: 'accessing' stamp: 'mt 2/16/2012 15:25:52.613'!
callgraph: aCallgraph

	(self callgraph notNil
		and: [aCallgraph notNil]
		and: [self callgraph traceEvent = aCallgraph traceEvent])
			ifTrue: [^ self].

	self ui treeView model node: aCallgraph.
	self callgraphChanged.! !

!SdCallgraphEditor methodsFor: 'signals' stamp: 'mt 7/17/2011 21:15:42.501'!
callgraphChanged

	self emit.! !

!SdCallgraphEditor methodsFor: 'find' stamp: 'mt 3/23/2012 11:30:10.927'!
checkBlock

	^ [:node | node label beginsWith: self ui findEdit theText asString]! !

!SdCallgraphEditor methodsFor: 'memento - cleanup' stamp: 'mt 6/20/2012 11:34:48.913'!
clear

	self callgraph: nil.! !

!SdCallgraphEditor methodsFor: 'accessing' stamp: 'mt 2/16/2012 15:23:17.794'!
currentNode

	^ self ui treeView currentNode! !

!SdCallgraphEditor methodsFor: 'accessing' stamp: 'mt 3/23/2012 11:55:18.006'!
currentNode: aNode

	| finder |
	self callgraph: aNode callgraph.

	finder := UiItemModelFinder on: self ui treeView model.
	finder nextSatisfying: [:cg | cg node id = aNode id].

	self ui treeView expandIndex: finder currentIndex.
	self ui treeView currentNode: finder current.! !

!SdCallgraphEditor methodsFor: 'find' stamp: 'mt 3/23/2012 11:42:38.041'!
findNext

	self selectResult: (finder nextSatisfying: self checkBlock).! !

!SdCallgraphEditor methodsFor: 'find' stamp: 'mt 3/23/2012 11:42:34.749'!
findPrev

	self selectResult: (finder previousSatisfying: self checkBlock).! !

!SdCallgraphEditor methodsFor: 'actions - preview' stamp: 'mt 7/31/2011 15:28:44.852'!
hidePreview

	previewPanel ifNil: [^ self].
	previewPanel delete.
	previewPanel := nil.! !

!SdCallgraphEditor methodsFor: 'initialization' stamp: 'mt 3/23/2012 11:47:58.678'!
initializeFinder

	finder := (UiItemModelFinder on: self ui treeView model).
	finder traversalMode: #depthFirst.
	
	"Initialize buttons."
	self connect: self ui findPrevBtn signal: #clicked: toSelector: #findPrev.
	self connect: self ui findNextBtn signal: #clicked: toSelector: #findNext.
	
	"Crosscutting connections."	
	self connect: self ui findEdit signal: #textEdited: to: finder selector: #reset.
	self connect: self ui findEdit signal: #textEdited: toSelector: #updateFindBtns.
	
	self updateFindBtns.
! !

!SdCallgraphEditor methodsFor: 'initialization' stamp: 'mt 3/23/2012 11:23:30.667'!
initializeTree
	
	"call tree"
	self ui treeView
		addColumns: {
			UiItemViewColumnSpec newFrom: {#text -> #label. #icon -> #receiverIcon. #menu -> #menu. #headerText -> 'Call Tree'}.
			"(UiItemViewColumnSpec newFrom: {#checked -> #checked})
				balloonTextConverter: [:obj | 'Set receiver as reference object'].
			(UiItemViewColumnSpec newFrom: {#icon -> #status. #headerText -> 'Status'})
				iconConverter: [:node | self statusIconFor: node]"
			};
		model: SdCallgraphModel new.

	self connect: self ui treeView model signal: #classActivated: toSelector: #classActivated:. 
	self connect: self ui treeView model signal: #methodActivated: toSelector: #methodActivated:.
	self connect: self ui treeView model signal: #objectActivated: toSelector: #objectActivated:.
	self connect: self ui treeView model signal: #traceActivated: toSelector: #traceActivated:.
	
	self connect: self signal: #callgraphChanged to: self ui treeView selector: #reset.
	
	self ui treeView disconnectSignal: #doubleClicked:.  
	self connect: self ui treeView signal: #returnPressed: toSelector: #activateMethod:.
	self connect: self ui treeView signal: #doubleClicked: toSelector: #activateMethod:.
	"self connect: self ui treeView signal: #changed: toSelector: #activateNode:."
	
	"call tree - source preview"
	self connect: self ui treeView signal: #currentNodeChanged: toSelector: #triggerPreview.
	self connect: self ui treeView viewport eventHandler signal: #focusLost toSelector: #hidePreview.
	self ui treeView viewport eventHandler on: Character escape send: #hidePreview to: self.
	
	! !

!SdCallgraphEditor methodsFor: 'initialization' stamp: 'mt 6/15/2012 11:38:35.614'!
initializeUi

	super initializeUi.
	
	"header"
	self connect: self ui closeBtn signal: #clicked: toSelector: #clear.
	
	"information label"
	self connect: self ui moreBtn signal: #toggled: toSelector: #updateMoreBtn.
	self connect: self ui moreBtn signal: #toggled: toSelector: #updateInfoLbl.
	self connect: self signal: #callgraphChanged toSelector: #updateInfoLbl.
		
	self
		initializeTree;
		initializeFinder.
	
	"Initial update."
	self updateInfoLbl.! !

!SdCallgraphEditor methodsFor: 'memento - ui' stamp: 'mt 6/20/2012 11:48:39.189'!
loadState: anEditorState

	super loadState: anEditorState.
	anEditorState loadCallgraphEditor: self.! !

!SdCallgraphEditor methodsFor: 'overlay messages' stamp: 'mt 6/15/2012 11:56:17.928'!
messageBounds

	^ self ui treeView viewportBounds! !

!SdCallgraphEditor methodsFor: 'accessing' stamp: 'mt 7/3/2012 11:36:59.863'!
morphsOfInterest

	| selectedMorphs |
	self flag: #invasive.
	selectedMorphs := self ui treeView selection cells collect: [:cell |
		self ui treeView viewport morphAt: cell].
	^ selectedMorphs
		ifEmpty: [{self ui infoLbl}]
		ifNotEmpty: [selectedMorphs]! !

!SdCallgraphEditor methodsFor: 'geometry' stamp: 'mt 6/15/2012 12:33:00.459'!
optimalWidth

	^ self minimalWidth max: self ui treeView optimalWidth! !

!SdCallgraphEditor methodsFor: 'actions' stamp: 'mt 9/1/2011 11:45:18.756'!
profileDuration

	SdCallgraphTracer new
		callgraph: self callgraph;
		profile: #duration.
		
	self callgraphChanged.! !

!SdCallgraphEditor methodsFor: 'memento - ui' stamp: 'mt 6/20/2012 11:48:51.448'!
saveState: anEditorState

	super saveState: anEditorState.
	anEditorState saveCallgraphEditor: self.! !

!SdCallgraphEditor methodsFor: 'find' stamp: 'mt 3/23/2012 11:49:03.463'!
selectResult: aNode

	aNode
		ifNil: [
			self updateFindBtns.
			self showInformation: 'Search finished.']
		ifNotNil: [:node |
			self ui treeView expandIndex: finder currentIndex. "faster than lookup index in view via #modelIndicesFor:."	
			self ui treeView currentNode: node]! !

!SdCallgraphEditor methodsFor: 'actions - preview' stamp: 'mt 2/16/2012 15:38:29.77'!
showPreview
	
	self showPreview: self ui treeView currentNode.! !

!SdCallgraphEditor methodsFor: 'actions - preview' stamp: 'mt 2/16/2012 15:40:09.552'!
showPreview: aCallNode
	"Show a preview for the current element if one is selected."
	
	aCallNode node isInstantiation
		ifTrue: [^ self].
	
	"Discard the current preview."
	previewPanel ifNotNil: [self hidePreview].
	
	previewPanel := SdPreviewBuilder createMethodPreviewFor: aCallNode node clientReference.

	previewPanel ifNil: [^ self].
	
	"Ensure visibility of preview box."
	self ui treeView selection currentBounds ifNotNil: [:selectionBounds |
		| globalRight |
		globalRight := (self localPointToGlobal: self topRight) x.
		(globalRight + previewPanel width) > ActiveWorld right
			ifTrue: [(selectionBounds left - previewPanel width) < ActiveWorld left
				ifFalse: [previewPanel topRight: selectionBounds topLeft]
				ifTrue: [previewPanel topLeft: selectionBounds bottomLeft]]
			ifFalse: [previewPanel topLeft: globalRight @ selectionBounds top].
		previewPanel bottom: (ActiveWorld bottom min: previewPanel bottom)].
		
	previewPanel openInWorld.! !

!SdCallgraphEditor methodsFor: 'actions - preview' stamp: 'mt 2/16/2012 15:43:55.773'!
triggerPreview

	self hidePreview.
	self
		removeAlarm: #showPreview;
		addAlarm: #showPreview
		after: 250.! !

!SdCallgraphEditor methodsFor: 'accessing - ui' stamp: 'mt 6/15/2012 11:36:43.354'!
uiClass

	^ SdCallgraphEditorUi! !

!SdCallgraphEditor methodsFor: 'updating' stamp: 'mt 3/23/2012 11:28:36.641'!
updateFindBtns

	self ui findNextBtn enabled: (self ui findEdit theText notEmpty and: [finder hasNext]).
	self ui findPrevBtn enabled: (self ui findEdit theText notEmpty and: [finder hasPrevious]).! !

!SdCallgraphEditor methodsFor: 'updating' stamp: 'mt 7/16/2011 21:39:51.892'!
updateInfoLbl

	| info needsMore |
	self callgraph ifNil: [
		self ui infoLbl text: 'Nothing traced.'.
		self ui moreBtn checked: false; hide.
		^ self].
	
	info := self callgraph traceEvent itemKind = #expression
		ifTrue: [self callgraph traceEvent itemExpression withBlanksTrimmed]
		ifFalse: [self callgraph traceEvent testClass name, ' >> ', self callgraph traceEvent testSelector].
	needsMore := (info includesSubString: String cr) or: [info size > 60].
	
	self ui moreBtn visible: needsMore.
	
	self ui moreBtn checked
		ifTrue: [self ui infoLbl text: '"', info, '"']
		ifFalse: [self ui infoLbl text: ('"{1}{2}"' format: {
			(info withNoLineLongerThan: 60) lines first.
			needsMore ifTrue: [' <font color="#777777">[...]</font>'] ifFalse: ['']}) asHtmlText].! !

!SdCallgraphEditor methodsFor: 'updating' stamp: 'mt 5/5/2011 13:16:17.146'!
updateMoreBtn

	self ui moreBtn checked
		ifTrue: [self ui moreBtn icon: UiSilkIcons bulletArrowUpIcon]
		ifFalse: [self ui moreBtn icon: UiSilkIcons bulletArrowDownIcon].! !

SdEditor subclass: #SdClassEditor
	instanceVariableNames: 'theClass sui finder commentEditor definitionEditor classFinder suppressMethodOpenedSignal'
	classVariableNames: 'LastOpenMethods RecentlyUsedClasses'
	poolDictionaries: ''
	category: 'Sight-Dynamic'!

!SdClassEditor commentStamp: 'mt 6/20/2012 13:16:26.811' prior: 0!
This is an editor for a whole class.

SdClassEditor new
	width: 500;
	theClass: String;
	openInWorld.
	
DEPRECATED.!

!SdClassEditor class methodsFor: 'accessing' stamp: 'mt 6/28/2011 20:59:01.17'!
editorDescription

	^ 'Create or modify a class.'! !

!SdClassEditor class methodsFor: 'accessing' stamp: 'mt 7/3/2011 08:56:31.06'!
editorGroup

	^ 1! !

!SdClassEditor class methodsFor: 'accessing' stamp: 'mt 7/2/2011 09:40:06.547'!
editorIcon

	^ UiSilkIcons carIcon! !

!SdClassEditor class methodsFor: 'accessing' stamp: 'mt 6/28/2011 20:58:42.024'!
editorName

	^ 'Class Editor'! !

!SdClassEditor class methodsFor: 'accessing' stamp: 'mt 4/28/2011 17:40:14.835'!
lastOpenMethods

	^ LastOpenMethods ifNil: [LastOpenMethods := Dictionary new]! !

!SdClassEditor methodsFor: 'actions' stamp: 'mt 4/14/2011 19:20:52.215'!
activateFinder
	"Show the finder and give it the keyboard."
	
	self ui findBtn checked: true.
	finder	grabKeyboard.
	finder ui searchField selectAll.! !

!SdClassEditor methodsFor: 'actions - class' stamp: 'mt 4/17/2011 11:51:54.982'!
addClass: name category: category

	^ Object
		subclass: name
		instanceVariableNames: ''
		classVariableNames: ''
		poolDictionaries: ''
		category: category! !

!SdClassEditor methodsFor: 'initialization - method editors' stamp: 'mt 6/28/2011 20:36:08.368'!
addMethodEditor: aSelector isMeta: aBoolean

	| editor |
	editor := (self addMethodEditorForReference: (MethodReference
			class: (aBoolean ifTrue: [self theClass theMetaClass] ifFalse: [self theClass])
			selector: aSelector))
		expand;
		grabKeyboard.
	
	self scrollToShow: editor.
	
	^ editor! !

!SdClassEditor methodsFor: 'initialization - method editors' stamp: 'mt 4/18/2011 15:47:08.821'!
addMethodEditor: aSelector isMeta: aBoolean protocol: protocolName
	"Classifies the selector under the given protocol name."
	
	| m organization |
	m := self addMethodEditor: aSelector isMeta: aBoolean.
	
	"Use method editor to retrieve the correct selector as the user may have entered a full method signature with arguments."
	organization := (aBoolean
		ifTrue: [self theClass theMetaClass]
		ifFalse: [self theClass]) organization.
		
	(organization categoryOfElement: m selector) ~= protocolName
		ifTrue: [organization classify: m selector under: protocolName].! !

!SdClassEditor methodsFor: 'initialization - method editors' stamp: 'mt 6/21/2012 10:50:12.231'!
addMethodEditorForReference: aMethodReference

	| m |
	"aMethodReference isValid ifFalse: [^ self]."

	(self methodEditors
		detect: [:methodEditor | methodEditor reference = aMethodReference]
		ifNone: []) ifNotNil: [:methodEditor | ^ methodEditor].

	m := SdMethodEditor new
			theClass: aMethodReference actualClass
			selector: aMethodReference selector;
			hResizing: #spaceFill.
			
	self methodEditorColumn addMethodEditor: m.
	
	self connect: m artifact signal: #mouseWheelUp:
		to: self ui codeArea verticalScrollBar selector: #decreaseValueBySingleStep.
	self connect: m artifact signal: #mouseWheelDown:
		to: self ui codeArea verticalScrollBar selector: #increaseValueBySingleStep.
	
	"Shortcuts for source code editor."
	m artifact eventHandler on: #(cmd) -> $F send: #activateFinder to: self.
		
	self methodsOpened: {m reference}.
	
	^ m! !

!SdClassEditor methodsFor: 'converting' stamp: 'mt 2/15/2012 16:45:20.59'!
asString

	^ self theClass
		ifNotNil: [:c | c name]
		ifNil: [super asString]! !

!SdClassEditor methodsFor: 'actions' stamp: 'mt 4/29/2011 15:18:48.952'!
browseClasses

	self
		closeAll;
		switchToSelectUi.! !

!SdClassEditor methodsFor: 'actions - class' stamp: 'mt 6/15/2012 14:17:28.426'!
chooseClass: className

	| class |
	(className isNil or: [className isEmpty]) ifTrue: [^ self].
	
	class := Smalltalk
		at: className
		ifAbsent: [self
			addClass: className
			category: 'Uncategorized'].	
			
	self theClass: class.! !

!SdClassEditor methodsFor: 'actions - class' stamp: 'mt 6/15/2012 14:17:36.883'!
chooseClass: className category: category

	| class |
	className ifEmpty: [^ self].
	
	class := Smalltalk
		at: className
		ifAbsent: [self
			addClass: className
			category: category].
		
	class category ~= category
		ifTrue: [class category: category].
			
	self theClass: class.! !

!SdClassEditor methodsFor: 'signals' stamp: 'mt 6/28/2011 17:45:23.382'!
classActivated: aClass

	self emitInOwnerChain.! !

!SdClassEditor methodsFor: 'actions' stamp: 'mt 6/15/2012 12:49:33.978'!
close
	"Close this class editor."
	
	self saveListOfOpenMethods.
	SdFadingToolbar hideAllToolbars.
	
	super close.! !

!SdClassEditor methodsFor: 'actions' stamp: 'mt 7/5/2011 14:53:48.957'!
closeAll

	self ui commentBtn checked: false.
	self ui definitionBtn checked: false.    
	
	self methodEditorColumn clear.
	
	finder clear.
	self ui findBtn checked: true.
	finder grabKeyboard.! !

!SdClassEditor methodsFor: 'geometry' stamp: 'mt 5/18/2012 11:02:52.797'!
defaultWidth

	^ (Preferences standardCodeFont widthOfString: (String new: 60 withAll: $x))! !

!SdClassEditor methodsFor: 'updating' stamp: 'mt 6/20/2012 11:19:06.74'!
editorChange: aSymbol

	
	! !

!SdClassEditor methodsFor: 'accessing - private' stamp: 'mt 4/6/2011 16:14:29.696'!
finder

	^ finder! !

!SdClassEditor methodsFor: 'events' stamp: 'mt 7/5/2011 14:59:07.724'!
grabKeyboard

	self methodEditors
		ifNotEmpty: [^ self methodEditorColumn submorphs first grabKeyboard].

	self ui findBtn checked
		ifTrue: [finder grabKeyboard]
		ifFalse: [self ui findBtn checked: true].! !

!SdClassEditor methodsFor: 'memento - data' stamp: 'mt 6/20/2012 13:17:43.767'!
hasUnacceptedChanges

	^ definitionEditor hasUnacceptedChanges
		or: [commentEditor hasUnacceptedChanges]
		or: [self methodEditors anySatisfy: [:e | e hasUnacceptedChanges]]! !

!SdClassEditor methodsFor: 'actions' stamp: 'mt 5/12/2011 16:07:44.669'!
hideFinder

	self ui findBtn checked: false.! !

!SdClassEditor methodsFor: 'layouting' stamp: 'mt 4/11/2011 10:43:31.531'!
hideTopContainer

	self ui topContainer
		hide;
		disableTableLayout: true.! !

!SdClassEditor methodsFor: 'initialization' stamp: 'mt 6/19/2012 15:53:52.858'!
initializeCodeArea

	self ui codeArea verticalScrollBar
		singleStep: 20;
		outerBorderWidth: 0;
		color: Color transparent.
	self ui codeArea transformMorph
		color: (Color gray: 0.3).

	self ui codeArea widget: SdMethodEditorColumn new.
	self ui codeArea sgConnectSignal: #focusChanged: toSelector: #scrollToShowGlobal:.! !

!SdClassEditor methodsFor: 'initialization' stamp: 'mt 6/15/2012 14:52:47.045'!
initializeCommentEditor

	commentEditor := UiTextEdit new
		hResizing: #spaceFill;
		scrollBarThickness: 9;
		colorFocusBackground: Color white;
		colorBackground: (Color gray: 0.85).
	self connect: commentEditor signal: #editingFinished: toSelector: #saveClassComment.
	commentEditor eventHandler on: #(cmd) -> $w send: #toggle to: self ui commentBtn. "close"
	self connect: self ui commentBtn signal: #toggled: toSelector: #toggleCommentEditor.! !

!SdClassEditor methodsFor: 'initialization' stamp: 'mt 6/15/2012 15:00:45.597'!
initializeDefinitionEditor

	definitionEditor := SdClassDefinitionEdit new
		hResizing: #spaceFill;
		verticalScrollBarPolicy: #alwaysOff;  
		areaResizable: true;
		colorFocusBackground: Color white;
		colorBackground: (Color gray: 0.85).
	self connect: definitionEditor signal: #editingFinished: toSelector: #saveClassDefinition.
	definitionEditor eventHandler on: #(cmd) -> $w send: #toggle to: self ui definitionBtn. "close"
	self connect: self ui definitionBtn signal: #toggled: toSelector: #toggleDefinitionEditor.! !

!SdClassEditor methodsFor: 'initialization' stamp: 'mt 4/14/2011 14:43:53.632'!
initializeEventHandler

	super initializeEventHandler.

	self eventHandler on: #(cmd) -> $F send: #activateFinder to: self.! !

!SdClassEditor methodsFor: 'initialization' stamp: 'mt 6/15/2012 14:51:17.01'!
initializeFinder
	
	finder := SdMethodFinder new hResizing: #spaceFill.
	self ui topContainer addMorphBack: finder.
		
	self connect: self ui findBtn signal: #toggled: toSelector: #toggleFinder.
	self connect: finder signal: #deleted to: self ui findBtn selector: #checked: pattern: #(=false).
	
	self connect: finder signal: #selectorChosen:isMeta: toSelector: #addMethodEditor:isMeta:.
	self connect: finder signal: #selectorChosen:isMeta:protocol: toSelector: #addMethodEditor:isMeta:protocol:.
	
	self toggleFinder.! !

!SdClassEditor methodsFor: 'initialization' stamp: 'mt 6/15/2012 15:04:10.823'!
initializeHeader

	super initializeHeader.	
	
	self connect: self ui superClassBtn eventHandler signal: #mouseClicked: toSelector: #popupSuperClassList:.
	self connect: self ui subClassBtn eventHandler signal: #mouseClicked: toSelector: #popupSubClassList:.! !

!SdClassEditor methodsFor: 'initialization' stamp: 'mt 6/15/2012 14:28:04.608'!
initializeSystemChangeNotifications

	super initializeSystemChangeNotifications.
	
	SystemChangeNotifier uniqueInstance 
		notify: self ofSystemChangesOfItem: SystemChangeNotifier methodKind using: #onMethodChange:;
		notify: self ofSystemChangesOfItem: SystemChangeNotifier classKind using: #onClassChange:;
		notify: self ofSystemChangesOfItem: SystemChangeNotifier protocolKind using: #onProtocolChange:;
		notify: self ofSystemChangesOfItem: SystemChangeNotifier categoryKind using: #onCategoryChange:;
		notify: self ofSystemChangesOfChange: SdMessageEvent changeKind using: #onMessageReceive:.! !

!SdClassEditor methodsFor: 'initialization' stamp: 'mt 6/19/2012 14:03:25.987'!
initializeUi

	super initializeUi.	
	
	self
		initializeFinder;
		initializeCommentEditor;
		initializeDefinitionEditor;
		initializeCodeArea.

	"General controls."
	self connect: self ui saveAllBtn signal: #clicked: toSelector: #saveAll.
	self connect: self ui closeAllBtn signal: #clicked: toSelector: #tryCloseAll.
	self connect: self ui testBtn signal: #clicked: toSelector: #openTestResultList.
	
	"General callbacks. Scene-graph based."
	self sgConnectSignal: #symbolActivated: toSelector: #openSymbol:from: pattern: #(1 0).
	self sgConnectSignal: #aboutToDelete toSelector: #passKeyboardFocusFrom: pattern: #(0).
	self sgConnectSignal: #focusLostUpwards toSelector: #passKeyboardFocusUp.
	self sgConnectSignal: #focusLostDownwards toSelector: #passKeyboardFocusDown.! !

!SdClassEditor methodsFor: 'testing' stamp: 'mt 4/22/2011 16:53:04.923'!
isClassEditor

	^ true! !

!SdClassEditor methodsFor: 'actions' stamp: 'mt 4/12/2011 14:16:14.727'!
loadClassComment

	commentEditor theText: self theClass organization classComment.
	self updateCommentBtn.! !

!SdClassEditor methodsFor: 'actions' stamp: 'mt 4/18/2011 16:34:50.914'!
loadClassDefinition

	definitionEditor theText:
		self theClass definition,
		'.', String cr,
		self theClass theMetaClass definition.! !

!SdClassEditor methodsFor: 'actions' stamp: 'mt 4/29/2011 10:03:37.832'!
loadListOfOpenMethods

	(self class lastOpenMethods
		at: self theClass name
		ifAbsent: []) ifNotNil: [:methodReferences | self openMethods: methodReferences].! !

!SdClassEditor methodsFor: 'memento - ui' stamp: 'mt 7/4/2011 18:01:36.713'!
loadState: anEditorState

	super loadState: anEditorState.
	anEditorState loadClassEditor: self.! !

!SdClassEditor methodsFor: 'info messages' stamp: 'mt 6/15/2012 14:35:14.48'!
messageBounds

	^ self ui codeArea viewportBounds! !

!SdClassEditor methodsFor: 'signals' stamp: 'mt 6/28/2011 17:59:22.867'!
methodActivated: aMethodReference

	self emitInOwnerChain.! !

!SdClassEditor methodsFor: 'as yet unclassified' stamp: 'mt 2/15/2012 16:45:41.12'!
methodEditorAdded: aMethodEditor
	"This callback is triggered by SdMethodEditor column whenever method editors are added."! !

!SdClassEditor methodsFor: 'accessing - private' stamp: 'mt 7/5/2011 14:53:48.513'!
methodEditorColumn
	"Container where all class element editors are stored."
	
	^ self ui codeArea widget! !

!SdClassEditor methodsFor: 'accessing - private' stamp: 'mt 7/5/2011 15:01:58.301'!
methodEditors

	^ self methodEditorColumn methodEditors! !

!SdClassEditor methodsFor: 'signals' stamp: 'mt 6/28/2011 18:19:48.501'!
methodsOpened: someMethodReferences

	suppressMethodOpenedSignal == true
		ifTrue: [^ self].

	self emitInOwnerChain.! !

!SdClassEditor methodsFor: 'accessing' stamp: 'mt 6/19/2012 17:31:21.185'!
morphsOfInterest

	^ (self methodEditors select: [:me | me hasAnyKeyboard])! !

!SdClassEditor methodsFor: 'signals' stamp: 'mt 6/28/2011 18:11:10.638'!
objectActivated: anObject

	self emitInOwnerChain.! !

!SdClassEditor methodsFor: 'system changes' stamp: 'mt 4/27/2011 17:31:23.815'!
onCategoryChange: categoryKindEvent

	categoryKindEvent isAdded
		ifTrue: [
			self showInformation: ('Class category added: <b>', categoryKindEvent itemCategory, '</b>.') asHtmlText].
		
	classFinder update.! !

!SdClassEditor methodsFor: 'system changes' stamp: 'mt 5/12/2011 10:05:40.49'!
onClassChange: classKindEvent

	classKindEvent changeKind = SdMessageEvent changeKind
		ifTrue: [^ self].
	
	classKindEvent itemClass theNonMetaClass ~= self theClass
		ifTrue: [^ self "ignore"].
	
	classKindEvent isCommented
		ifTrue: [
			self showInformation: ('Comment changed.') asHtmlText.
			self loadClassComment].
		
	classKindEvent isModified
		ifTrue: [
			self showInformation: ('Definition changed.') asHtmlText.
			self editorChange: #definition].
		
	classKindEvent isAdded
		ifTrue: [classFinder update].! !

!SdClassEditor methodsFor: 'system changes' stamp: 'mt 4/18/2011 13:24:35.628'!
onMessageReceive: messageEvent

	messageEvent itemClass theNonMetaClass ~= self theClass
		ifTrue: [^ self "ignore"].
	
	messageEvent isInformation ifTrue: [self showInformation: messageEvent text].
	messageEvent isWarning ifTrue: [self showWarning: messageEvent text].
	messageEvent isError ifTrue: [self showError: messageEvent text].! !

!SdClassEditor methodsFor: 'system changes' stamp: 'mt 3/23/2012 14:21:03.424'!
onMethodChange: methodKindEvent

	| locationString |
	methodKindEvent itemClass theNonMetaClass ~= self theClass
		ifTrue: [^ self "ignore"].
	
	locationString := '<b>', methodKindEvent itemSelector asString, '</b>'.
	methodKindEvent isModified
		ifTrue: [self showInformation: ('Modified ', locationString) asHtmlText].
	methodKindEvent isRemoved
		ifTrue: [self showInformation: ('Removed ', locationString) asHtmlText].
	methodKindEvent isAdded
		ifTrue: [self showInformation: ('Added ', locationString) asHtmlText].
	methodKindEvent isRecategorized
		ifTrue: [self showInformation: ('Recategorized ', locationString, ' into <b>', methodKindEvent itemProtocol, '</b>') asHtmlText].
	
	(self methodEditorColumn submorphs allButLast
		detect: [:m | (m isKindOf: SdMethodEditor)
			and: [m selector = methodKindEvent itemSelector]
			and: [m theClass isMeta = methodKindEvent itemClass isMeta]]
		ifNone: []) ifNotNil: [:methodEditor |
			methodKindEvent isRemoved
				ifTrue: [methodEditor delete]
				ifFalse: [methodEditor reset]].
	
	finder update.! !

!SdClassEditor methodsFor: 'system changes' stamp: 'mt 4/18/2011 13:24:59.455'!
onProtocolChange: protocolKindEvent

	protocolKindEvent itemClass theNonMetaClass ~= self theClass
		ifTrue: [^ self "ignore"].
		
	protocolKindEvent isAdded 
		ifTrue: [self showInformation: ('Protocol added: <b>', protocolKindEvent itemProtocol, '</b>') asHtmlText].
		
	finder update.! !

!SdClassEditor methodsFor: 'accessing' stamp: 'mt 5/23/2011 17:51:00.669'!
openMethod: aMethodReference
	"Open new method editors in a collapsed state if not already opened."
	
	aMethodReference isValid ifTrue: [
		^ self addMethodEditorForReference: aMethodReference].
	
	^ nil! !

!SdClassEditor methodsFor: 'accessing' stamp: 'mt 6/21/2012 10:36:40.544'!
openMethods

	^ self methodEditors collect: [:methodEditor |
		methodEditor reference]! !

!SdClassEditor methodsFor: 'accessing' stamp: 'mt 5/12/2011 17:33:59.44'!
openMethods: someMethodReferences
	"Open new method editors in a collapsed state if not already opened."
	
	suppressMethodOpenedSignal := true.
	
	someMethodReferences do: [:ref | self openMethod: ref].
	
	suppressMethodOpenedSignal := false.
	
	self methodsOpened: someMethodReferences.  ! !

!SdClassEditor methodsFor: 'actions' stamp: 'mt 5/20/2011 14:33:00.915'!
openSymbol: aSymbol
	"Open a method editor."
	
	^ self openSymbol: aSymbol from: nil! !

!SdClassEditor methodsFor: 'actions' stamp: 'mt 2/15/2012 16:15:40.242'!
openSymbol: aSymbol from: anEditor
	"Open a method editor. Lookup correct type if possible."
	
	"Guess local selectors."
	(self theClass selectors includes: aSymbol)
		ifTrue: [^ self addMethodEditor: aSymbol isMeta: false].
		
	(self theClass theMetaClass selectors includes: aSymbol)
		ifTrue: [^ self addMethodEditor: aSymbol isMeta: true].

	"Guess other classes."
	(Smalltalk includesKey: aSymbol) ifTrue: [ | obj |
		obj := Smalltalk at: aSymbol.
		self classActivated: (obj isBehavior
			ifTrue: [obj] ifFalse: [obj class "global var"])].! !

!SdClassEditor methodsFor: 'test handling' stamp: 'mt 5/12/2011 14:11:44.275'!
openTestResultList
	"Shows a popup menu with the last test runs that allows to open specific methods."
	
	| menu |
	menu := MenuMorph new
		defaultTarget: self;
		addTitle: ('--- {1} passed, {2} failed, {3} errors ---' format: {
			(self theClass lastRun at: #passed) size.
			(self theClass lastRun at: #failures) size.
			(self theClass lastRun at: #errors) size}).
		
	menu
		add: 'Run all tests' action: #runAllTests;
		addLine.
	
	(self theClass lastRun at: #failures) do: [:testSelector |
		menu
			add: testSelector
			selector: #openSymbol:
			argument: testSelector].
		
	menu addLine.
	
	(self theClass lastRun at: #errors) do: [:testSelector |
		menu
			add: testSelector
			selector: #openSymbol:
			argument: testSelector].

	menu
		popUpAt: ActiveHand position truncated
		forHand: ActiveHand
		in: ActiveWorld
		allowKeyboard: false.! !

!SdClassEditor methodsFor: 'geometry' stamp: 'mt 5/11/2011 11:17:19.4'!
optimalWidth

	| maxWidth |
	maxWidth := 0.
	self methodEditors do: [:me |
		maxWidth := maxWidth max: me optimalWidth].
	^ maxWidth! !

!SdClassEditor methodsFor: 'actions - focus' stamp: 'mt 7/4/2011 14:24:23.106'!
passKeyboardFocusDown

	| newEditor methodEditors |
	methodEditors := self methodEditors.
	newEditor := (methodEditors at: ((methodEditors indexOf:
		(methodEditors detect: [:m | m hasKeyboard]))
		+ 1 min: methodEditors size)).

	newEditor grabKeyboard.
	self ui codeArea scrollToShow: newEditor bounds duration: 500.! !

!SdClassEditor methodsFor: 'actions - focus' stamp: 'mt 9/1/2011 20:39:07.045'!
passKeyboardFocusFrom: aMethodEditor
	"This is useful when the given editor does not need the focus anymore, e.g., when about to be deleted."
	
	aMethodEditor hasKeyboard
		ifFalse: [^ self].
	
	(self methodEditors indexOf: aMethodEditor) < (self methodEditorColumn submorphs size - 1)
		ifTrue: [self passKeyboardFocusDown]  
		ifFalse: [self passKeyboardFocusUp].
		
	self methodEditorColumn submorphs size = 2 "given + shadow => empty after deletion"
		ifTrue: [self ui findBtn checked: true. finder grabKeyboard].! !

!SdClassEditor methodsFor: 'actions - focus' stamp: 'mt 7/4/2011 14:23:55.271'!
passKeyboardFocusUp

	| newEditor methodEditors |
	methodEditors := self methodEditors.
	newEditor := (methodEditors at: ((methodEditors indexOf:
		(methodEditors detect: [:m | m hasKeyboard]))
		- 1 max: 1)).
	
	newEditor grabKeyboard.
	self ui codeArea scrollToShow: newEditor bounds duration: 500.  ! !

!SdClassEditor methodsFor: 'actions - class' stamp: 'mt 6/15/2012 15:04:10.773'!
popupSubClassList: aMouseEvent

	| menu |
	menu := MenuMorph new
		defaultTarget: self;
		title: (aMouseEvent shiftPressed
			ifTrue: ['--- Switch to Subclass ---']
			ifFalse: ['--- Open Subclass ---']).
		
	(self theClass subclasses sortBy: [:c1 :c2 | c1 name <= c2 name])
		do: [:class | 
			menu
				add: class name
				selector: (aMouseEvent shiftPressed
					ifTrue: [#tryChangeClass:]
					ifFalse: [#classActivated:])
				argument: class].
		
	menu
		popUpAt: ActiveHand position truncated
		forHand: ActiveHand
		in: ActiveWorld
		allowKeyboard: false.! !

!SdClassEditor methodsFor: 'actions - class' stamp: 'mt 6/15/2012 15:03:51.45'!
popupSuperClassList: aMouseEvent

	| menu |
	menu := MenuMorph new
		defaultTarget: self;
		title: (aMouseEvent shiftPressed
			ifTrue: ['--- Switch to Superclass ---']
			ifFalse: ['--- Open Superclass ---']).
		
	self theClass allSuperclasses reverseDo: [:class | 
		menu
			add: class name
			selector: (aMouseEvent shiftPressed
					ifTrue: [#tryChangeClass:]
					ifFalse: [#classActivated:])
			argument: class].
		
	menu
		popUpAt: ActiveHand position truncated
		forHand: ActiveHand
		in: ActiveWorld
		allowKeyboard: false.! !

!SdClassEditor methodsFor: 'test handling' stamp: 'mt 5/12/2011 10:51:49.203'!
runAllTests

	Cursor wait showWhile: [
		self theClass suite run
			dispatchResultsIntoHistory].
	
	self updateTestBtn.! !

!SdClassEditor methodsFor: 'save & load' stamp: 'mt 5/26/2011 18:00:55.622'!
saveAll

	commentEditor acceptChanges.
		
	self methodEditors
		do: [:methodEditor | methodEditor saveMethod].! !

!SdClassEditor methodsFor: 'actions' stamp: 'mt 4/13/2011 15:46:01.523'!
saveClassComment

	self theClass organization classComment = commentEditor theText
		ifTrue: [^ self].

	self theClass comment: commentEditor theText.
	self updateCommentBtn.! !

!SdClassEditor methodsFor: 'actions' stamp: 'mt 4/12/2011 15:41:53.82'!
saveClassDefinition

! !

!SdClassEditor methodsFor: 'actions' stamp: 'mt 4/29/2011 10:03:09.529'!
saveListOfOpenMethods

	self class lastOpenMethods
		at: self theClass name
		put: self openMethods.! !

!SdClassEditor methodsFor: 'memento - ui' stamp: 'mt 7/4/2011 15:19:41.004'!
saveState: anEditorState

	super saveState: anEditorState.
	anEditorState saveClassEditor: self.! !

!SdClassEditor methodsFor: 'scrolling' stamp: 'mt 5/23/2011 17:51:29.89'!
scrollToShow: aMethodEditor
	
	self ui codeArea layoutChanged; fullBounds. 
	self ui codeArea scrollToShow: aMethodEditor bounds duration: 500.! !

!SdClassEditor methodsFor: 'layouting' stamp: 'mt 4/11/2011 14:18:43.761'!
showTopContainer

	self ui topContainer
		show;
		disableTableLayout: false.! !

!SdClassEditor methodsFor: 'accessing' stamp: 'mt 2/15/2012 16:42:31.486'!
theClass

	^ theClass! !

!SdClassEditor methodsFor: 'accessing' stamp: 'mt 2/15/2012 16:42:59.403'!
theClass: aClassOrMetaClass

	theClass = aClassOrMetaClass theNonMetaClass ifTrue: [^ self].
	
	theClass := aClassOrMetaClass theNonMetaClass.
	
	self editorChange: #class.! !

!SdClassEditor methodsFor: 'actions' stamp: 'mt 4/12/2011 15:31:33.22'!
toggleCommentEditor

	self ui commentBtn checked
		ifTrue: [
			self ui topContainer addMorphBack: commentEditor.
			commentEditor grabKeyboard]
		ifFalse: [commentEditor delete].! !

!SdClassEditor methodsFor: 'actions' stamp: 'mt 4/12/2011 15:31:45.865'!
toggleDefinitionEditor

	self ui definitionBtn checked
		ifTrue: [
			self ui topContainer addMorphBack: definitionEditor.
			definitionEditor grabKeyboard]
		ifFalse: [definitionEditor delete].! !

!SdClassEditor methodsFor: 'actions' stamp: 'mt 4/15/2011 10:22:56.489'!
toggleFinder

	self ui findBtn checked
		ifTrue: [ | resizeHandle |
			resizeHandle := SdResizeHandle new orientation: #horizontal.  
			resizeHandle target: finder ui resultList.
			self connect: finder signal: #deleted to: resizeHandle selector: #delete.
			self ui topContainer
				addMorphBack: finder;
				addMorphBack: resizeHandle.  
			finder grabKeyboard]
		ifFalse: [finder delete].! !

!SdClassEditor methodsFor: 'actions' stamp: 'mt 4/29/2011 15:19:39.903'!
tryBrowseClasses

	| msg |
	self hasUnacceptedChanges
		ifFalse: [^ self browseClasses].

	msg := SdOverlayMessageBox new
		title: 'Browse classes';
		message: 'There are unaccepted changes.' icon: UiSilkIcons informationIcon.
	msg addAction: 'Save all changes.' icon: UiSilkIcons diskMultipleIcon receiver: self selectors: #(saveAll tryBrowseClasses).
	msg addAction: 'Ignore all changes.' icon: UiSilkIcons binIcon receiver: self selectors: #(browseClasses).
	msg addAction: 'Abort this action.' icon: UiSilkIcons cancelIcon.
	
	msg showAbove: self.! !

!SdClassEditor methodsFor: 'actions' stamp: 'mt 5/19/2011 13:49:18.236'!
tryChangeClass: aClass
	"Change the currently used class. The edit UI needs to be visible here."
	
	| msg |
	self saveListOfOpenMethods.
	
	self hasUnacceptedChanges
		ifFalse: [^ self theClass: aClass].

	msg := SdOverlayMessageBox new
		title: 'Switch to class ', aClass name;
		message: 'There are unaccepted changes in ''', self theClass name,'''.' icon: UiSilkIcons informationIcon.
	(msg addAction: 'Save all changes.' icon: UiSilkIcons diskMultipleIcon receiver: self selector: #saveAll)
		ifNotNil: [:button | self connect: button signal: #clicked: toSelector: #tryChangeClass: pattern: {#=. aClass}].
	(msg addAction: 'Ignore all changes.' icon: UiSilkIcons binIcon)
		ifNotNil: [:button | self connect: button signal: #clicked: toSelector: #theClass: pattern: {#=. aClass}].
	msg addAction: 'Abort this action.' icon: UiSilkIcons cancelIcon.
	
	msg showAbove: self.! !

!SdClassEditor methodsFor: 'actions' stamp: 'mt 4/29/2011 15:04:46.48'!
tryCloseAll

	| msg |
	self hasUnacceptedChanges
		ifFalse: [^ self closeAll].
		
	msg := SdOverlayMessageBox new
		title: 'Close all editors';
		message: 'There are unaccepted changes.' icon: UiSilkIcons informationIcon.
	msg addAction: 'Save all changes.' icon: UiSilkIcons diskMultipleIcon receiver: self selectors: #(saveAll tryCloseAll).
	msg addAction: 'Ignore all changes.' icon: UiSilkIcons binIcon receiver: self selectors: #(closeAll).
	msg addAction: 'Abort this action.' icon: UiSilkIcons cancelIcon.
	
	msg showAbove: self.  ! !

!SdClassEditor methodsFor: 'initialization' stamp: 'mt 6/15/2012 14:12:35.054'!
uiClass

	^ SdClassEditorUi! !

!SdClassEditor methodsFor: 'updating' stamp: 'mt 4/12/2011 14:16:04.294'!
updateCommentBtn

	commentEditor theText
		ifEmpty: [self ui commentBtn icon: UiSilkIcons commentAddIcon]
		ifNotEmpty: [self ui commentBtn icon: UiSilkIcons commentIcon].! !

!SdClassEditor methodsFor: 'updating' stamp: 'mt 5/17/2011 12:04:21.927'!
updateTestBtn

	(self theClass inheritsFrom: TestCase)
		ifTrue: [self ui testBtn show]  
		ifFalse: [^ self ui testBtn hide].
		
	self ui testBtn icon: (SdMethodFinder iconForClass: self theClass).! !

!SdEditor class methodsFor: 'accessing' stamp: 'mt 6/28/2011 20:57:53.705'!
editorDescription

	^ 'n/a'! !

!SdEditor class methodsFor: 'accessing' stamp: 'mt 7/3/2011 08:56:10.122'!
editorGroup

	^ 99 "at last"! !

!SdEditor class methodsFor: 'accessing' stamp: 'mt 6/28/2011 14:30:47.202'!
editorIcon

	^ UiFugueIcons questionWhiteIcon! !

!SdEditor class methodsFor: 'accessing' stamp: 'mt 6/28/2011 20:57:44.789'!
editorName

	^ 'Editor'! !

!SdEditor class methodsFor: 'testing' stamp: 'mt 6/28/2011 21:09:44.815'!
isStandAlone
	"Check whether this editor is useful when instantiating it with #new."
	^ false! !

!SdEditor class methodsFor: 'testing' stamp: 'mt 6/28/2011 14:24:36.767'!
isWidgetClass

	^ false! !

!SdEditor methodsFor: 'geometry - actions' stamp: 'mt 7/2/2011 15:19:45.94'!
collapse

	self ui panel submorphs size = 1
		ifTrue: [^ self "already hidden"].
		
	self
		setProperty: #hiddenSubmorphs
		toValue: (self ui panel submorphs copyWithout: self ui panel firstSubmorph).
		
	self ui panel
		removeAllMorphsIn: (self valueOfProperty: #hiddenSubmorphs);
		vResizing: #shrinkWrap.
		
	self
		vResizing: #shrinkWrap;
		layoutInset: (0 @ 2 corner: 0@ -3).
	
	"Not really necessary but there are some UI interactions that make inconsistency possible here."
	self ui hideBtn checked: false.! !

!SdEditor methodsFor: 'accessing' stamp: 'mt 6/20/2012 11:24:08.996'!
column

	self allOwnersDo: [:morph |
		(morph isKindOf: SdEditorColumn)
			ifTrue: [^ morph]].
	^ nil! !

!SdEditor methodsFor: 'geometry' stamp: 'mt 6/15/2012 12:30:56.58'!
defaultWidth

	^ 300 max: self minimalWidth! !

!SdEditor methodsFor: 'drawing' stamp: 'mt 6/20/2012 11:29:36.948'!
drawOn: aCanvas
	
	aCanvas
		fillRectangle: self bounds
		color: (Color gray: 0.85).
	
	self drawTopLineOn: aCanvas.! !

!SdEditor methodsFor: 'drawing' stamp: 'mt 7/1/2011 17:32:48.497'!
drawTopLineOn: aCanvas
	
	aCanvas
		line: self topLeft to: self topRight color: (Color gray: 0.5);
		line: self topLeft + (0@1) to: self topRight + (0@1) color: (Color gray: 0.7).! !

!SdEditor methodsFor: 'geometry - actions' stamp: 'mt 7/2/2011 15:19:04.426'!
expand

	self ui panel submorphs size > 1
		ifTrue: [^ self "already visible"].
		
	self ui panel
		addAllMorphs: (self valueOfProperty: #hiddenSubmorphs);
		vResizing: #spaceFill.
		
	self
		vResizing: #spaceFill;
		layoutInset: 0;
		removeProperty: #hiddenSubmorphs.
	
	"Not really necessary but there are some UI interactions that make inconsistency possible here."
	self ui hideBtn checked: true.! !

!SdEditor methodsFor: 'focus' stamp: 'mt 6/18/2012 16:44:55.379'!
focusChanged: aGlobalRectangle

	self emitInOwnerChain.! !

!SdEditor methodsFor: 'accessing - header' stamp: 'mt 5/15/2012 11:18:18.512'!
header

	^ self isFloating
		ifTrue: [self owner "system window"]
		ifFalse: [self ui panel submorphs first]! !

!SdEditor methodsFor: 'accessing - header' stamp: 'mt 3/22/2012 12:08:28.221'!
headerColor

	^ self header color! !

!SdEditor methodsFor: 'accessing - header' stamp: 'mt 3/22/2012 11:59:21.647'!
headerColor: aColor

	| fillStyle header |
	header := self header.
	fillStyle := aColor = (Color gray: 0.85)
		ifTrue: [aColor]
		ifFalse: [(GradientFillStyle ramp: {
			0.15 -> (Color gray: 0.85).
			0.5 -> aColor.
			0.85 -> (Color gray: 0.85)})
			origin: header topLeft;
			direction: 0 @ header height].
	header fillStyle: fillStyle.! !

!SdEditor methodsFor: 'accessing - header' stamp: 'mt 5/15/2012 11:14:57.519'!
headerText

	^ self ui headerBtn text! !

!SdEditor methodsFor: 'accessing - header' stamp: 'mt 6/15/2012 14:34:06.855'!
headerText: aText

	self ui headerBtn text: aText.! !

!SdEditor methodsFor: 'initialization' stamp: 'mt 6/15/2012 14:27:46.35'!
initialize

	super initialize.
	
	self
		initializeUi;
		initializeEventHandler;
		initializeSystemChangeNotifications.! !

!SdEditor methodsFor: 'initialization' stamp: 'mt 6/15/2012 14:07:38.253'!
initializeEventHandler

	self eventHandler: UiEventHandler new.
	
	self
		connect: self eventHandler
		signal: #focusReceivedInSubmorph:
		toSelector: #setHeaderFocus:
		pattern: #(=true).
		
	self
		connect: self eventHandler
		signal: #focusLostInSubmorph:
		toSelector: #setHeaderFocus:
		pattern: #(=false).! !

!SdEditor methodsFor: 'initialization' stamp: 'mt 6/19/2012 16:17:38.267'!
initializeHeader
	"Call this if your UI contains the same elements in the header."

	self connect: self ui closeBtn signal: #clicked: toSelector: #tryClose.
	self connect: self ui hideBtn signal: #toggled: toSelector: #onVisibilityChanged:.
	self ui headerBtn target: self.! !

!SdEditor methodsFor: 'initialization' stamp: 'mt 6/15/2012 14:27:39.192'!
initializeSystemChangeNotifications! !

!SdEditor methodsFor: 'initialization' stamp: 'mt 6/18/2012 16:59:46.905'!
initializeUi

	self ui setupUi: self.
	self
		vResizing: #spaceFill;
		initializeHeader;
		width: self defaultWidth.! !

!SdEditor methodsFor: 'geometry - testing' stamp: 'mt 7/2/2011 14:57:11.701'!
isCollaped

	^ self isExpanded not! !

!SdEditor methodsFor: 'geometry - testing' stamp: 'mt 7/2/2011 14:57:03.704'!
isExpanded

	^ self vResizing == #spaceFill! !

!SdEditor methodsFor: 'geometry - testing' stamp: 'mt 5/3/2011 14:44:05.565'!
isFloating

	^ self owner notNil and: [self owner isSystemWindow]! !

!SdEditor methodsFor: 'memento - ui' stamp: 'mt 6/20/2012 11:12:29.005'!
loadState: anEditorState

	anEditorState loadEditor: self.! !

!SdEditor methodsFor: 'overlay messages' stamp: 'mt 6/15/2012 11:52:38.988'!
messageBounds

	^ self ui panel bounds! !

!SdEditor methodsFor: 'overlay messages' stamp: 'mt 6/15/2012 11:54:06.089'!
messagePosition
	"Return the position for the next/current message."

	| corner |
	corner := self messageBounds bottomRight.
	^ corner + (-1 @ 
			(((self submorphs
				select: [:m | m isKindOf: UiMessage]
				thenCollect: [:m | m top + 1]), {corner y}) min - corner y))! !

!SdEditor methodsFor: 'geometry' stamp: 'mt 6/15/2012 12:31:36.03'!
minimalWidth
	"Editors should never be smaller than this size."
	
	^ 100! !

!SdEditor methodsFor: 'accessing' stamp: 'mt 6/19/2012 17:05:12.345'!
morphsOfInterest
	"Return the morphs that are currently most important."
	
	^ {self}! !

!SdEditor methodsFor: 'geometry - callbacks' stamp: 'mt 7/1/2011 22:58:41.227'!
onVisibilityChanged: aBoolean

	aBoolean
		ifTrue: [self expand]
		ifFalse: [self collapse].! !

!SdEditor methodsFor: 'geometry - actions' stamp: 'mt 6/15/2012 11:32:06.643'!
openInWindow
	"Open in own system window."
	
	self eventHandler
		disconnectSignal: #focusReceivedInSubmorph:
		from: self;
		disconnectSignal: #focusLostInSubmorph:
		from: self.
	
	self header delete.
	
	^ (SdToolWindow
		morph: self
		label: self headerText)! !

!SdEditor methodsFor: 'geometry' stamp: 'mt 6/15/2012 11:33:35.887'!
optimalWidth
	"Editors should provide an optimal width because convenient resize interactions are provided by the IDE."
	
	^ self defaultWidth! !

!SdEditor methodsFor: 'memento - ui' stamp: 'mt 6/20/2012 11:12:39.916'!
saveState: anEditorState

	anEditorState saveEditor: self.! !

!SdEditor methodsFor: 'focus' stamp: 'mt 6/20/2012 11:14:45.925'!
setHeaderFocus: aBoolean
	
	aBoolean
		ifTrue: [
			self headerColor: (Color r: 0.2 g: 0.5 b: 1.0).
			self ui headerBtn text: ('<font color="#FFFFFF"><b>', self ui headerBtn text asString, '</b></font>') asHtmlText.
			
			self focusChanged: self boundsInWorld]
		ifFalse: [
			self headerColor: (Color gray: 0.85).
			self ui headerBtn text: ('<font color="#000000">', self ui headerBtn text asString, '</font>') asHtmlText	]! !

!SdEditor methodsFor: 'overlay messages' stamp: 'mt 6/15/2012 11:53:38.719'!
showError: aText
		
	self addMorph: ((UiMessage error: aText)
		disableTableLayout: true;  
		bottomRight: self messagePosition).! !

!SdEditor methodsFor: 'overlay messages' stamp: 'mt 6/15/2012 11:53:38.738'!
showInformation: aText
		
	self addMorph: ((UiMessage information: aText)
		disableTableLayout: true;  
		bottomRight: self messagePosition).! !

!SdEditor methodsFor: 'overlay messages' stamp: 'mt 6/15/2012 11:53:38.7'!
showWarning: aText
		
	self addMorph: ((UiMessage warning: aText)
		disableTableLayout: true;  
		bottomRight: self messagePosition).! !

!SdEditor methodsFor: 'accessing - ui' stamp: 'mt 5/18/2012 11:01:07.678'!
ui
	
	^ ui ifNil: [ui := self uiClass new]! !

!SdEditor methodsFor: 'accessing - ui' stamp: 'mt 5/18/2012 11:00:56.04'!
uiClass
	"Return the user interface class for the editor."
	
	self subclassResponsibility.! !

SdEditor subclass: #SdMethodContainer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sight-Dynamic'!

!SdMethodContainer methodsFor: 'memento - data' stamp: 'mt 6/20/2012 13:21:24.165'!
acceptChanges

	self methodEditors do: [:methodEditor |
		methodEditor saveMethod].! !

!SdMethodContainer methodsFor: 'initialization' stamp: 'mt 6/21/2012 10:50:27.441'!
addMethodEditorForReference: aMethodReference

	| m |
	"aMethodReference isValid ifFalse: [^ self]."

	(self methodEditors
		detect: [:methodEditor | methodEditor reference = aMethodReference]
		ifNone: []) ifNotNil: [:methodEditor | ^ methodEditor].

	m := SdMethodEditor new
			theClass: aMethodReference actualClass
			selector: aMethodReference selector;
			hResizing: #spaceFill.
			
	self methodEditorColumn addMethodEditor: m.
	
	self connect: m artifact signal: #mouseWheelUp:
		to: self ui codeArea verticalScrollBar selector: #decreaseValueBySingleStep.
	self connect: m artifact signal: #mouseWheelDown:
		to: self ui codeArea verticalScrollBar selector: #increaseValueBySingleStep.
	
	^ m! !

!SdMethodContainer methodsFor: 'memento - data' stamp: 'mt 5/26/2011 18:04:47.459'!
hasUnacceptedChanges

	^ self methodEditors anySatisfy: [:e |
		e hasUnacceptedChanges]! !

!SdMethodContainer methodsFor: 'initialization' stamp: 'mt 6/19/2012 18:52:05.218'!
initializeCodeArea

	self ui codeArea verticalScrollBar
		singleStep: 20;
		outerBorderWidth: 0;
		color: Color transparent.
	self ui codeArea transformMorph
		color: (Color gray: 0.3).

	self ui codeArea widget: SdMethodEditorColumn new.
	self ui codeArea sgConnectSignal: #focusChanged: toSelector: #scrollToShowGlobal:.
! !

!SdMethodContainer methodsFor: 'initialization' stamp: 'mt 6/19/2012 18:50:02.266'!
initializeHeader

	self connect: self ui closeBtn signal: #clicked: toSelector: #tryClose.
	self ui headerBtn target: self.! !

!SdMethodContainer methodsFor: 'initialization' stamp: 'mt 6/21/2012 10:13:08.596'!
initializeUi

	super initializeUi.
			
	self initializeCodeArea.
	
	"General callbacks. Scene-graph based."
	self sgConnectSignal: #aboutToClose toSelector: #passKeyboardFocusFrom: pattern: #(0).
	self sgConnectSignal: #focusLostUpwards toSelector: #passKeyboardFocusUp.
	self sgConnectSignal: #focusLostDownwards toSelector: #passKeyboardFocusDown.
	
	self sgConnectSignal: #methodActivated: toSelector: #openMethod:.! !

!SdMethodContainer methodsFor: 'accessing' stamp: 'mt 7/5/2011 14:54:20.5'!
methodEditorColumn

	^ self ui codeArea widget! !

!SdMethodContainer methodsFor: 'accessing' stamp: 'mt 7/5/2011 14:54:40.348'!
methodEditors

	^ self methodEditorColumn methodEditors! !

!SdMethodContainer methodsFor: 'accessing' stamp: 'mt 6/19/2012 18:57:07.612'!
morphsOfInterest

	^ (self methodEditors select: [:me | me hasAnyKeyboard])! !

!SdMethodContainer methodsFor: 'actions' stamp: 'mt 6/19/2012 19:12:11.607'!
openMethod: aMethodReference
	"Open new method editors in a collapsed state if not already opened."
	
	aMethodReference isValid ifTrue: [
		^ (self addMethodEditorForReference: aMethodReference)
			expand].
	
	^ nil! !

!SdMethodContainer methodsFor: 'as yet unclassified' stamp: 'mt 6/21/2012 15:43:40.342'!
optimalWidth

	^ self methodEditors
		inject: 0
		into: [:max :editor | max max: editor optimalWidth]! !

!SdMethodContainer methodsFor: 'actions - focus' stamp: 'mt 6/19/2012 19:03:59.286'!
passKeyboardFocusDown

	| newEditor methodEditors |
	methodEditors := self methodEditors.
	newEditor := (methodEditors at: ((methodEditors indexOf:
		(methodEditors detect: [:m | m hasKeyboard]))
		+ 1 min: methodEditors size)).

	newEditor grabKeyboard.
	self ui codeArea scrollToShow: newEditor bounds duration: 500.! !

!SdMethodContainer methodsFor: 'actions - focus' stamp: 'mt 6/20/2012 13:23:29.152'!
passKeyboardFocusFrom: aMethodEditor
	"This is useful when the given editor does not need the focus anymore, e.g., when about to be deleted."
	
	aMethodEditor hasKeyboard
		ifFalse: [^ self].
	
	(self methodEditors indexOf: aMethodEditor) < self methodEditors size
		ifTrue: [self passKeyboardFocusDown]  
		ifFalse: [self passKeyboardFocusUp].! !

!SdMethodContainer methodsFor: 'actions - focus' stamp: 'mt 6/19/2012 19:03:54.524'!
passKeyboardFocusUp

	| newEditor methodEditors |
	methodEditors := self methodEditors.
	newEditor := (methodEditors at: ((methodEditors indexOf:
		(methodEditors detect: [:m | m hasKeyboard]))
		- 1 max: 1)).
	
	newEditor grabKeyboard.
	self ui codeArea scrollToShow: newEditor bounds duration: 500.! !

!SdMethodContainer methodsFor: 'initialization' stamp: 'mt 6/15/2012 12:52:00.849'!
uiClass

	^ SdMethodContainerUi! !

SdEditor subclass: #SdObjectExplorer
	uses: TSdDynamicActivation
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sight-Dynamic'!

SdObjectExplorer class
	uses: TSdDynamicActivation classTrait
	instanceVariableNames: ''!

!SdObjectExplorer class methodsFor: 'accessing' stamp: 'mt 6/28/2011 20:59:39.164'!
editorDescription

	^ 'Explore an object with all properties in a tree view.'! !

!SdObjectExplorer class methodsFor: 'accessing' stamp: 'mt 6/28/2011 14:32:01.771'!
editorIcon

	^ UiFugueIcons nodeMagnifierIcon! !

!SdObjectExplorer class methodsFor: 'accessing' stamp: 'mt 6/28/2011 20:59:15.667'!
editorName

	^ 'Object Explorer'! !

!SdObjectExplorer methodsFor: 'accessing - model' stamp: 'mt 4/17/2012 10:46:50.864'!
allNodes

	^ self callgraph selectMethodCalls: self node clientReference! !

!SdObjectExplorer methodsFor: 'accessing - model' stamp: 'mt 4/17/2012 10:43:21.66'!
callgraph

	^ self ui treeView model callgraph! !

!SdObjectExplorer methodsFor: 'actions' stamp: 'mt 3/22/2012 17:01:18.541'!
changeReceiverFor: anObjectExplorerNode
	"Make do-its in source code edit relative to selected object in tree."
	
	self ui sourceCodeEdit doItReceiver:
		(anObjectExplorerNode ifNotNil: [:node | 
			node baseObject]).! !

!SdObjectExplorer methodsFor: 'dynamic - signals - activation' stamp: ''!
classActivated: aClass

	self emitInOwnerChain.! !

!SdObjectExplorer methodsFor: 'events' stamp: 'mt 6/15/2012 12:22:28.59'!
grabKeyboard
	"Always pass the keyboard focus on to the tree."

	self ui treeView grabKeyboard.! !

!SdObjectExplorer methodsFor: 'initialization' stamp: 'mt 4/17/2012 10:16:12.887'!
initializeTree
	
	self ui treeView
		addColumns: {
			UiItemViewColumnSpec newFrom: {#text -> #tag. #headerText -> 'Property'}.
			(UiItemViewColumnSpec newFrom: {#text -> #beforeText. #icon -> #beforeIcon. #menu -> #beforeMenu. #headerText -> 'Before'. #balloonText -> #beforeClass}) balloonTextConverter: [:classOrNil | classOrNil ifNotNil: [:class | class name]].
			(UiItemViewColumnSpec newFrom: {#text -> #afterText. #icon -> #afterIcon. #menu -> #afterMenu. #headerText -> 'After'. #balloonText -> #afterClass})
			balloonTextConverter: [:classOrNil | classOrNil ifNotNil: [:class | class name]]};
		addHorizontalHeader;
		model: SdObjectExplorerModel new;
		setResizeModeForColumn: 2 to: #rigid;
		setWidthForColumn: 2 to: 100;
		setResizeModeForColumn: 3 to: #rigid;
		setWidthForColumn: 3 to: 100.

	self connect: self ui treeView model signal: #classActivated: toSelector: #classActivated:. 
	self connect: self ui treeView model signal: #methodActivated: toSelector: #methodActivated:.
	self connect: self ui treeView model signal: #objectActivated: toSelector: #objectActivated:.
	self connect: self ui treeView model signal: #traceActivated: toSelector: #traceActivated:.
! !

!SdObjectExplorer methodsFor: 'initialization' stamp: 'mt 6/21/2012 14:31:15.232'!
initializeUi

	super initializeUi.

	self initializeTree.
		
	self ui sourceCodeEdit
		colorFocusBackground: Color white;
		colorFocusBorder: (Color gray: 0.3);
		updateFocusColor: false. "TODO: remove"
	
	self ui sourceCodeEdit eventHandler grabKeyboardOnMouseEnter: true.  
	
	self connect: self ui treeView signal: #currentNodeChanged: toSelector: #changeReceiverFor:.! !

!SdObjectExplorer methodsFor: 'memento - ui' stamp: 'mt 7/4/2011 18:06:49.715'!
loadState: anEditorState

	super loadState: anEditorState.
	anEditorState loadObjectExplorer: self.! !

!SdObjectExplorer methodsFor: 'dynamic - signals - activation' stamp: ''!
methodActivated: aMethodReference

	self emitInOwnerChain.! !

!SdObjectExplorer methodsFor: 'accessing' stamp: 'mt 7/3/2012 11:37:00.018'!
morphsOfInterest

	self flag: #invasive.
	^ self ui treeView selection cells collect: [:cell |
		self ui treeView viewport morphAt: cell]! !

!SdObjectExplorer methodsFor: 'accessing - model' stamp: 'mt 4/17/2012 10:42:49.545'!
node

	^ self ui treeView model node! !

!SdObjectExplorer methodsFor: 'accessing - model' stamp: 'mt 3/22/2012 16:53:32.041'!
object

	^ self ui treeView model baseObject! !

!SdObjectExplorer methodsFor: 'accessing' stamp: 'mt 4/17/2012 10:55:21.421'!
object: anObject
	"Set the object that is explored."

	self ui treeView model setStateChange: anObject.	
	self ui headerBtn text: (self object asString truncateWithElipsisTo: 25).

	"self ui callSlider disconnectSignal: #valueChanged:.
	self ui callSlider
		minimum: 1;
		maximum: (self callgraph selectMethodCalls: self node clientReference) size;
		currentValue: 1.
	self connect: self ui callSlider signal: #valueChanged: toSelector: #selectNode:."! !

!SdObjectExplorer methodsFor: 'dynamic - signals - activation' stamp: ''!
objectActivated: anObject

	self emitInOwnerChain.! !

!SdObjectExplorer methodsFor: 'geometry' stamp: 'mt 7/23/2011 11:02:12.872'!
optimalWidth

	^ super optimalWidth max: self ui treeView optimalWidth! !

!SdObjectExplorer methodsFor: 'memento - ui' stamp: 'mt 7/4/2011 15:19:40.783'!
saveState: anEditorState

	super saveState: anEditorState.
	anEditorState saveObjectExplorer: self.! !

!SdObjectExplorer methodsFor: 'actions' stamp: 'mt 4/17/2012 10:47:59.634'!
selectNode: anInteger! !

!SdObjectExplorer methodsFor: 'dynamic - signals - activation' stamp: ''!
traceActivated: aNode

	self emitInOwnerChain.! !

!SdObjectExplorer methodsFor: 'accessing - ui' stamp: 'mt 6/15/2012 12:21:21.228'!
uiClass

	^ SdObjectExplorerUi! !

SdEditor subclass: #SdPackageViewer
	uses: TSdDynamicActivation
	instanceVariableNames: 'previewPanel'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sight-Dynamic'!

SdPackageViewer class
	uses: TSdDynamicActivation classTrait
	instanceVariableNames: ''!

!SdPackageViewer class methodsFor: 'accessing' stamp: 'mt 6/28/2011 21:00:25.713'!
editorDescription

	^ 'Explore a whole package.'! !

!SdPackageViewer class methodsFor: 'accessing' stamp: 'mt 7/3/2011 08:57:01.081'!
editorGroup

	^ 2! !

!SdPackageViewer class methodsFor: 'accessing' stamp: 'mt 6/28/2011 14:33:54.861'!
editorIcon

	^ UiSilkIcons packageIcon! !

!SdPackageViewer class methodsFor: 'accessing' stamp: 'mt 6/28/2011 21:00:10.644'!
editorName

	^ 'Package Viewer'! !

!SdPackageViewer class methodsFor: 'testing' stamp: 'mt 6/28/2011 21:10:37.331'!
isStandAlone

	^ true! !

!SdPackageViewer methodsFor: 'actions' stamp: 'mt 6/20/2012 13:35:46.878'!
activateItem: aCodeNode

	aCodeNode isMethodNode ifTrue: [
		^ self methodActivated: aCodeNode method methodReference].

	aCodeNode isClassNode ifTrue: [
		^ self classActivated: aCodeNode theClass].
! !

!SdPackageViewer methodsFor: 'actions' stamp: 'mt 2/12/2012 18:21:25.226'!
choosePackage

	self ui packageCombo currentItem ifNil: [^ self].

	self ui treeView model packageInfo:
		(PackageInfo named: (self ui packageCombo currentItem
			at: #package)).! !

!SdPackageViewer methodsFor: 'actions - monticello' stamp: 'mt 5/20/2011 09:30:08.701'!
chooseRepository

	| menu |
	menu := MenuMorph new
		defaultTarget: self.
	
	self workingCopy repositoryGroup repositoriesDo: [:repo | menu add: repo description selector: #synchronizeWith: argument: repo].
	
	menu
		popUpAt: ActiveHand position truncated
		forHand: ActiveHand
		in: ActiveWorld
		allowKeyboard: false.! !

!SdPackageViewer methodsFor: 'events' stamp: 'mt 2/14/2012 17:00:19.025'!
grabKeyboard

	self ui treeView grabKeyboard.! !

!SdPackageViewer methodsFor: 'actions - preview' stamp: 'mt 7/17/2011 22:04:30.432'!
hidePreview

	previewPanel ifNil: [^ self].
	previewPanel delete.
	previewPanel := nil.! !

!SdPackageViewer methodsFor: 'initialization' stamp: 'mt 5/20/2011 09:55:08.842'!
initializeSystemChangeNotifications

	SystemChangeNotifier uniqueInstance 
		notify: self ofSystemChangesOfItem: SystemChangeNotifier categoryKind using: #onCategoryChange:;
		notify: self ofAllSystemChangesUsing: #updateCurrentPackageItem.! !

!SdPackageViewer methodsFor: 'initialization' stamp: 'mt 6/20/2012 13:35:46.924'!
initializeTree

	self ui treeView
		enableAutoSort;
		addColumns: {
			UiItemViewColumnSpec newFrom: {#text -> 1. #icon -> #icon. #menu -> #menu}.
			(UiItemViewColumnSpec newFrom: {#text -> 2})
				balloonTextConverter: [:obj | 'Number of tests that covered this method.'].
			(UiItemViewColumnSpec newFrom: {#text -> 3})
				balloonTextConverter: [:obj | 'Last author'].
			(UiItemViewColumnSpec newFrom: {#text -> 4})
				balloonTextConverter: [:obj | 'Last modification time']};
		model: SdPackageModel new;
		setHAlignmentForColumn: 2 to: #right; "coverage"
		setHAlignmentForColumn: 3 to: #right; "author"
		horizontalHeaderVisible: false.
	
	self ui treeView disconnectSignal: #doubleClicked:.
	self connect: self ui treeView signal: #returnPressed: toSelector: #activateItem:.
	self connect: self ui treeView signal: #doubleClicked: toSelector: #activateItem:.
	
	"Used for menu callbacks. See #showMenuAt:on:."
	self connect: self ui treeView model signal: #methodActivated: toSelector: #methodActivated:.
	self connect: self ui treeView model signal: #classActivated: toSelector: #classActivated:.
	self connect: self ui treeView model signal: #objectActivated: toSelector: #objectActivated:.
	self connect: self ui treeView model signal: #traceActivated: toSelector: #traceActivated:.! !

!SdPackageViewer methodsFor: 'initialization' stamp: 'mt 6/15/2012 12:36:58.892'!
initializeUi

	super initializeUi.
	
	"package list"
	self connect: self ui packageCombo signal: #currentTextChanged: toSelector: #choosePackage.
	self connect: self ui synchBtn signal: #clicked: toSelector: #chooseRepository.
	
	"preview"
	self connect: self ui treeView signal: #currentNodeChanged: toSelector: #triggerPreview.
	self connect: self ui treeView viewport eventHandler signal: #focusLost toSelector: #hidePreview.
	self ui treeView viewport eventHandler on: Character escape send: #hidePreview to: self.
	
	"tree"
	self initializeTree.
	
	self initializeSystemChangeNotifications.
	self updatePackageList.! !

!SdPackageViewer methodsFor: 'testing' stamp: 'mt 6/30/2011 11:08:44.377'!
isPackageViewer

	^ true! !

!SdPackageViewer methodsFor: 'memento - ui' stamp: 'mt 7/4/2011 18:08:13.639'!
loadState: anEditorState

	super loadState: anEditorState.
	anEditorState loadPackageViewer: self.! !

!SdPackageViewer methodsFor: 'accessing' stamp: 'mt 7/3/2012 11:37:00'!
morphsOfInterest

	self flag: #invasive.
	^ self ui treeView selection cells collect: [:cell |
		self ui treeView viewport morphAt: cell]! !

!SdPackageViewer methodsFor: 'system changes' stamp: 'mt 5/17/2011 09:47:40.562'!
onCategoryChange: aCategoryKindevent

	self updatePackageList.! !

!SdPackageViewer methodsFor: 'geometry' stamp: 'mt 6/10/2011 12:06:22.077'!
optimalWidth

	^ self ui treeView optimalWidth! !

!SdPackageViewer methodsFor: 'accessing' stamp: 'mt 2/14/2012 17:29:59.476'!
packageName

	^ self ui packageCombo currentItem at: #package! !

!SdPackageViewer methodsFor: 'accessing' stamp: 'mt 2/14/2012 17:30:21.021'!
packageName: aPackageName

	self packageName = aPackageName ifTrue: [^ self].

	self ui packageCombo currentItem: (self ui packageCombo list detect: [:item |
		(item at: #package) = aPackageName]).! !

!SdPackageViewer methodsFor: 'memento - ui' stamp: 'mt 7/4/2011 15:19:41.252'!
saveState: anEditorState

	super saveState: anEditorState.
	anEditorState savePackageViewer: self.! !

!SdPackageViewer methodsFor: 'selection' stamp: 'mt 2/15/2012 10:29:15.654'!
selectCategory: aSystemCategory

	| checkBlock |
	checkBlock := [:node | node isSystemCategoryNode and: [node category = aSystemCategory]].
	
	self packageName: (PackageOrganizer default packageOfSystemCategory: aSystemCategory) name.

	(self ui treeView currentNode ifNotNil: checkBlock ifNil: [false])
		ifTrue: [^ self "already selected"].

	self ui treeView currentNode: ((UiItemModelFinder on: self ui treeView model)
		traversalMode: #breadthFirst;
		detect: checkBlock
		ifNone: []).! !

!SdPackageViewer methodsFor: 'selection' stamp: 'mt 2/15/2012 10:36:35.83'!
selectProtocol: aProtocol class: aClass

	| finder classNode protocolNode |
	self selectCategory: aClass category.
	
	finder := (UiItemModelFinder on: self ui treeView model)
		traversalMode: #breadthFirst.
		
	classNode := finder nextSatisfying: [:node | node isClassNode and: [node theClass = aClass]].		
	classNode ifNil: [^ self].
	self ui treeView expandIndex: finder currentIndex.
	
	finder root: classNode.
	protocolNode := finder nextSatisfying: [:node | node isProtocolNode and: [node protocol = aProtocol]].
	protocolNode ifNil: [^ self].
	
	"#expandIndex: does not work here because we reset the #root in the finder."
	self ui treeView expandNode: protocolNode.
	self ui treeView currentNode: protocolNode.! !

!SdPackageViewer methodsFor: 'actions - preview' stamp: 'mt 2/15/2012 10:38:34.038'!
showPreview
	
	self showPreview: self ui treeView currentNode.! !

!SdPackageViewer methodsFor: 'actions - preview' stamp: 'mt 3/22/2012 11:34:03.879'!
showPreview: aCodeNode
	"Show a preview for the current element if one is selected."
	
	aCodeNode ifNil: [^ self].
	
	"Discard the current preview."
	previewPanel ifNotNil: [self hidePreview].
	
	aCodeNode isClassNode ifTrue: [
		previewPanel := SdPreviewBuilder createClassPreviewFor: aCodeNode theClass].
	aCodeNode isMethodNode ifTrue: [
		previewPanel := SdPreviewBuilder createMethodPreviewFor: aCodeNode method methodReference].

	previewPanel ifNil: [^ self].
	
	"Ensure visibility of preview box."
	self ui treeView selection currentBounds ifNotNil: [:selectionBounds |
		| globalRight |
		globalRight := (self localPointToGlobal: self topRight) x.
		(globalRight + previewPanel width) > ActiveWorld right
			ifTrue: [(selectionBounds left - previewPanel width) < ActiveWorld left
				ifFalse: [previewPanel topRight: selectionBounds topLeft]
				ifTrue: [previewPanel topLeft: selectionBounds bottomLeft]]
			ifFalse: [previewPanel topLeft: globalRight @ selectionBounds top].
		previewPanel bottom: (ActiveWorld bottom min: previewPanel bottom)].
		
	previewPanel openInWorld.! !

!SdPackageViewer methodsFor: 'actions - monticello' stamp: 'mt 5/20/2011 09:49:47.693'!
synchronizeWith: aRepository

	| newerVersions |
	"Merge new content."
	newerVersions := self workingCopy possiblyNewerVersionsIn: aRepository.
	newerVersions ifNotEmpty: [(aRepository
			versionNamed: newerVersions first
			ifAbsent: []) ifNotNil: [:v | v merge]].
	
	"Save own content."
	self workingCopy needsSaving ifFalse: [^ self].
	self workingCopy newVersion ifNotNil: [:v |
			Cursor wait showWhile: [aRepository storeVersion: v]].
		
	"Description may have changed of MC package."
	self updateCurrentPackageItem.! !

!SdPackageViewer methodsFor: 'actions - preview' stamp: 'mt 6/22/2012 16:21:06.31'!
triggerPreview

	self hidePreview.
	self
		removeAlarm: #showPreview;
		addAlarm: #showPreview
		after: 250.! !

!SdPackageViewer methodsFor: 'initialization' stamp: 'mt 6/15/2012 12:36:26.401'!
uiClass

	^ SdPackageViewerUi! !

!SdPackageViewer methodsFor: 'updating' stamp: 'mt 6/30/2011 11:02:46.66'!
updateCurrentPackageItem

	self ui packageCombo currentItem ifNotNil: [:item |
		item text: self workingCopy description].
	self ui packageCombo updateCurrentRow.! !

!SdPackageViewer methodsFor: 'updating' stamp: 'mt 2/12/2012 18:20:25.07'!
updatePackageList

	self ui packageCombo clear.
	self ui packageCombo
		addItemListFrom: PackageOrganizer default packageNames sorted
		using: [:pName :item | | mc |
			item at: #package put: pName.
			mc := MCPackage named: pName.
			mc hasWorkingCopy
				ifTrue: [item text: mc workingCopy description]
				ifFalse: [item text: ('<font color="#777777">', pName, ' (no working copy)</font>') asHtmlText]].! !

!SdPackageViewer methodsFor: 'actions - monticello' stamp: 'mt 2/12/2012 18:21:22.201'!
workingCopy

	^ (MCPackage named: (self ui packageCombo currentItem at: #package)) workingCopy! !

SdEditor subclass: #SdQueryEditor
	uses: TSdMemento
	instanceVariableNames: 'fromContainer selectContainer groupByContainer collectContainer'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sight-Dynamic'!

SdQueryEditor class
	uses: TSdMemento classTrait
	instanceVariableNames: ''!

!SdQueryEditor methodsFor: 'accessing - ui' stamp: 'mt 7/10/2012 14:51:39.945'!
collectContainer

	^ collectContainer! !

!SdQueryEditor methodsFor: 'accessing - ui' stamp: 'mt 7/9/2012 16:48:38.422'!
fromContainer

	^ fromContainer! !

!SdQueryEditor methodsFor: 'accessing - ui' stamp: 'mt 7/10/2012 14:51:31.853'!
groupByContainer

	^ groupByContainer! !

!SdQueryEditor methodsFor: 'initialization' stamp: 'mt 7/11/2012 11:31:40.645'!
initializeEventHandler

	super initializeEventHandler.
	
	self connect: self ui fromBtn signal: #toggled: toSelector: #toggleContainer:visible: pattern: #(=from 1).
	self connect: self ui selectBtn signal: #toggled: toSelector: #toggleContainer:visible: pattern: #(=select 1).
	self connect: self ui groupByBtn signal: #toggled: toSelector: #toggleContainer:visible: pattern: #(=groupBy 1).
	self connect: self ui collectBtn signal: #toggled: toSelector: #toggleContainer:visible: pattern: #(=collect 1).! !

!SdQueryEditor methodsFor: 'initialization' stamp: 'mt 7/11/2012 10:53:44.539'!
initializeUi

	super initializeUi.
	
	self ui treeView model: SdQueryModel new.
	self ui treeView groupSpec hideIfFirst: false.
	self ui treeView viewport drawCacheActive: true.
	
	self updateTreeView.
	
	self
		initializeUiOperationContainer: #from defaultStatement: '[#()]';
		initializeUiOperationContainer: #select defaultStatement: '[:obj | true]';
		initializeUiOperationContainer: #groupBy defaultStatement: '[:obj | #all]';
		initializeUiOperationContainer: #collect defaultStatement: '[:obj | obj]'.! !

!SdQueryEditor methodsFor: 'initialization' stamp: 'mt 7/10/2012 14:54:23.312'!
initializeUiCollectContainer

	| model |
	model := SdStatementListModel new
		defaultStatement: '[:obj | obj]'.
		
	collectContainer := (UiTreeView new
		addColumns: {
			UiItemViewColumnSpec newFrom: {#checked -> #checked. #checkable -> #checkable. #selectable -> #selectable}.
			UiItemViewColumnSpec newFrom: {#text -> #code. #editable -> #editable. #selectable -> #selectable. #headerText -> 'Collect'}.
			SdItemViewButtonColumnSpec new root: model};
		setResizeModeForColumn: 2 to: #rigid;
		setWidthForColumn: 2 to: 200;
		setVAlignmentTo: #center;
		rootIsDecorated: false;
		model: model;
		hResizing: #spaceFill).
		
	self connect: model signal: #statementsChanged toSelector: #updateCollect.! !

!SdQueryEditor methodsFor: 'initialization' stamp: 'mt 7/10/2012 14:01:03.699'!
initializeUiFromContainer

	| model |
	model := SdStatementListModel new
		defaultStatement: '[#()]'.
		
	fromContainer := (UiTreeView new
		addColumns: {
			UiItemViewColumnSpec newFrom: {#checked -> #checked. #checkable -> #checkable. #selectable -> #selectable}.
			UiItemViewColumnSpec newFrom: {#text -> #code. #editable -> #editable. #selectable -> #selectable. #headerText -> 'From'}.
			SdItemViewButtonColumnSpec new root: model};
		setResizeModeForColumn: 2 to: #rigid;
		setWidthForColumn: 2 to: 200;
		setVAlignmentTo: #center;
		rootIsDecorated: false;
		model: model;
		hResizing: #spaceFill).
		
	self connect: model signal: #statementsChanged toSelector: #updateFrom.! !

!SdQueryEditor methodsFor: 'initialization' stamp: 'mt 7/10/2012 14:53:51.465'!
initializeUiGroupByContainer

	| model |
	model := SdStatementListModel new
		defaultStatement: '[:obj | #all]'.
		
	groupByContainer := (UiTreeView new
		addColumns: {
			UiItemViewColumnSpec newFrom: {#checked -> #checked. #checkable -> #checkable. #selectable -> #selectable}.
			UiItemViewColumnSpec newFrom: {#text -> #code. #editable -> #editable. #selectable -> #selectable. #headerText -> 'Group by'}.
			SdItemViewButtonColumnSpec new root: model};
		setResizeModeForColumn: 2 to: #rigid;
		setWidthForColumn: 2 to: 200;
		setVAlignmentTo: #center;
		rootIsDecorated: false;
		model: model;
		hResizing: #spaceFill).
		
	self connect: model signal: #statementsChanged toSelector: #updateGroupBy.! !

!SdQueryEditor methodsFor: 'initialization' stamp: 'mt 7/11/2012 12:09:19.609'!
initializeUiOperationContainer: operationSymbol defaultStatement: code

	| model |
	model := SdStatementListModel new
		defaultStatement: code.
		
	self instVarNamed: operationSymbol, #Container put: (UiTreeView new
		addColumns: {
			UiItemViewColumnSpec newFrom: {#checked -> #checked. #checkable -> #checkable. #selectable -> #selectable}.
			UiItemViewColumnSpec newFrom: {#text -> #code. #icon -> #icon. #editable -> #editable. #selectable -> #selectable. #headerText -> operationSymbol}.
			SdItemViewButtonColumnSpec new root: model};
		setResizeModeForColumn: 2 to: #rigid;
		setWidthForColumn: 2 to: 200;
		setVAlignmentTo: #center;
		rootIsDecorated: false;
		model: model;
		hResizing: #spaceFill;
		height: 60).
		
	self connect: model signal: #resultsChanged toSelector: #updateQuery: pattern: {#=. operationSymbol}.
	self connect: model signal: #statementsChanged toSelector: #updateQueryButton: pattern: {#=. operationSymbol}.
	self connect: model signal: #statementsWarning toSelector: #updateWarningQueryButton: pattern: {#=. operationSymbol}.
	self connect: model signal: #statementsError toSelector: #updateErrorQueryButton: pattern: {#=. operationSymbol}.
	
	(#(groupBy collect) includes: operationSymbol) ifTrue: [
		model autoExclusive: true].! !

!SdQueryEditor methodsFor: 'initialization' stamp: 'mt 7/10/2012 14:00:54.54'!
initializeUiSelectContainer

	| model |
	model := SdStatementListModel new
		defaultStatement: '[:obj | true]'.
		
	selectContainer := (UiTreeView new
		addColumns: {
			UiItemViewColumnSpec newFrom: {#checked -> #checked. #checkable -> #checkable. #selectable -> #selectable}.
			UiItemViewColumnSpec newFrom: {#text -> #code. #editable -> #editable. #selectable -> #selectable. #headerText -> 'Select'}.
			SdItemViewButtonColumnSpec new root: model};
		setResizeModeForColumn: 2 to: #rigid;
		setWidthForColumn: 2 to: 200;
		setVAlignmentTo: #center;
		rootIsDecorated: false;
		model: model;
		hResizing: #spaceFill).
		
	self connect: model signal: #statementsChanged toSelector: #updateSelect.! !

!SdQueryEditor methodsFor: 'accessing' stamp: 'mt 7/9/2012 16:57:41.775'!
resultModel

	^ self ui treeView model! !

!SdQueryEditor methodsFor: 'accessing - ui' stamp: 'mt 7/10/2012 13:59:45.483'!
selectContainer

	^ selectContainer! !

!SdQueryEditor methodsFor: 'hide/show - ui' stamp: 'mt 7/10/2012 14:52:30.122'!
toggleCollectContainer: aBoolean

	aBoolean
		ifTrue: [self ui panel addMorph: self collectContainer inFrontOf: self ui controlsContainer]
		ifFalse: [self collectContainer delete].! !

!SdQueryEditor methodsFor: 'updating' stamp: 'mt 7/11/2012 11:30:50.207'!
toggleContainer: operationSymbol visible: aBoolean

	| container resizer |
	container := self instVarNamed: operationSymbol, #Container.
	
	aBoolean
		ifTrue: [
			resizer := SdResizeHandle new orientation: #horizontal; target: container.
			self ui panel
				addMorph: resizer inFrontOf: self ui controlsContainer;
				addMorph: container inFrontOf: self ui controlsContainer]
		ifFalse: [
			"The resize handle is in front of the container."
			resizer := self ui panel submorphs at: (self ui panel submorphs indexOf: container) - 1.
			
			container delete.
			resizer delete].! !

!SdQueryEditor methodsFor: 'hide/show - ui' stamp: 'mt 7/10/2012 13:41:59.919'!
toggleFromContainer: aBoolean

	aBoolean
		ifTrue: [self ui panel addMorph: self fromContainer inFrontOf: self ui controlsContainer]
		ifFalse: [self fromContainer delete].! !

!SdQueryEditor methodsFor: 'hide/show - ui' stamp: 'mt 7/10/2012 14:52:06.941'!
toggleGroupByContainer: aBoolean

	aBoolean
		ifTrue: [self ui panel addMorph: self groupByContainer inFrontOf: self ui controlsContainer]
		ifFalse: [self groupByContainer delete].! !

!SdQueryEditor methodsFor: 'hide/show - ui' stamp: 'mt 7/10/2012 14:00:00.807'!
toggleSelectContainer: aBoolean

	aBoolean
		ifTrue: [self ui panel addMorph: self selectContainer inFrontOf: self ui controlsContainer]
		ifFalse: [self selectContainer delete].! !

!SdQueryEditor methodsFor: 'accessing - ui' stamp: 'mt 6/22/2012 17:16:35.65'!
uiClass

	^ SdQueryEditorUi! !

!SdQueryEditor methodsFor: 'initialization' stamp: 'mt 7/10/2012 14:53:14.075'!
updateCollect

	self resultModel collectBlocks: self collectContainer model results.! !

!SdQueryEditor methodsFor: 'updating' stamp: 'mt 7/11/2012 11:45:27.936'!
updateErrorQueryButton: operationSymbol

	(self ui perform: (operationSymbol, #Btn) asSymbol)
		showError.! !

!SdQueryEditor methodsFor: 'initialization' stamp: 'mt 7/9/2012 17:23:53.549'!
updateFrom

	self resultModel fromBlocks: self fromContainer model results.! !

!SdQueryEditor methodsFor: 'initialization' stamp: 'mt 7/10/2012 14:53:00.377'!
updateGroupBy

	self resultModel groupByBlocks: self groupByContainer model results.! !

!SdQueryEditor methodsFor: 'updating' stamp: 'mt 7/11/2012 10:30:40.061'!
updateQuery: operationSymbol

	self resultModel
		perform: (operationSymbol, #Blocks:) asSymbol
		with: (self instVarNamed: operationSymbol, #Container) model results.! !

!SdQueryEditor methodsFor: 'updating' stamp: 'mt 7/11/2012 13:33:08.883'!
updateQueryButton: operationSymbol

	| button list number |
	button := self ui perform: (operationSymbol, #Btn) asSymbol.
	list := (self instVarNamed: operationSymbol, #Container) model.

	list hasWarnings ifTrue: [^ self updateWarningQueryButton: operationSymbol].
	list hasErrors ifTrue: [^ self updateErrorQueryButton: operationSymbol].
	
	number := list selectedStatements size.
	number > 0
		ifTrue: [button showNumber: number]
		ifFalse: [button clear].! !

!SdQueryEditor methodsFor: 'initialization' stamp: 'mt 7/10/2012 14:01:20.927'!
updateSelect

	self resultModel selectBlocks: self selectContainer model results.! !

!SdQueryEditor methodsFor: 'updating' stamp: 'mt 7/10/2012 14:02:51.953'!
updateTreeView
	"Set the correct number of columns."

	self ui treeView
		removeAllColumns;
		addColumns: {UiItemViewSimpleColumnSpec newFrom: {#text -> #object. #headerText -> 'Objects'}}.! !

!SdQueryEditor methodsFor: 'updating' stamp: 'mt 7/11/2012 11:45:20.358'!
updateWarningQueryButton: operationSymbol

	(self ui perform: (operationSymbol, #Btn) asSymbol)
		showWarning.! !

SdEditor subclass: #SdSpacer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sight-Dynamic'!

!SdSpacer class methodsFor: 'accessing' stamp: 'mt 7/3/2011 08:53:02.003'!
editorDescription

	^ 'Add some space between editors to organize your working sets.'! !

!SdSpacer class methodsFor: 'accessing' stamp: 'mt 7/3/2011 08:55:38.07'!
editorIcon

	^ UiSilkIcons pictureEmptyIcon! !

!SdSpacer class methodsFor: 'accessing' stamp: 'mt 7/3/2011 08:52:13.608'!
editorName

	^ 'Spacer'! !

!SdSpacer class methodsFor: 'testing' stamp: 'mt 7/3/2011 08:52:05.963'!
isStandAlone

	^ true! !

!SdSpacer methodsFor: 'geometry - actions' stamp: 'mt 7/3/2011 09:05:19.938'!
collapse

	"Cannot collapse."! !

!SdSpacer methodsFor: 'drawing' stamp: 'mt 6/20/2012 11:22:04.2'!
drawInnerShadowOn: aCanvas

	| c |
	c := Color black.

	aCanvas
		line: self topLeft + (0@1) to: self topRight + (-1@1) color: (c alpha: 0.5);
		line: self topLeft + (0@2) to: self topRight + (-1@2) color: (c alpha: 0.2).
	
	aCanvas
		line: self topLeft + (2@1) to: self bottomLeft + (2@ -1) color: (c alpha: 0.5);
		line: self topLeft + (3@2) to: self bottomLeft + (3@ -1) color: (c alpha: 0.2).
		
	aCanvas
		frameRectangle: (self innerBounds insetBy: (1@0 corner: 1@0))
		color: (c alpha: 0.8).! !

!SdSpacer methodsFor: 'drawing' stamp: 'mt 7/3/2011 08:51:50.167'!
drawOn: aCanvas

	self drawInnerShadowOn: aCanvas.! !

!SdSpacer methodsFor: 'geometry - actions' stamp: 'mt 7/3/2011 09:05:12.649'!
expand

	"Already expanded."! !

!SdSpacer methodsFor: 'initialization' stamp: 'mt 6/20/2012 10:23:00.91'!
initializeUi

	| closeBtn |
	closeBtn := UiToolButton new
		buttonStyle: #iconOnly;
		autoRaise: true;
		balloonText: 'Close Spacer';
		color: (Color gray: 0.5);
		icon: UiFugueIcons crossSmallIcon asGrayScale2.
	self connect: closeBtn signal: #clicked: toSelector: #delete.
	
	self
		color: (Color gray: 0.6);
		changeTableLayout;
		listDirection: #leftToRight;
		listCentering: #bottomRight;
		vResizing: #spaceFill.
		
	self addMorph: closeBtn.! !

SdEditor subclass: #SdSystemBrowserCategoriesEditor
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sight-Dynamic'!

!SdSystemBrowserCategoriesEditor methodsFor: 'initialization' stamp: 'mt 5/23/2012 10:16:15.842'!
initializeUi

	super initializeUi.
	
	self ui list
		enableAutoSort;
		listSpec: ((UiItemViewColumnSpec newFrom: {#text -> #yourself})
			textConverter: [:node | (node includesKey: #dummy)
				ifTrue: [('<font color="#AAAAAA">', (node at: #category), '</font>') asHtmlText]
				ifFalse: [node at: #category]]);
		model: SdSystemCategoriesModel new.
		
	self connect: self ui list signal: #selectionChanged: toSelector: #selectNodes:.! !

!SdSystemBrowserCategoriesEditor methodsFor: 'actions' stamp: 'mt 5/23/2012 10:17:17.589'!
selectNodes: somePropertyNodes

	self systemCategoriesSelected: (somePropertyNodes collect: [:node | node at: #category]).! !

!SdSystemBrowserCategoriesEditor methodsFor: 'signals' stamp: 'mt 5/23/2012 10:15:33.544'!
systemCategoriesSelected: someSystemCategories

	self emit.! !

!SdSystemBrowserCategoriesEditor methodsFor: 'accessing - ui' stamp: 'mt 5/18/2012 11:04:01.998'!
uiClass

	^ SdSystemBrowserCategoriesUi! !

SdEditor subclass: #SdSystemBrowserClassesEditor
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sight-Dynamic'!

!SdSystemBrowserClassesEditor methodsFor: 'signals' stamp: 'mt 5/23/2012 10:17:47.965'!
classSelected: aClass

	self emit.! !

!SdSystemBrowserClassesEditor methodsFor: 'initialization' stamp: 'mt 5/23/2012 10:26:39.62'!
initializeUi

	super initializeUi.
	
	self ui list
		listSpec: (UiItemViewColumnSpec newFrom: {#text -> #className. #icon -> #classIcon});
		model: SdSystemClassesModel new.
		
	self connect: self ui list signal: #currentNodeChanged: toSelector: #selectNode:.! !

!SdSystemBrowserClassesEditor methodsFor: 'actions' stamp: 'mt 5/23/2012 10:18:53.82'!
selectNode: aNode

	self classSelected: (Smalltalk at: (aNode at: #className)).! !

!SdSystemBrowserClassesEditor methodsFor: 'accessing' stamp: 'mt 5/22/2012 09:09:42.354'!
systemCategories

	^ self ui list model systemCategories! !

!SdSystemBrowserClassesEditor methodsFor: 'accessing' stamp: 'mt 5/22/2012 09:09:33.32'!
systemCategories: someCategories

	self ui list model systemCategories: someCategories.! !

!SdSystemBrowserClassesEditor methodsFor: 'accessing - ui' stamp: 'mt 5/18/2012 11:05:23.26'!
uiClass

	^ SdSystemBrowserClassesUi! !

SdEditor subclass: #SdSystemBrowserMessagesEditor
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sight-Dynamic'!

!SdSystemBrowserMessagesEditor methodsFor: 'actions' stamp: 'mt 5/23/2012 10:30:08.243'!
activateNode: aNode

	self methodActivated: (aNode at: #reference).! !

!SdSystemBrowserMessagesEditor methodsFor: 'initialization' stamp: 'mt 5/23/2012 10:31:26.465'!
initializeUi

	super initializeUi.
	
	self ui list
		enableAutoSort;
		listSpec: ((UiItemViewColumnSpec newFrom: {#text -> #yourself})
			textConverter: [:node |
				(((node at: #reference) classIsMeta
					ifTrue: ['<u>{1}</u> <font color="#AAAAAA">{2}</font>'] ifFalse: ['{1} <font color="#AAAAAA">{2}</font>'])
					format: {(node at: #reference) selector. (node at: #protocol)}) asHtmlText]);
		model: SdSystemMessagesModel new.
		
	self connect: self ui list signal: #doubleClicked: toSelector: #activateNode:.! !

!SdSystemBrowserMessagesEditor methodsFor: 'signals' stamp: 'mt 5/23/2012 10:28:18.224'!
methodActivated: aMethodReference

	self emitInOwnerChain.! !

!SdSystemBrowserMessagesEditor methodsFor: 'accessing' stamp: 'mt 5/22/2012 15:31:33.512'!
protocols

	self ui list model protocols! !

!SdSystemBrowserMessagesEditor methodsFor: 'accessing' stamp: 'mt 5/22/2012 15:31:21.119'!
theClass

	^ self ui list model theClass! !

!SdSystemBrowserMessagesEditor methodsFor: 'accessing' stamp: 'mt 5/22/2012 15:31:10.956'!
theClass: aClass protocols: someProtocols

	self ui list model theClass: aClass protocols: someProtocols.! !

!SdSystemBrowserMessagesEditor methodsFor: 'accessing - ui' stamp: 'mt 5/18/2012 11:06:11.41'!
uiClass

	^ SdSystemBrowserMessagesUi! !

SdEditor subclass: #SdSystemBrowserProtocolsEditor
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sight-Dynamic'!

!SdSystemBrowserProtocolsEditor methodsFor: 'initialization' stamp: 'mt 5/23/2012 10:25:41.527'!
initializeUi

	super initializeUi.
	
	self ui list
		enableAutoSort;
		listSpec: ((UiItemViewColumnSpec newFrom: {#text -> #yourself})
			textConverter: [:node |
				((node at: #protocol), '<font color="#AAAAAA"> (', (node at: #size) asString, ')</font>') asHtmlText]);
		model: SdSystemProtocolsModel new.
		
	self connect: self ui list signal: #selectionChanged: toSelector: #selectNodes:.! !

!SdSystemBrowserProtocolsEditor methodsFor: 'signals' stamp: 'mt 5/23/2012 10:20:54.915'!
protocolsSelected: someProtocols inClass: aClass

	self emit.! !

!SdSystemBrowserProtocolsEditor methodsFor: 'actions' stamp: 'mt 5/23/2012 10:25:17.837'!
selectNodes: someNodes

	self
		protocolsSelected: (someNodes collect: [:node | node at: #protocol])
		inClass: self theClass.! !

!SdSystemBrowserProtocolsEditor methodsFor: 'accessing' stamp: 'mt 5/22/2012 14:47:46.741'!
theClass

	^ self ui list model theClass! !

!SdSystemBrowserProtocolsEditor methodsFor: 'accessing' stamp: 'mt 5/22/2012 14:47:51.734'!
theClass: aClass

	self ui list model theClass: aClass.! !

!SdSystemBrowserProtocolsEditor methodsFor: 'accessing - ui' stamp: 'mt 5/18/2012 11:05:43.97'!
uiClass

	^ SdSystemBrowserProtocolsUi! !

SdEditor subclass: #SdTranscriptEditor
	instanceVariableNames: 'transcriptModel lastTimestamp'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sight-Dynamic'!

!SdTranscriptEditor class methodsFor: 'accessing' stamp: 'mt 6/28/2011 21:03:57.643'!
editorDescription

	^ 'Enhanced debugging output with timestamps.'! !

!SdTranscriptEditor class methodsFor: 'accessing' stamp: 'mt 7/3/2011 08:57:18.88'!
editorGroup

	^ 3! !

!SdTranscriptEditor class methodsFor: 'accessing' stamp: 'mt 6/28/2011 14:34:09.316'!
editorIcon

	^ UiSilkIcons applicationViewListIcon! !

!SdTranscriptEditor class methodsFor: 'accessing' stamp: 'mt 6/28/2011 21:03:38.934'!
editorName

	^ 'Transcript'! !

!SdTranscriptEditor class methodsFor: 'testing' stamp: 'mt 6/28/2011 21:10:43.734'!
isStandAlone

	^ true! !

!SdTranscriptEditor methodsFor: 'actions' stamp: 'mt 5/5/2011 16:38:21.501'!
addEntry: aString

	| timestamp entry |
	entry := aString withoutLineEndings withBlanksTrimmed.
	timestamp := ('<font color="#777777">[', 
			(String streamContents:
				[:aStream | Time now print24: true showSeconds: false on: aStream]),
			']</font> ') asHtmlText.

	((aString startsWith: String cr) or: [aString endsWith: String cr])
		ifTrue: [self ui transcriptEdit theText isEmpty
			ifFalse: [self ui transcriptEdit append: String cr].
			self ui timestampBtn checked
				ifTrue: [self ui transcriptEdit append: timestamp].
			(entry startsWith: '----SNAPSHOT')
				ifTrue: [self ui transcriptEdit append: ('<b>', entry, '</b>') asHtmlText]
				ifFalse: [self ui transcriptEdit append: entry]]
		ifFalse: [self ui transcriptEdit append: entry].
	
	self ui transcriptEdit scrollToBottom.
	
	self ui redrawBtn checked
		ifTrue: [self redraw].! !

!SdTranscriptEditor methodsFor: 'converting' stamp: 'mt 5/5/2011 16:39:02.759'!
asString

	^ 'Transcript'! !

!SdTranscriptEditor methodsFor: 'initialization' stamp: 'mt 6/15/2012 12:42:59.213'!
initializeUi

	super initializeUi.
		
	transcriptModel := SdTranscriptModel new.
	
	self connect: transcriptModel signal: #entryAppended: toSelector: #addEntry:.
	self connect: self ui clearTranscriptBtn signal: #clicked: to: self ui transcriptEdit selector: #clear.! !

!SdTranscriptEditor methodsFor: 'memento - ui' stamp: 'mt 7/4/2011 18:09:38.229'!
loadState: anEditorState

	super loadState: anEditorState.
	anEditorState loadTranscriptEditor: self.! !

!SdTranscriptEditor methodsFor: 'memento - ui' stamp: 'mt 7/4/2011 15:19:41.37'!
saveState: anEditorState

	super saveState: anEditorState.
	anEditorState saveTranscriptEditor: self.! !

!SdTranscriptEditor methodsFor: 'accessing - ui' stamp: 'mt 6/15/2012 12:41:55.888'!
uiClass

	^ SdTranscriptEditorUi! !

SdEditor subclass: #SdWorkspaceEditor
	uses: TSdDynamicActivation
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sight-Dynamic'!

SdWorkspaceEditor class
	uses: TSdDynamicActivation classTrait
	instanceVariableNames: ''!

!SdWorkspaceEditor class methodsFor: 'accessing' stamp: 'mt 6/28/2011 21:03:32.976'!
editorDescription

	^ 'Text area plus a lot of support for executable code.'! !

!SdWorkspaceEditor class methodsFor: 'accessing' stamp: 'mt 7/3/2011 08:57:22.924'!
editorGroup

	^ 3! !

!SdWorkspaceEditor class methodsFor: 'accessing' stamp: 'mt 6/28/2011 14:34:44.38'!
editorIcon

	^ UiSilkIcons applicationXpTerminalIcon! !

!SdWorkspaceEditor class methodsFor: 'accessing' stamp: 'mt 6/28/2011 21:03:28.241'!
editorName

	^ 'Workspace'! !

!SdWorkspaceEditor class methodsFor: 'testing' stamp: 'mt 6/28/2011 21:10:51.335'!
isStandAlone

	^ true! !

!SdWorkspaceEditor methodsFor: 'converting' stamp: 'mt 5/5/2011 16:39:15.962'!
asString

	^ 'Workspace'! !

!SdWorkspaceEditor methodsFor: 'events' stamp: 'mt 5/5/2011 16:40:26.251'!
grabKeyboard

	self ui workspaceEdit grabKeyboard.! !

!SdWorkspaceEditor methodsFor: 'initialization' stamp: 'mt 6/21/2012 14:31:01.628'!
initializeUi

	super initializeUi.
		
	self connect: self ui clearWorkspaceBtn signal: #clicked: to: self ui workspaceEdit selector: #clear.
		
	self ui workspaceEdit eventHandler on: #(cmd) -> $O send: #openSelection to: self.! !

!SdWorkspaceEditor methodsFor: 'memento - ui' stamp: 'mt 7/4/2011 18:11:23.988'!
loadState: anEditorState

	super loadState: anEditorState.
	anEditorState loadWorkspaceEditor: self.! !

!SdWorkspaceEditor methodsFor: 'actions' stamp: 'mt 3/29/2012 15:22:40.78'!
openSelection

	| result |
	result := self ui workspaceEdit evaluateSelection.
	((result isKindOf: FakeClassPool) or: [result == #failedDoit])
		ifTrue: [^ self].
		
	(result isKindOf: Behavior)
		ifTrue: [^ self classActivated: result].
		
	self objectActivated: (SdObjectStateChange new before: result; after: nil).! !

!SdWorkspaceEditor methodsFor: 'geometry' stamp: 'mt 5/12/2011 17:01:22.382'!
optimalWidth

	^ self ui workspaceEdit optimalWidth! !

!SdWorkspaceEditor methodsFor: 'memento - ui' stamp: 'mt 7/4/2011 15:19:40.893'!
saveState: anEditorState

	super saveState: anEditorState.
	anEditorState saveWorkspaceEditor: self.! !

!SdWorkspaceEditor methodsFor: 'accessing - ui' stamp: 'mt 6/15/2012 12:43:33.189'!
uiClass

	^ SdWorkspaceEditorUi! !

Morph subclass: #SdEditorBuilder
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sight-Dynamic'!

!SdEditorBuilder commentStamp: 'mt 5/18/2012 10:49:41.412' prior: 0!
Creates a group of associated editors and maintains communication between them (= mediator role).!

SdEditorBuilder subclass: #SdSystemBrowserBuilder
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sight-Dynamic'!

!SdSystemBrowserBuilder methodsFor: 'as yet unclassified' stamp: 'mt 6/15/2012 11:32:25.215'!
build

	| categories classes protocols selectors |
	categories := SdSystemBrowserCategoriesEditor new.
	classes := SdSystemBrowserClassesEditor new.
	protocols := SdSystemBrowserProtocolsEditor new.
	selectors := SdSystemBrowserMessagesEditor new.
	
	self connect: categories signal: #systemCategoriesSelected: to: classes selector: #systemCategories:.
	self connect: classes signal: #classSelected: to: protocols selector: #theClass:.
	self connect: protocols signal: #protocolsSelected:inClass: to: selectors selector: #theClass:protocols: pattern: #(2 1).
	
	categories openInWindow.
	classes openInWindow.
	protocols openInWindow.
	selectors openInWindow.! !

Morph subclass: #SdFadingToolbar
	instanceVariableNames: 'leftBar topBar rightBar bottomBar timeout'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sight-Dynamic-UI-Support'!

!SdFadingToolbar class methodsFor: 'as yet unclassified' stamp: 'mt 5/2/2011 20:59:49.339'!
hideAllToolbars

	ActiveWorld submorphs
		select: [:m | m isKindOf: SdFadingToolbar]  
		thenDo: [:m | m delete].! !

!SdFadingToolbar methodsFor: 'adding' stamp: 'mt 4/7/2011 14:59:47.001'!
addButton: aButton edge: aSymbol

	aSymbol = #left ifTrue: [leftBar addMorphBack: aButton].
	aSymbol = #top ifTrue: [topBar addMorphBack: aButton].
	aSymbol = #right ifTrue: [rightBar addMorphBack: aButton].
	aSymbol = #bottom ifTrue: [bottomBar addMorphBack: aButton].! !

!SdFadingToolbar methodsFor: 'adding' stamp: 'mt 7/23/2011 11:09:40.668'!
addSpacerToEdge: aSymbol

	| spacer |
	spacer := Morph new
		color: Color transparent;
		extent: 10@10.
		
	aSymbol = #left ifTrue: [leftBar addMorphBack: spacer].
	aSymbol = #top ifTrue: [topBar addMorphBack: spacer].
	aSymbol = #right ifTrue: [rightBar addMorphBack: spacer].
	aSymbol = #bottom ifTrue: [bottomBar addMorphBack: spacer].! !

!SdFadingToolbar methodsFor: 'accessing' stamp: 'mt 4/7/2011 14:48:29.386'!
alpha: aFloat
	
	leftBar alpha: aFloat.
	topBar alpha: aFloat.
	rightBar alpha: aFloat.
	bottomBar alpha: aFloat.! !

!SdFadingToolbar methodsFor: 'accessing' stamp: 'mt 6/20/2012 17:06:16.357'!
bottomPanel

	^ bottomBar! !

!SdFadingToolbar methodsFor: 'layout' stamp: 'mt 4/12/2011 17:26:45.304'!
fullBounds

	fullBounds ifNil: [
		self updateLayout].
	
	^ super fullBounds! !

!SdFadingToolbar methodsFor: 'events-processing' stamp: 'mt 4/7/2011 16:40:08.924'!
handleMouseMove: anEvent

	self mouseMove: anEvent.! !

!SdFadingToolbar methodsFor: 'initialization' stamp: 'mt 4/7/2011 17:01:51.113'!
initialize

	super initialize.

	self
		color: Color transparent;
		initializeEventHandler.
	
	leftBar := SdFadingToolbarPanel new orientation: #vertical; wrapDirection: #rightToLeft.  
	topBar := SdFadingToolbarPanel new orientation: #horizontal; wrapDirection: #bottomToTop.
	rightBar := SdFadingToolbarPanel new orientation: #vertical; wrapDirection: #leftToRight.
	bottomBar := SdFadingToolbarPanel new orientation: #horizontal; wrapDirection: #topToBottom.

	self addAllMorphs: {leftBar. topBar. rightBar. bottomBar}.! !

!SdFadingToolbar methodsFor: 'initialization' stamp: 'mt 5/4/2011 10:30:31.861'!
initializeEventHandler

	self eventHandler: UiEventHandler new.

	self connect: self eventHandler signal: #mouseLeft: toSelector: #alpha: pattern: #(= 0.0).
	self connect: self eventHandler signal: #mouseMoved: toSelector: #updateAlpha:.
	self connect: self eventHandler signal: #mouseEntered: toSelector: #updateAlpha:.
	
	self connect: self eventHandler signal: #mouseMoved: toSelector: #resetTimeout.! !

!SdFadingToolbar methodsFor: 'accessing' stamp: 'mt 6/20/2012 17:05:52.157'!
leftPanel

	^ leftBar! !

!SdFadingToolbar methodsFor: 'popup' stamp: 'mt 5/24/2011 16:28:03.091'!
popUpFor: aMorph
	
	self bounds: aMorph visibleBounds.

	self class hideAllToolbars.
	
	self reopen.! !

!SdFadingToolbar methodsFor: 'events-processing' stamp: 'mt 4/7/2011 16:45:39.314'!
rejectsEvent: anEvent

	(self bounds containsPoint: anEvent position)
		ifFalse: [^ super rejectsEvent: anEvent].

	^ (anEvent isMouse and: [
		anEvent isMouseMove
			or: [anEvent isMouseEnter]
			or: [anEvent isMouseLeave]]) not! !

!SdFadingToolbar methodsFor: 'popup' stamp: 'mt 5/4/2011 10:33:34.495'!
reopen

	self owner ifNil: [
		self
			resetTimeout;
			openInWorld].! !

!SdFadingToolbar methodsFor: 'events-processing' stamp: 'mt 5/4/2011 10:22:45.283'!
resetTimeout

	timeout := 3.
	
	self isStepping
		ifFalse: [self startStepping].! !

!SdFadingToolbar methodsFor: 'accessing' stamp: 'mt 6/20/2012 17:06:02.43'!
rightPanel

	^ rightBar! !

!SdFadingToolbar methodsFor: 'stepping' stamp: 'mt 5/4/2011 10:23:46.336'!
step

	timeout ifNil: [^ self resetTimeout].
	
	timeout = 0
		ifTrue: [self stopStepping; fadeOutThen: [self delete; show]. ^ self].
		
	timeout := timeout - 1.! !

!SdFadingToolbar methodsFor: 'stepping' stamp: 'mt 5/4/2011 10:21:03.944'!
stepTime

	^ 1000! !

!SdFadingToolbar methodsFor: 'accessing' stamp: 'mt 6/20/2012 17:06:09.879'!
topPanel

	^ topBar! !

!SdFadingToolbar methodsFor: 'layout' stamp: 'mt 4/7/2011 16:55:21.953'!
updateAlpha: aMouseEvent

	(self bounds containsPoint: aMouseEvent position) ifTrue: [
		leftBar alpha: (1.0 - ((aMouseEvent position x - self left max: 0) / (self width / 2)) max: 0.3).
		topBar alpha: (1.0 - ((aMouseEvent position y - self top max: 0) / (self height / 2)) max: 0.3).
		rightBar alpha: (1.0 - ((self right - aMouseEvent position x max: 0) / (self width / 2)) max: 0.3).
		bottomBar alpha: (1.0 - ((self bottom - aMouseEvent position y max: 0) / (self height / 2)) max: 0.3)].! !

!SdFadingToolbar methodsFor: 'layout' stamp: 'mt 4/7/2011 16:28:56.17'!
updateLayout
	"Simulate #spaceFill behaviour according to the bar's orientation."
	
	leftBar height: self height.
	topBar width: self width.
	rightBar height: self height.
	bottomBar width: self width.

	leftBar topRight: self topLeft.
	topBar bottomLeft: self topLeft.
	rightBar topLeft: self topRight.
	bottomBar topLeft: self bottomLeft.! !

Morph subclass: #SdFadingToolbarPanel
	instanceVariableNames: 'alpha orientation fadeEnabled'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sight-Dynamic-UI-Support'!

!SdFadingToolbarPanel commentStamp: 'mt 6/21/2010 16:38:29.674' prior: 0!
I just support the XpfCardMorph. You should normally not want to use me directly.

Normally, I contain some buttons and fade them in or out according to my alpha value.!

!SdFadingToolbarPanel methodsFor: 'accessing' stamp: 'mt 4/28/2011 12:39:37.687'!
alpha

	self submorphs ifEmpty: [^ 0.0].

	^ alpha ifNil: [alpha := 0.0]! !

!SdFadingToolbarPanel methodsFor: 'accessing' stamp: 'mt 4/28/2011 11:42:54.545'!
alpha: aFloat

	alpha := aFloat.
	
	self submorphs ifNotEmpty: [self redrawLater].! !

!SdFadingToolbarPanel methodsFor: 'drawing' stamp: 'mt 4/28/2011 12:39:55.986'!
drawOn: aCanvas

	aCanvas
		fillRoundRect: self panelBounds
		radius: 5
		fillStyle: (SolidFillStyle color: (Color black alpha: 0.5)).! !

!SdFadingToolbarPanel methodsFor: 'accessing' stamp: 'mt 6/21/2010 16:34:33.892'!
fadeEnabled 
	"Respect the alpha value while drawing?"
	
	^ fadeEnabled ifNil: [fadeEnabled := true]! !

!SdFadingToolbarPanel methodsFor: 'accessing' stamp: 'mt 6/21/2010 16:35:04.687'!
fadeEnabled: aBoolean

	aBoolean = fadeEnabled ifTrue: [^ self].
	
	fadeEnabled := aBoolean.
	self redrawLater.! !

!SdFadingToolbarPanel methodsFor: 'drawing' stamp: 'mt 6/21/2010 16:37:13.905'!
fullDrawOn: aCanvas

	self alpha = 0.0
		ifTrue: [^ self].

	(self alpha < 0.9 and: [self fadeEnabled])
		ifTrue: [^ super fullDrawOn: ((AnimAlphaBlendingCanvas on: aCanvas) alpha: self alpha)]
		ifFalse: [^ super fullDrawOn: aCanvas]! !

!SdFadingToolbarPanel methodsFor: 'initialization' stamp: 'mt 4/28/2011 12:40:06.131'!
initialize

	super initialize.
	
	self initializeEventHandler.
	
	self
		color: Color white;
		changeTableLayout;
		cellInset: 2;
		layoutInset: 2;
		orientation: #vertical.! !

!SdFadingToolbarPanel methodsFor: 'initialization' stamp: 'mt 4/28/2011 11:53:36.426'!
initializeEventHandler

	self eventHandler: UiEventHandler new.  

	self eventHandler
		grabKeyboardOnMouseEnter: false;  
		setProperty: #handlesMouseDown toValue: [false].

	self connect: self eventHandler signal: #mouseEntered: toSelector: #alpha: pattern: #(= 1.0).
	self connect: self eventHandler signal: #mouseLeft: toSelector: #alpha: pattern: #(= 0.0).
	self connect: self eventHandler signal: #mouseEntered: toSelector: #tryDelete:.
	self connect: self eventHandler signal: #mouseLeft: toSelector: #tryDelete:.! !

!SdFadingToolbarPanel methodsFor: 'accessing' stamp: 'mt 4/7/2011 14:28:28.138'!
orientation

	^ orientation! !

!SdFadingToolbarPanel methodsFor: 'accessing' stamp: 'mt 4/7/2011 14:28:45.026'!
orientation: aSymbol
	"#vertical #horizontal"

	aSymbol = orientation ifTrue: [^ self].

	orientation := aSymbol.
	
	self updateLayout.! !

!SdFadingToolbarPanel methodsFor: 'geometry' stamp: 'mt 6/20/2012 16:51:30.192'!
outerBounds

	^ self panelBounds! !

!SdFadingToolbarPanel methodsFor: 'geometry' stamp: 'mt 4/28/2011 11:32:40.828'!
panelBounds

	^ self submorphBounds outsetBy: 2  ! !

!SdFadingToolbarPanel methodsFor: 'events-processing' stamp: 'mt 4/28/2011 12:42:45.98'!
rejectsEvent: evt

	(self panelBounds containsPoint: evt position)
		ifTrue: [^ false]
		ifFalse: [self tryDelete: evt. ^ true]! !

!SdFadingToolbarPanel methodsFor: 'initialization' stamp: 'mt 4/28/2011 12:43:41.307'!
tryDelete: aMouseEvent

	(self owner morphsAt: aMouseEvent position)
		ifEmpty: [^ self owner delete].
		
	(self submorphs isEmpty and: [self bounds containsPoint: aMouseEvent position])
		ifTrue: [^ self owner delete].! !

!SdFadingToolbarPanel methodsFor: 'layout' stamp: 'mt 4/12/2011 17:33:50.568'!
updateLayout

	self orientation = #vertical
		ifTrue: [self
			width: 22;
			listDirection: #topToBottom].

	self orientation = #horizontal  
		ifTrue: [self
			height: 22;
			listDirection: #leftToRight].! !

Morph subclass: #SdFinder
	instanceVariableNames: 'ui previewPanel sortOrder preferredItemCount outerBorderWidth categoryFilter'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sight-Dynamic'!

SdFinder subclass: #SdClassFinder
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sight-Dynamic'!

!SdClassFinder commentStamp: 'mt 4/17/2011 16:30:36.489' prior: 0!
Class hierarchy sorting ported from OmniBrowser framework (OBClassSortFilter).!

!SdClassFinder methodsFor: 'actions - category filter' stamp: 'mt 9/1/2011 13:13:20.744'!
addCategory

	self currentElement ifEmpty: [^ self].
	
	self organization addCategory: self currentElement.
	
	"Create package if necessary."
	PackageOrganizer default
		packageOfSystemCategory: self currentElement
		ifNone: [PackageInfo named: self currentElement].! !

!SdClassFinder methodsFor: 'results - queries' stamp: 'mt 4/17/2011 11:08:07.496'!
allCategories

	^ (super allCategories, PackageOrganizer default packageNames) asSet! !

!SdClassFinder methodsFor: 'results - queries' stamp: 'mt 4/17/2011 10:08:58.07'!
allElements

	^ Smalltalk globals classNames! !

!SdClassFinder methodsFor: 'results - building' stamp: 'mt 5/9/2012 14:12:18.709'!
buildCategoryItemFor: aCategoryName

	| isPackage text |
	isPackage := PackageOrganizer default packageNames includes: aCategoryName.
	text := '{1} <font color="#AAAAAA">({2} class(es){3})</font>' format: {
		aCategoryName.
		(self elementsFor: aCategoryName) size.
		isPackage
			ifTrue: [', ', (PackageInfo named: aCategoryName) systemCategories size asString, ' categories']
			ifFalse: ['']}.
	
	^ UiListWidgetItem new
		text: text asHtmlText;
		icon: (isPackage
			ifTrue: [UiSilkIcons packageIcon]
			ifFalse: [self iconForCategory]);
		at: #category put: aCategoryName;
		at: #symbol put: aCategoryName;
		yourself! !

!SdClassFinder methodsFor: 'results - building' stamp: 'mt 5/9/2012 14:11:35.282'!
buildElementItemFor: anElementName

	| isPackage |
	isPackage := PackageOrganizer default packageNames includes: self categoryFilter.

	^ UiListWidgetItem new
		text: ((isPackage or: [self categoryFilter isNil])
			ifTrue: [(anElementName escapeHtmlText, ' <font color="#AAAAAA">(', (self categoryFor: anElementName), ')</font>') asHtmlText]
			ifFalse: [anElementName]);
		"icon: (self iconFor: anElementName);"
		at: #element put: anElementName;
		at: #symbol put: anElementName;
		yourself! !

!SdClassFinder methodsFor: 'results - building' stamp: 'mt 5/9/2012 14:11:35.229'!
buildElementItemsFor: sortedElements
	"Sorting ported from OmniBrowser code."
	
	| classes order superChain |
	self categoryFilter ifNil: [^ super buildElementItemsFor: sortedElements].
	
	classes := sortedElements collect: [:e | Smalltalk at: e].
	order := SortedCollection sortBlock: 
					[:assoc1 :assoc2 | | i chain2 chain1 result max |
					result := nil.
					chain1 := assoc1 key.
					chain2 := assoc2 key.
					max := chain1 size min: chain2 size.
					i := 1.
					[result isNil and: [i <= max]] whileTrue: 
							[(chain1 at: i) = (chain2 at: i) 
								ifTrue: [i := i + 1]
								ifFalse: [result := (chain1 at: i) name < (chain2 at: i) name]].
					result isNil ifTrue: [chain1 size < chain2 size] ifFalse: [result]].

	classes do: [:class |
		superChain := class withAllSuperclasses reversed.
		superChain removeAllSuchThat: [:cl | (classes includes: cl) not].
		order add: superChain contents -> class].
	
	^ order collect: [:assoc | 
			(self buildElementItemFor: assoc value name)
				icon: (assoc key size > 1
					ifTrue: [Form extent: (10 * (assoc key size - 1)) @1 depth: 32]
					ifFalse: [])].! !

!SdClassFinder methodsFor: 'results - queries' stamp: 'mt 2/15/2012 11:04:33.314'!
categoriesFor: aPackageName

	^ (PackageOrganizer default packageNamed: aPackageName ifAbsent: [])
		ifNil: [#()]
		ifNotNil: [:packageInfo | packageInfo systemCategories]! !

!SdClassFinder methodsFor: 'actions' stamp: 'mt 5/14/2012 16:14:47.423'!
chooseElement

	self currentElement ifEmpty: [^ self].

	"Category/package only relevant for new elements."
	self isCurrentElementNew
		ifTrue: [self categoryFilter
			ifNil: [self classChosen: self currentElement]
			ifNotNil: [:cat | self classChosen: self currentElement category: cat]]
		ifFalse: [self classChosen: self currentElement].! !

!SdClassFinder methodsFor: 'signals' stamp: 'mt 4/17/2011 10:09:39.977'!
classChosen: className

	self emit.! !

!SdClassFinder methodsFor: 'signals' stamp: 'mt 4/17/2011 10:09:50.735'!
classChosen: className category: aSystemCategory

	self emit.! !

!SdClassFinder methodsFor: 'actions' stamp: 'mt 5/9/2012 15:02:51.803'!
clear
	"Just go back to sys cat list in package if package can be found."
	
	| sysCat package matchedCategories |
	sysCat := self categoryFilter.
	
	package := PackageOrganizer default
		packageOfSystemCategory: self categoryFilter
		ifNone: [].
		
	(package isNil or: [package name = self categoryFilter]) ifTrue: [^ super clear].
	
	self categoryFilter: package name.
	self updateResults: self class tokenForAllCategories.
	
	"Select the current category in the list."
	matchedCategories := self ui resultList select: [:item | item text asString startsWith: sysCat].
	matchedCategories ifNotEmpty: [self ui resultList currentItem: matchedCategories first]! !

!SdClassFinder methodsFor: 'actions - preview' stamp: 'mt 7/17/2011 22:20:44.963'!
createPreviewPanelFor: anElement

	previewPanel := SdPreviewBuilder createClassPreviewFor: (Smalltalk at: anElement).! !

!SdClassFinder methodsFor: 'accessing' stamp: 'mt 5/9/2012 14:11:35.267'!
currentPackage

	^ PackageOrganizer default
		packageNamed: self categoryFilter
		ifAbsent: []! !

!SdClassFinder methodsFor: 'results - queries' stamp: 'mt 5/14/2012 15:37:12.443'!
element: anElement matches: aToken
	"Advanced matching. Match PluggableButtonMorph with captial letters PBM."

	| letters |
	(super element: anElement matches: aToken)
		ifTrue: [^ true].
		
	letters := anElement select: [:e | e isUppercase].
	^ letters includesSubString: aToken  
	! !

!SdClassFinder methodsFor: 'results - queries' stamp: 'mt 4/17/2011 11:00:24.665'!
elementsFor: aCategoryName

	(PackageOrganizer default packageNames includes: aCategoryName)
		ifFalse: [^ super elementsFor: aCategoryName]
		ifTrue: [^ (PackageInfo named: aCategoryName) systemCategories gather:
			[:cat | (SystemOrganization listAtCategoryNamed: cat)]]! !

!SdClassFinder methodsFor: 'icons' stamp: 'mt 4/17/2011 10:36:08.29'!
iconForCategory

	^ UiSilkIcons folderIcon! !

!SdClassFinder methodsFor: 'icons' stamp: 'mt 4/17/2011 10:36:47.331'!
iconForCategoryAdd

	^ UiSilkIcons folderAddIcon! !

!SdClassFinder methodsFor: 'icons' stamp: 'mt 4/17/2011 10:36:56.874'!
iconForCategoryEdit

	^ UiSilkIcons folderEditIcon! !

!SdClassFinder methodsFor: 'icons' stamp: 'mt 5/9/2012 13:43:53.718'!
iconForElementAdd 

	^ UiSilkIcons carAddIcon! !

!SdClassFinder methodsFor: 'initialization' stamp: 'mt 6/22/2011 12:56:22.788'!
initialize

	preferredItemCount := 10.
	super initialize.! !

!SdClassFinder methodsFor: 'testing' stamp: 'mt 4/17/2011 10:14:15.233'!
isCurrentElementNew

	^ (Smalltalk includesKey: self currentElement) not! !

!SdClassFinder methodsFor: 'accessing' stamp: 'mt 4/17/2011 10:06:20.147'!
organization

	^ SystemOrganization! !

!SdClassFinder methodsFor: 'updating' stamp: 'mt 5/10/2012 15:57:50.869'!
updateCategoryFilterButton

	super updateCategoryFilterButton.

	self currentPackage
		ifNotNil: [self ui categoryFilterBtn icon: UiSilkIcons packageIcon].! !

!SdFinder class methodsFor: 'shortcuts' stamp: 'mt 4/17/2011 09:27:06.456'!
tokenForAllCategories

	^ ';'! !

!SdFinder class methodsFor: 'shortcuts' stamp: 'mt 4/17/2011 09:27:04.42'!
tokenForAllElements

	^ '.'! !

!SdFinder methodsFor: 'actions - category filter' stamp: 'mt 4/17/2011 09:21:38.102'!
addCategory

	self subclassResponsibility.! !

!SdFinder methodsFor: 'results - queries' stamp: 'mt 4/17/2011 10:14:57.794'!
allCategories

	^ self organization categories! !

!SdFinder methodsFor: 'results - queries' stamp: 'mt 4/17/2011 09:33:32.985'!
allElements

	self subclassResponsibility.! !

!SdFinder methodsFor: 'results - building' stamp: 'mt 4/17/2011 10:16:53.261'!
buildCategoryItemFor: aCategoryName

	self subclassResponsibility.! !

!SdFinder methodsFor: 'results - building' stamp: 'mt 4/17/2011 15:36:44.39'!
buildCategoryItemsFor: categories

	^ categories collect: [:category | self buildCategoryItemFor: category].! !

!SdFinder methodsFor: 'results - building' stamp: 'mt 4/17/2011 10:16:41.228'!
buildElementItemFor: anElementName

	self subclassResponsibility.! !

!SdFinder methodsFor: 'results - building' stamp: 'mt 4/17/2011 15:36:18.739'!
buildElementItemsFor: elements

	^ elements collect: [:element | self buildElementItemFor: element].! !

!SdFinder methodsFor: 'results - building' stamp: 'mt 5/14/2012 11:51:00.013'!
buildItemsForCategories: categories elements: elements

	self sortOrder = #categoriesBeforeElements ifTrue: [
		^ (self buildCategoryItemsFor: categories),
			(self buildElementItemsFor: elements)].
		
	self sortOrder = #alphabetical ifTrue: [
		| labels |
		labels := SortedCollection new
			sortBlock: [:e1 :e2 | e1 key <= e2 key].
		labels
			addAll: (categories collect: [:cat | cat -> #category]);
			addAll: (elements collect: [:e | e -> #element]).
			
		^ labels collect: [:label |
			label value = #category
				ifTrue: [self buildCategoryItemFor: label key]
				ifFalse: [self buildElementItemFor: label key]]].! !

!SdFinder methodsFor: 'results - queries' stamp: 'mt 4/17/2011 11:09:28.629'!
categoriesFor: aCategoryName
	"Allow one level of subcategories."
	
	^ #()! !

!SdFinder methodsFor: 'results - queries' stamp: 'mt 4/17/2011 16:43:48.188'!
category: aCategory matches: aToken

	^ aCategory startsWith: aToken  ! !

!SdFinder methodsFor: 'accessing' stamp: 'mt 5/9/2012 14:11:35.024'!
categoryFilter

	^ categoryFilter! !

!SdFinder methodsFor: 'accessing' stamp: 'mt 5/14/2012 15:47:36.843'!
categoryFilter: aString
	
	aString = categoryFilter ifTrue: [^ self].
	
	categoryFilter := aString.
	self updateCategoryFilterButton.! !

!SdFinder methodsFor: 'results - queries' stamp: 'mt 4/17/2011 17:04:24.828'!
categoryFor: anElementName

	^ self organization categoryOfElement: anElementName.! !

!SdFinder methodsFor: 'actions - category filter' stamp: 'mt 5/14/2012 09:47:02.675'!
chooseCategory
	"Set the current category as filter."

	self categoryFilter: self currentCategoryInList.
	
	self ui searchField theText: self class tokenForAllElements.
	self ui searchField selectAll.
	
	self updateResults.! !

!SdFinder methodsFor: 'actions' stamp: 'mt 4/17/2011 09:23:05.795'!
chooseElement

	self subclassResponsibility.! !

!SdFinder methodsFor: 'actions' stamp: 'mt 4/17/2011 11:12:50.55'!
chooseItem
	"Decide the next action depending on the current search token and the current protocol."

	self currentCategoryInList
		ifNotNil: [^ self chooseCategory].
		
	^ self chooseElement! !

!SdFinder methodsFor: 'actions' stamp: 'mt 4/17/2011 12:05:11.457'!
chooseNextResult

	self ui resultList isEmpty ifTrue: [^ self].
	
	self ui resultList currentRow
		ifNil: [self ui resultList currentRow: 1]
		ifNotNil: [self ui resultList currentRow:
			(self ui resultList currentRow + 1 min: self ui resultList size)].! !

!SdFinder methodsFor: 'actions' stamp: 'mt 4/17/2011 12:05:07.766'!
choosePrevResult

	self ui resultList isEmpty ifTrue: [^ self].
	
	self ui resultList currentRow
		ifNil: [self ui resultList currentRow: 1]
		ifNotNil: [self ui resultList currentRow:
			(self ui resultList currentRow - 1 max: 1)].! !

!SdFinder methodsFor: 'actions' stamp: 'mt 5/14/2012 11:19:34.083'!
clear

	self categoryFilter
		ifNotNil: [:cat | | matchedCategories |
			self categoryFilter: nil.
			self updateResults: self class tokenForAllCategories.

			"Select the current category in the list."
			matchedCategories := self ui resultList select: [:item | item text asString startsWith: cat].
			matchedCategories
				ifEmpty: [self update]
				ifNotEmpty: [self ui resultList currentItem: matchedCategories first]]
		ifNil: [
			self ui searchField theText: self class tokenForAllCategories.
			self updateResults.
			self ui searchField selectAll.]



	
	
	! !

!SdFinder methodsFor: 'actions - preview' stamp: 'mt 5/11/2011 09:38:41.767'!
createPreviewPanelFor: anElement

	self subclassResponsibility.! !

!SdFinder methodsFor: 'accessing - query' stamp: 'mt 5/9/2012 14:11:35.199'!
currentCategory

	^ self categoryFilter ifNil: [self currentCategoryInList]! !

!SdFinder methodsFor: 'accessing - query' stamp: 'mt 5/9/2012 14:12:08.839'!
currentCategoryInList
	
	^ self ui resultList currentItem ifNotNil: [:item |
		item at: #category ifAbsent: []]! !

!SdFinder methodsFor: 'accessing - query' stamp: 'mt 5/10/2012 14:53:59.111'!
currentElement
	"Return the symbol of the searched element. Ignore special tokens, e.g., for all selectors."
			
	^ self isCurrentTokenSpecial
		ifTrue: ['']
		ifFalse: [self currentToken asSymbol]! !

!SdFinder methodsFor: 'accessing - query' stamp: 'mt 5/9/2012 13:56:52.225'!
currentElementInList

	^ self ui resultList currentItem ifNotNil: [:item |
		item at: #element ifAbsent: []]! !

!SdFinder methodsFor: 'accessing - query' stamp: 'mt 5/10/2012 14:53:20.565'!
currentToken
	"The piece of text that was entered by the user in the search field."		
			
	^ self ui searchField theText asString! !

!SdFinder methodsFor: 'accessing - query' stamp: 'mt 5/15/2012 10:16:14.946'!
currentToken: aString
	"This is the programmatical way to set the current search string. You should never manipulate the search field directly but use this method."
			
	self ui searchField theText: aString.
	
	self
		updateResults;
		updateSelection.! !

!SdFinder methodsFor: 'submorphs-add/remove' stamp: 'mt 2/15/2012 16:47:33.425'!
delete

	super delete.
	self deleted.! !

!SdFinder methodsFor: 'signals' stamp: 'mt 2/15/2012 16:47:24.104'!
deleted

	self emit.! !

!SdFinder methodsFor: 'drawing' stamp: 'mt 2/15/2012 15:47:13.558'!
drawOn: aCanvas

	aCanvas
		fillRectangle: self innerBounds
		color: (Color gray: 0.85).
		
	self outerBorderWidth > 0 ifTrue: [
		aCanvas
			frameRoundRect: self outerBounds
			radius: 3
			width: self outerBorderWidth  
			color: (Color gray: 0.3)].! !

!SdFinder methodsFor: 'drawing' stamp: 'mt 2/15/2012 10:59:52.149'!
drawOverlayOn: aCanvas
	
	self hasSubmorphKeyboard ifFalse: [
		aCanvas
			fillRectangle: self outerBounds
			color: ((Color gray: 0.85) alpha: 0.5)].! !

!SdFinder methodsFor: 'results - queries' stamp: 'mt 4/17/2011 16:43:58.319'!
element: anElement matches: aToken

	^ anElement startsWith: aToken  ! !

!SdFinder methodsFor: 'results - queries' stamp: 'mt 4/17/2011 10:06:01.159'!
elementsFor: aCategoryName

	^ self organization listAtCategoryNamed: aCategoryName  ! !

!SdFinder methodsFor: 'events' stamp: 'mt 4/17/2011 09:27:34.612'!
grabKeyboard

	self ui searchField grabKeyboard.! !

!SdFinder methodsFor: 'actions' stamp: 'mt 5/14/2012 11:54:51.218'!
hideCategoryAction

	self ui categoryActionBtn delete.! !

!SdFinder methodsFor: 'actions - category filter' stamp: 'mt 5/9/2012 14:44:13.255'!
hideCategoryFilter

	self ui categoryFilterBtn delete.! !

!SdFinder methodsFor: 'actions' stamp: 'mt 5/14/2012 11:55:50.937'!
hideElementAction

	self ui elementActionBtn delete.! !

!SdFinder methodsFor: 'actions - preview' stamp: 'mt 5/11/2011 09:40:54.508'!
hidePreview

	previewPanel ifNil: [^ self].
	previewPanel delete.
	previewPanel := nil.! !

!SdFinder methodsFor: 'actions' stamp: 'mt 4/17/2011 09:29:28.951'!
hideResults

	self ui resultList delete.! !

!SdFinder methodsFor: 'results - queries' stamp: 'mt 4/17/2011 09:38:33.333'!
iconFor: anElementName

	^ nil! !

!SdFinder methodsFor: 'icons' stamp: 'mt 4/17/2011 09:45:32.551'!
iconForCategory

	self subclassResponsibility.! !

!SdFinder methodsFor: 'icons' stamp: 'mt 4/17/2011 09:46:08.294'!
iconForCategoryAdd

	self subclassResponsibility.! !

!SdFinder methodsFor: 'icons' stamp: 'mt 4/17/2011 09:47:59.367'!
iconForCategoryEdit

	self subclassResponsibility.! !

!SdFinder methodsFor: 'icons' stamp: 'mt 5/10/2012 17:02:19.26'!
iconForElementAdd

	^ UiSilkIcons addIcon! !

!SdFinder methodsFor: 'icons' stamp: 'mt 5/9/2012 12:03:14.122'!
iconForElementEdit

	^ UiSilkIcons pencilIcon! !

!SdFinder methodsFor: 'initialization' stamp: 'mt 5/16/2012 11:15:49.369'!
initialize

	super initialize.

	self
		initializeUi;
		initializeKeyboardInput;
		initializeMouseInput;
		initializePreview;
		update.! !

!SdFinder methodsFor: 'initialization' stamp: 'mt 5/15/2012 10:12:59.986'!
initializeKeyboardInput
	
	self connect: self ui searchField signal: #textEdited: toSelector: #updateResults.
	self connect: self ui searchField signal: #textEdited: toSelector: #updateSelection.
	
	self connect: self ui resultList signal: #currentTextChanged: toSelector: #updateSearchField.
	
	self connect: self ui searchField signal: #textChanged: toSelector: #updateElementActionButton.
	self connect: self ui searchField signal: #textChanged: toSelector: #updateCategoryActionButton.
	self connect: self ui searchField signal: #textChanged: toSelector: #updateKeyboardShortcuts.

	self connect: self ui searchField signal: #textEdited: toSelector: #updateElementActionButton.
	self connect: self ui searchField signal: #textEdited: toSelector: #updateCategoryActionButton.
	self connect: self ui searchField signal: #textEdited: toSelector: #updateKeyboardShortcuts.
	
	
	"shortcuts"
	self ui searchField eventHandler on: Character arrowDown send: #chooseNextResult to: self.
	self ui searchField eventHandler on: Character arrowUp send: #choosePrevResult to: self.
	self ui searchField eventHandler on: Character escape send: #clear to: self.! !

!SdFinder methodsFor: 'initialization' stamp: 'mt 5/10/2012 15:04:39.23'!
initializeMouseInput
	
	"buttons"
	self connect: self ui elementActionBtn signal: #clicked: toSelector: #chooseElement.
	self connect: self ui categoryFilterBtn signal: #clicked: toSelector: #clear.

	"result list interaction"
	self connect: self ui resultList signal: #clicked: toSelector: #chooseItem.
	self connect: self ui searchField eventHandler signal: #mouseWheelUp: to: self ui resultList verticalScrollBar selector: #decreaseValueBySingleStep.
	self connect: self ui searchField eventHandler signal: #mouseWheelDown: to: self ui resultList verticalScrollBar selector: #increaseValueBySingleStep.! !

!SdFinder methodsFor: 'initialization' stamp: 'mt 5/10/2012 15:55:37.627'!
initializePreview

	self connect: self ui resultList signal: #currentNodeChanged: toSelector: #triggerPreview.
	self connect: self ui resultList viewport eventHandler signal: #focusLost toSelector: #hidePreview.
	self connect: self ui searchField eventHandler signal: #focusLost toSelector: #hidePreview.! !

!SdFinder methodsFor: 'initialization' stamp: 'mt 5/16/2012 11:15:14.579'!
initializeUi

	self ui setupUi: self.
	self ui panel
		layoutInset: 0;  
		vResizing: #shrinkWrap.
		
	self ui searchField
		deferEditSignalTime: 250. 
		
	"Access keyboard focus updates in important edit fields."
	self flag: #refactor.
	self connect: self ui searchField eventHandler signal: #focusReceived toSelector: #redrawLater.
	self connect: self ui searchField eventHandler signal: #focusLost toSelector: #redrawLater.
	self connect: self ui resultList viewport eventHandler signal: #focusReceived toSelector: #redrawLater.
	self connect: self ui resultList viewport eventHandler signal: #focusLost toSelector: #redrawLater.
		
	self
		color: (Color gray: 0.85);
		outerBorderWidth: 1;
		layoutInset: (0@1 corner: 0@0);
		vResizing: #shrinkWrap.! !

!SdFinder methodsFor: 'testing' stamp: 'mt 4/17/2011 09:50:03.078'!
isCurrentElementNew

	self subclassResponsibility.! !

!SdFinder methodsFor: 'testing' stamp: 'mt 5/10/2012 14:53:04.939'!
isCurrentTokenSpecial

	^ {self class tokenForAllElements. self class tokenForAllCategories}
		includes: self currentToken! !

!SdFinder methodsFor: 'testing' stamp: 'mt 4/17/2011 10:01:02.529'!
isValid
	"Indicate whether calculcations, updates and signal emittations work properly. "
	
	^ true! !

!SdFinder methodsFor: 'results - queries' stamp: 'mt 5/14/2012 15:15:07.346'!
matchedCategories

	^ self ui resultList items
		select: [:item | item includesKey: #category]
		thenCollect: [:item | item at: #category]! !

!SdFinder methodsFor: 'results - queries' stamp: 'mt 5/14/2012 15:16:02.389'!
matchedElements

	^ self ui resultList items
		select: [:item | item includesKey: #element]
		thenCollect: [:item | item at: #element]! !

!SdFinder methodsFor: 'accessing' stamp: 'mt 4/17/2011 10:04:06.659'!
organization

	^ self subclassResponsibility! !

!SdFinder methodsFor: 'accessing - ui' stamp: 'mt 2/15/2012 15:45:57.799'!
outerBorderWidth

	^ outerBorderWidth ifNil: [0]! !

!SdFinder methodsFor: 'accessing - ui' stamp: 'mt 2/15/2012 15:45:48.33'!
outerBorderWidth: anInteger

	outerBorderWidth := anInteger.! !

!SdFinder methodsFor: 'geometry' stamp: 'mt 2/15/2012 15:46:33.178'!
outerBounds

	^ self bounds outsetBy: self outerBorderWidth! !

!SdFinder methodsFor: 'accessing - ui' stamp: 'mt 6/22/2011 12:53:35.849'!
preferredItemCount
	"Number of visible items before scrolling is used."
	
	^ preferredItemCount ifNil: [preferredItemCount := 5]! !

!SdFinder methodsFor: 'accessing - ui' stamp: 'mt 6/22/2011 12:55:54.628'!
preferredItemCount: anInteger
	
	preferredItemCount := anInteger.
	
	self updateResultListExtent.! !

!SdFinder methodsFor: 'accessing - ui' stamp: 'mt 6/21/2011 16:30:42.671'!
previewPanel

	^ previewPanel! !

!SdFinder methodsFor: 'accessing - ui' stamp: 'mt 6/21/2011 16:30:50.225'!
previewPanel: aMorph

	previewPanel := aMorph.! !

!SdFinder methodsFor: 'actions' stamp: 'mt 5/14/2012 11:55:12.857'!
showCategoryAction

	self ui inputContainer 
		addMorph: self ui categoryActionBtn
		after: self ui searchField.! !

!SdFinder methodsFor: 'actions - category filter' stamp: 'mt 5/14/2012 11:24:29.396'!
showCategoryFilter

	self ui categoryFilterBtn
		icon: self iconForCategory;
		text: ('<font color="#AAAAAA">', self categoryFilter, '</font>') asHtmlText.

	"Check for performance reasons."
	self ui categoryFilterBtn owner ifNotNil: [^ self].

	self ui inputContainer
		addMorph: self ui categoryFilterBtn
		inFrontOf: self ui searchField.! !

!SdFinder methodsFor: 'actions' stamp: 'mt 5/14/2012 11:55:39.235'!
showElementAction

	self ui inputContainer 
		addMorphBack: self ui elementActionBtn.! !

!SdFinder methodsFor: 'actions - preview' stamp: 'mt 2/15/2012 16:00:27.012'!
showPreview
	"Show a preview for the current element if one is selected."
	
	| currentElement |
	currentElement := self currentElementInList.
	
	currentElement ifNil: [^ self].
	
	"Discard the current preview."
	previewPanel ifNotNil: [self hidePreview].
	
	self createPreviewPanelFor: currentElement.
	previewPanel ifNil: [^ self].
	
	"Ensure visibility of preview box."
	self ui resultList selection currentBounds ifNotNil: [:selectionBounds |
		| globalRight |
		globalRight := (self localPointToGlobal: self topRight) x.
		(globalRight + previewPanel width) > ActiveWorld right
			ifTrue: [(selectionBounds left - previewPanel width) < ActiveWorld left
				ifFalse: [previewPanel topRight: selectionBounds topLeft]
				ifTrue: [previewPanel topLeft: selectionBounds bottomLeft]]
			ifFalse: [previewPanel topLeft: globalRight @ selectionBounds top].
		previewPanel bottom: (ActiveWorld bottom min: previewPanel bottom)].
		
	previewPanel openInWorld.	! !

!SdFinder methodsFor: 'actions' stamp: 'mt 6/22/2011 12:55:44.784'!
showResults

	self updateResultListExtent.
	
	self ui resultList owner ifNil: [
		self ui panel addMorphBack: self ui resultList].! !

!SdFinder methodsFor: 'accessing - ui' stamp: 'mt 6/22/2011 10:24:35.464'!
sortOrder

	^ sortOrder ifNil: [sortOrder := #categoriesBeforeElements]! !

!SdFinder methodsFor: 'accessing - ui' stamp: 'mt 5/16/2012 11:47:20.839'!
sortOrder: aSymbol
	"#categoriesBeforeElements, #alphabetical"

	sortOrder = aSymbol ifTrue: [^ self].
	
	sortOrder := aSymbol.
	self updateResults.! !

!SdFinder methodsFor: 'actions - preview' stamp: 'mt 2/15/2012 16:06:10.985'!
triggerPreview

	self hidePreview.
		
	self
		removeAlarm: #showPreview;
		addAlarm: #showPreview
		after: 250.! !

!SdFinder methodsFor: 'accessing - ui' stamp: 'mt 5/9/2012 13:52:53.889'!
ui

	^ ui ifNil: [ui := SdFinderUi new]! !

!SdFinder methodsFor: 'accessing - ui' stamp: 'mt 6/21/2011 16:02:58.597'!
ui: aMorph

	ui := aMorph.! !

!SdFinder methodsFor: 'updating' stamp: 'mt 5/10/2012 15:52:09.251'!
update

	self
		updateResults;
		updateSelection;
		updateElementActionButton;
		updateCategoryActionButton;
		updateCategoryFilterButton.! !

!SdFinder methodsFor: 'updating' stamp: 'mt 5/14/2012 11:56:29.71'!
updateCategoryActionButton

	self ui categoryActionBtn disconnectSignal: #clicked: from: self.
	self hideCategoryAction.
	
	"If there is a category filter active, there will be no category action possible."
	self categoryFilter ifNotNil: [^ self].
	
	"A click will edit the category, i.e. set the category filter."
	(self currentCategory notNil and: [self categoryFilter isNil]) ifTrue: [
		self ui categoryActionBtn
			icon: self iconForCategoryEdit;
			balloonText: 'Set category filter to ''', self currentCategory, ''''.
		self
			showCategoryAction;
			connect: self ui categoryActionBtn signal: #clicked: toSelector: #chooseCategory].
	
	"A click will create a new category."
	(self currentCategory isNil and: [self currentElement notEmpty]) ifTrue: [
		self ui categoryActionBtn
			icon: self iconForCategoryAdd;
			balloonText: 'Add category ''', self currentElement, ''''.
		self
			showCategoryAction;
			connect: self ui categoryActionBtn signal: #clicked: toSelector: #addCategory].! !

!SdFinder methodsFor: 'updating' stamp: 'mt 5/14/2012 11:20:32.865'!
updateCategoryFilterButton

	self categoryFilter
		ifNil: [self hideCategoryFilter]
		ifNotNil: [self showCategoryFilter].! !

!SdFinder methodsFor: 'updating' stamp: 'mt 5/14/2012 11:56:45.485'!
updateElementActionButton
	"Show and update the element-action button if needed."

	(self isValid not or: [self currentElement isEmpty])
		ifTrue: [self hideElementAction. ^ self].
	
	self showElementAction.
	
	self isCurrentElementNew
		ifFalse: [self ui elementActionBtn
			icon: self iconForElementEdit;
			balloonText: 'Edit #', self currentElement]
		ifTrue: [
			({self class tokenForAllElements. self class tokenForAllCategories}
				includes: self currentElement)
					ifTrue: [self ui elementActionBtn hide]
					ifFalse: [	self ui elementActionBtn
						icon: self iconForElementAdd;
						balloonText: 'Add #', self currentElement]].! !

!SdFinder methodsFor: 'results - updating' stamp: 'mt 5/9/2012 14:11:35.128'!
updateItemsForResults
	"Icons or text or items may have to be updated."
	
	self ui resultList items do: [:listWidgetItem |
		(listWidgetItem includesKey: #element)
			ifTrue: [ | s i t |
				s := listWidgetItem at: #element.
				i := self iconFor: s.
				t := self categoryFilter ifNil: [(s escapeHtmlText,
					' <font color="#AAAAAA">(',
					(self categoryFor: s),
					')</font>') asHtmlText] ifNotNil: [s].
					
				i ~~ listWidgetItem icon ifTrue: [listWidgetItem icon: i].
				t ~= listWidgetItem text ifTrue: [listWidgetItem text: t]]].! !

!SdFinder methodsFor: 'updating' stamp: 'mt 5/14/2012 09:54:16.786'!
updateKeyboardShortcuts

	self currentCategoryInList
		ifNil: [
			self ui searchField eventHandler on: #(shift) -> Character cr send: #doClick to: self ui categoryActionBtn.
			self ui searchField eventHandler on: Character cr send: #doClick to: self ui elementActionBtn]
		ifNotNil: [
			self ui searchField eventHandler on: #(shift) -> Character cr send: #doClick to: self ui elementActionBtn.
			self ui searchField eventHandler on: Character cr send: #doClick to: self ui categoryActionBtn].! !

!SdFinder methodsFor: 'results - updating' stamp: 'mt 1/23/2012 09:47:21.991'!
updateResultListExtent

	self ui resultList height: 
		UiItemViewColumnSpec defaultItemExtent y 
			* (self ui resultList size min: self preferredItemCount)
			+ 1.! !

!SdFinder methodsFor: 'results - updating' stamp: 'mt 5/16/2012 11:29:20.687'!
updateResults

	self updateResults: self currentToken.! !

!SdFinder methodsFor: 'results - updating' stamp: 'mt 5/14/2012 14:53:59.65'!
updateResults: stringOrText
	"Actually perform the search operation."

	| token elements categories |
	token := stringOrText asString asSymbol.

	(self isValid not or: [token isEmpty]) ifTrue: [
		self ui resultList clear.
		^ self hideResults].

	"Find all elements, consider the current category and search token."
	elements := ((self categoryFilter
		ifNil: [self allElements]
		ifNotNil: [:cat | self elementsFor: cat])
		select: [:selector | token = self class tokenForAllElements or: [self element: selector matches: token]]) sorted.

	"Add categories to result if no current category is set."
	categories := ((self categoryFilter
		ifNil: [self allCategories]
		ifNotNil: [self categoriesFor: self categoryFilter])
		select: [:cat | token = self class tokenForAllCategories or: [self category: cat matches: token]]) sorted.
	
	"Only update the list if any changes occured."
	categories, elements = (self ui resultList items
		"Use extra property and not the text of the item to allow more rich information to be displayed, e.g., the category for an element."
		collect: [:item | item at: #symbol]) asArray
		ifTrue: [^ self updateItemsForResults].
	
	"Discard the old contents of the list because all new contents have been gathered."
	self ui resultList clear.
	
	self ui resultList addItemList: (self
		buildItemsForCategories: categories
		elements: elements).
	
	self ui resultList isEmpty
		ifTrue: [self hideResults]
		ifFalse: [self showResults].! !

!SdFinder methodsFor: 'updating' stamp: 'mt 5/10/2012 16:00:47.473'!
updateSearchField
	"Completes the search field with the current text in the result list. Select that part that has not been typed yet."

	| userText currentItemToken currentSearchToken i |
	self ui resultList currentItem ifNil: [^ self].
	
	currentItemToken := (self ui resultList currentItem at: #symbol) asString.
	currentSearchToken := self currentToken.

	currentItemToken = currentSearchToken 
		ifTrue: [^ self].
	
	userText := currentSearchToken allButLast: self ui searchField selectedText size.
	
	(currentItemToken startsWith: userText)
		ifTrue: [i := userText size + 1].

	self ui searchField theText: currentItemToken.
	
	i
		ifNil: [self ui searchField selectAll]
		ifNotNil: [self ui searchField select: (i to: self ui searchField theText size)].
			
	self grabKeyboard.
! !

!SdFinder methodsFor: 'updating' stamp: 'mt 2/15/2012 11:02:56.314'!
updateSelection
	"Try to find an exact match in the result list and select that item."
	
	self ui resultList currentItem: (self ui resultList items
		detect: [:item | (item at: #symbol) = self currentElement]
		ifNone: []).! !

SdFinder subclass: #SdItemFinder
	instanceVariableNames: 'classFinder methodFinder classLabel'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sight-Dynamic'!

!SdItemFinder commentStamp: 'mt 6/21/2011 15:38:00.676' prior: 0!
A generic finder for packages, classes, methods, ...!

!SdItemFinder methodsFor: 'actions - category filter' stamp: 'mt 6/21/2011 15:59:32.825'!
addCategory

	"Not possible."! !

!SdItemFinder methodsFor: 'results - queries' stamp: 'mt 6/21/2011 17:59:26.059'!
allElements

	^ self filterByClass
		ifTrue: [methodFinder allElements]
		ifFalse: [classFinder allElements]! !

!SdItemFinder methodsFor: 'signals' stamp: 'mt 3/23/2012 14:14:12.239'!
categoryChosen: categoryName

	(PackageOrganizer default packageNames includes: categoryName)
		ifTrue: [^ self packageChosen: categoryName].
		
	self emit.! !

!SdItemFinder methodsFor: 'actions - category filter' stamp: 'mt 6/22/2011 13:15:37.297'!
chooseCategory

	self filterByClass
		ifTrue: [self
			protocolChosen: self currentCategoryInList
			class: methodFinder theClass]
		ifFalse: [self categoryChosen: self currentCategoryInList].
		
	self close.! !

!SdItemFinder methodsFor: 'actions' stamp: 'mt 6/22/2011 13:15:43.13'!
chooseElement

	self currentElementInList ifNil: [^ self].

	self filterByClass
		ifTrue: [
			self
				selectorChosen: self currentElementInList
				class: methodFinder theClass.
			self methodChosen: (MethodReference
				class: methodFinder theClass
				selector: self currentElementInList)]
		ifFalse: [self classChosen: (Smalltalk at: self currentElementInList)].
		
	self close.! !

!SdItemFinder methodsFor: 'signals' stamp: 'mt 6/21/2011 16:22:30.883'!
classChosen: aClass

	self emit.! !

!SdItemFinder methodsFor: 'actions' stamp: 'mt 6/22/2011 13:14:15.804'!
clear

	self close.! !

!SdItemFinder methodsFor: 'actions' stamp: 'mt 6/22/2011 13:14:10.865'!
close

	self owner ifNotNil: [:o | o delete].! !

!SdItemFinder methodsFor: 'actions - preview' stamp: 'mt 6/21/2011 16:31:52.432'!
createPreviewPanelFor: anElement

	self filterByClass
		ifTrue: [
			methodFinder createPreviewPanelFor: anElement.
			previewPanel := methodFinder previewPanel]
		ifFalse: [
			classFinder createPreviewPanelFor: anElement.
			previewPanel := classFinder previewPanel].! !

!SdItemFinder methodsFor: 'accessing' stamp: 'mt 6/21/2011 15:57:55.899'!
currentElement
		
	| tokens |
	tokens := self tokens.
	tokens ifEmpty: [^ ''].
	
	({self class tokenForAllElements. self class tokenForAllCategories} includes: tokens last)
		ifTrue: [^ '']
		ifFalse: [^ tokens last asSymbol].! !

!SdItemFinder methodsFor: 'testing' stamp: 'mt 6/21/2011 15:49:31.391'!
filterByClass

	^ methodFinder isValid! !

!SdItemFinder methodsFor: 'icons' stamp: 'mt 6/21/2011 17:31:37.063'!
iconForCategory

	^ self filterByClass
		ifTrue: [methodFinder iconForCategory]
		ifFalse: [classFinder iconForCategory].! !

!SdItemFinder methodsFor: 'icons' stamp: 'mt 6/21/2011 17:31:42.652'!
iconForCategoryAdd

	^ self filterByClass
		ifTrue: [methodFinder iconForCategoryAdd]
		ifFalse: [classFinder iconForCategoryAdd].! !

!SdItemFinder methodsFor: 'icons' stamp: 'mt 6/21/2011 17:31:49.259'!
iconForCategoryEdit

	^ self filterByClass
		ifTrue: [methodFinder iconForCategoryEdit]
		ifFalse: [classFinder iconForCategoryEdit].! !

!SdItemFinder methodsFor: 'icons' stamp: 'mt 5/14/2012 11:05:24.967'!
iconForElementAdd

	^ self filterByClass
		ifTrue: [methodFinder iconForElementAdd]
		ifFalse: [classFinder iconForElementAdd].! !

!SdItemFinder methodsFor: 'icons' stamp: 'mt 5/14/2012 11:05:15.927'!
iconForElementEdit

	^ self filterByClass
		ifTrue: [methodFinder iconForElementEdit]
		ifFalse: [classFinder iconForElementEdit].! !

!SdItemFinder methodsFor: 'initialization' stamp: 'mt 5/16/2012 11:33:47.092'!
initialize

	"Use my UI to let the helper objects fill my result list."
	classFinder := SdClassFinder basicNew
		ui: self ui;
		perform: #initialize withArguments: #() inSuperclass: Morph.
	methodFinder := SdMethodFinder basicNew
		ui: self ui;
		perform: #initialize withArguments: #() inSuperclass: Morph.
	
	classLabel := UiLabel new.
	
	super initialize.
	
	classFinder
		sortOrder: #alphabetical;
		preferredItemCount: 10.
	methodFinder
		sortOrder: #alphabetical;
		preferredItemCount: 10.
	
	self ui searchField
		deferEditSignalTime: 500.
		
	self ui panel color: (Color gray: 0.9).! !

!SdItemFinder methodsFor: 'initialization' stamp: 'mt 5/14/2012 14:10:16.858'!
initializeMouseInput 

	super initializeMouseInput.

	"Make the button useful for categories and elements."
	self ui elementActionBtn disconnectSignal: #clicked: from: self.
	self connect: self ui elementActionBtn signal: #clicked: toSelector: #chooseItem.! !

!SdItemFinder methodsFor: 'testing' stamp: 'mt 5/14/2012 14:22:17.609'!
isCurrentElementNew

	^ self filterByClass
		ifTrue: [methodFinder isCurrentElementNew]
		ifFalse: [classFinder isCurrentElementNew]! !

!SdItemFinder methodsFor: 'signals' stamp: 'mt 6/22/2011 13:01:24.463'!
methodChosen: aMethodReference

	self emit.! !

!SdItemFinder methodsFor: 'accessing' stamp: 'mt 6/21/2011 15:58:55.943'!
organization

	^ self filterByClass
		ifTrue: [methodFinder organization]
		ifFalse: [classFinder organization]! !

!SdItemFinder methodsFor: 'signals' stamp: 'mt 6/30/2011 11:06:44.034'!
packageChosen: packageName

	self emit.! !

!SdItemFinder methodsFor: 'signals' stamp: 'mt 6/21/2011 16:22:07.071'!
protocolChosen: aProtocolName class: aClass

	self emit.! !

!SdItemFinder methodsFor: 'signals' stamp: 'mt 6/21/2011 16:22:24.59'!
selectorChosen: aSelector class: aClass

	self emit.! !

!SdItemFinder methodsFor: 'accessing' stamp: 'mt 6/21/2011 18:53:32.419'!
tokenDelimiter

	^ $#! !

!SdItemFinder methodsFor: 'accessing' stamp: 'mt 5/10/2012 16:55:32.872'!
tokens

	^ self currentToken
		findTokens: self tokenDelimiter! !

!SdItemFinder methodsFor: 'updating' stamp: 'mt 5/14/2012 12:01:04.755'!
updateCategoryActionButton

	self ui categoryActionBtn disconnectSignal: #clicked: from: self.
	self hideCategoryAction.! !

!SdItemFinder methodsFor: 'updating' stamp: 'mt 5/10/2012 15:58:21.497'!
updateCategoryFilterButton

	self hideCategoryFilter.! !

!SdItemFinder methodsFor: 'updating' stamp: 'mt 6/22/2011 14:06:26.336'!
updateClassLabel

	self filterByClass ifFalse: [^ classLabel delete].
	
	classLabel text: (classFinder buildElementItemFor: methodFinder theClass name) text.
	
	classLabel owner ifNil: [
		self ui panel addMorph: classLabel after: self ui inputContainer].! !

!SdItemFinder methodsFor: 'updating' stamp: 'mt 5/14/2012 14:25:07.231'!
updateElementActionButton
	"Show and update the element-action button if needed."

	self hideElementAction.

	(self isValid not or: [self currentElement isEmpty])
		ifTrue: [^ self].
	
	(self currentCategoryInList notNil or: [self currentElementInList notNil]) ifTrue: [
		self showElementAction.
		self ui elementActionBtn
			icon: self iconForElementEdit;
			balloonText: 'Edit #', self currentElement].! !

!SdItemFinder methodsFor: 'updating' stamp: 'mt 5/14/2012 12:01:55.894'!
updateKeyboardShortcuts

	self ui searchField eventHandler on: Character cr send: #doClick to: self ui elementActionBtn.! !

!SdItemFinder methodsFor: 'results - updating' stamp: 'mt 6/22/2011 14:02:10.545'!
updateResults: stringOrText

	| tokens finder |
	tokens := self tokens.
	
	methodFinder
		theClassSilent: nil;
		isMeta: false.
	
	tokens size >= 2 ifTrue: [
		"filter by class"
		| class |
		class := (classFinder allElements
			detect: [:e | classFinder element: e matches: tokens first]
			ifNone: []) ifNotNil: [:className | Smalltalk at: className].
		methodFinder theClassSilent: class].
	
	tokens size = 3 ifTrue: [
		methodFinder isMeta: true].
	
	finder := self filterByClass
		ifTrue: [methodFinder]
		ifFalse: [classFinder].
	
	tokens
		ifEmpty: [finder updateResults: stringOrText]
		ifNotEmpty: [finder updateResults: tokens last].
		
	self updateClassLabel.! !

!SdItemFinder methodsFor: 'updating' stamp: 'mt 2/15/2012 11:06:23.661'!
updateSearchField
	"Completes the search field with the current text in the result list. Select that part that has not been typed yet."
	
	| tokens userText prefixText currentItemToken currentSearchToken i |
	self ui resultList currentItem ifNil: [^ self].
	
	tokens := self tokens.
	
	"tokens size = 1 ifTrue: [^ super updateSearchField]."
	
	currentItemToken := (self ui resultList currentItem at: #symbol) asString.
	currentSearchToken := tokens
		ifEmpty: ['']
		ifNotEmpty: [tokens last].

	currentItemToken = currentSearchToken 
		ifTrue: [^ self].
	
	userText := currentSearchToken allButLast: self ui searchField selectedText size.
	
	(currentItemToken startsWith: userText)
		ifTrue: [i := userText size + 1]
		ifFalse: [i := 1].

	prefixText := tokens allButLast
		inject: ''
		into: [:text :token | text, token, self tokenDelimiter].
	i := i + prefixText size.
		
	self ui searchField theText: prefixText, currentItemToken.
	
	i
		ifNil: [self ui searchField selectAll]
		ifNotNil: [self ui searchField select: (i to: self ui searchField theText size)].
			
	self grabKeyboard.
! !

!SdItemFinder methodsFor: 'updating' stamp: 'mt 2/15/2012 11:06:35.421'!
updateSelection
	"Select any item that is a close match."
	
	| tokens check |
	tokens := self tokens.
	
	tokens ifEmpty: [^ self ui resultList currentItem: nil].
	
	check := self filterByClass
		ifTrue: [[:item | methodFinder
				element: (item at: #symbol)
				matches: tokens last]]
		ifFalse: [[:item | classFinder
			element: (item at: #symbol)
			matches: tokens last]].
	
	self ui resultList currentItem: (self ui resultList items
		detect: check
		ifNone: []).! !

SdFinder subclass: #SdMethodFinder
	instanceVariableNames: 'theClass isMeta sideBtn'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sight-Dynamic'!

SdMethodFinder class
	instanceVariableNames: 'iconCache'!

SdMethodFinder class
	instanceVariableNames: 'iconCache'!

!SdMethodFinder class methodsFor: 'omnibrowser icons' stamp: 'mt 4/17/2012 09:52:44.458'!
announcement
	^ ((ColorForm
	extent: 12@12
	depth: 8
	fromArray: #( 168300858 976894522 976888885 34288443 993737531 993722369 959979575 673982238 103889690 87761712 705236742 120273668 87758851 152641799 789920516 959985427 204284436 488586007 34289723 993723152 926613505 168311098 976632635 473311541 1010580540 1007826230 840318012 1010580540 456396046 1010580540 1010580526 623262780 1010580540 1010580540 1010580540 1010580540)
	offset: 0@0)
	colorsFromArray: #(#(0.706 0.788 0.875) #(0.439 0.596 0.761) #(0.545 0.674 0.807) #(0.887 0.934 0.996) #(0.538 0.667 0.804) #(0.423 0.585 0.753) #(0.859 0.918 0.992) #(0.844 0.91 0.992) #(0.577 0.694 0.819) #(0.879 0.93 0.996) #(0.953 0.969 0.98) #(0.663 0.757 0.855) #(0.863 0.922 0.992) #(0.372 0.549 0.733) #(0.71 0.792 0.879) #(0.867 0.926 0.996) #(0.815 0.891 0.992) #(0.361 0.542 0.729) #(0.435 0.592 0.761) #(0.875 0.926 0.996) #(0.827 0.902 0.992) #(0.819 0.894 0.992) #(0.678 0.768 0.863) #(0.49 0.635 0.784) #(0.898 0.941 0.996) #(0.867 0.922 0.996) #(0.482 0.628 0.78) #(0.639 0.741 0.848) #(0.937 0.953 0.973) #(0.815 0.894 0.992) #(0.871 0.926 0.996) #(0.819 0.894 0.988) #(0.941 0.965 0.996) #(0.855 0.914 0.992) #(0.84 0.906 0.992) #(0.91 0.945 0.996) #(0.522 0.655 0.796) #(0.431 0.592 0.757) #(0.745 0.815 0.891) #(0.883 0.934 0.996) #(0.902 0.945 0.996) #(0.458 0.612 0.768) #(0.891 0.937 0.996) #(0.836 0.902 0.992) #(0.894 0.937 0.996) #(0.851 0.914 0.992) #(0.914 0.937 0.965) #(0.831 0.902 0.992) #(0.902 0.941 0.996) #(0.863 0.918 0.992) #(0.365 0.545 0.729) #(0.984 0.988 0.992) #(0.6 0.714 0.831) #(0.906 0.934 0.961) #(0.616 0.721 0.836) #(0.914 0.949 0.996) #(0.992 0.996 0.996) #(0.353 0.534 0.725) #(0.345 0.53 0.721) #(1.0 1.0 1.0)))! !

!SdMethodFinder class methodsFor: 'omnibrowser icons' stamp: 'mt 4/17/2012 09:52:44.525'!
arrowDown
	^ ((ColorForm
	extent: 12@12
	depth: 8
	fromArray: #( 185273099 185273099 185273099 185273099 185273099 185273099 185273098 168430090 168495883 185273098 151587081 168495883 185273098 151191561 168495883 185207306 151388169 168430091 185207049 151257353 151587339 185272841 328199 151653131 185273098 150997001 168495883 185273099 168364298 185273099 185273099 185207307 185273099 185273099 185273099 185273099)
	offset: 0@0)
	colorsFromArray: #(#(0.573 0.804 0.369) #(0.565 0.768 0.412) #(0.577 0.804 0.372) #(0.561 0.804 0.326) #(0.588 0.831 0.345) #(0.6 0.844 0.353) #(0.565 0.804 0.329) #(0.545 0.772 0.349) #(0.486 0.682 0.353) #(0.388 0.561 0.271) #(1.0 1.0 1.0) #( )))! !

!SdMethodFinder class methodsFor: 'omnibrowser icons' stamp: 'mt 4/17/2012 09:52:44.552'!
arrowUp
	^ ((ColorForm
	extent: 12@12
	depth: 8
	fromArray: #( 185273099 185273099 185273099 185273099 185273099 185273099 185273099 185207307 185273099 185273099 168364298 185273099 185273098 150997001 168495883 185272841 328199 151653131 185207049 151257353 151587339 185207306 151388169 168430091 185273098 151191561 168495883 185273098 151587081 168495883 185273098 168430090 168495883 185273099 185273099 185273099)
	offset: 0@0)
	colorsFromArray: #(#(0.573 0.804 0.369) #(0.565 0.768 0.412) #(0.577 0.804 0.372) #(0.561 0.804 0.326) #(0.588 0.831 0.345) #(0.6 0.844 0.353) #(0.565 0.804 0.329) #(0.545 0.772 0.349) #(0.486 0.682 0.353) #(0.388 0.561 0.271) #(1.0 1.0 1.0) #( )))! !

!SdMethodFinder class methodsFor: 'omnibrowser icons' stamp: 'mt 4/17/2012 09:52:44.576'!
arrowUpAndDown
	^ ((ColorForm
	extent: 12@12
	depth: 8
	fromArray: #( 185273099 185207307 185273099 185273099 167772170 185273099 185273098 262400 168495883 185272832 67699971 658187 185204736 524800 2571 185207306 459776 168430091 185207306 394240 168430091 185204736 524800 2571 185272832 67699971 658187 185273098 262400 168495883 185273099 167772170 185273099 185273099 185207307 185273099)
	offset: 0@0)
	colorsFromArray: #(#(0.388 0.561 0.271) #(0.486 0.682 0.353) #(0.565 0.768 0.412) #(0.545 0.772 0.349) #(0.573 0.804 0.369) #(0.577 0.804 0.372) #(0.561 0.804 0.326) #(0.565 0.804 0.329) #(0.588 0.831 0.345) #(0.6 0.844 0.353) #(1.0 1.0 1.0) #( )))! !

!SdMethodFinder class methodsFor: 'custom icons' stamp: 'mt 4/14/2011 20:00:18.291'!
arrowUpDownIcon

	^ self icons
		at: #arrowUpDown
		ifAbsentPut: [
			| form canvas |
			form := Form extent: 16@16 depth: 32.
			canvas := form getCanvas.
			
			canvas
				translucentImage: UiFugueIcons control270SmallIcon
				at: 0 @ 3;
				translucentImage: UiFugueIcons control090SmallIcon
				at: 0 @ -3.
				
			form]! !

!SdMethodFinder class methodsFor: 'omnibrowser icons' stamp: 'mt 4/17/2012 09:52:44.599'!
blank
	^ Form extent: 12 @ 12 depth: 8! !

!SdMethodFinder class methodsFor: 'custom icons' stamp: 'mt 4/14/2011 20:09:44.359'!
blankIcon

	^ self icons
		at: #blank
		ifAbsentPut: [Form extent: 16@16 depth: 32].! !

!SdMethodFinder class methodsFor: 'omnibrowser icons' stamp: 'mt 4/17/2012 09:52:44.622'!
breakpoint
	^ ((ColorForm
	extent: 12@12
	depth: 8
	fromArray: #( 437918234 437918234 437918234 437654804 319885069 26 437590295 404100630 100859930 437524241 269290764 100860442 437327375 235736076 67305498 437261581 218893324 67305754 437130258 303174162 84082970 436931081 134678279 196890 437918234 437918234 196890 454761243 454761242 196890 454761243 454761242 196634 454761243 454761242 26)
	offset: 0@0)
	colorsFromArray: #(#(0.349 0.212 0.098) #(0.329 0.2 0.094) #(0.376 0.232 0.109) #(0.694 0.462 0.271) #(0.608 0.271 0.204) #(0.545 0.185 0.113) #(0.784 0.322 0.294) #(0.721 0.023 0.023) #(0.788 0.055 0.055) #(0.848 0.106 0.106) #(0.875 0.137 0.137) #(0.914 0.208 0.208) #(0.953 0.298 0.298) #(0.953 0.318 0.318) #(0.953 0.333 0.333) #(0.953 0.349 0.349) #(0.953 0.365 0.365) #(0.953 0.388 0.388) #(0.922 0.427 0.427) #(0.953 0.482 0.482) #(0.949 0.542 0.538) #(0.957 0.592 0.592) #(0.953 0.624 0.62) #(0.984 0.879 0.879) #(0.988 0.898 0.898) #(0.992 0.918 0.918) #(1.0 1.0 1.0) #( )))! !

!SdMethodFinder class methodsFor: 'class icons' stamp: 'mt 4/17/2012 10:18:46.821'!
classIcons

	^ {
		String -> #string.
		Collection -> #collection.
		Exception -> #exception.
		Magnitude -> #magnitude.
		Morph -> #morph
	}! !

!SdMethodFinder class methodsFor: 'omnibrowser icons' stamp: 'mt 4/17/2012 09:52:44.647'!
collection
	^ ((ColorForm
	extent: 12@12
	depth: 8
	fromArray: #( 168952850 171324982 909522486 255008812 271977989 285543990 706029348 70649368 724044854 254681884 271986469 689508662 135534100 137758237 890965046 909522486 909513472 436212534 909508866 151126326 909522486 909511457 807338806 909522486 909521969 841353526 909522486 909511458 504824630 909522486 909511943 755436854 909522486 909522486 909522486 909522486)
	offset: 0@0)
	colorsFromArray: #(#(0.565 0.764 0.538) #(0.992 0.98 0.934) #(0.957 0.879 0.549) #(0.953 0.867 0.514) #(1.0 0.569 0.286) #(0.577 0.772 0.553) #(0.557 0.761 0.53) #(0.957 0.875 0.538) #(1.0 0.949 0.914) #(0.937 0.827 0.369) #(1.0 0.953 0.922) #(0.953 0.871 0.53) #(0.542 0.753 0.518) #(0.992 0.98 0.926) #(0.937 0.965 0.934) #(1.0 0.678 0.466) #(1.0 0.667 0.451) #(0.408 0.678 0.372) #(1.0 0.694 0.494) #(0.93 0.961 0.926) #(1.0 0.682 0.478) #(0.918 0.631 0.447) #(1.0 0.557 0.271) #(0.848 0.757 0.384) #(0.545 0.745 0.506) #(0.561 0.686 0.522) #(0.392 0.671 0.357) #(0.466 0.659 0.423) #(0.887 0.53 0.298) #(0.514 0.71 0.474) #(0.807 0.737 0.458) #(0.887 0.796 0.423) #(0.91 0.628 0.443) #(0.93 0.84 0.466) #(0.894 0.804 0.435) #(0.831 0.553 0.372) #(0.823 0.542 0.357) #(0.643 0.772 0.604) #(0.804 0.733 0.443) #(0.871 0.588 0.408) #(0.498 0.698 0.462) #(0.612 0.733 0.573) #(1.0 0.577 0.306) #(0.639 0.764 0.6) #(0.926 0.569 0.337) #(0.937 0.823 0.353) #(0.937 0.581 0.349) #(0.419 0.686 0.388) #(0.883 0.811 0.53) #(0.894 0.823 0.534) #(0.848 0.776 0.494) #(0.973 0.612 0.38) #(0.941 0.831 0.384) #(0.573 0.694 0.534) #( ) ))! !

!SdMethodFinder class methodsFor: 'omnibrowser icons' stamp: 'mt 4/17/2012 09:52:44.673'!
exception
	^ ((ColorForm
	extent: 12@12
	depth: 8
	fromArray: #( 1583238196 1191577949 759500554 1583225870 390089009 36066088 1578711384 857557019 906518110 1581393173 991970905 1549688414 722677332 570761514 1583242846 1327383559 1091971346 5322527 792346372 337270359 1297099812 1011548469 286015067 654532190 1583242842 941838926 1432247902 1583242763 221384798 1583242846 1583224899 1029594718 1583242846 1583231050 1583242846 1583242846)
	offset: 0@0)
	colorsFromArray: #(#(0.906 0.764 0.392) #(0.945 0.867 0.6) #(0.918 0.776 0.306) #(0.969 0.922 0.815) #(0.945 0.831 0.443) #(0.953 0.84 0.443) #(0.934 0.823 0.388) #(0.953 0.819 0.286) #(0.98 0.949 0.855) #(0.93 0.815 0.376) #(0.992 0.98 0.941) #(0.894 0.733 0.302) #(0.945 0.792 0.4) #(0.898 0.725 0.286) #(0.949 0.863 0.423) #(0.965 0.91 0.737) #(0.984 0.961 0.906) #(0.914 0.772 0.365) #(0.91 0.768 0.384) #(0.941 0.844 0.415) #(0.953 0.844 0.498) #(0.965 0.871 0.4) #(0.953 0.836 0.474) #(0.945 0.859 0.439) #(0.949 0.867 0.651) #(0.988 0.965 0.867) #(0.949 0.815 0.455) #(0.957 0.855 0.542) #(0.953 0.875 0.514) #(0.957 0.836 0.341) #(0.953 0.867 0.474) #(0.914 0.78 0.474) #(0.945 0.8 0.263) #(0.934 0.811 0.431) #(0.941 0.792 0.216) #(0.93 0.788 0.443) #(0.965 0.914 0.796) #(0.965 0.891 0.51) #(0.898 0.733 0.22) #(0.906 0.764 0.435) #(0.992 0.984 0.953) #(0.898 0.737 0.275) #(0.957 0.894 0.71) #(0.992 0.977 0.914) #(0.926 0.815 0.569) #(0.918 0.788 0.333) #(0.973 0.902 0.561) #(0.918 0.788 0.286) #(0.957 0.891 0.725) #(0.937 0.815 0.396) #(0.902 0.757 0.396) #(0.965 0.867 0.369) #(0.937 0.84 0.384) #(0.934 0.836 0.526) #(0.91 0.764 0.306) #(0.887 0.721 0.333) #(0.914 0.764 0.357) #(0.941 0.855 0.412) #(0.949 0.855 0.462) #(0.949 0.811 0.232) #(0.957 0.891 0.635) #(0.945 0.863 0.659) #(0.941 0.776 0.408) #(0.953 0.855 0.474) #(0.945 0.844 0.427) #(0.941 0.78 0.236) #(0.957 0.891 0.608) #(0.875 0.69 0.216) #(0.969 0.883 0.451) #(0.906 0.761 0.286) #(0.957 0.848 0.498) #(0.934 0.836 0.396) #(0.961 0.84 0.415) #(0.941 0.831 0.408) #(0.977 0.941 0.855) #(0.949 0.875 0.604) #(0.965 0.91 0.655) #(0.922 0.757 0.404) #(0.941 0.851 0.635) #(0.965 0.914 0.698) #(0.879 0.69 0.247) #(0.898 0.741 0.353) #(0.891 0.717 0.302) #(0.973 0.934 0.804) #(0.953 0.831 0.279) #(1.0 0.996 0.992) #(0.941 0.796 0.443) #(0.941 0.804 0.486) #(0.98 0.922 0.573) #(0.914 0.772 0.345) #(0.98 0.945 0.859) #(0.902 0.725 0.322) #(0.969 0.918 0.772) #(0.926 0.8 0.357) #( ) ))! !

!SdMethodFinder class methodsFor: 'omnibrowser icons' stamp: 'mt 4/17/2012 09:52:44.702'!
flag
	^ ((ColorForm
	extent: 12@12
	depth: 8
	fromArray: #( 437918234 437918234 437918234 436470535 101584139 387389210 436404481 17105924 303634202 436666638 218827016 35198490 437126412 185075720 1644314 437060363 168298504 1644570 436930320 269422351 370743322 437326099 320082453 387520538 437918234 437918234 387520538 454761243 454761242 387520538 454761243 454761242 387520282 454761243 454761242 387389210)
	offset: 0@0)
	colorsFromArray: #(#(0.22 0.396 0.585) #(0.898 0.945 0.996) #(0.228 0.498 0.761) #(0.608 0.796 0.98) #(0.635 0.804 0.98) #(0.655 0.819 0.98) #(0.47 0.729 0.973) #(0.542 0.768 0.977) #(0.251 0.631 0.961) #(0.267 0.639 0.961) #(0.275 0.643 0.961) #(0.286 0.647 0.961) #(0.302 0.659 0.965) #(0.326 0.667 0.965) #(0.353 0.678 0.965) #(0.396 0.714 0.965) #(0.419 0.729 0.969) #(0.239 0.686 0.93) #(0.243 0.624 0.772) #(0.236 0.682 0.851) #(0.228 0.667 0.788) #(0.224 0.616 0.671) #(0.384 0.228 0.082) #(0.349 0.212 0.098) #(0.329 0.2 0.094) #(0.694 0.462 0.271) #(1.0 1.0 1.0) #( )))! !

!SdMethodFinder class methodsFor: 'class icons' stamp: 'mt 4/17/2012 10:19:05.439'!
iconForClass: aClassDescription

	(aClassDescription inheritsFrom: Morph)
		ifTrue: [^ aClassDescription widgetClassIcon].

	self classIcons do: [:assoc |
		(aClassDescription includesBehavior: assoc key)
			ifTrue: [^ self icons at: assoc value ifAbsentPut: [(self perform: assoc value) clippedTo: 16@16]]].

	(aClassDescription inheritsFrom: TestCase) ifFalse: [^ nil].
	
	^ (aClassDescription lastRun at: #errors)
		ifNotEmpty: [UiDiagonaIcons icon0401Small]
		ifEmpty: [(aClassDescription lastRun at: #failures)
			ifNotEmpty: [UiDiagonaIcons icon0404Small]
			ifEmpty: [(aClassDescription lastRun at: #passed)
				ifNotEmpty: [UiDiagonaIcons icon0402Small]
				ifEmpty: [UiDiagonaIcons icon0410Small]]]! !

!SdMethodFinder class methodsFor: 'method icons' stamp: 'mt 5/17/2011 12:09:19.492'!
iconForClass: aClassDescription selector: aSelector
	"Answer an icon to be shown for the selector aSymbol in aClassDescription."

	((aClassDescription inheritsFrom: TestCase) and: [aSelector startsWith: #test])
		ifTrue: [^ self iconForTestClass: aClassDescription selector: aSelector].

	aClassDescription methodDictionary at: aSelector ifPresent: [ :method |
		method literalsDo: [ :literal |
			(literal == #halt or: [ literal == #halt: or: [ literal == #haltIfNil or: [ literal == #haltIf: or: [ literal == #haltOnce or: [ literal == #haltOnce: or: [ literal == #haltOnCount: or: [ literal == #halt:onCount: ] ] ] ] ] ] ])
				ifTrue: [ ^ UiSilkIcons exclamationIcon].
			(literal == #flag: or: [ literal == #needsWork or: [ literal == #notYetImplemented ] ])
				ifTrue: [ ^ UiSilkIcons flagGreenIcon].

			literal == #emit
				ifTrue: [^ UiSilkIcons transmitIcon].
			literal == #emitAlways
				ifTrue: [^ UiSilkIcons transmitBlueIcon].
			(literal == #shouldBeImplemented or: [literal == #subclassResponsibility])
				ifTrue: [^ UiFugueIcons controlStopSquareSmallIcon] ] ].
		
		
		
	^ (self isOverride: aSelector in: aClassDescription)
		ifTrue: [
			(self isOverridden: aSelector in: aClassDescription)
				ifTrue: [ self arrowUpDownIcon ]
				ifFalse: [ UiFugueIcons control090SmallIcon ] ]
		ifFalse: [
			(self isOverridden: aSelector in: aClassDescription)
				ifTrue: [ UiFugueIcons control270SmallIcon ]
				ifFalse: [ self blankIcon ] ]! !

!SdMethodFinder class methodsFor: 'method icons' stamp: 'mt 5/17/2011 12:59:59.821'!
iconForTestClass: aClassDescription selector: aSelector
	"Answer an icon to be shown for the selector aSymbol in aClassDescription."

	"((aClassDescription inheritsFrom: TestCase) and: [aSelector startsWith: #test])
		ifFalse: [^ nil]."
		
	^ ((aClassDescription lastRun at: #errors) includes: aSelector)
		ifTrue: [UiDiagonaIcons icon0401Small]
		ifFalse: [((aClassDescription lastRun at: #failures) includes: aSelector)
			ifTrue: [UiDiagonaIcons icon0404Small]
			ifFalse: [((aClassDescription lastRun at: #passed) includes: aSelector)
				ifTrue: [UiDiagonaIcons icon0402Small]
				ifFalse: [UiDiagonaIcons icon0410Small]]]
! !

!SdMethodFinder class methodsFor: 'custom icons' stamp: 'mt 4/14/2011 19:51:48.27'!
icons

	^ iconCache ifNil: [iconCache := Dictionary new]! !

!SdMethodFinder class methodsFor: 'support' stamp: 'mt 4/27/2011 15:12:25.288'!
isOverridden: aSelector in: aClass
	aClass allSubclassesDo: [ :class |
		(class includesSelector: aSelector)
			ifTrue: [ ^ true ] ].
	^ false! !

!SdMethodFinder class methodsFor: 'support' stamp: 'mt 4/27/2011 15:12:07.62'!
isOverride: aSelector in: aClass
	aClass allSuperclassesDo: [ :class | 
		(class includesSelector: aSelector) 
			ifTrue: [ ^ true ] ].
	^ false! !

!SdMethodFinder class methodsFor: 'omnibrowser icons' stamp: 'mt 4/17/2012 10:05:53.681'!
magnitude
	^ ((ColorForm
	extent: 12@12
	depth: 8
	fromArray: #( 874447653 738461995 85013556 875824136 573444634 471217204 875826957 607204404 875115572 875836464 489816628 875836468 875836468 50409268 875836468 875836468 268902708 875836468 875836418 101004340 875836468 875836448 167851060 873804852 875825163 204747815 874722356 875763995 321259818 335557684 875042605 102243847 930868 875836468 875836468 875836468)
	offset: 0@0)
	colorsFromArray: #(#(0.372 0.372 0.372) #(0.608 0.608 0.608) #(0.961 0.961 0.961) #(0.506 0.506 0.506) #(0.588 0.588 0.588) #(0.415 0.415 0.415) #(0.419 0.419 0.419) #(0.384 0.384 0.384) #(0.745 0.745 0.745) #(0.561 0.561 0.561) #(0.447 0.447 0.447) #(0.435 0.435 0.435) #(0.427 0.427 0.427) #(0.545 0.545 0.545) #(0.522 0.522 0.522) #(0.902 0.902 0.902) #(0.761 0.761 0.761) #(0.53 0.53 0.53) #(0.686 0.686 0.686) #(0.628 0.628 0.628) #(0.181 0.181 0.181) #(0.204 0.204 0.204) #(0.604 0.604 0.604) #(0.455 0.455 0.455) #(0.408 0.408 0.408) #(0.341 0.341 0.341) #(0.659 0.659 0.659) #(0.333 0.333 0.333) #(0.663 0.663 0.663) #(0.624 0.624 0.624) #(0.396 0.396 0.396) #(0.875 0.875 0.875) #(0.542 0.542 0.542) #(0.592 0.592 0.592) #(0.569 0.569 0.569) #(0.236 0.236 0.236) #(0.565 0.565 0.565) #(0.494 0.494 0.494) #(0.62 0.62 0.62) #(0.953 0.953 0.953) #(0.733 0.733 0.733) #(0.502 0.502 0.502) #(0.298 0.298 0.298) #(0.451 0.451 0.451) #(0.585 0.585 0.585) #(0.439 0.439 0.439) #(0.698 0.698 0.698) #(0.714 0.714 0.714) #(0.721 0.721 0.721) #(0.855 0.855 0.855) #(0.474 0.474 0.474) #(0.871 0.871 0.871) #( ) ))! !

!SdMethodFinder class methodsFor: 'omnibrowser icons' stamp: 'mt 4/17/2012 09:52:44.754'!
morph
	^ ((ColorForm
	extent: 12@12
	depth: 8
	fromArray: #( 1578631802 292362797 539127618 1895825665 2117994270 1445606482 202325275 1997372285 33573212 859313989 1763509875 1213866361 1064308758 192424752 1645101626 793665883 476466020 85208644 1751792704 621947215 1414349622 527711064 676669009 1346794755 1617375851 1095982919 656635516 1819423020 354700362 1695037706 154613091 420699479 75263577 2139062143 2139062143 2139062143)
	offset: 0@0)
	colorsFromArray: #(#(0.557 0.714 0.898) #(0.526 0.686 0.887) #(0.557 0.706 0.887) #(0.494 0.604 0.796) #(0.494 0.6 0.792) #(0.585 0.811 1.0) #(0.879 0.93 0.883) #(0.514 0.671 0.867) #(0.84 0.867 0.902) #(0.581 0.667 0.804) #(0.474 0.577 0.753) #(0.729 0.851 0.674) #(0.51 0.678 0.883) #(0.565 0.71 0.918) #(0.733 0.894 1.0) #(0.538 0.694 0.883) #(0.455 0.741 1.0) #(0.553 0.69 0.871) #(0.969 0.867 0.78) #(0.506 0.635 0.815) #(0.757 0.906 1.0) #(0.851 0.879 0.922) #(0.655 0.844 1.0) #(0.836 0.918 0.992) #(0.604 0.741 0.902) #(0.518 0.631 0.804) #(0.542 0.678 0.855) #(0.549 0.698 0.883) #(0.753 0.875 0.725) #(0.815 0.894 0.823) #(0.51 0.667 0.863) #(0.639 0.733 0.91) #(0.522 0.659 0.84) #(0.686 0.757 0.867) #(0.542 0.671 0.836) #(1.0 0.949 0.612) #(0.848 0.859 0.894) #(0.988 0.949 0.918) #(1.0 0.682 0.514) #(0.984 0.871 0.415) #(1.0 0.796 0.674) #(0.977 0.914 0.867) #(0.518 0.671 0.859) #(0.585 0.776 0.518) #(0.836 0.879 0.922) #(0.534 0.671 0.851) #(0.706 0.757 0.855) #(0.643 0.745 0.879) #(0.819 0.918 1.0) #(0.827 0.871 0.906) #(0.458 0.721 0.404) #(0.62 0.737 0.891) #(0.51 0.631 0.8) #(0.577 0.663 0.848) #(0.506 0.612 0.776) #(0.565 0.671 0.84) #(0.926 0.961 0.992) #(0.581 0.659 0.792) #(0.545 0.639 0.792) #(0.4 0.686 0.353) #(0.811 0.898 0.827) #(0.561 0.706 0.883) #(0.518 0.674 0.871) #(0.659 0.757 0.891) #(0.887 0.945 0.902) #(1.0 0.84 0.717) #(0.717 0.776 0.863) #(0.678 0.745 0.859) #(0.538 0.628 0.776) #(0.898 0.945 0.992) #(1.0 0.918 0.549) #(0.996 0.961 0.757) #(0.863 0.93 0.992) #(0.474 0.628 0.827) #(0.844 0.871 0.914) #(0.62 0.807 0.581) #(0.848 0.867 0.91) #(0.988 0.977 0.898) #(0.804 0.914 1.0) #(0.98 0.977 0.934) #(0.957 0.84 0.365) #(0.961 0.93 0.714) #(0.596 0.678 0.815) #(1.0 0.6 0.314) #(0.953 0.937 0.823) #(1.0 0.538 0.243) #(0.502 0.659 0.855) #(0.498 0.596 0.768) #(0.549 0.792 0.577) #(0.612 0.682 0.807) #(0.914 0.957 0.992) #(0.706 0.863 1.0) #(0.482 0.616 0.8) #(0.498 0.624 0.792) #(0.694 0.757 0.863) #(1.0 0.737 0.569) #(0.631 0.721 0.902) #(0.522 0.772 1.0) #(0.549 0.792 1.0) #(0.553 0.647 0.823) #(0.836 0.926 1.0) #(0.84 0.863 0.891) #(0.423 0.717 0.423) #(0.788 0.898 0.733) #(0.612 0.729 0.887) #(0.918 0.953 0.922) #(0.934 0.965 0.934) #(0.616 0.831 0.628) #(0.53 0.643 0.807) #(0.545 0.686 0.863) #(0.502 0.596 0.753) #(0.616 0.702 0.823) #(0.772 0.898 1.0) #(0.581 0.686 0.844) #(0.851 0.891 0.934) #(0.937 0.965 0.992) #(0.729 0.859 0.686) #(0.671 0.745 0.879) #(0.682 0.749 0.879) #(0.545 0.698 0.898) #(0.388 0.682 0.341) #(0.534 0.639 0.8) #(0.561 0.702 0.883) #(0.553 0.706 0.91) #(0.486 0.588 0.776) #(0.542 0.698 0.887) #(0.522 0.678 0.875) #( ) ))! !

!SdMethodFinder class methodsFor: 'omnibrowser icons' stamp: 'mt 4/17/2012 09:52:44.783'!
string
	^ ((ColorForm
	extent: 12@12
	depth: 8
	fromArray: #( 673716502 100672805 623061032 673717016 118757928 587409448 673710082 33825576 354166824 673717518 268698408 19277864 673714447 504037672 638134312 673720360 302655016 606152744 673720360 673588264 555886632 673720360 673456424 572991528 673720360 671621672 656418856 673720360 673654568 538912808 673720360 671948840 84682792 673720360 673128232 320284712)
	offset: 0@0)
	colorsFromArray: #(#(0.439 0.721 0.937) #(0.447 0.674 0.93) #(0.573 0.784 0.953) #(0.451 0.682 0.937) #(0.534 0.761 0.949) #(0.435 0.631 0.926) #(0.439 0.729 0.945) #(0.573 0.788 0.953) #(0.443 0.651 0.926) #(0.443 0.663 0.93) #(0.427 0.671 0.93) #(0.494 0.733 0.945) #(0.431 0.631 0.926) #(0.435 0.643 0.926) #(0.498 0.745 0.945) #(0.478 0.694 0.934) #(0.569 0.78 0.953) #(0.941 0.965 0.992) #(0.941 0.961 0.992) #(0.431 0.628 0.926) #(0.538 0.764 0.949) #(0.447 0.682 0.937) #(0.435 0.706 0.937) #(0.431 0.628 0.918) #(0.522 0.768 0.949) #(0.827 0.898 0.977) #(0.455 0.694 0.937) #(0.419 0.71 0.937) #(0.447 0.682 0.93) #(0.455 0.698 0.937) #(0.443 0.71 0.937) #(0.435 0.635 0.926) #(0.435 0.639 0.926) #(0.443 0.659 0.926) #(0.439 0.651 0.926) #(0.451 0.686 0.937) #(0.443 0.659 0.93) #(0.439 0.717 0.937) #(0.443 0.671 0.93) #(0.435 0.647 0.926) #( ) ))! !

!SdMethodFinder methodsFor: 'actions - category filter' stamp: 'mt 4/18/2011 15:47:23.429'!
addCategory

	self currentElement ifEmpty: [^ self].
	
	self organization addCategory: self currentElement.
	
	"TODO: Move notification into class categorizer."
	SystemChangeNotifier uniqueInstance trigger: ((AddedEvent
		item: self currentElement
		kind: AbstractEvent protocolKind)
		itemClass: self theClass).! !

!SdMethodFinder methodsFor: 'results - queries' stamp: 'mt 4/17/2011 09:34:14.123'!
allElements

	^ self theClass selectors! !

!SdMethodFinder methodsFor: 'results - building' stamp: 'mt 5/9/2012 14:12:35.24'!
buildCategoryItemFor: aCategoryName

	^ UiListWidgetItem new
		text: (aCategoryName, ' <font color="#AAAAAA">(', (self elementsFor: aCategoryName) size asString, ' method(s))</font>') asHtmlText;
		icon: self iconForCategory;
		at: #category put: aCategoryName;
		at: #symbol put: aCategoryName;
		yourself! !

!SdMethodFinder methodsFor: 'results - building' stamp: 'mt 5/9/2012 14:11:35.348'!
buildElementItemFor: anElementName

	^ UiListWidgetItem new
		text: (self categoryFilter
			ifNil: [(anElementName escapeHtmlText, ' <font color="#AAAAAA">(', (self categoryFor: anElementName), ')</font>') asHtmlText]
			ifNotNil: [anElementName]);
		icon: (self iconFor: anElementName);
		at: #element put: anElementName;
		at: #symbol put: anElementName;
		yourself! !

!SdMethodFinder methodsFor: 'actions' stamp: 'mt 5/9/2012 14:11:35.316'!
chooseElement

	self currentElement ifEmpty: [^ self].
	
	self isCurrentElementNew
		ifTrue: [^ self categoryFilter
			ifNil: [self selectorChosen: self currentElement isMeta: self isMeta]
			ifNotNil: [:cat | self selectorChosen: self currentElement isMeta: self isMeta protocol: cat]].
	
	self selectorChosen: self currentElement isMeta: self isMeta.! !

!SdMethodFinder methodsFor: 'actions - preview' stamp: 'mt 7/17/2011 22:13:29.399'!
createPreviewPanelFor: anElement

	^ previewPanel := SdPreviewBuilder createMethodPreviewFor: (
		MethodReference
			class: (self isMeta
				ifTrue: [self theClass theMetaClass]
				ifFalse: [self theClass])
			selector: anElement)! !

!SdMethodFinder methodsFor: 'results - queries' stamp: 'mt 4/17/2011 09:38:52.26'!
iconFor: anElementName

	^ self class iconForClass: self theClass selector: anElementName! !

!SdMethodFinder methodsFor: 'icons' stamp: 'mt 4/17/2011 09:46:02.656'!
iconForCategory

	^ UiSilkIcons tagOrangeIcon! !

!SdMethodFinder methodsFor: 'icons' stamp: 'mt 4/17/2011 09:46:15.175'!
iconForCategoryAdd

	^ UiSilkIcons tagBlueAddIcon! !

!SdMethodFinder methodsFor: 'icons' stamp: 'mt 4/17/2011 09:48:09.681'!
iconForCategoryEdit

	^ UiSilkIcons tagBlueEditIcon! !

!SdMethodFinder methodsFor: 'initialization' stamp: 'mt 5/14/2012 11:10:35.555'!
initializeKeyboardInput 

	super initializeKeyboardInput.

	self ui searchField eventHandler on: #(cmd) -> $q send: #toggleSide to: self.! !

!SdMethodFinder methodsFor: 'initialization' stamp: 'mt 5/14/2012 11:10:21.44'!
initializeMouseInput

	super initializeMouseInput.
	
	self connect: sideBtn signal: #clicked: toSelector: #toggleSide.
! !

!SdMethodFinder methodsFor: 'initialization' stamp: 'mt 6/15/2012 15:37:40.518'!
initializeUi
	
	sideBtn := UiToolButton new
		text: #instance;
		icon: SdIcons instanceSideIcon;
		buttonStyle: #iconOnly;
		layoutInset: 0.

	super initializeUi.
	
	self ui inputContainer addMorphFront: sideBtn.
	
	self connect: self signal: #sideToggled toSelector: #updateSideBtn.
	self connect: self signal: #sideToggled toSelector: #clear.! !

!SdMethodFinder methodsFor: 'testing' stamp: 'mt 4/18/2011 14:21:27.112'!
isCurrentElementNew

	^ (self theClass includesSelector: self currentElement) not! !

!SdMethodFinder methodsFor: 'accessing' stamp: 'mt 5/14/2012 15:07:27.672'!
isMeta

	^ isMeta ifNil: [false]! !

!SdMethodFinder methodsFor: 'accessing' stamp: 'mt 5/16/2012 11:39:22.842'!
isMeta: aBoolean

	isMeta = aBoolean ifTrue: [^ self].
	
	isMeta := aBoolean.
	self sideToggled.! !

!SdMethodFinder methodsFor: 'testing' stamp: 'mt 4/17/2011 10:01:22.085'!
isValid
	"The method finder needs a class."
	
	^ self theClass notNil! !

!SdMethodFinder methodsFor: 'accessing' stamp: 'mt 4/18/2011 14:17:58.907'!
organization

	^ self theClass organization! !

!SdMethodFinder methodsFor: 'signals' stamp: 'mt 4/18/2011 13:03:31.962'!
selectorChosen: aSymbol isMeta: aBoolean
	"Emitted whenever the user decided for a symbol. This can be a new one."
	
	self emit.! !

!SdMethodFinder methodsFor: 'signals' stamp: 'mt 4/18/2011 13:04:03.486'!
selectorChosen: aSymbol isMeta: aBoolean protocol: protocolName
	"Emitted whenever the user decided for a symbol. This can be a new one."
		
	self emit.! !

!SdMethodFinder methodsFor: 'signals - private' stamp: 'mt 5/16/2012 11:35:27.216'!
sideToggled

	self emit.! !

!SdMethodFinder methodsFor: 'accessing' stamp: 'mt 5/14/2012 15:31:31.069'!
theClass

	^ theClass ifNotNil: [:cls |
		self isMeta
			ifTrue: [cls theMetaClass]
			ifFalse: [cls]]! !

!SdMethodFinder methodsFor: 'accessing' stamp: 'mt 5/14/2012 15:02:45.158'!
theClass: aClass

	theClass := aClass.
	self clear.! !

!SdMethodFinder methodsFor: 'accessing' stamp: 'mt 5/14/2012 15:02:46.921'!
theClassSilent: aClass
	"Change the current class without notification."
	
	theClass := aClass.! !

!SdMethodFinder methodsFor: 'actions' stamp: 'mt 6/15/2012 15:36:44.831'!
toggleSide

	self isMeta: self isMeta not.! !

!SdMethodFinder methodsFor: 'updating' stamp: 'mt 6/15/2012 15:28:46.39'!
updateSideBtn

	self isMeta
		ifTrue: [sideBtn
			icon: SdIcons classSideIcon;
			balloonText: 'class side - click to toggle (CMD+Q)'.]
		ifFalse: [sideBtn
			icon: SdIcons instanceSideIcon;
			balloonText: 'instance side - click to toggle (CMD+Q)'].! !

Morph subclass: #SdOverlayConnector
	instanceVariableNames: 'sourceMorphs targetMorphs'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sight-Dynamic-UI-Support'!

!SdOverlayConnector class methodsFor: 'instance creation' stamp: 'mt 6/19/2012 17:52:32.023'!
from: someSourceMorphs to: someTargetMorphs in: aContainer

	| instance |
	instance := self new
		addAllSourceMorphs: someSourceMorphs;
		addAllTargetMorphs: someTargetMorphs.
	aContainer addMorphFront: instance.
	^ instance
		! !

!SdOverlayConnector methodsFor: 'accessing' stamp: 'mt 6/19/2012 17:50:37.767'!
addAllSourceMorphs: someMorphs

	someMorphs do: [:source | 
		source allOwnersDo: [:morph | morph isTransformMorph ifTrue: [
			self connectTransformMorph: morph]].
		self connectMorph: source].
	
	self sourceMorphs addAll: someMorphs.! !

!SdOverlayConnector methodsFor: 'accessing' stamp: 'mt 6/19/2012 17:51:12.459'!
addAllTargetMorphs: someMorphs

	someMorphs do: [:target |
		target allOwnersDo: [:morph | morph isTransformMorph ifTrue: [
			self connectTransformMorph: morph]].
		self connectMorph: target].
	
	self targetMorphs addAll: someMorphs.! !

!SdOverlayConnector methodsFor: 'initialization' stamp: 'mt 6/14/2012 09:28:55.461'!
connectMorph: aMorph

	self connect: aMorph signal: #positionChanged: toSelector: #update.
	self connect: aMorph signal: #extentChanged: toSelector: #update.! !

!SdOverlayConnector methodsFor: 'initialization' stamp: 'mt 6/14/2012 09:35:25.221'!
connectTransformMorph: aMorph

	self connectMorph: aMorph.
	self connect: aMorph signal: #offsetChanged: toSelector: #update.! !

!SdOverlayConnector methodsFor: 'initialization' stamp: 'mt 6/14/2012 09:29:10.776'!
disconnectMorph: aMorph

	aMorph disconnectSignal: #positionChanged: from: self.
	aMorph disconnectSignal: #extentChanged: from: self.! !

!SdOverlayConnector methodsFor: 'initialization' stamp: 'mt 6/14/2012 09:34:59.635'!
disconnectTransformMorph: aMorph

	self disconnectMorph: aMorph.
	aMorph disconnectSignal: #offsetChanged: from: self.! !

!SdOverlayConnector methodsFor: 'drawing' stamp: 'mt 6/19/2012 18:02:21.79'!
drawFramesOn: aCanvas

	self sourceMorphs, self targetMorphs	do: [:m |
		aCanvas
			frameRoundRect: ((m boundsIn: self owner) outsetBy: 3)
			radius: 3
			width: 3
			color: Color orange].! !

!SdOverlayConnector methodsFor: 'drawing' stamp: 'mt 6/19/2012 18:35:33.161'!
drawLinesOn: aCanvas
	"Just connect two morphs for now. "
	
	| middle source target |
	source := self sourceMorphs first.
	target := self targetMorphs first.
	
	middle := (source point: source center in: self owner) - (((source point: source center in: self owner) - 
		(target point: target center in: self owner)) // 2).

	aCanvas
		line: ((source boundsIn: self owner) pointNearestTo: middle)
		to: ((target boundsIn: self owner) pointNearestTo: middle)
		width: 5
		color: Color orange.! !

!SdOverlayConnector methodsFor: 'drawing' stamp: 'mt 6/19/2012 18:17:13.757'!
drawOn: aCanvas

	self
		drawFramesOn: aCanvas;
		drawLinesOn: aCanvas.! !

!SdOverlayConnector methodsFor: 'initialization' stamp: 'mt 6/19/2012 17:32:57.549'!
initialize

	super initialize.
	self
		color: Color transparent;
		disableTableLayout: true.! !

!SdOverlayConnector methodsFor: 'testing' stamp: 'mt 6/19/2012 17:59:13.399'!
isOverlayConnector

	^ true! !

!SdOverlayConnector methodsFor: 'event handling' stamp: 'mt 6/13/2012 16:25:13.716'!
rejectsEvent: evt

	^ true! !

!SdOverlayConnector methodsFor: 'accessing' stamp: 'mt 6/19/2012 18:20:46.373'!
removeAllSourceMorphs

	self sourceMorphs do: [:source |
		self removeSourceMorph: source].! !

!SdOverlayConnector methodsFor: 'accessing' stamp: 'mt 6/19/2012 18:20:09.713'!
removeAllTargetMorphs

	self targetMorphs do: [:target |
		self removeTargetMorph: target].! !

!SdOverlayConnector methodsFor: 'accessing' stamp: 'mt 6/19/2012 18:19:49.593'!
removeSourceMorph: source

	source allOwnersDo: [:morph | morph isTransformMorph ifTrue: [
		self disconnectTransformMorph: morph]].
	self disconnectMorph: source.

	self sourceMorphs remove: source.! !

!SdOverlayConnector methodsFor: 'accessing' stamp: 'mt 6/19/2012 18:27:43.908'!
removeTargetMorph: target

	target allOwnersDo: [:morph | morph isTransformMorph ifTrue: [
		self disconnectTransformMorph: morph]].
	self disconnectMorph: target.
	
	self targetMorphs remove: target.! !

!SdOverlayConnector methodsFor: 'accessing' stamp: 'mt 6/14/2012 10:23:35.204'!
sourceMorphBounds

	^ source boundsIn: self owner! !

!SdOverlayConnector methodsFor: 'accessing' stamp: 'mt 6/19/2012 17:47:41.67'!
sourceMorphs

	^ sourceMorphs ifNil: [sourceMorphs := OrderedCollection new]! !

!SdOverlayConnector methodsFor: 'accessing' stamp: 'mt 6/14/2012 10:23:41.686'!
targetMorphBounds

	^ target boundsIn: self owner! !

!SdOverlayConnector methodsFor: 'accessing' stamp: 'mt 6/19/2012 17:47:57.461'!
targetMorphs

	^ targetMorphs ifNil: [targetMorphs := OrderedCollection new]! !

!SdOverlayConnector methodsFor: 'updating' stamp: 'mt 6/19/2012 18:22:04.147'!
update
	
	| newBounds |
	self updateReferences.
	(self sourceMorphs isEmpty or: [self targetMorphs isEmpty])
		ifTrue: [^ self delete].
	
	newBounds := self sourceMorphs first boundsIn: self owner.
	
	self sourceMorphs, self targetMorphs do: [:morph |
		newBounds := newBounds quickMerge: (morph boundsIn: self owner)].
	
	self
		bounds: (newBounds outsetBy: 5);
		comeToFront;
		redrawLater.! !

!SdOverlayConnector methodsFor: 'updating' stamp: 'mt 6/19/2012 18:40:53.927'!
updateReferences

	self sourceMorphs do: [:morph |
		morph isInWorld ifFalse: [self removeSourceMorph: morph]].

	self targetMorphs do: [:morph |
		morph isInWorld ifFalse: [self removeTargetMorph: morph]].! !

Morph subclass: #SdOverlayMessageBox
	instanceVariableNames: 'ui'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sight-Dynamic-UI-Support'!

!SdOverlayMessageBox class methodsFor: 'examples' stamp: 'mt 4/29/2011 10:28:12.065'!
example01

	| box |
	box := self new.
	box title: 'Example Message'.
	box message: 'Wanna clear the<br>transcript?' icon: UiSilkIcons helpIcon.
	box addAction: 'Yes.' icon: UiSilkIcons acceptIcon receiver: Transcript selector: #clear.
	box addAction: 'No!!' icon: UiSilkIcons cancelIcon.
	
	box
		extent: 200@200;
		center: ActiveWorld center;
		openInWorld.! !

!SdOverlayMessageBox methodsFor: 'configuration' stamp: 'mt 4/29/2011 15:51:29.39'!
addAction: textOrString icon: aForm

	| button |
	button := UiPushButton new
		icon: aForm;
		text: textOrString;
		hResizing: #spaceFill.
	self connect: button signal: #clicked: toSelector: #delete.
	
	self ui buttonContainer addMorphBack: button.
	self updateShortcuts.
	
	^ button  ! !

!SdOverlayMessageBox methodsFor: 'configuration' stamp: 'mt 4/29/2011 15:51:34.855'!
addAction: textOrString icon: aForm receiver: anObject selector: aSymbol

	| button |
	button := UiPushButton new
		icon: aForm;
		text: textOrString;
		hResizing: #spaceFill.
	self connect: button signal: #clicked: toSelector: #delete.
	self connect: button signal: #clicked: to: anObject selector: aSymbol.
	
	self ui buttonContainer addMorphBack: button.
	self updateShortcuts.
		
	^ button  ! !

!SdOverlayMessageBox methodsFor: 'configuration' stamp: 'mt 4/29/2011 15:51:40.011'!
addAction: textOrString icon: aForm receiver: anObject selectors: someSymbols

	| button |
	button := UiPushButton new
		icon: aForm;
		text: textOrString;
		hResizing: #spaceFill.
	self connect: button signal: #clicked: toSelector: #delete.
	
	someSymbols do: [:symbol |
		self connect: button signal: #clicked: to: anObject selector: symbol].
	
	self ui buttonContainer addMorphBack: button.
	self updateShortcuts.
	
	^ button  ! !

!SdOverlayMessageBox methodsFor: 'geometry' stamp: 'mt 5/2/2011 15:30:50.387'!
extent: aPoint

	| extentChanged |
	extentChanged := aPoint ~= self extent.

	super extent: aPoint.

	extentChanged ifFalse: [^ self].
	
	(aPoint x > aPoint y and: [self ui buttonContainer submorphs size < 3])
		ifTrue: [self ui buttonContainer listDirection: #leftToRight]
		ifFalse: [self ui buttonContainer listDirection: #topToBottom].
		
	self ui buttonContainer
		layoutInset: (self ui buttonContainer listDirection = #leftToRight
			ifTrue: [(self width * 0.30)@0 corner: (self width * 0.30)@0]
			ifFalse: [(self width * 0.20)@0 corner: (self width * 0.20)@0]).
		
	(self ui buttonContainer listDirection = #leftToRight
		ifFalse: [#(0.1 0.2 0.5 0.9)]  
		ifTrue: [#(0.0 0.2 0.75 1.0)]) overlappingPairsWithIndexDo: [:top :bottom :index |
			(self ui panel submorphs at: index)
				frameFractions: (0@top corner: 1@bottom)].
			
	self ui buttonContainer submorphs size = 1 ifTrue: [
		self ui buttonContainer listCentering: #center.
		self ui buttonContainer submorphs first hResizing: #shrinkWrap].
	self ui buttonContainer submorphs size > 1 ifTrue: [
		self ui buttonContainer listCentering: #topLeft.
		self ui buttonContainer submorphs first hResizing: #spaceFill].! !

!SdOverlayMessageBox methodsFor: 'initialization' stamp: 'mt 5/12/2011 15:44:13.107'!
initialize

	super initialize.
	
	self ui setupUi: self.
	
	"Order morphs."
	self ui buttonContainer comeToFront.
	self ui messageContainer comeToFront.
	self ui titleLbl comeToFront.
	
	self eventHandler: UiEventHandler new. 
	
	self ignoresColorMappings: true.  ! !

!SdOverlayMessageBox methodsFor: 'configuration' stamp: 'mt 5/2/2011 15:54:49.573'!
message: aString

	self ui messageLbl text: ('<font color="#FFFFFF">', aString, '</font>') asHtmlText.! !

!SdOverlayMessageBox methodsFor: 'configuration' stamp: 'mt 5/2/2011 15:54:45.89'!
message: aString icon: anIcon

	self ui iconLbl form: anIcon.
	self ui messageLbl text: ('<font color="#FFFFFF">', aString, '</font>') asHtmlText.! !

!SdOverlayMessageBox methodsFor: 'popup' stamp: 'mt 4/29/2011 15:48:11.589'!
showAbove: aMorph

	self grabKeyboard.  

	self
		extent: aMorph extent;
		topLeft: aMorph topLeft;
		disableTableLayout: true.

	aMorph height < self minExtent y
		ifFalse: [^ aMorph addMorphFront: self].
		
	"Show NOT embedded in morph."
	self
		borderColor: Color white;
		borderWidth: 1;
		height: self minExtent y + 5;
		topLeft: (aMorph localPointToGlobal: aMorph topLeft);
		openInWorld.  ! !

!SdOverlayMessageBox methodsFor: 'configuration' stamp: 'mt 4/29/2011 10:26:32.788'!
title: aString

	self ui titleLbl text: ('<font color="#FFFFFF"><b>', aString, '</b></font>') asHtmlText.! !

!SdOverlayMessageBox methodsFor: 'accessing' stamp: 'mt 4/25/2011 17:14:24.177'!
ui

	^ ui ifNil: [ui := SdOverlayMessageBoxUi new]! !

!SdOverlayMessageBox methodsFor: 'initialization' stamp: 'mt 4/29/2011 15:51:56.612'!
updateShortcuts
	"Set number keys as shortcuts for buttons."
	
	self eventHandler removeAllShortcuts.
	
	self ui buttonContainer submorphs withIndexDo: [:button :index |
		self eventHandler on: (Character digitValue: index) send: #doClick to: button].! !

Morph subclass: #SdTape
	uses: TSdMemento
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sight-Dynamic-UI-Columns'!

SdTape class
	uses: TSdMemento classTrait
	instanceVariableNames: ''!

SdTape subclass: #SdFixedTape
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sight-Dynamic-UI-Columns'!

!SdFixedTape methodsFor: 'submorphs-add/remove' stamp: 'mt 6/19/2012 14:41:23.215'!
privateAddMorph: anEditor atIndex: index

	self submorphs ifEmpty: [self showFull].
	super privateAddMorph: anEditor atIndex: index.
! !

!SdFixedTape methodsFor: 'events-processing' stamp: 'mt 6/20/2012 13:49:50.201'!
rejectsEvent: evt

	^ self visible not or: [super rejectsEvent: evt]! !

!SdFixedTape methodsFor: 'submorphs-add/remove' stamp: 'mt 6/19/2012 14:40:43.258'!
removedMorph: aMorph
	"Update layout for the other morphs."

	super removedMorph: aMorph.  
	
	self submorphs ifEmpty: [self hideFull].! !

!SdTape methodsFor: 'add/remove - columns' stamp: 'mt 6/19/2012 15:20:07.186'!
addColumnAfter: anotherMorph

	| column |
	column := SdEditorColumn new.

	anotherMorph
		ifNil: [self addMorphBack: column]
		ifNotNil: [self
			addMorph: column after: (self submorphs
				"Find resize handle."
				at: (self submorphs indexOf: anotherMorph) + 1)].
	
	self addResizeHandleFor: column.
	
	self connect: column signal: #editorDroppedInFrontOfMe: toSelector: #addColumnFor:inFrontOf: pattern: #(1 0).
	self connect: column signal: #editorDroppedAfterMe: toSelector: #addColumnFor:after: pattern: #(1 0).
	
	^ column! !

!SdTape methodsFor: 'add/remove - columns' stamp: 'mt 6/20/2012 13:57:06.272'!
addColumnFor: anEditor

	| column |
	column := SdEditorColumn new.

	self addMorphBack: column.
	self addResizeHandleFor: column.
	
	column addMorphBack: anEditor.
	
	self connect: column signal: #editorDroppedInFrontOfMe: toSelector: #addColumnFor:inFrontOf: pattern: #(1 0).
	self connect: column signal: #editorDroppedAfterMe: toSelector: #addColumnFor:after: pattern: #(1 0).
	
	anEditor grabKeyboard.
	
	^ column! !

!SdTape methodsFor: 'add/remove - columns' stamp: 'mt 6/18/2012 17:37:23.525'!
addColumnFor: anEditor after: anotherMorph

	| column |
	column := (self addColumnAfter: anotherMorph)
		addMorphBack: anEditor.
		
	anEditor grabKeyboard.
	
	^ column! !

!SdTape methodsFor: 'add/remove - columns' stamp: 'mt 6/18/2012 17:37:46.305'!
addColumnFor: anEditor inFrontOf: anotherMorph

	| column |
	column := (self addColumnInFrontOf: anotherMorph)
		addMorphBack: anEditor.
		
	anEditor grabKeyboard.
	
	^ column! !

!SdTape methodsFor: 'add/remove - columns' stamp: 'mt 6/19/2012 15:20:01.735'!
addColumnInFrontOf: anotherMorph

	| column |
	column := SdEditorColumn new.
	
	self
		addMorph: column inFrontOf: anotherMorph;
		addResizeHandleFor: column.
		
	self connect: column signal: #editorDroppedInFrontOfMe: toSelector: #addColumnFor:inFrontOf: pattern: #(1 0).
	self connect: column signal: #editorDroppedAfterMe: toSelector: #addColumnFor:after: pattern: #(1 0).
		
	^ column! !

!SdTape methodsFor: 'add/remove - editors' stamp: 'mt 6/18/2012 16:35:29.727'!
addEditor: anEditorClass

	^ self addEditor: anEditorClass after: nil! !

!SdTape methodsFor: 'add/remove - editors' stamp: 'mt 6/18/2012 17:33:39.699'!
addEditor: anEditorClass after: anotherEditor

	| editor |
	editor := anEditorClass new.

	anotherEditor
		ifNotNil: [self addColumnFor: editor after: anotherEditor column]
		ifNil: [self addColumnFor: editor].
	
	^ editor! !

!SdTape methodsFor: 'add/remove - columns' stamp: 'mt 6/18/2012 16:22:49.376'!
addResizeHandleFor: aColumn

	| resizeHandle container |
	container := SdColumnSeparator new.
		
	resizeHandle := SdResizeHandle new
		target: aColumn.
	
	self connect: aColumn signal: #deleted to: container selector: #delete.

	container addMorph: resizeHandle.

	self
		addMorph: container
		after: aColumn.! !

!SdTape methodsFor: 'accessing' stamp: 'mt 6/18/2012 16:12:40.826'!
columns

	^ self submorphs select: [:m | m isKindOf: SdColumn]! !

!SdTape methodsFor: 'accessing' stamp: 'mt 6/18/2012 16:17:01.079'!
editors

	^ self columns gather: [:column | column editors]! !

!SdTape methodsFor: 'signals' stamp: 'mt 6/18/2012 16:38:38.97'!
focusChanged: aGlobalRectangle

	self emitInOwnerChain.! !

!SdTape methodsFor: 'accessing' stamp: 'mt 6/18/2012 16:17:33.748'!
focusedEditor

	^ self editors detect: [:editor | editor hasAnyKeyboard] ifNone: []! !

!SdTape methodsFor: 'system events' stamp: 'mt 6/20/2012 10:02:03.956'!
handleTraceItEvent: aTraceItEvent

	| callgraph |
	self hasAnyKeyboard ifFalse: [^ self].
	
	callgraph := SdCallgraphEditor callgraphAt: aTraceItEvent.
	callgraph isEmpty ifTrue: [
		SdCallgraphTracer new
			callgraph: callgraph;
			trace].

	self openTrace: callgraph after: self focusedEditor.! !

!SdTape methodsFor: 'initialization' stamp: 'mt 6/19/2012 16:11:10.441'!
initialize

	super initialize.
	
	self
		initializeSystemChangeNotifications;
		color: Color transparent;
		layoutPolicy: SdTapeLayout new.
		
	self sgConnectSignal: #editorDropped: toSelector: #addColumnFor:.
	self sgConnectSignal: #editorDroppedInFrontOfMe: toSelector: #addColumnFor:inFrontOf: pattern: #(1 0).
	self sgConnectSignal: #editorDroppedAfterMe: toSelector: #addColumnFor:after: pattern: #(1 0).
	
	self sgConnectSignal: #classActivated: toSelector: #openClass:after: pattern: #(1 0).
	self sgConnectSignal: #methodActivated: toSelector: #openMethod:after: pattern: #(1 0).
	self sgConnectSignal: #objectActivated: toSelector: #openObject:after: pattern: #(1 0).
	self sgConnectSignal: #traceActivated: toSelector: #openTrace:after: pattern: #(1 0).! !

!SdTape methodsFor: 'initialization' stamp: 'mt 6/19/2012 16:11:03.308'!
initializeSystemChangeNotifications

	SystemChangeNotifier uniqueInstance 
		notify: self ofSystemChangesOfItem: AbstractEvent expressionKind change: SdTraceItEvent changeKind using: #handleTraceItEvent:;
		notify: self ofSystemChangesOfItem: #test change: SdTraceItEvent changeKind using: #handleTraceItEvent:.! !

!SdTape methodsFor: 'accessing' stamp: 'mt 6/22/2012 16:13:34.062'!
nextMethodContainerAfter: anotherEditor

	| editors index container |
	editors := self editors.
	index := (editors indexOf: anotherEditor) + 1.
	
	^ (index <= editors size and: [(container := (editors at: index)) isKindOf: SdMethodContainer])
		ifTrue: [container]
		ifFalse: [nil]! !

!SdTape methodsFor: 'actions - open' stamp: 'mt 6/18/2012 16:52:01.5'!
openCategory: aSystemCategory

	self openCategory: aSystemCategory after: nil.! !

!SdTape methodsFor: 'actions - open' stamp: 'mt 6/18/2012 16:52:01.677'!
openCategory: aSystemCategory after: anEditor
	
	(self openPackage: (PackageOrganizer default packageOfSystemCategory: aSystemCategory) name after: anEditor)
		ifNotNil: [:packageViewer | packageViewer selectCategory: aSystemCategory].! !

!SdTape methodsFor: 'actions - open' stamp: 'mt 6/18/2012 16:52:01.785'!
openClass: aClass

	^ self openClass: aClass theNonMetaClass after: nil! !

!SdTape methodsFor: 'actions - open' stamp: 'mt 6/19/2012 17:27:36.188'!
openClass: aClass after: anEditor

	^ (self addEditor: SdClassEditor after: anEditor)
		theClass: aClass;
		grabKeyboard;
		yourself! !

!SdTape methodsFor: 'actions - open' stamp: 'mt 6/18/2012 16:52:01.999'!
openMethod: aMethodReference

	self openMethod: aMethodReference after: nil! !

!SdTape methodsFor: 'actions - open' stamp: 'mt 6/21/2012 17:55:01.653'!
openMethod: aMethodReference after: anotherEditor

	| editor |
	aMethodReference isValid ifFalse: [^ self].
	
	editor := (self nextMethodContainerAfter: anotherEditor)
		ifNil: [self addEditor: SdMethodContainer after: anotherEditor].
	
	(editor openMethod: aMethodReference)
		expand;
		grabKeyboard.
	
	SdOverlayConnector from: anotherEditor morphsOfInterest to: editor morphsOfInterest in: self.

	^ editor
				
	! !

!SdTape methodsFor: 'actions - open' stamp: 'mt 6/18/2012 16:52:02.213'!
openObject: anObject

	^ self openObject: anObject after: nil! !

!SdTape methodsFor: 'actions - open' stamp: 'mt 6/18/2012 16:52:49.152'!
openObject: anObject after: anotherEditor

	(self addEditor: SdObjectExplorer after: anotherEditor)
		ifNotNil: [:explorer |
			explorer object: anObject.
			explorer grabKeyboard.
			^ explorer].! !

!SdTape methodsFor: 'actions - open' stamp: 'mt 6/18/2012 16:52:02.427'!
openPackage: aPackageName
	
	self openPackage: aPackageName after: nil.! !

!SdTape methodsFor: 'actions - open' stamp: 'mt 6/19/2012 17:27:59.347'!
openPackage: aPackageName after: anEditor
	
	^ (self addEditor: SdPackageViewer after: anEditor)
		packageName: aPackageName;
		grabKeyboard;
		yourself! !

!SdTape methodsFor: 'actions - open' stamp: 'mt 6/18/2012 16:52:02.641'!
openProtocol: aProtocol class: aClass
	
	self openProtocol: aProtocol class: aClass after: nil.! !

!SdTape methodsFor: 'actions - open' stamp: 'mt 6/18/2012 16:52:02.791'!
openProtocol: aProtocol class: aClass after: anEditor
	
	(self openPackage: (PackageOrganizer default packageOfClass: aClass) name after: anEditor)
		ifNotNil: [:packageViewer | packageViewer selectProtocol: aProtocol class: aClass].! !

!SdTape methodsFor: 'actions - open' stamp: 'mt 6/18/2012 16:52:02.899'!
openTrace: aNode

	self openTrace: aNode after: nil.
! !

!SdTape methodsFor: 'actions - open' stamp: 'mt 6/19/2012 18:30:12.408'!
openTrace: aCallNode after: anotherEditor

	| editor |
	editor := (self addEditor: SdCallgraphEditor after: anotherEditor)
		currentNode: aCallNode;
		grabKeyboard;
		yourself.
	
	SdOverlayConnector from: anotherEditor morphsOfInterest to: editor morphsOfInterest in: self.
	
	^ editor
	! !

SdTape subclass: #SdUnboundedTape
	instanceVariableNames: 'shadow'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sight-Dynamic-UI-Columns'!

!SdUnboundedTape methodsFor: 'add/remove - columns' stamp: 'mt 6/19/2012 14:45:02.692'!
addColumnFor: aMorph

	^ self addColumnFor: aMorph inFrontOf: shadow! !

!SdUnboundedTape methodsFor: 'initialization' stamp: 'mt 6/20/2012 16:54:14.258'!
createShadow

	shadow := SdShadow new
		addCloseBtn;
		orientation: #vertical;
		convertSourceBlock: [:object | object isBehavior ifTrue: [object new] ifFalse: [object]];
		acceptedDropBlock: [:object | object isBehavior or: [object isKindOf: SdEditor]].
	^ shadow! !

!SdUnboundedTape methodsFor: 'initialization' stamp: 'mt 6/20/2012 13:51:14.73'!
initialize

	| shadow |
	super initialize.
	
	shadow := self createShadow.
	self addMorph: shadow.
	
	self connect: shadow signal: #editorDropped: toSelector: #addColumnFor:.
	self connect: shadow signal: #closeRequested toSelector: #tryClose.! !

Morph subclass: #SdTestMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sight-Dynamic-Tests-Support'!

!SdTestMorph class methodsFor: 'instance creation' stamp: 'mt 5/14/2012 14:39:33.928'!
withValue: anObject

	^ self new value: anObject! !

!SdTestMorph methodsFor: 'accessing' stamp: 'mt 6/28/2011 16:24:26.253'!
value

	^ self valueOfProperty: #value ifAbsent: [nil]! !

!SdTestMorph methodsFor: 'accessing' stamp: 'mt 6/28/2011 16:29:53.927'!
value: aValue

	self setProperty: #value toValue: aValue.
	self valueChanged: aValue.! !

!SdTestMorph methodsFor: 'signals' stamp: 'mt 6/28/2011 16:20:40.323'!
valueChanged: aValue

	self emitInOwnerChain.! !

!SdTestMorph methodsFor: 'signals' stamp: 'mt 6/28/2011 16:23:55.029'!
valueChanged: aValue and: anotherValue

	self emitInOwnerChain.! !

Morph subclass: #SdTranscriptModel
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sight-Dynamic-Models'!

!SdTranscriptModel commentStamp: 'mt 4/18/2011 17:23:29.339' prior: 0!
I map transcript changes to signals. I am a morph because of the implementation of TranscriptStream>>#release.!

!SdTranscriptModel methodsFor: 'signals' stamp: 'mt 4/18/2011 17:19:37.539'!
cleared

	self emit.! !

!SdTranscriptModel methodsFor: 'signals' stamp: 'mt 4/18/2011 17:20:01.716'!
closed

	self emit.! !

!SdTranscriptModel methodsFor: 'signals' stamp: 'mt 4/18/2011 17:29:18.593'!
entryAppended: aString

	self emit.! !

!SdTranscriptModel methodsFor: 'initialization' stamp: 'mt 4/18/2011 17:19:17.698'!
initialize

	super initialize.
	
	Transcript addDependent: self.! !

!SdTranscriptModel methodsFor: 'updating' stamp: 'mt 4/18/2011 17:35:07.382'!
update: aSymbol

	aSymbol = #clearText ifTrue: [self cleared].
	aSymbol = #close ifTrue: [self closed].
	aSymbol = #appendEntry ifTrue: [self entryAppended: Transcript contents].! !
